/* ranown.f -- translated by f2c (version 20020621). */

#include <stdio.h>
#include <stdlib.h>

#define seed 12345

/* Common Block Declarations */

union {
  struct {
    int istart, iff;
  } one;
  struct {
    int icst, iff;
  } two;
} inrandom;

#define inra1 (inrandom.one)
#define inra2 (inrandom.two)

/* Subroutine                                                 */ 
/*                                                            */
/* RANOWN: RANDOM NUMBERS, IMPROVEMENT OF SYSTEM ROUTINE RAND */
/* USING RANDOMIZING SHUFFLE, CF NUMERICAL RECIPES, P.195     */
/* INTERFACE TO SYSTEM GENERATOR IS CALLED RANSYS             */

double ranown(int *i)
{
  /* System generated locals */
    
  float ret_val;

  /* Local variables */
  
  static int j;
  static float v[97], y;
  static int jj;
  extern double ransys(int *);
  
  if(inra1.iff == 0) {
    inra1.iff = 1;
	
    for(j = 1; j <= 97; ++j) {
      y = ransys(&inra1.istart);

      /* L100: */
    }
	
    for(j = 1; j <= 97; ++j) {
      v[j - 1] = ransys(&inra1.istart);
      
      /* L101: */
    }
    
    y = ransys(&inra1.istart);
  }

 L102:
  
  j = (int) (y * 97.0f) + 1;
  
  if(j > 97 || j < 1) {
    y = ransys(&inra1.istart);

    goto L102;
  }
  
  y = v[j - 1];
  ret_val = y;
  ++jj;
  v[j - 1] = ransys(&inra1.istart);
  
  return(ret_val);
} /* ranown */

/* Subroutine                                */ 
/*                                           */
/* INITIALIZE RANDOM NUMBER GENERATOR RANOWN */
/* DEFINES START VALUE OF INDEX              */

int inrand(int *istart)
{
  inra2.icst = *istart;
  inra2.iff = 0;
  
  return(0);
} /* inrand */

/* Subroutine                                                         */ 
/*                                                                    */
/* RANSYS                                                             */
/* INTERFACE RANSYS BETWEEN SYSTEM RANDOM NUMBER GENERATOR AND RANOWN */
/* VERSION  VAX FORTRAN                                               */

double ransys(int *i)
{
  /* System generated locals */
  
  float ret_val;
  
  /* Local variables */
  
  extern double ran(int *);
  
  /* random number generator */
  /* I: seed, changed by RAN */
    
  ret_val = ran(i);
  
  return(ret_val);
} /* ransys_ */

double ran(int *val) 
{
  /* System generated locals */
  
  float ret_val;

  /* Initialize the random number generator */

  srand(seed);

  ret_val = ((float) *val / 32768.0f) * rand();

  return(ret_val);
}
