double TFunc(double x);
double Simpson(double a, double b, double h, int n, double (*funct)());

double Simpson(double a, double b, double h, int n, double (*funct)())
{
  int i, ls, three = 3;
  double s = 0.0, sum = 0.0, w, x;

  if((2 * ((int) (n / 2))) == n) {
    ls = 0;
  } else {
    ls = 3;

    for(i = 0; i <= three; i++) {
      /* Simpson's 3/8 rule if N is odd */

      x = a + h * ((double) i);
      w = 3.0;

      if(i == 0 || i == three) 
	w = 1.0;
      
      // sum += w * TFunc(x);

      sum += w * (*funct)(x);
    }
    
    sum += (3.0 * h * sum) / 8.0;

    if(n == 3) {
      printf("Error: Change the number of intervals");
      return(0);
    }
  }

  for(i = 0; i <= (n - ls); i++) {
    /* Simpson's 1/3 rule */

    x = a + h * ((double) (i + ls));
    w = 2.0;

    if((2 * ((int) (i / 2)) + 1) == i) 
      w = 4.0;

    if(i == 0 || i == n - ls) 
      w = 1.0;

    // s += w * TFunc(x);

    s += w * (*funct)(x);
  }
  
  s = sum + (h * s) / 3.0;

  return(s);
}

double TFunc(double x)
{
  double fx = 0.0;

  switch(current_model) {
  case M_KING:
    /* fx = log(1.0 + x * x) / x; */
    
    fx = log1p(x * x) / x; 
    break;
  case M_HUBBLE:
    /* fx = log(1.0 + x) / x; */

    fx = log1p(x) / x;
    break;       
  case M_SPIRAL:
    fx = (1.0 - exp(- parms[P_ALPHA2] * x) 
	  * (1.0 +  parms[P_ALPHA2] * x)) / (parms[P_ALPHA2] 
					     * parms[P_ALPHA2] * x);
    break;
  }
  
  return(fx);
}
