/*
  
#include <stdio.h>
#include <math.h>
#include "glxf.h"

**/

/*
  
void model_menu_siman(double *x, int i);
void chang_refsdal_siman(double *x, int i);
void singular_isothermal_sphere_siman(double *x, int i);
void nonsingular_isothermal_sphere_siman(double *x, int i);
void transparent_sphere_siman(double *x, int i);
void elliptical_siman(double *x, int i);
void king_siman(double *x, int i);
void truncated_king_siman(double *x, int i);
void hubble_siman(double *x, int i);
void de_vaucouleur_siman(double *x, int i);
void spiral_siman(double *x, int i);
void multipole_siman(double *x, int i);
void rotation_lens_siman(double *x, int i);
void double_lens_siman(double *x, int i);
void uniform_ring_siman(double *x, int i);

**/

void assign(double *x);

void assign(double *x)
{     
  switch(SIM_AN) {
  case FALSE:
    Prmt[0] = Y[0];
    Prmt[1] = Y[1];
    Prmt[2] = parms[P_E];

    // Prmt[3] = parms[P_THETA];

    Prmt[3] = (M_PI * parms[P_THETA]) / 180.0;
    
    Prmt[4] = parms[P_GAMMA];
    Prmt[5] = parms[P_SIGMA];

    // Prmt[6] = parms[P_PHI];
    
    Prmt[6] = (M_PI * parms[P_PHI]) / 180.0;

    E_rad  = Prmt[2];
    E2_rad = E_rad * E_rad;
    E3_rad = E_rad * E2_rad;
    E4_rad = E_rad * E3_rad;

    CS = cos(Prmt[3]);
    SS = sin(Prmt[3]);

    B1 = 1.0 - Prmt[5] - Prmt[4] * cos(Prmt[6]);
    B2 = 1.0 - Prmt[5] + Prmt[4] * cos(Prmt[6]);
    B3 =               - Prmt[4] * sin(Prmt[6]);
     
    switch(current_model) {
    case M_CHANG_REFSDAL:
      break;   
    case M_SING_ISOT_SPHERE:
      Prmt[7] = parms[P_EXP];
      break;
    case M_NSING_ISOT_SPHERE:
      Prmt[7] = parms[P_KAPPA];
      Prmt[8] = parms[P_C];
      break;
    case M_TRANSP_SPHERE:
      Prmt[7] = parms[P_C];
      break;
    case M_ELLIPTICAL:
      Prmt[7]  = parms[P_KAPPA];
      Prmt[8]  = parms[P_ALPHA];
      Prmt[9]  = parms[P_EPSILON];
      Prmt[10] = parms[P_C];     
      break;
    case M_KING:
      Prmt[7] = parms[P_KAPPA];
      break;
    case M_TRUNC_KING:
      Prmt[7] = parms[P_KAPPA2];
      Prmt[8] = parms[P_C];     
      break;
    case M_HUBBLE:
      Prmt[7] = parms[P_KAPPA];
      break;
    case M_DE_VAUCOULEUR:
      Prmt[7] = parms[P_KAPPA];
      break;
    case M_SPIRAL:
      Prmt[7] = parms[P_KAPPA];
      Prmt[8] = parms[P_ALPHA2];
      break;
    case M_MULTIPOLE:
      Prmt[7]  = parms[P_KAPPA0];
      Prmt[8]  = parms[P_DX_QP];
      Prmt[9]  = parms[P_DY_QP];
      Prmt[10] = parms[P_QXX];
      Prmt[11] = parms[P_QXY];
      Prmt[12] = parms[P_QYY];
      break;
    case M_ROTATION_LENS:
      Prmt[7] = parms[P_SX];
      Prmt[8] = parms[P_SY];
      break;
    case M_DOUBLE_LENS:
      Prmt[7]  = parms[P_X_1];
      Prmt[8]  = parms[P_Y_1];
      Prmt[9]  = parms[P_X_2];
      Prmt[10] = parms[P_Y_2];
      Prmt[11] = parms[P_M_1];
      Prmt[12] = parms[P_M_2];
      Prmt[13] = parms[P_BETA];
      Prmt[14] = parms[P_GAMMA2];
      Prmt[15] = parms[P_SIGMA2];

      // Prmt[16] = parms[P_PHI2];

      Prmt[16] = (M_PI * parms[P_PHI2]) / 180.0;
      
      C1 = 1.0 - Prmt[15] - Prmt[14] * cos(Prmt[16]);
      C2 = 1.0 - Prmt[15] + Prmt[14] * cos(Prmt[16]);
      C3 =                - Prmt[14] * sin(Prmt[16]);
      break;
    case M_UNIFORM_RING:
      Prmt[7] = parms[P_KAPPA];
      Prmt[8] = parms[P_Ri];
      Prmt[9] = parms[P_Ro];     
      break; 
    }   

    break;
  case TRUE:
    if(sl_1 == FALSE) {
      Prmt[0] = Y[0];
    } else {
      Prmt[0] = x[0];        
    }

    if(sl_2 == FALSE) {
      Prmt[1] = Y[1];
    } else {
      Prmt[1] = x[1];        
    }

    if(sl_3 == FALSE) {
      Prmt[2] = parms[P_E];
    } else {
      Prmt[2] = x[2];        
    }

    if(sl_4 == FALSE) {
      Prmt[3] = (M_PI * parms[P_THETA]) / 180.0; 
    } else {
      Prmt[3] = x[3];        
    }

    if(sl_5 == FALSE) {
      Prmt[4] = parms[P_GAMMA];
    } else {
      Prmt[4] = x[4];        
    }

    if(sl_6 == FALSE) {
      Prmt[5] = parms[P_SIGMA];
    } else {
      Prmt[5] = x[5];        
    }

    if(sl_7 == FALSE) {
      Prmt[6] = (M_PI * parms[P_PHI]) / 180.0;
    } else {
      Prmt[6] = x[6];        
    }

    E_rad  = Prmt[2];
    E2_rad = E_rad * E_rad;
    E3_rad = E_rad * E2_rad;
    E4_rad = E_rad * E3_rad;

    CS = cos(Prmt[3]);
    SS = sin(Prmt[3]);

    B1 = 1.0 - Prmt[5] - Prmt[4] * cos(Prmt[6]);
    B2 = 1.0 - Prmt[5] + Prmt[4] * cos(Prmt[6]);
    B3 =               - Prmt[4] * sin(Prmt[6]);

    switch(current_model) {
    case M_CHANG_REFSDAL:
      break;   
    case M_SING_ISOT_SPHERE:
      if(sl_11 == FALSE) {
        Prmt[7] = parms[P_EXP];
      } else {
        Prmt[7] = x[7];        
      }

      break;
    case M_NSING_ISOT_SPHERE:
      if(sl_8 == FALSE) {
        Prmt[7] = parms[P_KAPPA];
      } else {
        Prmt[7] = x[7];        
      }

      if(sl_12 == FALSE) {
        Prmt[8] = parms[P_C];
      } else {
        Prmt[8] = x[8];        
      }

      break;
    case M_TRANSP_SPHERE:
      if(sl_12 == FALSE) {
        Prmt[7] = parms[P_C];
      } else {
        Prmt[7] = x[7];        
      }

      break;
    case M_ELLIPTICAL:
      if(sl_8 == FALSE) {
        Prmt[7]  = parms[P_KAPPA];
      } else {
        Prmt[7] = x[7];        
      }

      if(sl_12 == FALSE) {
        Prmt[10] = parms[P_C];
      } else {
        Prmt[10] = x[10];        
      }

      if(sl_33 == FALSE) {
        Prmt[9] = parms[P_EPSILON];
      } else {
        Prmt[9] = x[9];        
      }

      if(sl_34 == FALSE) {
        Prmt[8] = parms[P_ALPHA];
      } else {
        Prmt[8] = x[8];        
      }
      
      break;
    case M_KING:
      if(sl_8 == FALSE) {
        Prmt[7] = parms[P_KAPPA];
      } else {
        Prmt[7] = x[7];       
      }
      
      break;
    case M_TRUNC_KING:
      if(sl_9 == FALSE) {
        Prmt[7] = parms[P_KAPPA2];
      } else {
        Prmt[7] = x[7];        
      }

      if(sl_12 == FALSE) {
        Prmt[8] = parms[P_C];     
      } else {
        Prmt[8] = x[8];        
      }
      
      break;
    case M_HUBBLE:
      if(sl_8 == FALSE) {
        Prmt[7] = parms[P_KAPPA];
      } else {
        Prmt[7] = x[7];       
      }
      
      break;
    case M_DE_VAUCOULEUR:
      if(sl_8 == FALSE) {
        Prmt[7] = parms[P_KAPPA];
      } else {
        Prmt[7] = x[7];       
      }
      
      break;
    case M_SPIRAL:
      if(sl_8 == FALSE) {
        Prmt[7] = parms[P_KAPPA];
      } else {
        Prmt[7] = x[7];       
      }

      if(sl_10 == FALSE) {
        Prmt[8] = parms[P_ALPHA2];
      } else {
        Prmt[8] = x[8];       
      } 

      break;
    case M_MULTIPOLE:
      if(sl_27 == FALSE) {
        Prmt[7] = parms[P_KAPPA0];
      } else {
        Prmt[7] = x[7];       
      }

      if(sl_28 == FALSE) {
        Prmt[8] = parms[P_DX_QP];
      } else {
        Prmt[8] = x[8];       
      }
      
      if(sl_29 == FALSE) {  
        Prmt[9] = parms[P_DY_QP];
      } else {
        Prmt[9] = x[9];       
      }

      if(sl_30 == FALSE) {  
        Prmt[10] = parms[P_QXX];
      } else {
        Prmt[10] = x[10];       
      }

      if(sl_31 == FALSE) {  
        Prmt[11] = parms[P_QXY];
      } else {
        Prmt[11] = x[11];       
      }

      if(sl_32 == FALSE) {  
        Prmt[12] = parms[P_QYY];
      } else {
        Prmt[12] = x[12];       
      }
      
      break;
    case M_ROTATION_LENS:
      if(sl_25 == FALSE) {  
        Prmt[7] = parms[P_SX];
      } else {
        Prmt[7] = x[7];       
      }

      if(sl_26 == FALSE) {  
        Prmt[8] = parms[P_SY];
      } else {
        Prmt[8] = x[8];       
      }
      
      break;
    case M_DOUBLE_LENS:
      if(sl_15 == FALSE) {  
        Prmt[11] = parms[P_M_1];
      } else {
        Prmt[11] = x[11];       
      }

      if(sl_16 == FALSE) {  
        Prmt[7]  = parms[P_X_1];
      } else {
        Prmt[7] = x[7];       
      }

      if(sl_17 == FALSE) {  
        Prmt[8]  = parms[P_Y_1];
      } else {
        Prmt[8] = x[8];       
      }

      if(sl_18 == FALSE) {  
        Prmt[13] = parms[P_BETA];
      } else {
        Prmt[13] = x[13];       
      }

      if(sl_19 == FALSE) {  
        Prmt[14] = parms[P_GAMMA2];
      } else {
        Prmt[14] = x[14];       
      }

      if(sl_20 == FALSE) {  
        Prmt[15] = parms[P_SIGMA2];
      } else {
        Prmt[15] = x[15];       
      }

      if(sl_21 == FALSE) {  
        Prmt[16] = (M_PI * parms[P_PHI2]) / 180.0;
      } else {
        Prmt[16] = x[16];       
      }

      if(sl_22 == FALSE) {  
        Prmt[12] = parms[P_M_2];
      } else {
        Prmt[12] = x[12];       
      }

      if(sl_23 == FALSE) {  
        Prmt[9]  = parms[P_X_2];
      } else {
        Prmt[9] = x[9];       
      }

      if(sl_24 == FALSE) {  
        Prmt[10] = parms[P_Y_2];      
      } else {
        Prmt[10] = x[10];       
      }

      C1 = 1.0 - Prmt[15] - Prmt[14] * cos(Prmt[16]);
      C2 = 1.0 - Prmt[15] + Prmt[14] * cos(Prmt[16]);
      C3 =                - Prmt[14] * sin(Prmt[16]);
      break;
    case M_UNIFORM_RING:
      if(sl_8 == FALSE) {  
        Prmt[7] = parms[P_KAPPA];
      } else {
        Prmt[7] = x[7];       
      }

      if(sl_13 == FALSE) {  
        Prmt[8] = parms[P_Ri];
              } else {
        Prmt[8] = x[8];       
      }

      if(sl_14 == FALSE) {  
        Prmt[9] = parms[P_Ro];
      } else {
        Prmt[9] = x[9];       
      }
      
      break; 
    }   

    break;
  }
}

void model_menu_siman(double *x, int i)
{
  glColor3f(0.0, 0.0, 0.0);
}

void uniform_ring_siman(double *x, int i) 
{
  double x0 = x_obs[i];
  double x1 = y_obs[i];

  double xbar0, xbar1, radius_E2, radius_E, Mkaprp, Mkapto, alpha0, alpha1;

  assign(x);
  
  xbar0 =   (x0 - xl) * CS + (x1 - yl) * SS;
  xbar1 = - (x0 - xl) * SS + (x1 - yl) * CS;  

  radius_E2 = (xbar0 * xbar0 + xbar1 * xbar1) / E2_rad;
  radius_E  = sqrt(radius_E2);
  
  Mkaprp = 10.0 * Prmt[7] * (radius_E2 - Prmt[8] * Prmt[8]);
  Mkapto = 10.0 * Prmt[7] * (Prmt[9] * Prmt[9] - Prmt[8] * Prmt[8]);

  if(radius_E >= Prmt[9]) {
    alpha0 = (Mkapto * xbar0) / radius_E2;
    alpha1 = (Mkapto * xbar1) / radius_E2; 	     
  } else {
    if(radius_E >= Prmt[8]) {
      alpha0 = (Mkaprp * xbar0) / radius_E2;
      alpha1 = (Mkaprp * xbar1) / radius_E2; 	
    } else {
      alpha0 = 0.0;
      alpha1 = 0.0; 
    }   
  }
          
  Y_x[i] = B1 * xbar0 + B3 * xbar1 - alpha0;
  Y_y[i] = B2 * xbar1 + B3 * xbar0 - alpha1;
}

void chang_refsdal_siman(double *x, int i)
{
  double x0 = x_obs[i];
  double x1 = y_obs[i];

  double xbar0, xbar1, radius_E2, radius_E, alpha0, alpha1;

  assign(x);

  xbar0 =   (x0 - xl) * CS + (x1 - yl) * SS;
  xbar1 = - (x0 - xl) * SS + (x1 - yl) * CS;  

  radius_E2 = (xbar0 * xbar0 + xbar1 * xbar1) / E2_rad;
  
  alpha0 = xbar0 / radius_E2;
  alpha1 = xbar1 / radius_E2;
  
  Y_x[i] = B1 * xbar0 + B3 * xbar1 - alpha0;
  Y_y[i] = B2 * xbar1 + B3 * xbar0 - alpha1;
}

void double_lens_siman(double *x, int i)
{
  double x0 = x_obs[i];
  double x1 = y_obs[i];

  double xbar0, xbar1, radius_E2, alpha0, alpha1;
  double rs12, xd1, xd2, yp1, yp2, rd2;
  
  assign(x);

  xbar0 =   (x0 - xl) * CS + (x1 - yl) * SS;
  xbar1 = - (x0 - xl) * SS + (x1 - yl) * CS;  

  radius_E2 = (xbar0 * xbar0 + xbar1 * xbar1) / E2_rad;

  rs12 = ((xbar0 - Prmt[7]) * (xbar0 - Prmt[7])
          + (xbar1 - Prmt[8]) * (xbar1 - Prmt[8])) / E2_rad;

  yp1 = C1 * xbar0 + C3 * xbar1;
  yp2 = C2 * xbar1 + C3 * xbar0; 
  
  xd1 = yp1 - Prmt[11] * Prmt[13] * (xbar0 - Prmt[7]) / rs12; 
  xd2 = yp2 - Prmt[11] * Prmt[13] * (xbar1 - Prmt[8]) / rs12; 

  rd2 = ((xd1 - Prmt[9]) * (xd1 - Prmt[9])
         + (xd2 - Prmt[10]) * (xd2 - Prmt[10])) / E2_rad;

  alpha0 = Prmt[11] * (xbar0 - Prmt[7]) / rs12
    + Prmt[12] * (xd1 - Prmt[9]) / rd2;  
  alpha1 = Prmt[11] * (xbar1 - Prmt[8]) / rs12
    + Prmt[12] * (xd2 - Prmt[10]) / rd2;          

  Y_x[i] = B1 * xbar0 + B3 * xbar1 - alpha0;
  Y_y[i] = B2 * xbar1 + B3 * xbar0 - alpha1;
}

void singular_isothermal_sphere_siman(double *x, int i)
{
  double x0 = x_obs[i];
  double x1 = y_obs[i];

  double xbar0, xbar1, radius_E2, radius_E, rbeta, alpha0, alpha1;

  assign(x);

  xbar0 =   (x0 - xl) * CS + (x1 - yl) * SS;
  xbar1 = - (x0 - xl) * SS + (x1 - yl) * CS;  

  radius_E2 = (xbar0 * xbar0 + xbar1 * xbar1) / E2_rad;

  rbeta = pow(radius_E2, Prmt[7] / 2.0 - 1.0);
    
  alpha0 = rbeta * xbar0;
  alpha1 = rbeta * xbar1;  
  
  Y_x[i] = B1 * xbar0 + B3 * xbar1 - alpha0;
  Y_y[i] = B2 * xbar1 + B3 * xbar0 - alpha1;
}

void nonsingular_isothermal_sphere_siman(double *x, int i)
{
  double x0 = x_obs[i];
  double x1 = y_obs[i];

  double xbar0, xbar1, s2, radius_E2, radius_E, funcnis, alpha0, alpha1;

  assign(x);

  xbar0 =   (x0 - xl) * CS + (x1 - yl) * SS;
  xbar1 = - (x0 - xl) * SS + (x1 - yl) * CS;  

  radius_E2 = (xbar0 * xbar0 + xbar1 * xbar1) / E2_rad;

  s2 = Prmt[8] * Prmt[8] + radius_E2;
    
  funcnis = sqrt(s2) - Prmt[8];

  alpha0 = (Prmt[7] * funcnis * xbar0) / radius_E2;
  alpha1 = (Prmt[7] * funcnis * xbar1) / radius_E2;

  Y_x[i] = B1 * xbar0 + B3 * xbar1 - alpha0;
  Y_y[i] = B2 * xbar1 + B3 * xbar0 - alpha1;
}

void transparent_sphere_siman(double *x, int i)
{
  double x0 = x_obs[i];
  double x1 = y_obs[i];

  double xbar0, xbar1, s2, radius_E2, radius_E, functs, alpha0, alpha1;

  assign(x);
  
  xbar0 =   (x0 - xl) * CS + (x1 - yl) * SS;
  xbar1 = - (x0 - xl) * SS + (x1 - yl) * CS;  

  radius_E2 = xbar0 * xbar0 + xbar1 * xbar1;
  radius_E  = sqrt(radius_E2);

  s2 = 1.0 - radius_E2 / (Prmt[7] * Prmt[7]);

  functs = 1.0 - pow(s2, (3.0 / 2.0));

  if(parms[P_C] > radius_E){
    alpha0 = (functs * xbar0) / (radius_E2 / E2_rad);
    alpha1 = (functs * xbar1) / (radius_E2 / E2_rad);    
  } else {
    alpha0 = xbar0 / (radius_E2 / E2_rad);
    alpha1 = xbar1 / (radius_E2 / E2_rad); 
  }   

  Y_x[i] = B1 * xbar0 + B3 * xbar1 - alpha0;
  Y_y[i] = B2 * xbar1 + B3 * xbar0 - alpha1;
}

void elliptical_siman(double *x, int i)
{
  double Epsilon1 = 1.0 - Prmt[9];
  double Epsilon2 = 1.0 + Prmt[9];
  double delta  = Prmt[8] - 1.0;
  double delta2 = 2.0 * Prmt[8];

  double x0 = x_obs[i];
  double x1 = y_obs[i];

  double xbar0, xbar1, s2, radius_E2, radius_E, functs, alpha0, alpha1;

  assign(x);
  
  xbar0 =   (x0 - xl) * CS + (x1 - yl) * SS;
  xbar1 = - (x0 - xl) * SS + (x1 - yl) * CS;  
  
  s2 = (Prmt[10] * Prmt[10]
        + Epsilon1 * xbar0 * xbar0 + Epsilon2 * xbar1 * xbar1) / E2_rad;
  
  alpha0 = (Prmt[7] * Epsilon1 * xbar0
            * pow(s2, delta)) / pow(Prmt[10], delta2);
  alpha1 = (Prmt[7] * Epsilon2 * xbar1
            * pow(s2, delta)) / pow(Prmt[10], delta2);

  Y_x[i] = B1 * xbar0 + B3 * xbar1 - alpha0;
  Y_y[i] = B2 * xbar1 + B3 * xbar0 - alpha1;

  /* printf("Y_x[%d] = %g, Y_y[%d] = %g \n", i, Y_x[i], i, Y_y[i]); */
}

void king_siman(double *x, int i)
{
  /* log1p(x) = log(1.0 + x) */

  double x0 = x_obs[i];
  double x1 = y_obs[i];

  double xbar0, xbar1, radius_E2, radius_E, alpha0, alpha1;

  assign(x);
  
  xbar0 =   (x0 - xl) * CS + (x1 - yl) * SS;
  xbar1 = - (x0 - xl) * SS + (x1 - yl) * CS;  

  radius_E2 = (xbar0 * xbar0 + xbar1 * xbar1) / E2_rad;

  alpha0 = (Prmt[7] * xbar0 * log1p(radius_E2)) / radius_E2;
  alpha1 = (Prmt[7] * xbar1 * log1p(radius_E2)) / radius_E2;

  Y_x[i] = B1 * xbar0 + B3 * xbar1 - alpha0;
  Y_y[i] = B2 * xbar1 + B3 * xbar0 - alpha1;
}

void truncated_king_siman(double *x, int i)
{
  /* hypot(x, y) = sqrt(x * x + y * y) */

  double x0 = x_obs[i];
  double x1 = y_obs[i];

  double xbar0, xbar1, radius_E2, radius_E, alpha0, alpha1;
  double func1, func2, func3;
  
  assign(x);
  
  xbar0 =   (x0 - xl) * CS + (x1 - yl) * SS;
  xbar1 = - (x0 - xl) * SS + (x1 - yl) * CS;  

  radius_E2 = (xbar0 * xbar0 + xbar1 * xbar1) / E2_rad;
  radius_E  = sqrt(radius_E2);

  func1 = log1p(radius_E2) + radius_E2 / (1.0 + (Prmt[8] * Prmt[8]) / E2_rad); 
  func2 = (4.0 * (hypot(1.0, radius_E) - 1.0)) / hypot(1.0, Prmt[8] / E_rad);
  func3 = func1 - func2;
  
  alpha0 = (Prmt[7] * xbar0 * func3) / radius_E2; 
  alpha1 = (Prmt[7] * xbar1 * func3) / radius_E2;

  Y_x[i] = B1 * xbar0 + B3 * xbar1 - alpha0;
  Y_y[i] = B2 * xbar1 + B3 * xbar0 - alpha1;
}

void hubble_siman(double *x, int i)
{
  double x0 = x_obs[i];
  double x1 = y_obs[i];

  double xbar0, xbar1, radius_E2, radius_E, funchb, alpha0, alpha1;
  
  assign(x);
  
  xbar0 =   (x0 - xl) * CS + (x1 - yl) * SS;
  xbar1 = - (x0 - xl) * SS + (x1 - yl) * CS;  

  radius_E2 = (xbar0 * xbar0 + xbar1 * xbar1) / E2_rad;
  radius_E  = sqrt(radius_E2);
  
  funchb = log1p(radius_E) - radius_E / (1.0 + radius_E);

  alpha0 = (2.0 * Prmt[7] * xbar0 * funchb) / radius_E2;
  alpha1 = (2.0 * Prmt[7] * xbar1 * funchb) / radius_E2;  

  Y_x[i] = B1 * xbar0 + B3 * xbar1 - alpha0;
  Y_y[i] = B2 * xbar1 + B3 * xbar0 - alpha1;
}

void de_vaucouleur_siman(double *x, int i)
{
  double x0 = x_obs[i];
  double x1 = y_obs[i];
  
  double xbar0, xbar1, radius_E2, radius_E, alpha0, alpha1;
  double poly1, poly2, poly3, poly4, poly5, poly6, poly7;
  double func1, func2;

  assign(x);
  
  xbar0 =   (x0 - xl) * CS + (x1 - yl) * SS;
  xbar1 = - (x0 - xl) * SS + (x1 - yl) * CS;  

  radius_E2 = (xbar0 * xbar0 + xbar1 * xbar1) / E2_rad;
  radius_E  = sqrt(radius_E2);
 
  poly1 = 720.0 / tau8 + (720.0 * pow(radius_E, (1.0 / 4.0))) / tau7;
  poly2 = poly1 + pow(radius_E, (3.0 / 2.0)) / tau2;
  poly3 = poly2 + (6.0 * pow(radius_E, (5.0 / 4.0))) / tau3;
  poly4 = poly3 + (30.0 * radius_E) / tau4;
  poly5 = poly4 + (120.0 * pow(radius_E, (3.0 / 4.0))) / tau5;
  poly6 = poly5 + (360.0 * sqrt(radius_E)) / tau6;
  poly7 = 7.0 * poly6 + pow(radius_E, (7.0 / 4.0)) / tau;

  func1 = poly7 * exp(- tau * (pow(radius_E, (1.0 / 4.0)) - 1.0));
  func2 = func1 - (5040.0 * Ftau) / tau8;

  alpha0 = - (8.0 * Prmt[7] * xbar0 * func2) / radius_E2;
  alpha1 = - (8.0 * Prmt[7] * xbar1 * func2) / radius_E2;

  Y_x[i] = B1 * xbar0 + B3 * xbar1 - alpha0;
  Y_y[i] = B2 * xbar1 + B3 * xbar0 - alpha1;
}

void spiral_siman(double *x, int i)
{
  double x0 = x_obs[i];
  double x1 = y_obs[i];
  
  double xbar0, xbar1, radius_E2, radius_E, funcs, alpha0, alpha1;

  assign(x);
  
  xbar0 =   (x0 - xl) * CS + (x1 - yl) * SS;
  xbar1 = - (x0 - xl) * SS + (x1 - yl) * CS;  

  radius_E2 = (xbar0 * xbar0 + xbar1 * xbar1) / E2_rad;
  radius_E  = sqrt(radius_E2);
  
  funcs = 2.0 * Prmt[7] * (1.0 - exp(- Prmt[8] * radius_E)
			   * (parms[P_ALPHA2] * radius_E + 1.0));
  
  alpha0 = (funcs * xbar0) / (Prmt[8] * Prmt[8] * radius_E2);
  alpha1 = (funcs * xbar1) / (Prmt[8] * Prmt[8] * radius_E2);  
  
  Y_x[i] = B1 * xbar0 + B3 * xbar1 - alpha0;
  Y_y[i] = B2 * xbar1 + B3 * xbar0 - alpha1;
}

void multipole_siman(double *x, int i)
{
  double x0 = x_obs[i];
  double x1 = y_obs[i];
  
  double xbar0, xbar1, radius_E2, radius_E4, alpha0, alpha1;
  double dipolm1, dipolm2, quadrupolm1, quadrupolm2; 

  assign(x);
  
  xbar0 =   (x0 - xl) * CS + (x1 - yl) * SS;
  xbar1 = - (x0 - xl) * SS + (x1 - yl) * CS;  

  radius_E2 = (xbar0 * xbar0 + xbar1 * xbar1) / E2_rad;
  radius_E4 = radius_E2 * radius_E2;

  dipolm1 = E3_rad * (Prmt[8] * (xbar1 * xbar1 - xbar0 * xbar0)
                      - 2.0 * Prmt[9] * xbar0 *
                      xbar1) / pow((xbar0 * xbar0 + xbar1 * xbar1), 2.0);
    
  dipolm2 = - E3_rad * (Prmt[9] * (xbar1 * xbar1 - xbar0 * xbar0)
                        + 2.0 * Prmt[8] * xbar0 *
                        xbar1) / pow((xbar0 * xbar0 + xbar1 * xbar1), 2.0);

  quadrupolm1 = 2.0 * E4_rad * (Prmt[10] * xbar0 *
                                (3.0 * xbar1 * xbar1 - xbar0 * xbar0)
                                + Prmt[11] * xbar1 *
                                (xbar1 * xbar1 - 3.0 * xbar0 * xbar0)) /
    pow((xbar0 * xbar0 + xbar1 * xbar1), 3.0);

  quadrupolm2 = 2.0 * E4_rad * (Prmt[12] * xbar1 *
                              (3.0 * xbar0 * xbar0 - xbar1 * xbar1)
                              + Prmt[11] * xbar0 *
                              (xbar0 * xbar0 - 3.0 * xbar1 * xbar1)) /
    pow((xbar0 * xbar0 + xbar1 * xbar1), 3.0);
    
  alpha0 = (Prmt[7] * xbar0) / radius_E2 + dipolm1 + quadrupolm1; 
  alpha1 = (Prmt[7] * xbar1) / radius_E2 + dipolm2 + quadrupolm2;

  Y_x[i] = B1 * xbar0 + B3 * xbar1 - alpha0;
  Y_y[i] = B2 * xbar1 + B3 * xbar0 - alpha1;
}

void rotation_lens_siman(double *x, int i)
{
  double x0 = x_obs[i];
  double x1 = y_obs[i];
  
  double xbar0, xbar1, radius_E2, radius_E4, funcrl, alpha0, alpha1;

  assign(x);
  
  xbar0 =   (x0 - xl) * CS + (x1 - yl) * SS;
  xbar1 = - (x0 - xl) * SS + (x1 - yl) * CS;  

  radius_E2 = (xbar0 * xbar0 + xbar1 * xbar1) / E2_rad;
  radius_E4 = radius_E2 * radius_E2;

  funcrl = (Prmt[7] * xbar1 - Prmt[8] * xbar0) / E_rad;

  alpha0 = xbar0 / radius_E2 + (2.0 * funcrl * xbar0) / radius_E4
    + parms[8] / (E_rad * radius_E2);
  alpha1 = xbar1 / radius_E2 + (2.0 * funcrl * xbar1) / radius_E4
    - parms[7] / (E_rad * radius_E2);

  Y_x[i] = B1 * xbar0 + B3 * xbar1 - alpha0;
  Y_y[i] = B2 * xbar1 + B3 * xbar0 - alpha1;
}       

