#include <stdlib.h>
#include <string.h>

// #include <forms.h>


#include "forms.h"
#include "glform.h"
#include "glxf.h"

/*

static int border0 = FL_NOBORDER; 
static int border  = FL_TRANSIENT;

**/

static int border2 = FL_FULLBORDER;

// char *fname = "m45.jpg";

char *fname;

FD_GLcp *Panel;
FD_Help *Help;
FD_Oposition *Oposition;
FD_Optimum *Optimum;
FD_Roots *Roots;
FD_Parametres *Parametres;
FD_track *Track;
FD_Model_Pars_Ellip *Elliptic;
FD_Model_Pars_Multi *Multi;
FD_Model_Pars_SIS *SIS;
FD_Model_Pars_NSIS *NSIS;
FD_Model_Pars_Sphere *Sphere;
FD_Model_Pars_Spiral *Spiral_M;
FD_Model_Pars_Chang *Chang;
FD_Model_Pars_Double *Double;
FD_Model_Pars_Second *Second;
FD_Model_Pars_Rot *Rotation;
FD_Model_Pars_Hubble *Hubble;
FD_Model_Pars_King *King;
FD_Model_Pars_TKing *TKing;
FD_Model_Pars_DeVau *DeVau;
FD_Model_Pars_Uring *Uring;

/* callbacks and freeobj handles for form GLcp */

void cb_source_pos(FL_OBJECT *ob, long data)
{
  FD_GLcp *main_form = (FD_GLcp *)data;
  
  if(ob == (main_form->x_pos)) {
    fl_set_positioner_xvalue(main_form->source_pos,
			     fl_get_counter_value(ob));
  } else if(ob == (main_form->y_pos)) {
    fl_set_positioner_yvalue(main_form->source_pos,
			     fl_get_counter_value(ob));
  } else if (ob == (main_form->source_pos)) {
    fl_set_counter_value(main_form->x_pos,
			 fl_get_positioner_xvalue(ob));
    fl_set_counter_value(main_form->y_pos,
			 fl_get_positioner_yvalue(ob));
  }

  source_position.x = fl_get_counter_value(main_form->x_pos);
  source_position.y = fl_get_counter_value(main_form->y_pos);

  Y[0] = source_position.x;
  Y[1] = source_position.y;

  /* Refresh */

  handle_expose(0, 0); 
} 

void cb_parameters(FL_OBJECT *ob, long parameter)
{
  parms[parameter] = fl_get_slider_value(ob);

  /*
    
  switch(parameter) {
  case P_THETA:
  case P_PHI:
  case P_PHI2:
    parms[parameter] *= M_PI / 180.0;

    break;
  default:
    break;
  }

  */
  
  /* Refresh */

  handle_expose(0, 0);
}

void cb_presicion(FL_OBJECT *ob, long data)
{
  precision = (int) fl_get_counter_value(ob);

  /* Refresh */

  handle_expose(0, 0); 
}

void cb_switches(FL_OBJECT *ob, long which_switch)
{
  /*
    
  if(fl_get_button(ob)) {
    if(source_figure == F_IMAGE) {
      printf("Press the Image button after you had chosen the image file. \n");
      printf("Choose the image file with the Image File button. \n");
      printf("The program crashes if you press the Image button after \n");
      printf("you have chosen the source with the Source Menu. \n");
    } 
  }

  **/
  
  if(fl_get_button(ob)) {
    switches |= which_switch;
  } else {
    switches &= ~which_switch;
  }
  
  /* Refresh */

  handle_expose(0, 0); 
}

void cb_cc_caustic(FL_OBJECT *ob, long which_cocc)
{
  /*

  critical();
  caustic();

  */

  printf("Not yet implemented \n");
}

void cb_light_curve(FL_OBJECT *ob, long which_curve)
{
  printf("Not yet implemented \n");
}

void cb_time_delay(FL_OBJECT *ob, long which_td)
{
  extern void draw_contour_td();

  draw_contour_td();
}

void load_file(FL_OBJECT *ob, long arg)
{
  fname = (char *) fl_show_file_selector("File To Load", "", "*", "");

  // fl_activate_object(GLcp->images);
}

void cb_sources(FL_OBJECT *ob, long data)
{
  source_figure = fl_get_menu(ob);

  switch(source_figure) {
  case F_MODEL:
    
    break;
  case F_FULL_CIRCLE:
    
    break;
  case F_RINGS:

    break;
  case F_IMAGE:

    break;
  default:
    break;
  }
}

void cb_images(FL_OBJECT *ob, long data)
{
  source_figure = fl_get_menu(ob);

  switch(source_figure) {
  case F_MODEL:
    
    break;
  case F_FULL_CIRCLE:
    
    break;
  case F_RINGS:

    break;
  case F_IMAGE:

    break;
  default:
    break;
  }
}

void cb_save(FL_OBJECT *ob, long data)
{
  current_save = fl_get_menu(ob);

  switch(current_save) {
  case 1:
    system("xv &"); 
    break;
  case 2:
    system("display"); 
    break;
  case 3:
    system("/usr/local/bin/gimp &"); 
    break;
  case 4:
    system("snapshot &"); 
    break;
  default:
    break;
  }
}

void cb_exit(FL_OBJECT *ob, long data)
{  
 fl_finish();
 exit(0); 
}

void cb_model(FL_OBJECT *ob, long data)
{
  FD_GLcp *main_form = (FD_GLcp *) data;

  current_model = fl_get_choice(ob) - 1; 

  fl_hide_object(main_form->p_E);
  fl_hide_object(main_form->p_theta);
  fl_hide_object(main_form->p_gamma);
  fl_hide_object(main_form->p_sigma);
  fl_hide_object(main_form->p_phi);
  fl_hide_object(main_form->p_R);
  fl_hide_object(main_form->p_C);  
  fl_hide_object(main_form->p_xt);  
  fl_hide_object(main_form->p_doublelens_model);
  fl_hide_object(main_form->p_rotationlens_model);
  fl_hide_object(main_form->p_quadrupole_model);
  fl_hide_object(main_form->p_elliptical_model);
  fl_hide_object(main_form->p_kappa);
  fl_hide_object(main_form->p_kappa2);
  fl_hide_object(main_form->p_alpha);  
  fl_hide_object(main_form->p_alpha2); 
  fl_hide_object(main_form->p_alpha3); 
  fl_hide_object(main_form->p_epsilon);
  fl_hide_object(main_form->p_epsilon2);
  fl_hide_object(main_form->p_epsilon3);
  fl_hide_object(main_form->p_exp);
  fl_hide_object(main_form->p_ko);
  fl_hide_object(main_form->p_uniform_ring);    
  fl_hide_object(main_form->p_elliptical_kk);    

  switch(current_model) {
  case M_MODEL_MENU:
    break;
  case M_CHANG_REFSDAL:    
    fl_show_object(main_form->p_E);
    fl_show_object(main_form->p_theta);
    fl_show_object(main_form->p_gamma);
    fl_show_object(main_form->p_sigma);
    fl_show_object(main_form->p_phi);
    fl_show_object(main_form->p_R);
    break;    
  case M_SECOND:    
    fl_show_object(main_form->p_E);
    fl_show_object(main_form->p_theta);
    fl_show_object(main_form->p_gamma);
    fl_show_object(main_form->p_sigma);
    fl_show_object(main_form->p_phi);
    fl_show_object(main_form->p_R);
    fl_show_object(main_form->p_ko);
    break;    
  case M_SING_ISOT_SPHERE:
    fl_show_object(main_form->p_E);
    fl_show_object(main_form->p_theta);
    fl_show_object(main_form->p_gamma);
    fl_show_object(main_form->p_sigma);
    fl_show_object(main_form->p_phi);
    fl_show_object(main_form->p_R);
    fl_show_object(main_form->p_exp);
    break;
  case M_DE_VAUCOULEUR:
  case M_KING: 
  case M_HUBBLE:
  case M_N_F_W:
    fl_show_object(main_form->p_E);
    fl_show_object(main_form->p_theta);
    fl_show_object(main_form->p_gamma);
    fl_show_object(main_form->p_sigma);
    fl_show_object(main_form->p_phi);
    fl_show_object(main_form->p_R);
    fl_show_object(main_form->p_kappa);
    break;
  case M_SPIRAL:
    fl_show_object(main_form->p_E);
    fl_show_object(main_form->p_theta);
    fl_show_object(main_form->p_gamma);
    fl_show_object(main_form->p_sigma);
    fl_show_object(main_form->p_phi);
    fl_show_object(main_form->p_R);
    fl_show_object(main_form->p_kappa);
    fl_show_object(main_form->p_alpha2);                     
    break;    
  case M_TRUNC_KING:
    fl_show_object(main_form->p_E);
    fl_show_object(main_form->p_theta);
    fl_show_object(main_form->p_gamma);
    fl_show_object(main_form->p_sigma);
    fl_show_object(main_form->p_phi);
    fl_show_object(main_form->p_R);
    fl_show_object(main_form->p_C);                     
    fl_show_object(main_form->p_kappa2);
    break;    
  case M_NSING_ISOT_SPHERE:
    fl_show_object(main_form->p_E);
    fl_show_object(main_form->p_theta);
    fl_show_object(main_form->p_gamma);
    fl_show_object(main_form->p_sigma);
    fl_show_object(main_form->p_phi);
    fl_show_object(main_form->p_R);
    fl_show_object(main_form->p_C);                     
    fl_show_object(main_form->p_kappa);
    break;
  case M_TRANSP_SPHERE:
    fl_show_object(main_form->p_E);
    fl_show_object(main_form->p_theta);
    fl_show_object(main_form->p_gamma);
    fl_show_object(main_form->p_sigma);
    fl_show_object(main_form->p_phi);
    fl_show_object(main_form->p_R);
    fl_show_object(main_form->p_C);                     
    break;
  case M_ELLIPTICAL:
    fl_show_object(main_form->p_E);
    fl_show_object(main_form->p_theta);
    fl_show_object(main_form->p_gamma);
    fl_show_object(main_form->p_sigma);
    fl_show_object(main_form->p_phi);
    fl_show_object(main_form->p_R);        
    fl_show_object(main_form->p_C);        
    fl_show_object(main_form->p_kappa);
    fl_show_object(main_form->p_elliptical_model);
    break;            
  case M_MULTIPOLE:
    fl_show_object(main_form->p_E);
    fl_show_object(main_form->p_theta);
    fl_show_object(main_form->p_gamma);
    fl_show_object(main_form->p_sigma);
    fl_show_object(main_form->p_phi);
    fl_show_object(main_form->p_R);        
    fl_show_object(main_form->p_quadrupole_model);
    break;
  case M_ROTATION_LENS:
    fl_show_object(main_form->p_E);
    fl_show_object(main_form->p_theta);
    fl_show_object(main_form->p_gamma);
    fl_show_object(main_form->p_sigma);
    fl_show_object(main_form->p_phi);
    fl_show_object(main_form->p_R);        
    fl_show_object(main_form->p_rotationlens_model);
    break;
  case M_DOUBLE_LENS:
    fl_show_object(main_form->p_E);
    fl_show_object(main_form->p_theta);
    fl_show_object(main_form->p_gamma);
    fl_show_object(main_form->p_sigma);
    fl_show_object(main_form->p_phi);
    fl_show_object(main_form->p_R);    
    fl_show_object(main_form->p_doublelens_model);    
    break;    
  case M_UNIFORM_RING:
    fl_show_object(main_form->p_E);
    fl_show_object(main_form->p_theta);
    fl_show_object(main_form->p_gamma);
    fl_show_object(main_form->p_sigma);
    fl_show_object(main_form->p_phi);
    fl_show_object(main_form->p_R);
    fl_show_object(main_form->p_kappa);
    fl_show_object(main_form->p_uniform_ring);    
    break;
  case M_ELL_SIS_KK:
    fl_show_object(main_form->p_E);
    fl_show_object(main_form->p_theta);
    fl_show_object(main_form->p_gamma);
    fl_show_object(main_form->p_sigma);
    fl_show_object(main_form->p_phi);
    fl_show_object(main_form->p_R);
    fl_show_object(main_form->p_kappa);
    fl_show_object(main_form->p_epsilon3);
    break;
  case M_ELL_KING:
  case M_ELL_HUBBLE:  
  case M_ELL_NIS:
  case M_ELL_PLUMMER:
    fl_show_object(main_form->p_E);
    fl_show_object(main_form->p_theta);
    fl_show_object(main_form->p_gamma);
    fl_show_object(main_form->p_sigma);
    fl_show_object(main_form->p_phi);
    fl_show_object(main_form->p_R);
    fl_show_object(main_form->p_C);        
    fl_show_object(main_form->p_kappa);
    fl_show_object(main_form->p_epsilon2);
    break;
  case M_ELL_KK:
    fl_show_object(main_form->p_E);
    fl_show_object(main_form->p_theta);
    fl_show_object(main_form->p_gamma);
    fl_show_object(main_form->p_sigma);
    fl_show_object(main_form->p_phi);
    fl_show_object(main_form->p_R);
    fl_show_object(main_form->p_C);        
    fl_show_object(main_form->p_kappa);
    fl_show_object(main_form->p_elliptical_kk);    
    break;
  case M_BARKANA:
    fl_show_object(main_form->p_E);
    fl_show_object(main_form->p_theta);
    fl_show_object(main_form->p_gamma);
    fl_show_object(main_form->p_sigma);
    fl_show_object(main_form->p_phi);
    fl_show_object(main_form->p_R);
    fl_show_object(main_form->p_C);        
    fl_show_object(main_form->p_kappa);
    fl_show_object(main_form->p_alpha3); 
    fl_show_object(main_form->p_epsilon2);                    
    break;
  default:
    break;
  }

  /* Refresh */

  handle_expose(0, 0); 
}

void cb_source(FL_OBJECT *ob, long data)
{
  source_figure = fl_get_choice(ob) - 1;

  /* Refresh */

  handle_expose(0, 0); 
}

void image_win(FL_OBJECT *ob, long data) 
{  
  if(fl_get_button(ob)) {
    fl_winshow(GLwin);
  } else {
    fl_winhide(GLwin);
  }
}

void model_params(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  char s1[10], s2[10], s3[10], s4[10], s5[10], s6[10], s7[10], s8[10];
  char s9[10], s10[10], s11[10], s12[10], s13[10], s14[10], s15[10], s16[10];
  char s17[10], s18[10], s19[10], s20[10], s21[10], s22[10], s23[10], s24[10];
  char s25[10], s26[10], s27[10], s28[10], s29[10], s30[10], s31[10], s32[10];
  char s33[10], s34[10], s35[10], s36[10], s37[10], s38[10], s39[10], s40[10];
  
  // Parametres = create_form_Parametres();

  switch(current_model) {
  case M_MODEL_MENU:
    Parametres = create_form_Parametres();

    if(fl_mouse_button()) {
      //                             FL_PLACE_MOUSE|FL_FREE_SIZE,
      
      fl_prepare_form_window(Parametres->Parameters, FL_PLACE_GEOMETRY, 
			     border2, "Parametres Window");

      fl_show_form_window(Parametres->Parameters);
    }

    sprintf(s1, "%g", Y[0]);
    fl_set_input(Parametres->input_x, s1);  
  
    sprintf(s2, "%g", Y[1]);
    fl_set_input(Parametres->input_y, s2);  

    sprintf(s3, "%g", parms[P_E]);
    fl_set_input(Parametres->input_E, s3);  

    // sprintf(s4, "%g", (180.0 * parms[P_THETA]) / M_PI);

    sprintf(s4, "%g", parms[P_THETA]);
    fl_set_input(Parametres->input_theta, s4);  

    sprintf(s5, "%g", parms[P_GAMMA]);
    fl_set_input(Parametres->input_gamma, s5);  

    sprintf(s6, "%g", parms[P_SIGMA]);
    fl_set_input(Parametres->input_sigma, s6);  

    // sprintf(s7, "%g", (180.0 * parms[P_PHI]) / M_PI);

    sprintf(s7, "%g", parms[P_PHI]);
    fl_set_input(Parametres->input_phi, s7);  

    sprintf(s8, "%g", parms[P_KAPPA]);
    fl_set_input(Parametres->input_kappa, s8);  

    sprintf(s9, "%g", parms[P_EPSILON]);
    fl_set_input(Parametres->input_epsilon, s9);

    // sprintf(s10, "%g", (180.0 * parms[P_PHI2]) / M_PI);

    sprintf(s10, "%g", parms[P_C]);
    fl_set_input(Parametres->input_C, s10);  

    sprintf(s11, "%g", parms[P_X_1]);
    fl_set_input(Parametres->input_x1, s11);  

    sprintf(s12, "%g", parms[P_Y_1]);
    fl_set_input(Parametres->input_y1, s12);  

    sprintf(s13, "%g", parms[P_X_1]);
    fl_set_input(Parametres->input_x2, s13);  

    sprintf(s14, "%g", parms[P_Y_2]);
    fl_set_input(Parametres->input_y2, s14);  

    sprintf(s15, "%g", parms[P_M_1]);
    fl_set_input(Parametres->input_m1, s15);  

    sprintf(s16, "%g", parms[P_M_2]);
    fl_set_input(Parametres->input_m2, s16);  

    sprintf(s17, "%g", parms[P_BETA]);
    fl_set_input(Parametres->input_beta, s17);  

    sprintf(s18, "%g", parms[P_SIGMA2]);
    fl_set_input(Parametres->input_C, s18);  

    sprintf(s19, "%g", parms[P_Ri]);
    fl_set_input(Parametres->input_ri, s19);  

    sprintf(s20, "%g", parms[P_Ro]);
    fl_set_input(Parametres->input_ro, s20);  

    sprintf(s21, "%g", parms[P_X_1]);
    fl_set_input(Parametres->input_x1, s21);  

    sprintf(s22, "%g", parms[P_Y_1]);
    fl_set_input(Parametres->input_y1, s22);  

    sprintf(s23, "%g", parms[P_M_1]);
    fl_set_input(Parametres->input_m1, s23);  

    sprintf(s24, "%g", parms[P_X_2]);
    fl_set_input(Parametres->input_x2, s24);  

    sprintf(s25, "%g", parms[P_Y_2]);  
    fl_set_input(Parametres->input_y2, s25);

    sprintf(s26, "%g", parms[P_M_2]);
    fl_set_input(Parametres->input_m2, s26);  

    sprintf(s27, "%g", parms[P_DX_QP]);
    fl_set_input(Parametres->input_dx, s27);  

    sprintf(s28, "%g", parms[P_DY_QP]);
    fl_set_input(Parametres->input_dy, s28);  

    sprintf(s29, "%g", parms[P_QXX]);
    fl_set_input(Parametres->input_qxx, s29);  

    sprintf(s30, "%g", parms[P_QXY]);
    fl_set_input(Parametres->input_qxy, s30);  

    sprintf(s31, "%g", parms[P_QYY]);
    fl_set_input(Parametres->input_qyy, s31);  

    sprintf(s32, "%g", parms[P_SX]);
    fl_set_input(Parametres->input_sx, s32);  

    sprintf(s33, "%g", parms[P_SY]);
    fl_set_input(Parametres->input_sy, s33);  

    sprintf(s34, "%g", parms[P_EXP]);
    fl_set_input(Parametres->input_exp, s34);  

    sprintf(s35, "%g", parms[P_ALPHA3]);
    fl_set_input(Parametres->input_exp, s35);  

    sprintf(s36, "%g", parms[P_Ko]);
    fl_set_input(Parametres->input_exp, s36);  

    sprintf(s37, "%g", parms[P_THETA_INC]);
    fl_set_input(Parametres->input_exp, s37);  

    sprintf(s38, "%g", parms[P_Q3]);
    fl_set_input(Parametres->input_exp, s38);  

    sprintf(s39, "%g", parms[P_EPSILON2]);
    fl_set_input(Parametres->input_exp, s39);  

    sprintf(s40, "%g", parms[P_EPSILON3]);
    fl_set_input(Parametres->input_exp, s40);  

    //    fl_deactivate_object(GLcp->model_ps);

    break;
  case M_CHANG_REFSDAL:    
    Chang = create_form_Model_Pars_Chang();

    if(fl_mouse_button()) {
      //                             FL_PLACE_MOUSE|FL_FREE_SIZE,
      
      fl_prepare_form_window(Chang->Model_Pars_Chang, FL_PLACE_GEOMETRY, 
			     border2, "Parametres Window");

      // fl_scale_form(Chang->Model_Pars_Chang, 0.8, 0.8);
      
      fl_show_form_window(Chang->Model_Pars_Chang);
    }
    
    sprintf(s1, "%g", Y[0]);
    fl_set_input(Chang->input_x, s1);

    sprintf(s2, "%g", Y[1]);
    fl_set_input(Chang->input_y, s2);  

    sprintf(s3, "%g", parms[P_E]);
    fl_set_input(Chang->input_E, s3);  

    sprintf(s4, "%g", parms[P_THETA]);
    fl_set_input(Chang->input_theta, s4);  

    sprintf(s5, "%g", parms[P_GAMMA]);
    fl_set_input(Chang->input_gamma, s5);  

    sprintf(s6, "%g", parms[P_SIGMA]);
    fl_set_input(Chang->input_sigma, s6);  

    // sprintf(s7, "%g", (180.0 * parms[P_PHI]) / M_PI);

    sprintf(s7, "%g", parms[P_PHI]);
    fl_set_input(Chang->input_phi, s7);  

    //    fl_deactivate_object(GLcp->model_ps);
    
    break;
  case M_SING_ISOT_SPHERE:
    SIS = create_form_Model_Pars_SIS();

    if(fl_mouse_button()) {
      //                             FL_PLACE_MOUSE|FL_FREE_SIZE,
      
      fl_prepare_form_window(SIS->Model_Pars_SIS, FL_PLACE_GEOMETRY, 
			     border2, "Parametres Window");

      fl_show_form_window(SIS->Model_Pars_SIS);
    }

    sprintf(s1, "%g", Y[0]);
    fl_set_input(SIS->input_x, s1);

    sprintf(s2, "%g", Y[1]);
    fl_set_input(SIS->input_y, s2);  

    sprintf(s3, "%g", parms[P_E]);
    fl_set_input(SIS->input_E, s3);  

    sprintf(s4, "%g", parms[P_THETA]);
    fl_set_input(SIS->input_theta, s4);  

    sprintf(s5, "%g", parms[P_GAMMA]);
    fl_set_input(SIS->input_gamma, s5);  

    sprintf(s6, "%g", parms[P_SIGMA]);
    fl_set_input(SIS->input_sigma, s6);  

    // sprintf(s7, "%g", (180.0 * parms[P_PHI]) / M_PI);

    sprintf(s7, "%g", parms[P_PHI]);
    fl_set_input(SIS->input_phi, s7);  
    
    sprintf(s34, "%g", parms[P_EXP]);
    fl_set_input(SIS->input_exp, s34);  

    //    fl_deactivate_object(GLcp->model_ps);
    
    break;
  case M_DE_VAUCOULEUR:
    DeVau = create_form_Model_Pars_DeVau();

    if(fl_mouse_button()) {
      //                             FL_PLACE_MOUSE|FL_FREE_SIZE,
      
      fl_prepare_form_window(DeVau->Model_Pars_DeVau, FL_PLACE_GEOMETRY,
                             border2, "Parametres Window");

      fl_show_form_window(DeVau->Model_Pars_DeVau);
    }
    
    sprintf(s1, "%g", Y[0]);
    fl_set_input(DeVau->input_x, s1);

    sprintf(s2, "%g", Y[1]);
    fl_set_input(DeVau->input_y, s2);  

    sprintf(s3, "%g", parms[P_E]);
    fl_set_input(DeVau->input_E, s3);  

    sprintf(s4, "%g", parms[P_THETA]);
    fl_set_input(DeVau->input_theta, s4);  

    sprintf(s5, "%g", parms[P_GAMMA]);
    fl_set_input(DeVau->input_gamma, s5);  

    sprintf(s6, "%g", parms[P_SIGMA]);
    fl_set_input(DeVau->input_sigma, s6);  

    // sprintf(s7, "%g", (180.0 * parms[P_PHI]) / M_PI);

    sprintf(s7, "%g", parms[P_PHI]);
    fl_set_input(DeVau->input_phi, s7);  

    sprintf(s13, "%g", parms[P_KAPPA]);
    fl_set_input(DeVau->input_kappa, s13);  

    //    fl_deactivate_object(GLcp->model_ps);

    break;
  case M_KING:
    King = create_form_Model_Pars_King();

    if(fl_mouse_button()) {
      //                             FL_PLACE_MOUSE|FL_FREE_SIZE,
      
      fl_prepare_form_window(King->Model_Pars_King, FL_PLACE_GEOMETRY,
                             border2, "Parametres Window");

      fl_show_form_window(King->Model_Pars_King);
    }

    sprintf(s1, "%g", Y[0]);
    fl_set_input(King->input_x, s1);

    sprintf(s2, "%g", Y[1]);
    fl_set_input(King->input_y, s2);  

    sprintf(s3, "%g", parms[P_E]);
    fl_set_input(King->input_E, s3);  

    sprintf(s4, "%g", parms[P_THETA]);
    fl_set_input(King->input_theta, s4);  

    sprintf(s5, "%g", parms[P_GAMMA]);
    fl_set_input(King->input_gamma, s5);  

    sprintf(s6, "%g", parms[P_SIGMA]);
    fl_set_input(King->input_sigma, s6);  

    // sprintf(s7, "%g", (180.0 * parms[P_PHI]) / M_PI);

    sprintf(s7, "%g", parms[P_PHI]);
    fl_set_input(King->input_phi, s7);  

    sprintf(s13, "%g", parms[P_KAPPA]);
    fl_set_input(King->input_kappa, s13);  

    //    fl_deactivate_object(GLcp->model_ps);
    
    break;
  case M_HUBBLE:
    Hubble = create_form_Model_Pars_Hubble();

    if(fl_mouse_button()) {
      //                             FL_PLACE_MOUSE|FL_FREE_SIZE,
      
      fl_prepare_form_window(Hubble->Model_Pars_Hubble, FL_PLACE_GEOMETRY,
                             border2, "Parametres Window");

      fl_show_form_window(Hubble->Model_Pars_Hubble);
    }

    sprintf(s1, "%g", Y[0]);
    fl_set_input(Hubble->input_x, s1);

    sprintf(s2, "%g", Y[1]);
    fl_set_input(Hubble->input_y, s2);  

    sprintf(s3, "%g", parms[P_E]);
    fl_set_input(Hubble->input_E, s3);  

    sprintf(s4, "%g", parms[P_THETA]);
    fl_set_input(Hubble->input_theta, s4);  

    sprintf(s5, "%g", parms[P_GAMMA]);
    fl_set_input(Hubble->input_gamma, s5);  

    sprintf(s6, "%g", parms[P_SIGMA]);
    fl_set_input(Hubble->input_sigma, s6);  

    // sprintf(s7, "%g", (180.0 * parms[P_PHI]) / M_PI);

    sprintf(s7, "%g", parms[P_PHI]);
    fl_set_input(Hubble->input_phi, s7);  

    sprintf(s13, "%g", parms[P_KAPPA]);
    fl_set_input(Hubble->input_kappa, s13);  

    //    fl_deactivate_object(GLcp->model_ps);

    break;
  case M_SPIRAL:
    Spiral_M = create_form_Model_Pars_Spiral();

    if(fl_mouse_button()) {
      //                             FL_PLACE_MOUSE|FL_FREE_SIZE,
      
      fl_prepare_form_window(Spiral_M->Model_Pars_Spiral, FL_PLACE_GEOMETRY,
                             border2, "Parametres Window");

      fl_show_form_window(Spiral_M->Model_Pars_Spiral);
    }

    sprintf(s1, "%g", Y[0]);
    fl_set_input(Spiral_M->input_x, s1);

    sprintf(s2, "%g", Y[1]);
    fl_set_input(Spiral_M->input_y, s2);  

    sprintf(s3, "%g", parms[P_E]);
    fl_set_input(Spiral_M->input_E, s3);  

    sprintf(s4, "%g", parms[P_THETA]);
    fl_set_input(Spiral_M->input_theta, s4);  

    sprintf(s5, "%g", parms[P_GAMMA]);
    fl_set_input(Spiral_M->input_gamma, s5);  

    sprintf(s6, "%g", parms[P_SIGMA]);
    fl_set_input(Spiral_M->input_sigma, s6);  

    // sprintf(s7, "%g", (180.0 * parms[P_PHI]) / M_PI);

    sprintf(s7, "%g", parms[P_PHI]);
    fl_set_input(Spiral_M->input_phi, s7);  

    sprintf(s13, "%g", parms[P_KAPPA]);
    fl_set_input(Spiral_M->input_kappa, s13);  

    sprintf(s12, "%g", parms[P_ALPHA2]);
    fl_set_input(Spiral_M->input_alpha2, s12);  

    //    fl_deactivate_object(GLcp->model_ps);

    break;
  case M_TRUNC_KING:
    TKing = create_form_Model_Pars_TKing();

    if(fl_mouse_button()) {
      //                             FL_PLACE_MOUSE|FL_FREE_SIZE,
      
      fl_prepare_form_window(TKing->Model_Pars_TKing, FL_PLACE_GEOMETRY,
                             border2, "Parametres Window");

      fl_show_form_window(TKing->Model_Pars_TKing);
    }

    sprintf(s1, "%g", Y[0]);
    fl_set_input(TKing->input_x, s1);

    sprintf(s2, "%g", Y[1]);
    fl_set_input(TKing->input_y, s2);  

    sprintf(s3, "%g", parms[P_E]);
    fl_set_input(TKing->input_E, s3);  

    sprintf(s4, "%g", parms[P_THETA]);
    fl_set_input(TKing->input_theta, s4);  

    sprintf(s5, "%g", parms[P_GAMMA]);
    fl_set_input(TKing->input_gamma, s5);  

    sprintf(s6, "%g", parms[P_SIGMA]);
    fl_set_input(TKing->input_sigma, s6);  

    // sprintf(s7, "%g", (180.0 * parms[P_PHI]) / M_PI);

    sprintf(s7, "%g", parms[P_PHI]);
    fl_set_input(TKing->input_phi, s7);  

    sprintf(s15, "%g", parms[P_KAPPA2]);
    fl_set_input(TKing->input_kappa2, s15);  

    sprintf(s18, "%g", parms[P_C]);
    fl_set_input(TKing->input_C, s18);  

    //    fl_deactivate_object(GLcp->model_ps);

    break;
  case M_NSING_ISOT_SPHERE:
    NSIS = create_form_Model_Pars_NSIS();

    if(fl_mouse_button()) {
      //                             FL_PLACE_MOUSE|FL_FREE_SIZE,
      
      fl_prepare_form_window(NSIS->Model_Pars_NSIS, FL_PLACE_GEOMETRY,
                             border2, "Parametres Window");

      fl_show_form_window(NSIS->Model_Pars_NSIS);
    }

    sprintf(s1, "%g", Y[0]);
    fl_set_input(NSIS->input_x, s1);

    sprintf(s2, "%g", Y[1]);
    fl_set_input(NSIS->input_y, s2);  

    sprintf(s3, "%g", parms[P_E]);
    fl_set_input(NSIS->input_E, s3);  

    sprintf(s4, "%g", parms[P_THETA]);
    fl_set_input(NSIS->input_theta, s4);  

    sprintf(s5, "%g", parms[P_GAMMA]);
    fl_set_input(NSIS->input_gamma, s5);  

    sprintf(s6, "%g", parms[P_SIGMA]);
    fl_set_input(NSIS->input_sigma, s6);  

    // sprintf(s7, "%g", (180.0 * parms[P_PHI]) / M_PI);

    sprintf(s7, "%g", parms[P_PHI]);
    fl_set_input(NSIS->input_phi, s7);  

    sprintf(s13, "%g", parms[P_KAPPA]);
    fl_set_input(NSIS->input_kappa, s13);  

    sprintf(s18, "%g", parms[P_C]);
    fl_set_input(NSIS->input_C, s18);  

    //    fl_deactivate_object(GLcp->model_ps);    

    break;
  case M_TRANSP_SPHERE:
    Sphere = create_form_Model_Pars_Sphere();

    if(fl_mouse_button()) {
      //                             FL_PLACE_MOUSE|FL_FREE_SIZE,
      
      fl_prepare_form_window(Sphere->Model_Pars_Sphere, FL_PLACE_GEOMETRY,
                             border2, "Parametres Window");

      fl_show_form_window(Sphere->Model_Pars_Sphere);
    }

    sprintf(s1, "%g", Y[0]);
    fl_set_input(Sphere->input_x, s1);

    sprintf(s2, "%g", Y[1]);
    fl_set_input(Sphere->input_y, s2);  

    sprintf(s3, "%g", parms[P_E]);
    fl_set_input(Sphere->input_E, s3);  

    sprintf(s4, "%g", parms[P_THETA]);
    fl_set_input(Sphere->input_theta, s4);  

    sprintf(s5, "%g", parms[P_GAMMA]);
    fl_set_input(Sphere->input_gamma, s5);  

    sprintf(s6, "%g", parms[P_SIGMA]);
    fl_set_input(Sphere->input_sigma, s6);  

    // sprintf(s7, "%g", (180.0 * parms[P_PHI]) / M_PI);

    sprintf(s7, "%g", parms[P_PHI]);
    fl_set_input(Sphere->input_phi, s7);  

    sprintf(s18, "%g", parms[P_C]);
    fl_set_input(Sphere->input_C, s18);  

    //    fl_deactivate_object(GLcp->model_ps);
    
    break;
  case M_ELLIPTICAL:
    Elliptic = create_form_Model_Pars_Ellip();

    if(fl_mouse_button()) {
      //                             FL_PLACE_MOUSE|FL_FREE_SIZE,

      fl_prepare_form_window(Elliptic->Model_Pars_Ellip, FL_PLACE_GEOMETRY,
                             border2, "Parametres Window");

      fl_show_form_window(Elliptic->Model_Pars_Ellip);
    }

    sprintf(s1, "%g", Y[0]);
    fl_set_input(Elliptic->input_x, s1);

    sprintf(s2, "%g", Y[1]);
    fl_set_input(Elliptic->input_y, s2);  

    sprintf(s3, "%g", parms[P_E]);
    fl_set_input(Elliptic->input_E, s3);  

    sprintf(s4, "%g", parms[P_THETA]);
    fl_set_input(Elliptic->input_theta, s4);  

    sprintf(s5, "%g", parms[P_GAMMA]);
    fl_set_input(Elliptic->input_gamma, s5);  

    sprintf(s6, "%g", parms[P_SIGMA]);
    fl_set_input(Elliptic->input_sigma, s6);  

    // sprintf(s7, "%g", (180.0 * parms[P_PHI]) / M_PI);

    sprintf(s7, "%g", parms[P_PHI]);
    fl_set_input(Elliptic->input_phi, s7);  

    sprintf(s13, "%g", parms[P_KAPPA]);
    fl_set_input(Elliptic->input_kappa, s13);  

    sprintf(s18, "%g", parms[P_C]);
    fl_set_input(Elliptic->input_C, s18);  

    sprintf(s16, "%g", parms[P_EPSILON]);
    fl_set_input(Elliptic->input_epsilon, s16);  

    sprintf(s11, "%g", parms[P_ALPHA]);
    fl_set_input(Elliptic->input_alpha, s11);  

    //    fl_deactivate_object(GLcp->model_ps);
    
    break;
  case M_MULTIPOLE:
    Multi = create_form_Model_Pars_Multi();

    if(fl_mouse_button()) {
      //                             FL_PLACE_MOUSE|FL_FREE_SIZE,
      
      fl_prepare_form_window(Multi->Model_Pars_Multi, FL_PLACE_GEOMETRY,
                             border2, "Parametres Window");

      fl_show_form_window(Multi->Model_Pars_Multi);
    }

    sprintf(s1, "%g", Y[0]);
    fl_set_input(Multi->input_x, s1);

    sprintf(s2, "%g", Y[1]);
    fl_set_input(Multi->input_y, s2);  

    sprintf(s3, "%g", parms[P_E]);
    fl_set_input(Multi->input_E, s3);  

    sprintf(s4, "%g", parms[P_THETA]);
    fl_set_input(Multi->input_theta, s4);  

    sprintf(s5, "%g", parms[P_GAMMA]);
    fl_set_input(Multi->input_gamma, s5);  

    sprintf(s6, "%g", parms[P_SIGMA]);
    fl_set_input(Multi->input_sigma, s6);  

    // sprintf(s7, "%g", (180.0 * parms[P_PHI]) / M_PI);

    sprintf(s7, "%g", parms[P_PHI]);
    fl_set_input(Multi->input_phi, s7);  

    sprintf(s14, "%g", parms[P_KAPPA0]);
    fl_set_input(Multi->input_kappa0, s14);  

    sprintf(s27, "%g", parms[P_DX_QP]);
    fl_set_input(Multi->input_dx, s27);  

    sprintf(s28, "%g", parms[P_DY_QP]);
    fl_set_input(Multi->input_dy, s28);  

    sprintf(s29, "%g", parms[P_QXX]);
    fl_set_input(Multi->input_qxx, s29);  

    sprintf(s30, "%g", parms[P_QXY]);
    fl_set_input(Multi->input_qxy, s30);  

    sprintf(s31, "%g", parms[P_QYY]);
    fl_set_input(Multi->input_qyy, s31);  

    //    fl_deactivate_object(GLcp->model_ps);
 
    break;
  case M_ROTATION_LENS:
    Rotation = create_form_Model_Pars_Rot();

    if(fl_mouse_button()) {
      //                             FL_PLACE_MOUSE|FL_FREE_SIZE,
      
      fl_prepare_form_window(Rotation->Model_Pars_Rot, FL_PLACE_GEOMETRY,
                             border2, "Parametres Window");

      fl_show_form_window(Rotation->Model_Pars_Rot);
    }

    sprintf(s1, "%g", Y[0]);
    fl_set_input(Rotation->input_x, s1);

    sprintf(s2, "%g", Y[1]);
    fl_set_input(Rotation->input_y, s2);  

    sprintf(s3, "%g", parms[P_E]);
    fl_set_input(Rotation->input_E, s3);  

    sprintf(s4, "%g", parms[P_THETA]);
    fl_set_input(Rotation->input_theta, s4);  

    sprintf(s5, "%g", parms[P_GAMMA]);
    fl_set_input(Rotation->input_gamma, s5);  

    sprintf(s6, "%g", parms[P_SIGMA]);
    fl_set_input(Rotation->input_sigma, s6);  

    // sprintf(s7, "%g", (180.0 * parms[P_PHI]) / M_PI);

    sprintf(s7, "%g", parms[P_PHI]);
    fl_set_input(Rotation->input_phi, s7);  

    sprintf(s32, "%g", parms[P_SX]);
    fl_set_input(Rotation->input_sx, s32);  

    sprintf(s33, "%g", parms[P_SY]);
    fl_set_input(Rotation->input_sy, s33);  

    //    fl_deactivate_object(GLcp->model_ps);
    
    break;
  case M_DOUBLE_LENS:
    Double = create_form_Model_Pars_Double();

    if(fl_mouse_button()) {
      //                             FL_PLACE_MOUSE|FL_FREE_SIZE,

      fl_prepare_form_window(Double->Model_Pars_Double, FL_PLACE_GEOMETRY,
                             border2, "Parametres Window");

      fl_show_form_window(Double->Model_Pars_Double);
    }

    sprintf(s1, "%g", Y[0]);
    fl_set_input(Double->input_x, s1);

    sprintf(s2, "%g", Y[1]);
    fl_set_input(Double->input_y, s2);  

    sprintf(s3, "%g", parms[P_E]);
    fl_set_input(Double->input_E, s3);  

    sprintf(s4, "%g", parms[P_THETA]);
    fl_set_input(Double->input_theta, s4);  

    sprintf(s5, "%g", parms[P_GAMMA]);
    fl_set_input(Double->input_gamma, s5);  

    sprintf(s6, "%g", parms[P_SIGMA]);
    fl_set_input(Double->input_sigma, s6);  

    // sprintf(s7, "%g", (180.0 * parms[P_PHI]) / M_PI);

    sprintf(s7, "%g", parms[P_PHI]);
    fl_set_input(Double->input_phi, s7);  

    sprintf(s8, "%g", parms[P_GAMMA2]);
    fl_set_input(Double->input_gamma2, s8);  

    sprintf(s9, "%g", parms[P_SIGMA2]);
    fl_set_input(Double->input_sigma2, s9);

    // sprintf(s10, "%g", (180.0 * parms[P_PHI2]) / M_PI);

    sprintf(s10, "%g", parms[P_PHI2]);
    fl_set_input(Double->input_phi2, s10);  

    sprintf(s17, "%g", parms[P_BETA]);
    fl_set_input(Double->input_beta, s17);  

    sprintf(s21, "%g", parms[P_X_1]);
    fl_set_input(Double->input_x1, s21);  
    
    sprintf(s22, "%g", parms[P_Y_1]);
    fl_set_input(Double->input_y1, s22);  

    sprintf(s23, "%g", parms[P_M_1]);
    fl_set_input(Double->input_m1, s23);  

    sprintf(s24, "%g", parms[P_X_2]);
    fl_set_input(Double->input_x2, s24);  

    sprintf(s25, "%g", parms[P_Y_2]);  
    fl_set_input(Double->input_y2, s25);

    sprintf(s26, "%g", parms[P_M_2]);
    fl_set_input(Double->input_m2, s26);  

    //    fl_deactivate_object(GLcp->model_ps);
    
    break;
  case M_UNIFORM_RING:
    Uring = create_form_Model_Pars_Uring();

    if(fl_mouse_button()) {
      //                             FL_PLACE_MOUSE|FL_FREE_SIZE,
      
      fl_prepare_form_window(Uring->Model_Pars_Uring, FL_PLACE_GEOMETRY,
                             border2, "Parametres Window");

      fl_show_form_window(Uring->Model_Pars_Uring);
    }

    sprintf(s1, "%g", Y[0]);
    fl_set_input(Uring->input_x, s1);

    sprintf(s2, "%g", Y[1]);
    fl_set_input(Uring->input_y, s2);  

    sprintf(s3, "%g", parms[P_E]);
    fl_set_input(Uring->input_E, s3);  

    sprintf(s4, "%g", parms[P_THETA]);
    fl_set_input(Uring->input_theta, s4);  

    sprintf(s5, "%g", parms[P_GAMMA]);
    fl_set_input(Uring->input_gamma, s5);  

    sprintf(s6, "%g", parms[P_SIGMA]);
    fl_set_input(Uring->input_sigma, s6);  

    // sprintf(s7, "%g", (180.0 * parms[P_PHI]) / M_PI);

    sprintf(s7, "%g", parms[P_PHI]);
    fl_set_input(Uring->input_phi, s7);  

    sprintf(s13, "%g", parms[P_KAPPA]);
    fl_set_input(Uring->input_kappa, s13);  

    sprintf(s19, "%g", parms[P_Ri]);
    fl_set_input(Uring->input_ri, s19);  

    sprintf(s20, "%g", parms[P_Ro]);
    fl_set_input(Uring->input_ro, s20);  

    //    fl_deactivate_object(GLcp->model_ps);

    break;
  case M_SECOND:
    
    break;
  case M_ELL_SIS_KK:

    break;
  case M_ELL_KING:       

    break;
  case M_ELL_HUBBLE:           

    break;
  case M_ELL_NIS:

    break;
  case M_ELL_PLUMMER:

    break;
  case M_ELL_KK:  

    break; 
 case M_N_F_W:

    break;
  case M_BARKANA:  

    break;
  default:
    break;
  }
  
  /*  if(fl_get_button(ob)) { 
        fl_show_form(Parametres->Parameters, FL_PLACE_MOUSE|FL_FREE_SIZE,
                     border2, "Parametres Window"); */

  /*
    
  if(fl_mouse_button()) {
    fl_prepare_form_window(Parametres->Parameters,
                           FL_PLACE_MOUSE|FL_FREE_SIZE,
                           border2, "Parametres Window");

    fl_show_form_window(Parametres->Parameters);
  }

  **/

  fl_deactivate_object(GLcp->model_ps);

  /* Refresh */     

  /* handle_expose(0, 0); */

  glXSwapBuffers(fl_display, GLwin);
}

void set_par(FL_OBJECT *ob, long data)
{
  switch(current_model) {
  case M_MODEL_MENU:
    Y[0]             = atof(fl_get_input(Parametres->input_x));  
    Y[1]             = atof(fl_get_input(Parametres->input_y));  
    parms[P_E]       = atof(fl_get_input(Parametres->input_E));

    parms[P_THETA]   = atof(fl_get_input(Parametres->input_theta));  

    parms[P_GAMMA]   = atof(fl_get_input(Parametres->input_gamma));
    parms[P_SIGMA]   = atof(fl_get_input(Parametres->input_sigma));

    parms[P_PHI]     = atof(fl_get_input(Parametres->input_phi));  

    parms[P_GAMMA2]  = atof(fl_get_input(Parametres->input_gamma2));
    parms[P_SIGMA2]  = atof(fl_get_input(Parametres->input_sigma2));

    parms[P_PHI2]    = atof(fl_get_input(Parametres->input_phi2));

    parms[P_ALPHA]   = atof(fl_get_input(Parametres->input_alpha));
    parms[P_ALPHA2]  = atof(fl_get_input(Parametres->input_alpha2));  
    parms[P_KAPPA]   = atof(fl_get_input(Parametres->input_kappa));
    parms[P_KAPPA0]  = atof(fl_get_input(Parametres->input_kappa0));
    parms[P_KAPPA2]  = atof(fl_get_input(Parametres->input_kappa2));
    parms[P_EPSILON] = atof(fl_get_input(Parametres->input_epsilon));
    parms[P_BETA]    = atof(fl_get_input(Parametres->input_beta));
    parms[P_C]       = atof(fl_get_input(Parametres->input_C));
    parms[P_Ri]      = atof(fl_get_input(Parametres->input_ri));
    parms[P_Ro]      = atof(fl_get_input(Parametres->input_ro));
    parms[P_X_1]     = atof(fl_get_input(Parametres->input_x1));
    parms[P_Y_1]     = atof(fl_get_input(Parametres->input_y1));
    parms[P_M_1]     = atof(fl_get_input(Parametres->input_m1));
    parms[P_X_2]     = atof(fl_get_input(Parametres->input_x2));
    parms[P_Y_2]     = atof(fl_get_input(Parametres->input_y2));
    parms[P_M_2]     = atof(fl_get_input(Parametres->input_m2));
    parms[P_DX_QP]   = atof(fl_get_input(Parametres->input_dx));
    parms[P_DY_QP]   = atof(fl_get_input(Parametres->input_dy));
    parms[P_QXX]     = atof(fl_get_input(Parametres->input_qxx));
    parms[P_QXY]     = atof(fl_get_input(Parametres->input_qxy));
    parms[P_QYY]     = atof(fl_get_input(Parametres->input_qyy));
    parms[P_SX]      = atof(fl_get_input(Parametres->input_sx));
    parms[P_SY]      = atof(fl_get_input(Parametres->input_sy));
    parms[P_EXP]     = atof(fl_get_input(Parametres->input_exp));

    fl_set_positioner_xvalue(GLcp->source_pos, Y[0]);
    fl_set_positioner_yvalue(GLcp->source_pos, Y[1]);

    // fl_set_positioner_xvalue(GLcp->lens_pos, 0.0);
    // fl_set_positioner_yvalue(GLcp->lens_pos, 0.0);

    fl_set_counter_value(GLcp->x_pos, Y[0]);
    fl_set_counter_value(GLcp->y_pos, Y[1]);
  
    fl_set_slider_value(GLcp->p_E, parms[P_E]);
  
    // fl_set_slider_value(GLcp->p_theta, (180.0 * parms[P_THETA]) / M_PI); 

    fl_set_slider_value(GLcp->p_theta, parms[P_THETA]); 

    fl_set_slider_value(GLcp->p_gamma, parms[P_GAMMA]);
    fl_set_slider_value(GLcp->p_sigma, parms[P_SIGMA]);
  
    // fl_set_slider_value(GLcp->p_phi, (180.0 * parms[P_PHI]) / M_PI); 

    fl_set_slider_value(GLcp->p_phi, parms[P_PHI]); 

    fl_set_slider_value(GLcp->p_kappa, parms[P_KAPPA]);
    fl_set_slider_value(GLcp->p_epsilon, parms[P_EPSILON]);
    fl_set_slider_value(GLcp->p_C, parms[P_C]);
    fl_set_slider_value(GLcp->p_x_1, parms[P_X_1]);
    fl_set_slider_value(GLcp->p_y_1, parms[P_Y_1]);
    fl_set_slider_value(GLcp->p_x_2, parms[P_X_2]);
    fl_set_slider_value(GLcp->p_y_2, parms[P_Y_2]);
    fl_set_slider_value(GLcp->p_m_1, parms[P_M_1]);
    fl_set_slider_value(GLcp->p_m_2, parms[P_M_2]);
    fl_set_slider_value(GLcp->p_beta, parms[P_BETA]);
    fl_set_slider_value(GLcp->p_gamma2, parms[P_GAMMA2]);
    fl_set_slider_value(GLcp->p_sigma2, parms[P_SIGMA2]);
  
    // fl_set_slider_value(GLcp->p_phi2, (180.0 * parms[P_PHI2]) / M_PI);

    fl_set_slider_value(GLcp->p_phi2, parms[P_PHI2]);

    fl_set_slider_value(GLcp->p_sx, parms[P_SX]);
    fl_set_slider_value(GLcp->p_sy, parms[P_SY]);
    fl_set_slider_value(GLcp->p_alpha, parms[P_ALPHA]);
    fl_set_slider_value(GLcp->p_alpha2, parms[P_ALPHA2]);
    fl_set_slider_value(GLcp->p_exp, parms[P_EXP]);  
    fl_set_slider_value(GLcp->p_kappa2, parms[P_KAPPA2]);
    fl_set_slider_value(GLcp->p_rad_i, parms[P_Ri]);
    fl_set_slider_value(GLcp->p_rad_o, parms[P_Ro]);
    fl_set_slider_value(GLcp->p_kappa0, parms[P_KAPPA0]);
    fl_set_slider_value(GLcp->p_dx_qp, parms[P_DX_QP]);
    fl_set_slider_value(GLcp->p_dy_qp, parms[P_DY_QP]);
    fl_set_slider_value(GLcp->p_qxx, parms[P_QXX]);
    fl_set_slider_value(GLcp->p_qxy, parms[P_QXY]);
    fl_set_slider_value(GLcp->p_qyy, parms[P_QYY]);

    /*
    
      parms[P_THETA]  *= M_PI / 180.0; 
      parms[P_PHI]    *= M_PI / 180.0;
      parms[P_PHI2]   *= M_PI / 180.0; 

    **/
  
    /*
    
      printf("X                = %g \n", Y[0]);
      printf("Y                = %g \n", Y[1]);  
      printf("parms[P_E]       = %g \n", parms[P_E]);
      printf("parms[P_THETA]   = %g \n", parms[P_THETA]);
      printf("parms[P_GAMMA]   = %g \n", parms[P_GAMMA]);
      printf("parms[P_SIGMA]   = %g \n", parms[P_SIGMA]);
      printf("parms[P_PHI]     = %g \n", parms[P_PHI]);
      printf("parms[P_C]       = %g \n", parms[P_C]);
      printf("parms[P_EPSILON] = %g \n", parms[P_EPSILON]);
      printf("parms[P_ALPHA]   = %g \n", parms[P_ALPHA]);
      printf("parms[P_ALPHA2]  = %g \n", parms[P_ALPHA2]);
      printf("parms[P_KAPPA]   = %g \n", parms[P_KAPPA]);
      printf("parms[P_KAPPA0]  = %g \n", parms[P_KAPPA0]);
      printf("parms[P_KAPPA2]  = %g \n", parms[P_KAPPA2]);
      printf("parms[P_GAMMA2]  = %g \n", parms[P_GAMMA2]);
      printf("parms[P_SIGMA2]  = %g \n", parms[P_SIGMA2]);
      printf("parms[P_PHI2]    = %g \n", parms[P_PHI2]);
      printf("parms[P_Ro]      = %g \n", parms[P_Ro]);
      printf("parms[P_Ri]      = %g \n", parms[P_Ri]);
      printf("parms[P_DX_QP]   = %g \n", parms[P_DX_QP]);
      printf("parms[P_DY_QP]   = %g \n", parms[P_DY_QP]);
      printf("parms[P_QXX]     = %g \n", parms[P_QXX]);
      printf("parms[P_QXY]     = %g \n", parms[P_QXY]);
      printf("parms[P_QYY]     = %g \n", parms[P_QYY]);
      printf("parms[P_SX]      = %g \n", parms[P_SX]);
      printf("parms[P_SY]      = %g \n", parms[P_SY]);
      printf("parms[P_X_1]     = %g \n", parms[P_X_1]);
      printf("parms[P_X_2]     = %g \n", parms[P_X_2]);
      printf("parms[P_Y_1]     = %g \n", parms[P_Y_1]);
      printf("parms[P_Y_2]     = %g \n", parms[P_Y_2]);
      printf("parms[P_M_1]     = %g \n", parms[P_M_1]);
      printf("parms[P_M_2]     = %g \n", parms[P_M_2]);
      printf("parms[P_BETA]    = %g \n", parms[P_BETA]);   
      printf("parms[P_EXP]     = %g \n", parms[P_EXP]);
      printf("parms[P_THETA] = %g \n", (180.0 * parms[P_THETA] / M_PI));
      printf("parms[P_PHI] = %g \n", (180.0 * parms[P_PHI] / M_PI));
      printf("parms[P_PHI2] = %g \n", (180.0 * parms[P_PHI2] / M_PI));

      printf("sl_1  = %d \n", sl_1);   
      printf("sl_2  = %d \n", sl_2);   
      printf("sl_3  = %d \n", sl_3);   
      printf("sl_4  = %d \n", sl_4);   
      printf("sl_5  = %d \n", sl_5);   
      printf("sl_6  = %d \n", sl_6);   
      printf("sl_7  = %d \n", sl_7);   
      printf("sl_8  = %d \n", sl_8);   
      printf("sl_9  = %d \n", sl_9);   
      printf("sl_10 = %d \n", sl_10);   
      printf("sl_11 = %d \n", sl_11);   
      printf("sl_12 = %d \n", sl_12);   
      printf("sl_13 = %d \n", sl_13);   
      printf("sl_14 = %d \n", sl_14);   
      printf("sl_15 = %d \n", sl_15);   
      printf("sl_16 = %d \n", sl_16);   
      printf("sl_17 = %d \n", sl_17);   
      printf("sl_18 = %d \n", sl_18);   
      printf("sl_19 = %d \n", sl_19);   
      printf("sl_20 = %d \n", sl_20);   
      printf("sl_21 = %d \n", sl_21);   
      printf("sl_22 = %d \n", sl_22);   
      printf("sl_23 = %d \n", sl_23);   
      printf("sl_24 = %d \n", sl_24);   
      printf("sl_25 = %d \n", sl_25);   
      printf("sl_26 = %d \n", sl_26);   
      printf("sl_27 = %d \n", sl_27);   
      printf("sl_28 = %d \n", sl_28);   
      printf("sl_29 = %d \n", sl_29);   
      printf("sl_30 = %d \n", sl_30);
      printf("sl_31 = %d \n", sl_31);
      printf("sl_32 = %d \n", sl_32);
      printf("sl_33 = %d \n", sl_33);
      printf("sl_34 = %d \n", sl_34);

    **/

    break;
  case M_CHANG_REFSDAL:    
    Y[0]           = atof(fl_get_input(Chang->input_x));  
    Y[1]           = atof(fl_get_input(Chang->input_y));  
    parms[P_E]     = atof(fl_get_input(Chang->input_E));
    parms[P_THETA] = atof(fl_get_input(Chang->input_theta));  
    parms[P_GAMMA] = atof(fl_get_input(Chang->input_gamma));
    parms[P_SIGMA] = atof(fl_get_input(Chang->input_sigma));
    parms[P_PHI]   = atof(fl_get_input(Chang->input_phi));  

    break;
  case M_SING_ISOT_SPHERE:
    Y[0]           = atof(fl_get_input(SIS->input_x));  
    Y[1]           = atof(fl_get_input(SIS->input_y));  
    parms[P_E]     = atof(fl_get_input(SIS->input_E));
    parms[P_THETA] = atof(fl_get_input(SIS->input_theta));  
    parms[P_GAMMA] = atof(fl_get_input(SIS->input_gamma));
    parms[P_SIGMA] = atof(fl_get_input(SIS->input_sigma));
    parms[P_PHI]   = atof(fl_get_input(SIS->input_phi));  
    parms[P_EXP]   = atof(fl_get_input(SIS->input_exp));  

    break;
  case M_DE_VAUCOULEUR:
    Y[0]           = atof(fl_get_input(DeVau->input_x));  
    Y[1]           = atof(fl_get_input(DeVau->input_y));  
    parms[P_E]     = atof(fl_get_input(DeVau->input_E));
    parms[P_THETA] = atof(fl_get_input(DeVau->input_theta));  
    parms[P_GAMMA] = atof(fl_get_input(DeVau->input_gamma));
    parms[P_SIGMA] = atof(fl_get_input(DeVau->input_sigma));
    parms[P_PHI]   = atof(fl_get_input(DeVau->input_phi));  
    parms[P_KAPPA] = atof(fl_get_input(DeVau->input_kappa));  

    break;
  case M_KING:
    Y[0]           = atof(fl_get_input(King->input_x));  
    Y[1]           = atof(fl_get_input(King->input_y));  
    parms[P_E]     = atof(fl_get_input(King->input_E));
    parms[P_THETA] = atof(fl_get_input(King->input_theta));  
    parms[P_GAMMA] = atof(fl_get_input(King->input_gamma));
    parms[P_SIGMA] = atof(fl_get_input(King->input_sigma));
    parms[P_PHI]   = atof(fl_get_input(King->input_phi));  
    parms[P_KAPPA] = atof(fl_get_input(King->input_kappa));  

    break;
  case M_HUBBLE:
    Y[0]           = atof(fl_get_input(Hubble->input_x));  
    Y[1]           = atof(fl_get_input(Hubble->input_y));  
    parms[P_E]     = atof(fl_get_input(Hubble->input_E));
    parms[P_THETA] = atof(fl_get_input(Hubble->input_theta));  
    parms[P_GAMMA] = atof(fl_get_input(Hubble->input_gamma));
    parms[P_SIGMA] = atof(fl_get_input(Hubble->input_sigma));
    parms[P_PHI]   = atof(fl_get_input(Hubble->input_phi));  
    parms[P_KAPPA] = atof(fl_get_input(Hubble->input_kappa));  

    break;
  case M_SPIRAL:
    Y[0]            = atof(fl_get_input(Spiral_M->input_x));  
    Y[1]            = atof(fl_get_input(Spiral_M->input_y));  
    parms[P_E]      = atof(fl_get_input(Spiral_M->input_E));
    parms[P_THETA]  = atof(fl_get_input(Spiral_M->input_theta));  
    parms[P_GAMMA]  = atof(fl_get_input(Spiral_M->input_gamma));
    parms[P_SIGMA]  = atof(fl_get_input(Spiral_M->input_sigma));
    parms[P_PHI]    = atof(fl_get_input(Spiral_M->input_phi));  
    parms[P_KAPPA]  = atof(fl_get_input(Spiral_M->input_kappa));  
    parms[P_ALPHA2] = atof(fl_get_input(Spiral_M->input_alpha2));  

    break;
  case M_TRUNC_KING:
    Y[0]            = atof(fl_get_input(TKing->input_x));  
    Y[1]            = atof(fl_get_input(TKing->input_y));  
    parms[P_E]      = atof(fl_get_input(TKing->input_E));
    parms[P_THETA]  = atof(fl_get_input(TKing->input_theta));  
    parms[P_GAMMA]  = atof(fl_get_input(TKing->input_gamma));
    parms[P_SIGMA]  = atof(fl_get_input(TKing->input_sigma));
    parms[P_PHI]    = atof(fl_get_input(TKing->input_phi));  
    parms[P_KAPPA2] = atof(fl_get_input(TKing->input_kappa2));  
    parms[P_C]      = atof(fl_get_input(TKing->input_C));  

    break;
  case M_NSING_ISOT_SPHERE:
    Y[0]           = atof(fl_get_input(NSIS->input_x));  
    Y[1]           = atof(fl_get_input(NSIS->input_y));  
    parms[P_E]     = atof(fl_get_input(NSIS->input_E));
    parms[P_THETA] = atof(fl_get_input(NSIS->input_theta));  
    parms[P_GAMMA] = atof(fl_get_input(NSIS->input_gamma));
    parms[P_SIGMA] = atof(fl_get_input(NSIS->input_sigma));
    parms[P_PHI]   = atof(fl_get_input(NSIS->input_phi));  
    parms[P_KAPPA] = atof(fl_get_input(NSIS->input_kappa));  
    parms[P_C]     = atof(fl_get_input(NSIS->input_C));  

    break;
  case M_TRANSP_SPHERE:
    Y[0]           = atof(fl_get_input(Sphere->input_x));  
    Y[1]           = atof(fl_get_input(Sphere->input_y));  
    parms[P_E]     = atof(fl_get_input(Sphere->input_E));
    parms[P_THETA] = atof(fl_get_input(Sphere->input_theta));  
    parms[P_GAMMA] = atof(fl_get_input(Sphere->input_gamma));
    parms[P_SIGMA] = atof(fl_get_input(Sphere->input_sigma));
    parms[P_PHI]   = atof(fl_get_input(Sphere->input_phi));  
    parms[P_C]     = atof(fl_get_input(Sphere->input_C));  

    break;
  case M_ELLIPTICAL:
    Y[0]             = atof(fl_get_input(Elliptic->input_x));  
    Y[1]             = atof(fl_get_input(Elliptic->input_y));  
    parms[P_E]       = atof(fl_get_input(Elliptic->input_E));
    parms[P_THETA]   = atof(fl_get_input(Elliptic->input_theta));  
    parms[P_GAMMA]   = atof(fl_get_input(Elliptic->input_gamma));
    parms[P_SIGMA]   = atof(fl_get_input(Elliptic->input_sigma));
    parms[P_PHI]     = atof(fl_get_input(Elliptic->input_phi));  
    parms[P_KAPPA]   = atof(fl_get_input(Elliptic->input_kappa));  
    parms[P_EPSILON] = atof(fl_get_input(Elliptic->input_kappa));  
    parms[P_ALPHA]   = atof(fl_get_input(Elliptic->input_kappa));  
    parms[P_C]       = atof(fl_get_input(Elliptic->input_C));  

    break;
  case M_MULTIPOLE:
    Y[0]            = atof(fl_get_input(Multi->input_x));  
    Y[1]            = atof(fl_get_input(Multi->input_y));  
    parms[P_E]      = atof(fl_get_input(Multi->input_E));
    parms[P_THETA]  = atof(fl_get_input(Multi->input_theta));  
    parms[P_GAMMA]  = atof(fl_get_input(Multi->input_gamma));
    parms[P_SIGMA]  = atof(fl_get_input(Multi->input_sigma));
    parms[P_PHI]    = atof(fl_get_input(Multi->input_phi));  
    parms[P_KAPPA0] = atof(fl_get_input(Multi->input_kappa0));  
    parms[P_DX_QP]  = atof(fl_get_input(Multi->input_dx));  
    parms[P_DY_QP]  = atof(fl_get_input(Multi->input_dy));  
    parms[P_QXX]    = atof(fl_get_input(Multi->input_qxx));  
    parms[P_QXY]    = atof(fl_get_input(Multi->input_qxy));  
    parms[P_QYY]    = atof(fl_get_input(Multi->input_qyy));  

    break;
  case M_ROTATION_LENS:
    Y[0]           = atof(fl_get_input(Rotation->input_x));  
    Y[1]           = atof(fl_get_input(Rotation->input_y));  
    parms[P_E]     = atof(fl_get_input(Rotation->input_E));
    parms[P_THETA] = atof(fl_get_input(Rotation->input_theta));  
    parms[P_GAMMA] = atof(fl_get_input(Rotation->input_gamma));
    parms[P_SIGMA] = atof(fl_get_input(Rotation->input_sigma));
    parms[P_PHI]   = atof(fl_get_input(Rotation->input_phi));  
    parms[P_SX]    = atof(fl_get_input(Rotation->input_sx));  
    parms[P_SY]    = atof(fl_get_input(Rotation->input_sy));  

    break;
  case M_DOUBLE_LENS:
    Y[0]            = atof(fl_get_input(Double->input_x));  
    Y[1]            = atof(fl_get_input(Double->input_y));  
    parms[P_E]      = atof(fl_get_input(Double->input_E));
    parms[P_THETA]  = atof(fl_get_input(Double->input_theta));  
    parms[P_BETA]   = atof(fl_get_input(Double->input_theta));  
    parms[P_GAMMA]  = atof(fl_get_input(Double->input_gamma));
    parms[P_SIGMA]  = atof(fl_get_input(Double->input_sigma));
    parms[P_PHI]    = atof(fl_get_input(Double->input_phi));  
    parms[P_GAMMA2] = atof(fl_get_input(Double->input_gamma));
    parms[P_SIGMA2] = atof(fl_get_input(Double->input_sigma));
    parms[P_PHI2]   = atof(fl_get_input(Double->input_phi));  
    parms[P_X_1]    = atof(fl_get_input(Double->input_x1));  
    parms[P_Y_1]    = atof(fl_get_input(Double->input_y1));  
    parms[P_X_2]    = atof(fl_get_input(Double->input_x2));  
    parms[P_Y_2]    = atof(fl_get_input(Double->input_y2));  
    parms[P_M_1]    = atof(fl_get_input(Double->input_m1));  
    parms[P_M_2]    = atof(fl_get_input(Double->input_m2));  

    break;
  case M_UNIFORM_RING:
    Y[0]           = atof(fl_get_input(Uring->input_x));  
    Y[1]           = atof(fl_get_input(Uring->input_y));  
    parms[P_E]     = atof(fl_get_input(Uring->input_E));
    parms[P_THETA] = atof(fl_get_input(Uring->input_theta));  
    parms[P_GAMMA] = atof(fl_get_input(Uring->input_gamma));
    parms[P_SIGMA] = atof(fl_get_input(Uring->input_sigma));
    parms[P_PHI]   = atof(fl_get_input(Uring->input_phi));  
    parms[P_KAPPA] = atof(fl_get_input(Uring->input_kappa));  
    parms[P_Ri]    = atof(fl_get_input(Uring->input_ri));  
    parms[P_Ro]    = atof(fl_get_input(Uring->input_ro));  

    break;
  case M_SECOND:
    
    break;
  case M_ELL_SIS_KK:

    break;
  case M_ELL_KING:       

    break;
  case M_ELL_HUBBLE:           

    break;
  case M_ELL_NIS:

    break;
  case M_ELL_PLUMMER:

    break;
  case M_ELL_KK:  

    break; 
 case M_N_F_W:

    break;
  case M_BARKANA:  

    break;
  default:
    break;
  }

  // SIM_AN = TRUE;

  PRAXIS = TRUE;
  
  /* Refresh */     

  /* handle_expose(0, 0); */

  glXSwapBuffers(fl_display, GLwin);
}

void reset_par(FL_OBJECT *ob, long data)
{
  switch(current_model) {
  case M_MODEL_MENU:
    fl_set_input(Parametres->input_x, "0.0");
    fl_set_input(Parametres->input_y, "0.0");
    fl_set_input(Parametres->input_E, "1.5");
    fl_set_input(Parametres->input_theta, "0.0");
    fl_set_input(Parametres->input_gamma, "0.05");
    fl_set_input(Parametres->input_sigma, "0.05");
    fl_set_input(Parametres->input_phi, "0.0");
    fl_set_input(Parametres->input_gamma2, "0.05");
    fl_set_input(Parametres->input_sigma2, "0.05");
    fl_set_input(Parametres->input_phi2, "0.0");
    fl_set_input(Parametres->input_alpha, "0.2");
    fl_set_input(Parametres->input_alpha2, "1.0");
    fl_set_input(Parametres->input_kappa, "1.0");
    fl_set_input(Parametres->input_kappa0, "1.0");
    fl_set_input(Parametres->input_kappa2, "5.0");
    fl_set_input(Parametres->input_epsilon, "0.4");
    fl_set_input(Parametres->input_beta, "1.0");
    fl_set_input(Parametres->input_C, "1.0");
    fl_set_input(Parametres->input_ri, "1.0");
    fl_set_input(Parametres->input_ro, "2.0");
    fl_set_input(Parametres->input_x1, "0.0");
    fl_set_input(Parametres->input_y1, "0.0");
    fl_set_input(Parametres->input_x2, "0.0");
    fl_set_input(Parametres->input_y2, "0.0");
    fl_set_input(Parametres->input_m1, "0.5");
    fl_set_input(Parametres->input_m2, "0.0");
    fl_set_input(Parametres->input_dx, "1.0");
    fl_set_input(Parametres->input_dy, "1.0");
    fl_set_input(Parametres->input_qxx, "0.5");
    fl_set_input(Parametres->input_qxy, "0.0");
    fl_set_input(Parametres->input_qyy, "-0.5");
    fl_set_input(Parametres->input_sx, "0.5");
    fl_set_input(Parametres->input_sy, "0.5");
    fl_set_input(Parametres->input_exp, "1.0");

    Y[0]             = atof(fl_get_input(Parametres->input_x));  
    Y[1]             = atof(fl_get_input(Parametres->input_y));  
    parms[P_E]       = atof(fl_get_input(Parametres->input_E));
    parms[P_THETA]   = atof(fl_get_input(Parametres->input_theta));
    parms[P_GAMMA]   = atof(fl_get_input(Parametres->input_gamma));
    parms[P_SIGMA]   = atof(fl_get_input(Parametres->input_sigma));
    parms[P_PHI]     = atof(fl_get_input(Parametres->input_phi));
    parms[P_GAMMA2]  = atof(fl_get_input(Parametres->input_gamma2));
    parms[P_SIGMA2]  = atof(fl_get_input(Parametres->input_sigma2));
    parms[P_PHI2]    = atof(fl_get_input(Parametres->input_phi2));
    parms[P_ALPHA]   = atof(fl_get_input(Parametres->input_alpha));
    parms[P_ALPHA2]  = atof(fl_get_input(Parametres->input_alpha2));  
    parms[P_KAPPA]   = atof(fl_get_input(Parametres->input_kappa));
    parms[P_KAPPA0]  = atof(fl_get_input(Parametres->input_kappa0));
    parms[P_KAPPA2]  = atof(fl_get_input(Parametres->input_kappa2));
    parms[P_EPSILON] = atof(fl_get_input(Parametres->input_epsilon));
    parms[P_BETA]    = atof(fl_get_input(Parametres->input_beta));
    parms[P_C]       = atof(fl_get_input(Parametres->input_C));
    parms[P_Ri]      = atof(fl_get_input(Parametres->input_ri));
    parms[P_Ro]      = atof(fl_get_input(Parametres->input_ro));
    parms[P_X_1]     = atof(fl_get_input(Parametres->input_x1));
    parms[P_Y_1]     = atof(fl_get_input(Parametres->input_y1));
    parms[P_M_1]     = atof(fl_get_input(Parametres->input_m1));
    parms[P_X_2]     = atof(fl_get_input(Parametres->input_x2));
    parms[P_Y_2]     = atof(fl_get_input(Parametres->input_y2));
    parms[P_M_2]     = atof(fl_get_input(Parametres->input_m2));
    parms[P_DX_QP]   = atof(fl_get_input(Parametres->input_dx));
    parms[P_DY_QP]   = atof(fl_get_input(Parametres->input_dy));
    parms[P_QXX]     = atof(fl_get_input(Parametres->input_qxx));
    parms[P_QXY]     = atof(fl_get_input(Parametres->input_qxy));
    parms[P_QYY]     = atof(fl_get_input(Parametres->input_qyy));
    parms[P_SX]      = atof(fl_get_input(Parametres->input_sx));
    parms[P_SY]      = atof(fl_get_input(Parametres->input_sy));
    parms[P_EXP]     = atof(fl_get_input(Parametres->input_exp));

    fl_set_positioner_xvalue(GLcp->source_pos, Y[0]);
    fl_set_positioner_yvalue(GLcp->source_pos, Y[1]);

    // fl_set_positioner_xvalue(GLcp->lens_pos, Y[0]);
    // fl_set_positioner_yvalue(GLcp->lens_pos, Y[1]);

    fl_set_counter_value(GLcp->x_pos, Y[0]);
    fl_set_counter_value(GLcp->y_pos, Y[1]);

    fl_set_slider_value(GLcp->p_E, parms[P_E]);
    fl_set_slider_value(GLcp->p_theta, parms[P_THETA]);
    fl_set_slider_value(GLcp->p_gamma, parms[P_GAMMA]);
    fl_set_slider_value(GLcp->p_sigma, parms[P_SIGMA]);
    fl_set_slider_value(GLcp->p_phi, parms[P_PHI]);
    fl_set_slider_value(GLcp->p_kappa, parms[P_KAPPA]);
    fl_set_slider_value(GLcp->p_epsilon, parms[P_EPSILON]);
    fl_set_slider_value(GLcp->p_C, parms[P_C]);
    fl_set_slider_value(GLcp->p_x_1, parms[P_X_1]);
    fl_set_slider_value(GLcp->p_y_1, parms[P_Y_1]);
    fl_set_slider_value(GLcp->p_x_2, parms[P_X_2]);
    fl_set_slider_value(GLcp->p_y_2, parms[P_Y_2]);
    fl_set_slider_value(GLcp->p_m_1, parms[P_M_1]);
    fl_set_slider_value(GLcp->p_m_2, parms[P_M_2]);
    fl_set_slider_value(GLcp->p_beta, parms[P_BETA]);
    fl_set_slider_value(GLcp->p_gamma2, parms[P_GAMMA2]);
    fl_set_slider_value(GLcp->p_sigma2, parms[P_SIGMA2]);
    fl_set_slider_value(GLcp->p_phi2, parms[P_PHI2]);
    fl_set_slider_value(GLcp->p_sx, parms[P_SX]);
    fl_set_slider_value(GLcp->p_sy, parms[P_SY]);
    fl_set_slider_value(GLcp->p_alpha, parms[P_ALPHA]);
    fl_set_slider_value(GLcp->p_alpha2, parms[P_ALPHA2]);
    fl_set_slider_value(GLcp->p_exp, parms[P_EXP]);  
    fl_set_slider_value(GLcp->p_kappa2, parms[P_KAPPA2]);
    fl_set_slider_value(GLcp->p_rad_i, parms[P_Ri]);
    fl_set_slider_value(GLcp->p_rad_o, parms[P_Ro]);
    fl_set_slider_value(GLcp->p_kappa0, parms[P_KAPPA0]);
    fl_set_slider_value(GLcp->p_dx_qp, parms[P_DX_QP]);
    fl_set_slider_value(GLcp->p_dy_qp, parms[P_DY_QP]);
    fl_set_slider_value(GLcp->p_qxx, parms[P_QXX]);
    fl_set_slider_value(GLcp->p_qxy, parms[P_QXY]);
    fl_set_slider_value(GLcp->p_qyy, parms[P_QYY]);

    break;
  case M_CHANG_REFSDAL:    
    fl_set_input(Chang->input_x, "0.0");
    fl_set_input(Chang->input_y, "0.0");
    fl_set_input(Chang->input_E, "1.5");
    fl_set_input(Chang->input_theta, "0.0");
    fl_set_input(Chang->input_gamma, "0.05");
    fl_set_input(Chang->input_sigma, "0.05");
    fl_set_input(Chang->input_phi, "0.0");

    Y[0]           = atof(fl_get_input(Chang->input_x));  
    Y[1]           = atof(fl_get_input(Chang->input_y));  
    parms[P_E]     = atof(fl_get_input(Chang->input_E));
    parms[P_THETA] = atof(fl_get_input(Chang->input_theta));  
    parms[P_GAMMA] = atof(fl_get_input(Chang->input_gamma));
    parms[P_SIGMA] = atof(fl_get_input(Chang->input_sigma));
    parms[P_PHI]   = atof(fl_get_input(Chang->input_phi));  

    break;
  case M_SING_ISOT_SPHERE:
    fl_set_input(SIS->input_x, "0.0");
    fl_set_input(SIS->input_y, "0.0");
    fl_set_input(SIS->input_E, "1.5");
    fl_set_input(SIS->input_theta, "0.0");
    fl_set_input(SIS->input_gamma, "0.05");
    fl_set_input(SIS->input_sigma, "0.05");
    fl_set_input(SIS->input_phi, "0.0");
    fl_set_input(SIS->input_exp, "1.0");

    Y[0]           = atof(fl_get_input(SIS->input_x));  
    Y[1]           = atof(fl_get_input(SIS->input_y));  
    parms[P_E]     = atof(fl_get_input(SIS->input_E));
    parms[P_THETA] = atof(fl_get_input(SIS->input_theta));  
    parms[P_GAMMA] = atof(fl_get_input(SIS->input_gamma));
    parms[P_SIGMA] = atof(fl_get_input(SIS->input_sigma));
    parms[P_PHI]   = atof(fl_get_input(SIS->input_phi));  
    parms[P_EXP]   = atof(fl_get_input(SIS->input_exp));  

    break;
  case M_DE_VAUCOULEUR:
    fl_set_input(DeVau->input_x, "0.0");
    fl_set_input(DeVau->input_y, "0.0");
    fl_set_input(DeVau->input_E, "1.5");
    fl_set_input(DeVau->input_theta, "0.0");
    fl_set_input(DeVau->input_gamma, "0.05");
    fl_set_input(DeVau->input_sigma, "0.05");
    fl_set_input(DeVau->input_phi, "0.0");
    fl_set_input(DeVau->input_kappa, "1.0");

    Y[0]           = atof(fl_get_input(DeVau->input_x));  
    Y[1]           = atof(fl_get_input(DeVau->input_y));  
    parms[P_E]     = atof(fl_get_input(DeVau->input_E));
    parms[P_THETA] = atof(fl_get_input(DeVau->input_theta));  
    parms[P_GAMMA] = atof(fl_get_input(DeVau->input_gamma));
    parms[P_SIGMA] = atof(fl_get_input(DeVau->input_sigma));
    parms[P_PHI]   = atof(fl_get_input(DeVau->input_phi));  
    parms[P_KAPPA] = atof(fl_get_input(DeVau->input_kappa));  

    break;
  case M_KING:
    fl_set_input(King->input_x, "0.0");
    fl_set_input(King->input_y, "0.0");
    fl_set_input(King->input_E, "1.5");
    fl_set_input(King->input_theta, "0.0");
    fl_set_input(King->input_gamma, "0.05");
    fl_set_input(King->input_sigma, "0.05");
    fl_set_input(King->input_phi, "0.0");
    fl_set_input(King->input_kappa, "1.0");

    Y[0]           = atof(fl_get_input(King->input_x));  
    Y[1]           = atof(fl_get_input(King->input_y));  
    parms[P_E]     = atof(fl_get_input(King->input_E));
    parms[P_THETA] = atof(fl_get_input(King->input_theta));  
    parms[P_GAMMA] = atof(fl_get_input(King->input_gamma));
    parms[P_SIGMA] = atof(fl_get_input(King->input_sigma));
    parms[P_PHI]   = atof(fl_get_input(King->input_phi));  
    parms[P_KAPPA] = atof(fl_get_input(King->input_kappa));  

    break;
  case M_HUBBLE:
    fl_set_input(Hubble->input_x, "0.0");
    fl_set_input(Hubble->input_y, "0.0");
    fl_set_input(Hubble->input_E, "1.5");
    fl_set_input(Hubble->input_theta, "0.0");
    fl_set_input(Hubble->input_gamma, "0.05");
    fl_set_input(Hubble->input_sigma, "0.05");
    fl_set_input(Hubble->input_phi, "0.0");
    fl_set_input(Hubble->input_kappa, "1.0");

    Y[0]           = atof(fl_get_input(Hubble->input_x));  
    Y[1]           = atof(fl_get_input(Hubble->input_y));  
    parms[P_E]     = atof(fl_get_input(Hubble->input_E));
    parms[P_THETA] = atof(fl_get_input(Hubble->input_theta));  
    parms[P_GAMMA] = atof(fl_get_input(Hubble->input_gamma));
    parms[P_SIGMA] = atof(fl_get_input(Hubble->input_sigma));
    parms[P_PHI]   = atof(fl_get_input(Hubble->input_phi));  
    parms[P_KAPPA] = atof(fl_get_input(Hubble->input_kappa));  

    break;
  case M_SPIRAL:
    fl_set_input(Spiral_M->input_x, "0.0");
    fl_set_input(Spiral_M->input_y, "0.0");
    fl_set_input(Spiral_M->input_E, "1.5");
    fl_set_input(Spiral_M->input_theta, "0.0");
    fl_set_input(Spiral_M->input_gamma, "0.05");
    fl_set_input(Spiral_M->input_sigma, "0.05");
    fl_set_input(Spiral_M->input_phi, "0.0");
    fl_set_input(Spiral_M->input_kappa, "1.0");
    fl_set_input(Spiral_M->input_alpha2, "1.0");

    Y[0]            = atof(fl_get_input(Spiral_M->input_x));  
    Y[1]            = atof(fl_get_input(Spiral_M->input_y));  
    parms[P_E]      = atof(fl_get_input(Spiral_M->input_E));
    parms[P_THETA]  = atof(fl_get_input(Spiral_M->input_theta));  
    parms[P_GAMMA]  = atof(fl_get_input(Spiral_M->input_gamma));
    parms[P_SIGMA]  = atof(fl_get_input(Spiral_M->input_sigma));
    parms[P_PHI]    = atof(fl_get_input(Spiral_M->input_phi));  
    parms[P_KAPPA]  = atof(fl_get_input(Spiral_M->input_kappa));  
    parms[P_ALPHA2] = atof(fl_get_input(Spiral_M->input_alpha2));  

    break;
  case M_TRUNC_KING:
    fl_set_input(TKing->input_x, "0.0");
    fl_set_input(TKing->input_y, "0.0");
    fl_set_input(TKing->input_E, "1.5");
    fl_set_input(TKing->input_theta, "0.0");
    fl_set_input(TKing->input_gamma, "0.05");
    fl_set_input(TKing->input_sigma, "0.05");
    fl_set_input(TKing->input_phi, "0.0");
    fl_set_input(TKing->input_kappa2, "1.0");
    fl_set_input(TKing->input_C, "1.0");

    Y[0]            = atof(fl_get_input(TKing->input_x));  
    Y[1]            = atof(fl_get_input(TKing->input_y));  
    parms[P_E]      = atof(fl_get_input(TKing->input_E));
    parms[P_THETA]  = atof(fl_get_input(TKing->input_theta));  
    parms[P_GAMMA]  = atof(fl_get_input(TKing->input_gamma));
    parms[P_SIGMA]  = atof(fl_get_input(TKing->input_sigma));
    parms[P_PHI]    = atof(fl_get_input(TKing->input_phi));  
    parms[P_KAPPA2] = atof(fl_get_input(TKing->input_kappa2));  
    parms[P_C]      = atof(fl_get_input(TKing->input_C));  

    break;
  case M_NSING_ISOT_SPHERE:
    fl_set_input(NSIS->input_x, "0.0");
    fl_set_input(NSIS->input_y, "0.0");
    fl_set_input(NSIS->input_E, "1.5");
    fl_set_input(NSIS->input_theta, "0.0");
    fl_set_input(NSIS->input_gamma, "0.05");
    fl_set_input(NSIS->input_sigma, "0.05");
    fl_set_input(NSIS->input_phi, "0.0");
    fl_set_input(NSIS->input_kappa, "1.0");
    fl_set_input(NSIS->input_C, "1.0");

    Y[0]           = atof(fl_get_input(NSIS->input_x));  
    Y[1]           = atof(fl_get_input(NSIS->input_y));  
    parms[P_E]     = atof(fl_get_input(NSIS->input_E));
    parms[P_THETA] = atof(fl_get_input(NSIS->input_theta));  
    parms[P_GAMMA] = atof(fl_get_input(NSIS->input_gamma));
    parms[P_SIGMA] = atof(fl_get_input(NSIS->input_sigma));
    parms[P_PHI]   = atof(fl_get_input(NSIS->input_phi));  
    parms[P_KAPPA] = atof(fl_get_input(NSIS->input_kappa));  
    parms[P_C]     = atof(fl_get_input(NSIS->input_C));  

    break;
  case M_TRANSP_SPHERE:
    fl_set_input(Sphere->input_x, "0.0");
    fl_set_input(Sphere->input_y, "0.0");
    fl_set_input(Sphere->input_E, "1.5");
    fl_set_input(Sphere->input_theta, "0.0");
    fl_set_input(Sphere->input_gamma, "0.05");
    fl_set_input(Sphere->input_sigma, "0.05");
    fl_set_input(Sphere->input_phi, "0.0");
    fl_set_input(Sphere->input_C, "1.0");

    Y[0]           = atof(fl_get_input(Sphere->input_x));  
    Y[1]           = atof(fl_get_input(Sphere->input_y));  
    parms[P_E]     = atof(fl_get_input(Sphere->input_E));
    parms[P_THETA] = atof(fl_get_input(Sphere->input_theta));  
    parms[P_GAMMA] = atof(fl_get_input(Sphere->input_gamma));
    parms[P_SIGMA] = atof(fl_get_input(Sphere->input_sigma));
    parms[P_PHI]   = atof(fl_get_input(Sphere->input_phi));  
    parms[P_C]     = atof(fl_get_input(Sphere->input_C));  

    break;
  case M_ELLIPTICAL:
    fl_set_input(Elliptic->input_x, "0.0");
    fl_set_input(Elliptic->input_y, "0.0");
    fl_set_input(Elliptic->input_E, "1.5");
    fl_set_input(Elliptic->input_theta, "0.0");
    fl_set_input(Elliptic->input_gamma, "0.05");
    fl_set_input(Elliptic->input_sigma, "0.05");
    fl_set_input(Elliptic->input_phi, "0.0");
    fl_set_input(Elliptic->input_kappa, "1.0");
    fl_set_input(Elliptic->input_C, "1.0");
    fl_set_input(Elliptic->input_alpha, "0.2");
    fl_set_input(Elliptic->input_epsilon, "0.4");

    Y[0]             = atof(fl_get_input(Elliptic->input_x));  
    Y[1]             = atof(fl_get_input(Elliptic->input_y));  
    parms[P_E]       = atof(fl_get_input(Elliptic->input_E));
    parms[P_THETA]   = atof(fl_get_input(Elliptic->input_theta));  
    parms[P_GAMMA]   = atof(fl_get_input(Elliptic->input_gamma));
    parms[P_SIGMA]   = atof(fl_get_input(Elliptic->input_sigma));
    parms[P_PHI]     = atof(fl_get_input(Elliptic->input_phi));  
    parms[P_KAPPA]   = atof(fl_get_input(Elliptic->input_kappa));  
    parms[P_EPSILON] = atof(fl_get_input(Elliptic->input_epsilon));  
    parms[P_ALPHA]   = atof(fl_get_input(Elliptic->input_alpha));  
    parms[P_C]       = atof(fl_get_input(Elliptic->input_C));  

    break;
  case M_MULTIPOLE:
    fl_set_input(Multi->input_x, "0.0");
    fl_set_input(Multi->input_y, "0.0");
    fl_set_input(Multi->input_E, "1.5");
    fl_set_input(Multi->input_theta, "0.0");
    fl_set_input(Multi->input_gamma, "0.05");
    fl_set_input(Multi->input_sigma, "0.05");
    fl_set_input(Multi->input_phi, "0.0");
    fl_set_input(Multi->input_dx, "1.0");
    fl_set_input(Multi->input_dy, "1.0");
    fl_set_input(Multi->input_qxx, "0.5");
    fl_set_input(Multi->input_qxy, "0.0");
    fl_set_input(Multi->input_qyy, "-0.5");

    Y[0]            = atof(fl_get_input(Multi->input_x));  
    Y[1]            = atof(fl_get_input(Multi->input_y));  
    parms[P_E]      = atof(fl_get_input(Multi->input_E));
    parms[P_THETA]  = atof(fl_get_input(Multi->input_theta));  
    parms[P_GAMMA]  = atof(fl_get_input(Multi->input_gamma));
    parms[P_SIGMA]  = atof(fl_get_input(Multi->input_sigma));
    parms[P_PHI]    = atof(fl_get_input(Multi->input_phi));  
    parms[P_KAPPA0] = atof(fl_get_input(Multi->input_kappa0));  
    parms[P_DX_QP]  = atof(fl_get_input(Multi->input_dx));
    parms[P_DY_QP]  = atof(fl_get_input(Multi->input_dy));
    parms[P_QXX]    = atof(fl_get_input(Multi->input_qxx));
    parms[P_QXY]    = atof(fl_get_input(Multi->input_qxy));
    parms[P_QYY]    = atof(fl_get_input(Multi->input_qyy));

    break;
  case M_ROTATION_LENS:
    fl_set_input(Rotation->input_x, "0.0");
    fl_set_input(Rotation->input_y, "0.0");
    fl_set_input(Rotation->input_E, "1.5");
    fl_set_input(Rotation->input_theta, "0.0");
    fl_set_input(Rotation->input_gamma, "0.05");
    fl_set_input(Rotation->input_sigma, "0.05");
    fl_set_input(Rotation->input_phi, "0.0");
    fl_set_input(Rotation->input_sx, "0.5");
    fl_set_input(Rotation->input_sy, "0.5");

    Y[0]           = atof(fl_get_input(Rotation->input_x));  
    Y[1]           = atof(fl_get_input(Rotation->input_y));  
    parms[P_E]     = atof(fl_get_input(Rotation->input_E));
    parms[P_THETA] = atof(fl_get_input(Rotation->input_theta));  
    parms[P_GAMMA] = atof(fl_get_input(Rotation->input_gamma));
    parms[P_SIGMA] = atof(fl_get_input(Rotation->input_sigma));
    parms[P_PHI]   = atof(fl_get_input(Rotation->input_phi));  
    parms[P_SX]    = atof(fl_get_input(Rotation->input_sx));
    parms[P_SY]    = atof(fl_get_input(Rotation->input_sy));

    break;
  case M_DOUBLE_LENS:
    fl_set_input(Double->input_x, "0.0");
    fl_set_input(Double->input_y, "0.0");
    fl_set_input(Double->input_E, "1.5");
    fl_set_input(Double->input_theta, "0.0");
    fl_set_input(Double->input_gamma, "0.05");
    fl_set_input(Double->input_sigma, "0.05");
    fl_set_input(Double->input_phi, "0.0");
    fl_set_input(Double->input_beta, "1.0");
    fl_set_input(Double->input_x1, "0.0");
    fl_set_input(Double->input_y1, "0.0");
    fl_set_input(Double->input_x2, "0.0");
    fl_set_input(Double->input_y2, "0.0");
    fl_set_input(Double->input_m1, "0.5");
    fl_set_input(Double->input_m2, "0.0");

    Y[0]            = atof(fl_get_input(Double->input_x));  
    Y[1]            = atof(fl_get_input(Double->input_y));  
    parms[P_E]      = atof(fl_get_input(Double->input_E));
    parms[P_THETA]  = atof(fl_get_input(Double->input_theta));  
    parms[P_BETA]   = atof(fl_get_input(Double->input_beta));
    parms[P_GAMMA]  = atof(fl_get_input(Double->input_gamma));
    parms[P_SIGMA]  = atof(fl_get_input(Double->input_sigma));
    parms[P_PHI]    = atof(fl_get_input(Double->input_phi));  
    parms[P_X_1]    = atof(fl_get_input(Double->input_x1));
    parms[P_Y_1]    = atof(fl_get_input(Double->input_y1));
    parms[P_M_1]    = atof(fl_get_input(Double->input_m1));
    parms[P_X_2]    = atof(fl_get_input(Double->input_x2));
    parms[P_Y_2]    = atof(fl_get_input(Double->input_y2));
    parms[P_M_2]    = atof(fl_get_input(Double->input_m2));
    parms[P_GAMMA2] = atof(fl_get_input(Double->input_gamma2));
    parms[P_SIGMA2] = atof(fl_get_input(Double->input_sigma2));
    parms[P_PHI2]   = atof(fl_get_input(Double->input_phi2));

    break;
  case M_UNIFORM_RING:
    fl_set_input(Uring->input_x, "0.0");
    fl_set_input(Uring->input_y, "0.0");
    fl_set_input(Uring->input_E, "1.5");
    fl_set_input(Uring->input_theta, "0.0");
    fl_set_input(Uring->input_gamma, "0.05");
    fl_set_input(Uring->input_sigma, "0.05");
    fl_set_input(Uring->input_phi, "0.0");
    fl_set_input(Uring->input_ri, "1.0");
    fl_set_input(Uring->input_ro, "2.0");

    Y[0]           = atof(fl_get_input(Uring->input_x));  
    Y[1]           = atof(fl_get_input(Uring->input_y));  
    parms[P_E]     = atof(fl_get_input(Uring->input_E));
    parms[P_THETA] = atof(fl_get_input(Uring->input_theta));  
    parms[P_GAMMA] = atof(fl_get_input(Uring->input_gamma));
    parms[P_SIGMA] = atof(fl_get_input(Uring->input_sigma));
    parms[P_PHI]   = atof(fl_get_input(Uring->input_phi));  
    parms[P_Ri]    = atof(fl_get_input(Uring->input_ri));
    parms[P_Ro]    = atof(fl_get_input(Uring->input_ro));

    break;
  case M_SECOND:
    
    break;
  case M_ELL_SIS_KK:

    break;
  case M_ELL_KING:       

    break;
  case M_ELL_HUBBLE:           

    break;
  case M_ELL_NIS:

    break;
  case M_ELL_PLUMMER:

    break;
  case M_ELL_KK:  

    break; 
 case M_N_F_W:

    break;
  case M_BARKANA:  

    break;
  default:
    break;
  }

  // SIM_AN = FALSE;

  PRAXIS = FALSE;
  
  sl_model    = FALSE;        
  sl_macro    = FALSE;        
  sl_re       = FALSE;
  sl_position = FALSE;
  
  sl_1  = FALSE;      
  sl_2  = FALSE;      
  sl_3  = FALSE;
  sl_4  = FALSE;
  sl_5  = FALSE;
  sl_6  = FALSE;
  sl_7  = FALSE;
  sl_8  = FALSE;
  sl_9  = FALSE;
  sl_10 = FALSE;
  sl_11 = FALSE;
  sl_12 = FALSE;
  sl_13 = FALSE;
  sl_14 = FALSE;
  sl_15 = FALSE;
  sl_16 = FALSE;
  sl_17 = FALSE;
  sl_18 = FALSE;
  sl_19 = FALSE;
  sl_20 = FALSE;
  sl_21 = FALSE;
  sl_22 = FALSE;
  sl_23 = FALSE;
  sl_24 = FALSE;
  sl_25 = FALSE;
  sl_26 = FALSE;
  sl_27 = FALSE;
  sl_28 = FALSE;
  sl_29 = FALSE;
  sl_30 = FALSE;
  sl_31 = FALSE;
  sl_32 = FALSE;
  sl_33 = FALSE;
  sl_34 = FALSE;
  
  /* Refresh */     

  /* handle_expose(0, 0); */

  glXSwapBuffers(fl_display, GLwin);
}

void ex_par(FL_OBJECT *ob, long data)
{
  fl_hide_form(Parametres->Parameters);
  fl_activate_object(GLcp->model_ps);
}

/* callbacks and freeobj handles for form Help */

void cb_help(FL_OBJECT *ob, long data)
{
  Help = create_form_Help();
  
  if(fl_mouse_button())
    fl_show_form(Help->Help_me, FL_PLACE_MOUSE|FL_FREE_SIZE, border2, 
		 "Help Window");

  fl_deactivate_object(GLcp->help_win);
}

void exit_help(FL_OBJECT *ob, long data)
{
  fl_hide_form(Help->Help_me);
  fl_activate_object(GLcp->help_win);
}

/* callbacks and freeobj handles for form Oposition */

void cb_oposition(FL_OBJECT *ob, long data)
{
  Oposition = create_form_Oposition();
  
  if(fl_mouse_button())
    fl_show_form(Oposition->O_position, FL_PLACE_MOUSE|FL_FREE_SIZE, border2, 
		 "Input Window for Observed Image Positions");

  fl_deactivate_object(GLcp->obip);
}

void cb_image_coordinates_add(FL_OBJECT *ob, long data)
{
  FD_Oposition *main_form = (FD_Oposition *) data; 

  char s[1024];

  sprintf(s, "%s; %s",
          fl_get_input(main_form->imp_x), fl_get_input(main_form->imp_y));
  fl_add_browser_line(main_form->image_locations, s);

  x_obs[Index2] = atof(fl_get_input(main_form->imp_x));
  y_obs[Index2] = atof(fl_get_input(main_form->imp_y));

  Index2 +=1;
}

void cb_image_coordinates_replace(FL_OBJECT *ob, long data)
{
  FD_Oposition *main_form = (FD_Oposition *)data; 

  char s[1024];
  int n;

  if((n=fl_get_browser(main_form->image_locations))) {
    sprintf(s, "%s; %s",
	    fl_get_input(main_form->imp_x),
	    fl_get_input(main_form->imp_y));
    fl_replace_browser_line(main_form->image_locations, n, s);
  }

  x_obs[Index2] = atof(fl_get_input(main_form->imp_x));
  y_obs[Index2] = atof(fl_get_input(main_form->imp_y));

  Index2 +=1;
}

void cb_image_coordinates_remove(FL_OBJECT *ob, long data)
{
  FD_Oposition *main_form = (FD_Oposition *)data; 

  int n;
  
  if((n=fl_get_browser(main_form->image_locations)))
    fl_delete_browser_line(main_form->image_locations,n);

  x_obs[Index2] = 0.0;
  y_obs[Index2] = 0.0;

  Index2 -= 1;
}

void cb_image_coordinates_clear(FL_OBJECT *ob, long data)
{
  int i;
  
  FD_Oposition *main_form = (FD_Oposition *) data; 

  fl_clear_browser(main_form->image_locations);

  Index2 = 0;

  for(i = 0; i < Number_of_images; i++) {
    x_obs[i] = 0.0;
    y_obs[i] = 0.0;
  }
}

void cb_imp(FL_OBJECT *ob, long data)
{
  char s1[9], s2[9];

  FD_Oposition *main_form = (FD_Oposition *)data; 

  int n;

  if(ob != (main_form->image_locations))
    return;

  if((n=fl_get_browser(main_form->image_locations))) {
    sscanf(fl_get_browser_line(ob, n),
	   "%8[0123456789.-+]; %8[0123456789.-+]", s1, s2);
    fl_set_input(main_form->imp_x, s1);
    fl_set_input(main_form->imp_y, s2);
  }
}

void cb_obimpos(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  GLUquadricObj *qobj = gluNewQuadric();

  int n, i;
  char s1[9], s2[9];
  double x, y;

  glColor3f(0.0, 1.0, 0.0);

  /* gluQuadricDrawStyle(qobj, GLU_SILHOUETTE); */

  /* glPushMatrix();  
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();  */

  if(fl_get_button(ob)) {
    n = fl_get_browser_maxline(Oposition->image_locations);
      
    for(i = 1; i <= n; ++i) {
      sscanf(fl_get_browser_line(Oposition->image_locations, i),
             "%8[0123456789.-+]; %8[0123456789.-+]", s1, s2);

      x = strtod(s1, NULL);
      y = strtod(s2, NULL);

      gluQuadricDrawStyle(qobj, GLU_SILHOUETTE);
      glTranslated(x, y, 0.0); 	
      gluDisk(qobj, 0.10, 0.75, 32, 1);
    }
  }

  /* glTranslated(1.0, 1.0, 0.0); */
  /* gluDisk(qobj, 0.20, 0.40, 32, 3); */

  glPopMatrix();     
  gluDeleteQuadric(qobj); 

  /* Refresh */
 
  handle_expose(0, 0);
}

void cb_impset(FL_OBJECT *ob, long data)
{
  int i; 

  Number_of_images = atoi(fl_get_input(Oposition->inp_noim));
  
  printf("Number_of_images = %d \n", Number_of_images); 

  for(i = 0; i < Number_of_images; i++) {
    printf("x_obs[%d] = %g, y_obs[%d] = %g \n", i, x_obs[i], i, y_obs[i]);
  }
}

void cb_impreset(FL_OBJECT *ob, long data)
{
  int i;

  Number_of_images = atoi(fl_get_input(Oposition->inp_noim));
  
  /* printf("Number_of_images = %d\n", Number_of_images); */

  Index2 = 0;
  
  for(i = 0; i < Number_of_images; i++) {
    x_obs[i] = 0.0;
    y_obs[i] = 0.0;
  }
}

void exit_op(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  fl_hide_form(Oposition->O_position);
  fl_activate_object(GLcp->obip);
}

void cb_root_positions(FL_OBJECT *ob, long data)
{
  int ir = 0, color = 4;
  double dxi = 1.0;
  double dxf, dyf;
  double xf  = 4.0;  

  VEC x_init;

  switch(current_model) {
  case M_MODEL_MENU:
    break;
  case M_CHANG_REFSDAL:    
  case M_SING_ISOT_SPHERE:
  case M_DE_VAUCOULEUR:
  case M_KING:
  case M_HUBBLE:
  case M_SPIRAL:
  case M_TRUNC_KING:
  case M_NSING_ISOT_SPHERE:
  case M_TRANSP_SPHERE:
  case M_ELLIPTICAL:
  case M_MULTIPOLE:
  case M_ROTATION_LENS:
  case M_DOUBLE_LENS:
  case M_UNIFORM_RING:
    for(dxf = - xf; dxf <= xf; dxf += dxi) {
      for(dyf = - xf; dyf <= xf; dyf += dxi) {    
	x_init[0] = dxf; 
	x_init[1] = dyf;
	
	roots(x_init, ir, color);       

	ir += 1;
      }
    }
    
    break;
  default:
    break;
  }
  
  glXSwapBuffers(fl_display, GLwin);
}

void cb_roots(FL_OBJECT *ob, long data)
{
  char s[10];

  Roots = create_form_Roots();
  
  if(fl_mouse_button())
    fl_show_form(Roots->Root, FL_PLACE_MOUSE|FL_FREE_SIZE, border2, 
		 "Input Window for Observed Image Positions");

  switch(current_model) {
  case M_MODEL_MENU:
    break;
  case M_CHANG_REFSDAL:    
    Number_of_roots = 4;   
    break;
  case M_SING_ISOT_SPHERE:
    Number_of_roots = 4;   
    break;
  case M_DE_VAUCOULEUR:
    Number_of_roots = 4;   
    break;       
  case M_KING:
    Number_of_roots = 5;   
    break;
  case M_HUBBLE:
    Number_of_roots = 5;   
    break;
  case M_SPIRAL:
    Number_of_roots = 8;   
    break;    
  case M_TRUNC_KING:
    Number_of_roots = 9;   
    break;
  case M_NSING_ISOT_SPHERE:
    Number_of_roots = 5;   
    break;
  case M_TRANSP_SPHERE:
    Number_of_roots = 5;   
    break;
  case M_ELLIPTICAL:
    Number_of_roots = 5;   
    break;
  case M_MULTIPOLE:
    Number_of_roots = 8;   
    break;
  case M_ROTATION_LENS:
    Number_of_roots = 5;   
    break;
  case M_DOUBLE_LENS:
    Number_of_roots = 9;   
    break;
  case M_UNIFORM_RING:
    Number_of_roots = 9;   
    break;
  default:
    break;
  }

  sprintf(s, "%d", Number_of_roots);

  fl_set_input(Roots->inp_nor, s);

  fl_deactivate_object(GLcp->root_pos);
} 

void cb_root_coordinates_add(FL_OBJECT *ob, long data)
{
  FD_Roots *main_form = (FD_Roots *) data; 

  char s[1024];

  sprintf(s, "%s; %s",
          fl_get_input(main_form->rp_x), fl_get_input(main_form->rp_y));
  fl_add_browser_line(main_form->root_locations, s);

  Xr[Index][0] = atof(fl_get_input(main_form->rp_x));
  Xr[Index][1] = atof(fl_get_input(main_form->rp_y));

  Index +=1;
}

void cb_root_coordinates_replace(FL_OBJECT *ob, long data)
{
  FD_Roots *main_form = (FD_Roots *) data; 

  char s[1024];
  int n;

  if((n=fl_get_browser(main_form->root_locations))) {
    sprintf(s, "%s; %s",
	    fl_get_input(main_form->rp_x),
	    fl_get_input(main_form->rp_y));
    fl_replace_browser_line(main_form->root_locations, n, s);
  }

  Xr[Index][0] = atof(fl_get_input(main_form->rp_x));
  Xr[Index][1] = atof(fl_get_input(main_form->rp_y));

  Index +=1;
}

void cb_root_coordinates_remove(FL_OBJECT *ob, long data)
{
  FD_Roots *main_form = (FD_Roots *) data; 

  int n;
  
  if((n = fl_get_browser(main_form->root_locations)))
    fl_delete_browser_line(main_form->root_locations, n);

  Xr[Index][0] = 0.0;
  Xr[Index][1] = 0.0;

  Index -= 1;
}

void cb_root_coordinates_clear(FL_OBJECT *ob, long data)
{
  int i;
  
  FD_Roots *main_form = (FD_Roots *) data; 

  fl_clear_browser(main_form->root_locations);

  Index = 0;

  for(i = 0; i < Number_of_roots; i++) {
    Xr[i][0] = 0.0;
    Xr[i][1] = 0.0;
  }
}

void cb_rp(FL_OBJECT *ob, long data)
{
  char s1[9], s2[9];

  FD_Roots *main_form = (FD_Roots *) data; 

  int n;

   if(ob != (main_form->root_locations))
    return;

  if((n = fl_get_browser(main_form->root_locations))) {
    sscanf(fl_get_browser_line(ob, n),
	   "%8[0123456789.-+]; %8[0123456789.-+]", s1, s2);
    fl_set_input(main_form->rp_x, s1);
    fl_set_input(main_form->rp_y, s2);
  }
}

void cb_rpset(FL_OBJECT *ob, long data)
{
  /* int i; */
  
  char s[10];

  /* atoi, atof: these functions convert string to an interger or a double */

  Number_of_roots = atoi(fl_get_input(Roots->inp_nor));
  
  sprintf(s, "%d", Number_of_roots);

  fl_set_input(Roots->inp_nor, s);

  /* printf("%d\n", Number_of_roots); */

  /* SWEPT = 4; */

  SWEPT = current_swept;

  /* printf("SWEPT = %d\n", SWEPT); */

  /*
    
  for(i = 0; i < Number_of_roots; i++) {
    x_root[i] = Xr[i][0];
    y_root[i] = Xr[i][1];

    printf("x_root[%d] = %g, y_root[%d] = %g\n", i, x_root[i], i, y_root[i]);
  }
  
  **/
}

void cb_rpreset(FL_OBJECT *ob, long data)
{
  int i;
  char s[10];

  switch(current_model) {
  case M_MODEL_MENU:
    break;
  case M_CHANG_REFSDAL:    
    Number_of_roots = 4;   
    break;
  case M_SING_ISOT_SPHERE:
    Number_of_roots = 4;   
    break;
  case M_DE_VAUCOULEUR:
    Number_of_roots = 4;   
    break;       
  case M_KING:
    Number_of_roots = 5;   
    break;
  case M_HUBBLE:
    Number_of_roots = 5;   
    break;
  case M_SPIRAL:
    Number_of_roots = 8;   
    break;    
  case M_TRUNC_KING:
    Number_of_roots = 9;   
    break;
  case M_NSING_ISOT_SPHERE:
    Number_of_roots = 5;   
    break;
  case M_TRANSP_SPHERE:
    Number_of_roots = 5;   
    break;
  case M_ELLIPTICAL:
    Number_of_roots = 5;   
    break;
  case M_MULTIPOLE:
    Number_of_roots = 8;   
    break;
  case M_ROTATION_LENS:
    Number_of_roots = 5;   
    break;
  case M_DOUBLE_LENS:
    Number_of_roots = 9;   
    break;
  case M_UNIFORM_RING:
    Number_of_roots = 9;   
    break;
  default:
    break;
  }

  sprintf(s, "%d", Number_of_roots);

  fl_set_input(Roots->inp_nor, s);

  SWEPT = 0;

  // SIM_AN = FALSE;

  PRAXIS = FALSE;
  
  /* printf("SWEPT = %d\n", SWEPT); */

  Index = 0;
  
  for(i = 0; i < Number_of_roots; i++) {
    Xr[i][0] = 0.0;
    Xr[i][1] = 0.0;
  }
}

void cb_drawroots(FL_OBJECT *ob, long data)
{
  switch(current_model) {
  case M_MODEL_MENU:
    break;
  case M_CHANG_REFSDAL:    
  case M_SING_ISOT_SPHERE:
  case M_DE_VAUCOULEUR:
  case M_KING:
  case M_HUBBLE:
  case M_SPIRAL:
  case M_TRUNC_KING:
  case M_NSING_ISOT_SPHERE:
  case M_TRANSP_SPHERE:
  case M_ELLIPTICAL:
  case M_MULTIPOLE:
  case M_ROTATION_LENS:
  case M_DOUBLE_LENS:
  case M_UNIFORM_RING:
    root_finder(Swept, Zero, 4);      
    break;
  default:
    break;
  }

  // draw_niveau();

  glXSwapBuffers(fl_display, GLwin);
}

void cb_initr(FL_OBJECT *ob, long data)
{
  Swept = fl_get_slider_value(Roots->swept);

  /* printf("Swept = %g\n", Swept); */
}

void cb_swept(FL_OBJECT *ob, long data)
{
  /*
    
  if(fl_get_button(Roots->fswept)) {
    SWEPT = 1;
  }

  if(fl_get_button(Roots->sswept)) {
    SWEPT = 2;
  }

  if(fl_get_button(Roots->tswept)) {
    SWEPT = 3;
  }

  */
  
  /* printf("SWEPT = %d\n", SWEPT); */
}

void cb_swept_save(FL_OBJECT *ob, long data)
{
  current_swept = fl_get_menu(Roots->swept_save);

  switch(current_swept) {
  case 1:
    SWEPT = 1;
    break;
  case 2:
    SWEPT = 2;
    break;
  case 3: 
    SWEPT = 3;
    break;
  default:
    break;
  }
}

void exit_root(FL_OBJECT *ob, long data)
{
  fl_hide_form(Roots->Root);
  fl_activate_object(GLcp->root_pos);
}

void cb_min_td(FL_OBJECT *ob, long data)
{  
  switch(current_model) {
  case M_MODEL_MENU:
    break;
  case M_CHANG_REFSDAL:    
  case M_SING_ISOT_SPHERE:
  case M_DE_VAUCOULEUR:
  case M_KING:
  case M_HUBBLE:
  case M_SPIRAL:
  case M_TRUNC_KING:
  case M_NSING_ISOT_SPHERE:
  case M_TRANSP_SPHERE:
  case M_ELLIPTICAL:
  case M_MULTIPOLE:
  case M_ROTATION_LENS:
  case M_DOUBLE_LENS:
  case M_UNIFORM_RING:
    // minimum_time_delay(); 

    break;
  default:
    break;
  }     

  glXSwapBuffers(fl_display, GLwin);      
} 

void cb_opt_siman(FL_OBJECT *ob, long data)
{
  char s[10], s2[10];

  Optimum = create_form_Optimum();
  
  if(fl_mouse_button())
    fl_show_form(Optimum->Optimum, FL_PLACE_MOUSE|FL_FREE_SIZE, border2, 
		 "Optimization Window");

  switch(current_model) {
  case M_MODEL_MENU:
    break;
  case M_CHANG_REFSDAL:    
    Number_of_params = 7;   
    break;
  case M_SING_ISOT_SPHERE:
    Number_of_params = 8;   
    break;
  case M_DE_VAUCOULEUR:
    Number_of_params = 8;
    break;       
  case M_KING:
    Number_of_params = 8;   
    break;
  case M_HUBBLE:
    Number_of_params = 8;   
    break;
  case M_SPIRAL:
    Number_of_params = 9;   
    break;    
  case M_TRUNC_KING:
    Number_of_params = 9;   
    break;
  case M_NSING_ISOT_SPHERE:
    Number_of_params = 9;   
    break;
  case M_TRANSP_SPHERE:
    Number_of_params = 8;   
    break;
  case M_ELLIPTICAL:
    Number_of_params = 11;   
    break;
  case M_MULTIPOLE:
    Number_of_params = 13;   
    break;
  case M_ROTATION_LENS:
    Number_of_params = 9;   
    break;
  case M_DOUBLE_LENS:
    Number_of_params = 17;   
    break;
  case M_UNIFORM_RING:
    Number_of_params = 10;   
    break;
  default:
    break;
  }

  sprintf(s, "%d", Number_of_params);
  sprintf(s2, "%d", N_constraints);

  fl_set_input(Optimum->inp_nop, s);
  fl_set_input(Optimum->n_consts, s2);

  fl_deactivate_object(GLcp->optimum);
}

void cb_optimum(FL_OBJECT *ob, long data)
{
  char s[10], s2[10];

  Optimum = create_form_Optimum();
  
  if(fl_mouse_button())
    fl_show_form(Optimum->Optimum, FL_PLACE_MOUSE|FL_FREE_SIZE, border2, 
		 "Optimization Window");

  switch(current_model) {
  case M_MODEL_MENU:
    break;
  case M_CHANG_REFSDAL:    
    Number_of_params = 7;   
    break;
  case M_SING_ISOT_SPHERE:
    Number_of_params = 8;   
    break;
  case M_DE_VAUCOULEUR:
    Number_of_params = 8;
    break;       
  case M_KING:
    Number_of_params = 8;   
    break;
  case M_HUBBLE:
    Number_of_params = 8;   
    break;
  case M_SPIRAL:
    Number_of_params = 9;   
    break;    
  case M_TRUNC_KING:
    Number_of_params = 9;   
    break;
  case M_NSING_ISOT_SPHERE:
    Number_of_params = 9;   
    break;
  case M_TRANSP_SPHERE:
    Number_of_params = 8;   
    break;
  case M_ELLIPTICAL:
    Number_of_params = 11;   
    break;
  case M_MULTIPOLE:
    Number_of_params = 13;   
    break;
  case M_ROTATION_LENS:
    Number_of_params = 9;   
    break;
  case M_DOUBLE_LENS:
    Number_of_params = 17;   
    break;
  case M_UNIFORM_RING:
    Number_of_params = 10;   
    break;
  default:
    break;
  }

  sprintf(s, "%d", Number_of_params);
  sprintf(s2, "%d", N_constraints);

  fl_set_input(Optimum->inp_nop, s);
  fl_set_input(Optimum->n_consts, s2);

  fl_deactivate_object(GLcp->optimum);
}

void ex_opt(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  fl_hide_form(Optimum->Optimum);
  fl_activate_object(GLcp->optimum);
}

void optim_of_models(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  char s1[10], s2[10], s3[10], s4[10], s5[10], s6[10], s7[10], s8[10];
  char s9[10], s10[10], s11[10], s12[10], s13[10], s14[10], s15[10], s16[10];
  char s17[10], s18[10], s19[10], s20[10], s21[10], s22[10], s23[10], s24[10];
  char s25[10], s26[10], s27[10], s28[10], s29[10], s30[10], s31[10], s32[10];
  char s33[10], s34[10];

  /* s35[10], s36[10], s37[10], s38[10], s39[10], s40[10]; */

  /* SWEPT = 3; */

  // optimization(); 

  if(sl_model == FALSE && sl_macro == FALSE &&
     sl_re == FALSE && sl_position == FALSE) {
    printf("Set the parameters that have to be optimized"
           " in the corresponding model parameter window \n");
  } else {
    main_praxis();
  
    switch(current_model) {
    case M_MODEL_MENU:
      sprintf(s1, "%g", xl);
      fl_set_input(Parametres->input_x, s1);  

      sprintf(s2, "%g", yl);
      fl_set_input(Parametres->input_y, s2);  

      sprintf(s3, "%g", parms[P_E]);
      fl_set_input(Parametres->input_E, s3);  
    
      sprintf(s4, "%g", (180.0 * parms[P_THETA]) / M_PI);
      fl_set_input(Parametres->input_theta, s4);  

      sprintf(s5, "%g", parms[P_GAMMA]);
      fl_set_input(Parametres->input_gamma, s5);  

      sprintf(s6, "%g", parms[P_SIGMA]);
      fl_set_input(Parametres->input_sigma, s6);  

      sprintf(s7, "%g", (180.0 * parms[P_PHI]) / M_PI);
      fl_set_input(Parametres->input_phi, s7);  

      sprintf(s8, "%g", parms[P_GAMMA2]);
      fl_set_input(Parametres->input_gamma2, s8);  

      sprintf(s9, "%g", parms[P_SIGMA2]);
      fl_set_input(Parametres->input_sigma2, s9);

      sprintf(s10, "%g", (180.0 * parms[P_PHI2]) / M_PI);
      fl_set_input(Parametres->input_phi2, s10);  

      sprintf(s11, "%g", parms[P_ALPHA]);
      fl_set_input(Parametres->input_alpha, s11);  

      sprintf(s12, "%g", parms[P_ALPHA2]);
      fl_set_input(Parametres->input_alpha2, s12);  
    
      sprintf(s13, "%g", parms[P_KAPPA]);
      fl_set_input(Parametres->input_kappa, s13);  

      sprintf(s14, "%g", parms[P_KAPPA0]);
      fl_set_input(Parametres->input_kappa0, s14);  

      sprintf(s15, "%g", parms[P_KAPPA2]);
      fl_set_input(Parametres->input_kappa2, s15);  

      sprintf(s16, "%g", parms[P_EPSILON]);
      fl_set_input(Parametres->input_epsilon, s16);  

      sprintf(s17, "%g", parms[P_BETA]);
      fl_set_input(Parametres->input_beta, s17);  

      sprintf(s18, "%g", parms[P_C]);
      fl_set_input(Parametres->input_C, s18);  

      sprintf(s19, "%g", parms[P_Ri]);
      fl_set_input(Parametres->input_ri, s19);  

      sprintf(s20, "%g", parms[P_Ro]);
      fl_set_input(Parametres->input_ro, s20);  

      sprintf(s21, "%g", parms[P_X_1]);
      fl_set_input(Parametres->input_x1, s21);  

      sprintf(s22, "%g", parms[P_Y_1]);
      fl_set_input(Parametres->input_y1, s22);  

      sprintf(s23, "%g", parms[P_M_1]);
      fl_set_input(Parametres->input_m1, s23);  

      sprintf(s24, "%g", parms[P_X_2]);
      fl_set_input(Parametres->input_x2, s24);  

      sprintf(s25, "%g", parms[P_Y_2]);  
      fl_set_input(Parametres->input_y2, s25);

      sprintf(s26, "%g", parms[P_M_2]);
      fl_set_input(Parametres->input_m2, s26);  
    
      sprintf(s27, "%g", parms[P_DX_QP]);
      fl_set_input(Parametres->input_dx, s27);  

      sprintf(s28, "%g", parms[P_DY_QP]);
      fl_set_input(Parametres->input_dy, s28);  

      sprintf(s29, "%g", parms[P_QXX]);
      fl_set_input(Parametres->input_qxx, s29);  

      sprintf(s30, "%g", parms[P_QXY]);
      fl_set_input(Parametres->input_qxy, s30);  

      sprintf(s31, "%g", parms[P_QYY]);
      fl_set_input(Parametres->input_qyy, s31);  

      sprintf(s32, "%g", parms[P_SX]);
      fl_set_input(Parametres->input_sx, s32);  

      sprintf(s33, "%g", parms[P_SY]);
      fl_set_input(Parametres->input_sy, s33);  

      sprintf(s34, "%g", parms[P_EXP]);
      fl_set_input(Parametres->input_exp, s34);

      fl_set_positioner_xvalue(GLcp->source_pos, xl);
      fl_set_positioner_yvalue(GLcp->source_pos, yl);
      fl_set_counter_value(GLcp->x_pos, xl);
      fl_set_counter_value(GLcp->y_pos, yl);

      fl_set_slider_value(GLcp->p_E, Prmt[2]);

      // fl_set_slider_value(GLcp->p_theta, (180.0 * Prmt[3]) / M_PI);
      
      fl_set_slider_value(GLcp->p_theta, Prmt[3]);
      fl_set_slider_value(GLcp->p_gamma, Prmt[4]);
      fl_set_slider_value(GLcp->p_sigma, Prmt[5]);

      // fl_set_slider_value(GLcp->p_phi, (180.0 * Prmt[6]) / M_PI);

      fl_set_slider_value(GLcp->p_phi, Prmt[6]);
      fl_set_slider_value(GLcp->p_kappa, Prmt[7]);
      fl_set_slider_value(GLcp->p_epsilon, Prmt[8]);
      fl_set_slider_value(GLcp->p_C, Prmt[9]);
      fl_set_slider_value(GLcp->p_x_1, Prmt[10]);
      fl_set_slider_value(GLcp->p_y_1, Prmt[11]);
      fl_set_slider_value(GLcp->p_x_2, Prmt[12]);
      fl_set_slider_value(GLcp->p_y_2, Prmt[13]);
      fl_set_slider_value(GLcp->p_m_1, Prmt[14]);
      fl_set_slider_value(GLcp->p_m_2, Prmt[15]);
      fl_set_slider_value(GLcp->p_beta, Prmt[16]);
      fl_set_slider_value(GLcp->p_gamma2, Prmt[17]);
      fl_set_slider_value(GLcp->p_sigma2, Prmt[18]);

      // fl_set_slider_value(GLcp->p_phi2, (180.0 * Prmt[19]) / M_PI);

      fl_set_slider_value(GLcp->p_phi2, Prmt[19]);
      fl_set_slider_value(GLcp->p_sx, Prmt[20]);
      fl_set_slider_value(GLcp->p_sy, Prmt[21]);
      fl_set_slider_value(GLcp->p_alpha, Prmt[22]);
      fl_set_slider_value(GLcp->p_alpha2, Prmt[23]);
      fl_set_slider_value(GLcp->p_exp, Prmt[24]);  
      fl_set_slider_value(GLcp->p_kappa2, Prmt[25]);
      fl_set_slider_value(GLcp->p_rad_i, Prmt[26]);
      fl_set_slider_value(GLcp->p_rad_o, Prmt[27]);
      fl_set_slider_value(GLcp->p_kappa0, Prmt[28]);
      fl_set_slider_value(GLcp->p_dx_qp, Prmt[29]);
      fl_set_slider_value(GLcp->p_dy_qp, Prmt[30]);
      fl_set_slider_value(GLcp->p_qxx, Prmt[31]);
      fl_set_slider_value(GLcp->p_qxy, Prmt[32]);
      fl_set_slider_value(GLcp->p_qyy, Prmt[33]);

      break;
    case M_CHANG_REFSDAL:    
      sprintf(s1, "%g", xl);
      fl_set_input(Chang->input_x, s1);  

      sprintf(s2, "%g", yl);
      fl_set_input(Chang->input_y, s2);  

      sprintf(s3, "%g", parms[P_E]);
      fl_set_input(Chang->input_E, s3);  

      sprintf(s4, "%g", (180.0 * parms[P_THETA]) / M_PI);
      fl_set_input(Chang->input_theta, s4);  

      sprintf(s5, "%g", parms[P_GAMMA]);
      fl_set_input(Chang->input_gamma, s5);  

      sprintf(s6, "%g", parms[P_SIGMA]);
      fl_set_input(Chang->input_sigma, s6);  

      sprintf(s7, "%g", (180.0 * parms[P_PHI]) / M_PI);
      fl_set_input(Chang->input_phi, s7);  

      fl_set_positioner_xvalue(GLcp->source_pos, xl);
      fl_set_positioner_yvalue(GLcp->source_pos, yl);
      fl_set_counter_value(GLcp->x_pos, xl);
      fl_set_counter_value(GLcp->y_pos, yl);

      fl_set_slider_value(GLcp->p_E, Xprmt[2]);

      // fl_set_slider_value(GLcp->p_theta, (180.0 * Xprmt[3]) / M_PI);

      fl_set_slider_value(GLcp->p_theta, Xprmt[3]);
      fl_set_slider_value(GLcp->p_gamma, Xprmt[4]);
      fl_set_slider_value(GLcp->p_sigma, Xprmt[5]);

      // fl_set_slider_value(GLcp->p_phi, (180.0 * Xprmt[6]) / M_PI);

      fl_set_slider_value(GLcp->p_phi, Xprmt[6]);

      break;
    case M_SING_ISOT_SPHERE:
      sprintf(s1, "%g", xl);
      fl_set_input(SIS->input_x, s1);  

      sprintf(s2, "%g", yl);
      fl_set_input(SIS->input_y, s2);  

      sprintf(s3, "%g", parms[P_E]);
      fl_set_input(SIS->input_E, s3);  

      sprintf(s4, "%g", (180.0 * parms[P_THETA]) / M_PI);
      fl_set_input(SIS->input_theta, s4);  

      sprintf(s5, "%g", parms[P_GAMMA]);
      fl_set_input(SIS->input_gamma, s5);  

      sprintf(s6, "%g", parms[P_SIGMA]);
      fl_set_input(SIS->input_sigma, s6);  

      sprintf(s7, "%g", (180.0 * parms[P_PHI]) / M_PI);
      fl_set_input(SIS->input_phi, s7);  

      sprintf(s34, "%g", parms[P_EXP]);
      fl_set_input(SIS->input_exp, s34);

      fl_set_positioner_xvalue(GLcp->source_pos, xl);
      fl_set_positioner_yvalue(GLcp->source_pos, yl);
      fl_set_counter_value(GLcp->x_pos, xl);
      fl_set_counter_value(GLcp->y_pos, yl);

      fl_set_slider_value(GLcp->p_E, Xprmt[2]);

      // fl_set_slider_value(GLcp->p_theta, (180.0 * Xprmt[3]) / M_PI);

      fl_set_slider_value(GLcp->p_theta, Xprmt[3]);
      fl_set_slider_value(GLcp->p_gamma, Xprmt[4]);
      fl_set_slider_value(GLcp->p_sigma, Xprmt[5]);

      // fl_set_slider_value(GLcp->p_phi, (180.0 * Xprmt[6]) / M_PI);

      fl_set_slider_value(GLcp->p_phi, Xprmt[6]);
      fl_set_slider_value(GLcp->p_exp, Xprmt[7]);  

      break;
    case M_DE_VAUCOULEUR:
      sprintf(s1, "%g", xl);
      fl_set_input(DeVau->input_x, s1);  

      sprintf(s2, "%g", yl);
      fl_set_input(DeVau->input_y, s2);  

      sprintf(s3, "%g", parms[P_E]);
      fl_set_input(DeVau->input_E, s3);  

      sprintf(s4, "%g", (180.0 * parms[P_THETA]) / M_PI);
      fl_set_input(DeVau->input_theta, s4);  

      sprintf(s5, "%g", parms[P_GAMMA]);
      fl_set_input(DeVau->input_gamma, s5);  

      sprintf(s6, "%g", parms[P_SIGMA]);
      fl_set_input(DeVau->input_sigma, s6);  

      sprintf(s7, "%g", (180.0 * parms[P_PHI]) / M_PI);
      fl_set_input(DeVau->input_phi, s7);  

      sprintf(s13, "%g", parms[P_KAPPA]);
      fl_set_input(DeVau->input_kappa, s13);  

      fl_set_positioner_xvalue(GLcp->source_pos, xl);
      fl_set_positioner_yvalue(GLcp->source_pos, yl);
      fl_set_counter_value(GLcp->x_pos, xl);
      fl_set_counter_value(GLcp->y_pos, yl);

      fl_set_slider_value(GLcp->p_E, Xprmt[2]);

      // fl_set_slider_value(GLcp->p_theta, (180.0 * Xprmt[3]) / M_PI);

      fl_set_slider_value(GLcp->p_theta, Xprmt[3]);
      fl_set_slider_value(GLcp->p_gamma, Xprmt[4]);
      fl_set_slider_value(GLcp->p_sigma, Xprmt[5]);

      // fl_set_slider_value(GLcp->p_phi, (180.0 * Xprmt[6]) / M_PI);

      fl_set_slider_value(GLcp->p_phi, Xprmt[6]);
      fl_set_slider_value(GLcp->p_kappa, Xprmt[7]);

      break;
    case M_KING:
      sprintf(s1, "%g", xl);
      fl_set_input(King->input_x, s1);  

      sprintf(s2, "%g", yl);
      fl_set_input(King->input_y, s2);  

      sprintf(s3, "%g", parms[P_E]);
      fl_set_input(King->input_E, s3);  

      sprintf(s4, "%g", (180.0 * parms[P_THETA]) / M_PI);
      fl_set_input(King->input_theta, s4);  

      sprintf(s5, "%g", parms[P_GAMMA]);
      fl_set_input(King->input_gamma, s5);  

      sprintf(s6, "%g", parms[P_SIGMA]);
      fl_set_input(King->input_sigma, s6);  

      sprintf(s7, "%g", (180.0 * parms[P_PHI]) / M_PI);
      fl_set_input(King->input_phi, s7);  

      sprintf(s13, "%g", parms[P_KAPPA]);
      fl_set_input(King->input_kappa, s13);  

      fl_set_positioner_xvalue(GLcp->source_pos, xl);
      fl_set_positioner_yvalue(GLcp->source_pos, yl);
      fl_set_counter_value(GLcp->x_pos, xl);
      fl_set_counter_value(GLcp->y_pos, yl);

      fl_set_slider_value(GLcp->p_E, Xprmt[2]);

      // fl_set_slider_value(GLcp->p_theta, (180.0 * Xprmt[3]) / M_PI);

      fl_set_slider_value(GLcp->p_theta, Xprmt[3]);
      fl_set_slider_value(GLcp->p_gamma, Xprmt[4]);
      fl_set_slider_value(GLcp->p_sigma, Xprmt[5]);

      // fl_set_slider_value(GLcp->p_phi, (180.0 * Xprmt[6]) / M_PI);

      fl_set_slider_value(GLcp->p_phi, Xprmt[6]);
      fl_set_slider_value(GLcp->p_kappa, Xprmt[7]);

      break;
    case M_HUBBLE:
      sprintf(s1, "%g", xl);
      fl_set_input(Hubble->input_x, s1);  

      sprintf(s2, "%g", yl);
      fl_set_input(Hubble->input_y, s2);  

      sprintf(s3, "%g", parms[P_E]);
      fl_set_input(Hubble->input_E, s3);  

      sprintf(s4, "%g", (180.0 * parms[P_THETA]) / M_PI);
      fl_set_input(Hubble->input_theta, s4);  

      sprintf(s5, "%g", parms[P_GAMMA]);
      fl_set_input(Hubble->input_gamma, s5);  

      sprintf(s6, "%g", parms[P_SIGMA]);
      fl_set_input(Hubble->input_sigma, s6);  

      sprintf(s7, "%g", (180.0 * parms[P_PHI]) / M_PI);
      fl_set_input(Hubble->input_phi, s7);  

      sprintf(s13, "%g", parms[P_KAPPA]);
      fl_set_input(Hubble->input_kappa, s13);  

      fl_set_positioner_xvalue(GLcp->source_pos, xl);
      fl_set_positioner_yvalue(GLcp->source_pos, yl);
      fl_set_counter_value(GLcp->x_pos, xl);
      fl_set_counter_value(GLcp->y_pos, yl);

      fl_set_slider_value(GLcp->p_E, Xprmt[2]);

      // fl_set_slider_value(GLcp->p_theta, (180.0 * Xprmt[3]) / M_PI);

      fl_set_slider_value(GLcp->p_theta, Xprmt[3]);
      fl_set_slider_value(GLcp->p_gamma, Xprmt[4]);
      fl_set_slider_value(GLcp->p_sigma, Xprmt[5]);

      // fl_set_slider_value(GLcp->p_phi, (180.0 * Xprmt[6]) / M_PI);

      fl_set_slider_value(GLcp->p_phi, Xprmt[6]);
      fl_set_slider_value(GLcp->p_kappa, Xprmt[7]);

      break;
    case M_SPIRAL:
      sprintf(s1, "%g", xl);
      fl_set_input(Spiral_M->input_x, s1);  

      sprintf(s2, "%g", yl);
      fl_set_input(Spiral_M->input_y, s2);  

      sprintf(s3, "%g", parms[P_E]);
      fl_set_input(Spiral_M->input_E, s3);  

      sprintf(s4, "%g", (180.0 * parms[P_THETA]) / M_PI);
      fl_set_input(Spiral_M->input_theta, s4);  

      sprintf(s5, "%g", parms[P_GAMMA]);
      fl_set_input(Spiral_M->input_gamma, s5);  

      sprintf(s6, "%g", parms[P_SIGMA]);
      fl_set_input(Spiral_M->input_sigma, s6);  

      sprintf(s7, "%g", (180.0 * parms[P_PHI]) / M_PI);
      fl_set_input(Spiral_M->input_phi, s7);  

      sprintf(s12, "%g", parms[P_ALPHA2]);
      fl_set_input(Spiral_M->input_alpha2, s12);  

      sprintf(s13, "%g", parms[P_KAPPA]);
      fl_set_input(Spiral_M->input_kappa, s13);  

      fl_set_positioner_xvalue(GLcp->source_pos, xl);
      fl_set_positioner_yvalue(GLcp->source_pos, yl);
      fl_set_counter_value(GLcp->x_pos, xl);
      fl_set_counter_value(GLcp->y_pos, yl);

      fl_set_slider_value(GLcp->p_E, Xprmt[2]);

      // fl_set_slider_value(GLcp->p_theta, (180.0 * Xprmt[3]) / M_PI);

      fl_set_slider_value(GLcp->p_theta, Xprmt[3]);
      fl_set_slider_value(GLcp->p_gamma, Xprmt[4]);
      fl_set_slider_value(GLcp->p_sigma, Xprmt[5]);

      // fl_set_slider_value(GLcp->p_phi, (180.0 * Xprmt[6]) / M_PI);

      fl_set_slider_value(GLcp->p_phi, Xprmt[6]);
      fl_set_slider_value(GLcp->p_kappa, Xprmt[7]);
      fl_set_slider_value(GLcp->p_alpha, Xprmt[8]);

      break;
    case M_TRUNC_KING:
      sprintf(s1, "%g", xl);
      fl_set_input(TKing->input_x, s1);  

      sprintf(s2, "%g", yl);
      fl_set_input(TKing->input_y, s2);  

      sprintf(s3, "%g", parms[P_E]);
      fl_set_input(TKing->input_E, s3);  

      sprintf(s4, "%g", (180.0 * parms[P_THETA]) / M_PI);
      fl_set_input(TKing->input_theta, s4);  

      sprintf(s5, "%g", parms[P_GAMMA]);
      fl_set_input(TKing->input_gamma, s5);  

      sprintf(s6, "%g", parms[P_SIGMA]);
      fl_set_input(TKing->input_sigma, s6);  

      sprintf(s7, "%g", (180.0 * parms[P_PHI]) / M_PI);
      fl_set_input(TKing->input_phi, s7);  

      sprintf(s15, "%g", parms[P_KAPPA2]);
      fl_set_input(TKing->input_kappa2, s15);  

      sprintf(s18, "%g", parms[P_C]);
      fl_set_input(TKing->input_C, s18);  

      fl_set_positioner_xvalue(GLcp->source_pos, xl);
      fl_set_positioner_yvalue(GLcp->source_pos, yl);
      fl_set_counter_value(GLcp->x_pos, xl);
      fl_set_counter_value(GLcp->y_pos, yl);

      fl_set_slider_value(GLcp->p_E, Xprmt[2]);

      // fl_set_slider_value(GLcp->p_theta, (180.0 * Xprmt[3]) / M_PI);

      fl_set_slider_value(GLcp->p_theta, Xprmt[3]);
      fl_set_slider_value(GLcp->p_gamma, Xprmt[4]);
      fl_set_slider_value(GLcp->p_sigma, Xprmt[5]);

      // fl_set_slider_value(GLcp->p_phi, (180.0 * Xprmt[6]) / M_PI);

      fl_set_slider_value(GLcp->p_phi, Xprmt[6]);
      fl_set_slider_value(GLcp->p_C, Xprmt[7]);
      fl_set_slider_value(GLcp->p_kappa2, Xprmt[8]);

      break;
    case M_NSING_ISOT_SPHERE:
      sprintf(s1, "%g", xl);
      fl_set_input(NSIS->input_x, s1);  

      sprintf(s2, "%g", yl);
      fl_set_input(NSIS->input_y, s2);  

      sprintf(s3, "%g", parms[P_E]);
      fl_set_input(NSIS->input_E, s3);  

      sprintf(s4, "%g", (180.0 * parms[P_THETA]) / M_PI);
      fl_set_input(NSIS->input_theta, s4);  

      sprintf(s5, "%g", parms[P_GAMMA]);
      fl_set_input(NSIS->input_gamma, s5);  

      sprintf(s6, "%g", parms[P_SIGMA]);
      fl_set_input(NSIS->input_sigma, s6);  

      sprintf(s7, "%g", (180.0 * parms[P_PHI]) / M_PI);
      fl_set_input(NSIS->input_phi, s7);  
    
      sprintf(s13, "%g", parms[P_KAPPA]);
      fl_set_input(NSIS->input_kappa, s13);  

      sprintf(s18, "%g", parms[P_C]);
      fl_set_input(NSIS->input_C, s18);  
      
      fl_set_positioner_xvalue(GLcp->source_pos, xl);
      fl_set_positioner_yvalue(GLcp->source_pos, yl);
      fl_set_counter_value(GLcp->x_pos, xl);
      fl_set_counter_value(GLcp->y_pos, yl);

      fl_set_slider_value(GLcp->p_E, Xprmt[2]);

      // fl_set_slider_value(GLcp->p_theta, (180.0 * Xprmt[3]) / M_PI);

      fl_set_slider_value(GLcp->p_theta, Xprmt[3]);
      fl_set_slider_value(GLcp->p_gamma, Xprmt[4]);
      fl_set_slider_value(GLcp->p_sigma, Xprmt[5]);

      // fl_set_slider_value(GLcp->p_phi, (180.0 * Xprmt[6]) / M_PI);

      fl_set_slider_value(GLcp->p_phi, Xprmt[6]);
      fl_set_slider_value(GLcp->p_kappa, Xprmt[7]);
      fl_set_slider_value(GLcp->p_C, Xprmt[8]);

      break;
    case M_TRANSP_SPHERE:
      sprintf(s1, "%g", xl);
      fl_set_input(Sphere->input_x, s1);  

      sprintf(s2, "%g", yl);
      fl_set_input(Sphere->input_y, s2);  

      sprintf(s3, "%g", parms[P_E]);
      fl_set_input(Sphere->input_E, s3);  

      sprintf(s4, "%g", (180.0 * parms[P_THETA]) / M_PI);
      fl_set_input(Sphere->input_theta, s4);  

      sprintf(s5, "%g", parms[P_GAMMA]);
      fl_set_input(Sphere->input_gamma, s5);  
      
      sprintf(s6, "%g", parms[P_SIGMA]);
      fl_set_input(Sphere->input_sigma, s6);  

      sprintf(s7, "%g", (180.0 * parms[P_PHI]) / M_PI);
      fl_set_input(Sphere->input_phi, s7);  

      sprintf(s18, "%g", parms[P_C]);
      fl_set_input(Sphere->input_C, s18);  
      
      fl_set_positioner_xvalue(GLcp->source_pos, xl);
      fl_set_positioner_yvalue(GLcp->source_pos, yl);
      fl_set_counter_value(GLcp->x_pos, xl);
      fl_set_counter_value(GLcp->y_pos, yl);

      fl_set_slider_value(GLcp->p_E, Xprmt[2]);

      // fl_set_slider_value(GLcp->p_theta, (180.0 * Xprmt[3]) / M_PI);

      fl_set_slider_value(GLcp->p_theta, Xprmt[3]);
      fl_set_slider_value(GLcp->p_gamma, Xprmt[4]);
      fl_set_slider_value(GLcp->p_sigma, Xprmt[5]);

      // fl_set_slider_value(GLcp->p_phi, (180.0 * Xprmt[6]) / M_PI);

      fl_set_slider_value(GLcp->p_phi, Xprmt[6]);
      fl_set_slider_value(GLcp->p_C, Xprmt[7]);

      break;
    case M_ELLIPTICAL:
      sprintf(s1, "%g", xl);
      fl_set_input(Elliptic->input_x, s1);  

      sprintf(s2, "%g", yl);
      fl_set_input(Elliptic->input_y, s2);  

      sprintf(s3, "%g", parms[P_E]);
      fl_set_input(Elliptic->input_E, s3);  

      sprintf(s4, "%g", (180.0 * parms[P_THETA]) / M_PI);
      fl_set_input(Elliptic->input_theta, s4);  

      sprintf(s5, "%g", parms[P_GAMMA]);
      fl_set_input(Elliptic->input_gamma, s5);  

      sprintf(s6, "%g", parms[P_SIGMA]);
      fl_set_input(Elliptic->input_sigma, s6);  
      
      sprintf(s7, "%g", (180.0 * parms[P_PHI]) / M_PI);
      fl_set_input(Elliptic->input_phi, s7);  

      sprintf(s11, "%g", parms[P_ALPHA]);
      fl_set_input(Elliptic->input_alpha, s11);  

      sprintf(s13, "%g", parms[P_KAPPA]);
      fl_set_input(Elliptic->input_kappa, s13);  

      sprintf(s16, "%g", parms[P_EPSILON]);
      fl_set_input(Elliptic->input_epsilon, s16);  

      sprintf(s18, "%g", parms[P_C]);
      fl_set_input(Elliptic->input_C, s18);  
    
      fl_set_positioner_xvalue(GLcp->source_pos, xl);
      fl_set_positioner_yvalue(GLcp->source_pos, yl);
      fl_set_counter_value(GLcp->x_pos, xl);
      fl_set_counter_value(GLcp->y_pos, yl);

      fl_set_slider_value(GLcp->p_E, Xprmt[2]);

      // fl_set_slider_value(GLcp->p_theta, (180.0 * Xprmt[3]) / M_PI);

      fl_set_slider_value(GLcp->p_theta, Xprmt[3]);
      fl_set_slider_value(GLcp->p_gamma, Xprmt[4]);
      fl_set_slider_value(GLcp->p_sigma, Xprmt[5]);

      // fl_set_slider_value(GLcp->p_phi, (180.0 * Xprmt[6]) / M_PI);

      fl_set_slider_value(GLcp->p_phi, Xprmt[6]);
      fl_set_slider_value(GLcp->p_kappa, Xprmt[7]);
      fl_set_slider_value(GLcp->p_epsilon, Xprmt[8]);
      fl_set_slider_value(GLcp->p_C, Xprmt[9]);
      fl_set_slider_value(GLcp->p_alpha, Xprmt[10]);

      printf("Model --> Elliptical \n");

      break;
    case M_MULTIPOLE:
      sprintf(s1, "%g", xl);
      fl_set_input(Multi->input_x, s1);  

      sprintf(s2, "%g", yl);
      fl_set_input(Multi->input_y, s2);  

      sprintf(s3, "%g", parms[P_E]);
      fl_set_input(Multi->input_E, s3);  

      sprintf(s4, "%g", (180.0 * parms[P_THETA]) / M_PI);
      fl_set_input(Multi->input_theta, s4);  

      sprintf(s5, "%g", parms[P_GAMMA]);
      fl_set_input(Multi->input_gamma, s5);  

      sprintf(s6, "%g", parms[P_SIGMA]);
      fl_set_input(Multi->input_sigma, s6);  

      sprintf(s7, "%g", (180.0 * parms[P_PHI]) / M_PI);
      fl_set_input(Multi->input_phi, s7);  

      sprintf(s14, "%g", parms[P_KAPPA0]);
      fl_set_input(Multi->input_kappa0, s14);  

      sprintf(s27, "%g", parms[P_DX_QP]);
      fl_set_input(Multi->input_dx, s27);  

      sprintf(s28, "%g", parms[P_DY_QP]);
      fl_set_input(Multi->input_dy, s28);  

      sprintf(s29, "%g", parms[P_QXX]);
      fl_set_input(Multi->input_qxx, s29);  

      sprintf(s30, "%g", parms[P_QXY]);
      fl_set_input(Multi->input_qxy, s30);  

      sprintf(s31, "%g", parms[P_QYY]);
      fl_set_input(Multi->input_qyy, s31);  

      fl_set_positioner_xvalue(GLcp->source_pos, xl);
      fl_set_positioner_yvalue(GLcp->source_pos, yl);
      fl_set_counter_value(GLcp->x_pos, xl);
      fl_set_counter_value(GLcp->y_pos, yl);

      fl_set_slider_value(GLcp->p_E, Xprmt[2]);

      // fl_set_slider_value(GLcp->p_theta, (180.0 * Xprmt[3]) / M_PI);
      
      fl_set_slider_value(GLcp->p_theta, Xprmt[3]);
      fl_set_slider_value(GLcp->p_gamma, Xprmt[4]);
      fl_set_slider_value(GLcp->p_sigma, Xprmt[5]);

      // fl_set_slider_value(GLcp->p_phi, (180.0 * Xprmt[6]) / M_PI);

      fl_set_slider_value(GLcp->p_phi, Xprmt[6]);
      fl_set_slider_value(GLcp->p_kappa0, Xprmt[7]);
      fl_set_slider_value(GLcp->p_dx_qp, Xprmt[8]);
      fl_set_slider_value(GLcp->p_dy_qp, Xprmt[9]);
      fl_set_slider_value(GLcp->p_qxx, Xprmt[10]);
      fl_set_slider_value(GLcp->p_qxy, Xprmt[11]);
      fl_set_slider_value(GLcp->p_qyy, Xprmt[12]);

      break;
    case M_ROTATION_LENS:
      sprintf(s1, "%g", xl);
      fl_set_input(Rotation->input_x, s1);  
    
      sprintf(s2, "%g", yl);
      fl_set_input(Rotation->input_y, s2);  

      sprintf(s3, "%g", parms[P_E]);
      fl_set_input(Rotation->input_E, s3);  

      sprintf(s4, "%g", (180.0 * parms[P_THETA]) / M_PI);
      fl_set_input(Rotation->input_theta, s4);  

      sprintf(s5, "%g", parms[P_GAMMA]);
      fl_set_input(Rotation->input_gamma, s5);  

      sprintf(s6, "%g", parms[P_SIGMA]);
      fl_set_input(Rotation->input_sigma, s6);  

      sprintf(s7, "%g", (180.0 * parms[P_PHI]) / M_PI);
      fl_set_input(Rotation->input_phi, s7);  

      sprintf(s32, "%g", parms[P_SX]);
      fl_set_input(Rotation->input_sx, s32);  

      sprintf(s33, "%g", parms[P_SY]);
      fl_set_input(Rotation->input_sy, s33);  
    
      fl_set_positioner_xvalue(GLcp->source_pos, xl);
      fl_set_positioner_yvalue(GLcp->source_pos, yl);
      fl_set_counter_value(GLcp->x_pos, xl);
      fl_set_counter_value(GLcp->y_pos, yl);

      fl_set_slider_value(GLcp->p_E, Xprmt[2]);

      // fl_set_slider_value(GLcp->p_theta, (180.0 * Xprmt[3]) / M_PI);

      fl_set_slider_value(GLcp->p_theta, Xprmt[3]);
      fl_set_slider_value(GLcp->p_gamma, Xprmt[4]);
      fl_set_slider_value(GLcp->p_sigma, Xprmt[5]);

      // fl_set_slider_value(GLcp->p_phi, (180.0 * Xprmt[6]) / M_PI);

      fl_set_slider_value(GLcp->p_phi, Xprmt[6]);
      fl_set_slider_value(GLcp->p_sx, Xprmt[7]);
      fl_set_slider_value(GLcp->p_sy, Xprmt[8]);

      break;
    case M_DOUBLE_LENS:
      sprintf(s1, "%g", xl);
      fl_set_input(Double->input_x, s1);  

      sprintf(s2, "%g", yl);
      fl_set_input(Double->input_y, s2);  

      sprintf(s3, "%g", parms[P_E]);
      fl_set_input(Double->input_E, s3);  

      sprintf(s4, "%g", (180.0 * parms[P_THETA]) / M_PI);
      fl_set_input(Double->input_theta, s4);  

      sprintf(s5, "%g", parms[P_GAMMA]);
      fl_set_input(Double->input_gamma, s5);  

      sprintf(s6, "%g", parms[P_SIGMA]);
      fl_set_input(Double->input_sigma, s6);  

      sprintf(s7, "%g", (180.0 * parms[P_PHI]) / M_PI);
      fl_set_input(Double->input_phi, s7);  

      sprintf(s8, "%g", parms[P_GAMMA2]);
      fl_set_input(Double->input_gamma2, s8);  

      sprintf(s9, "%g", parms[P_SIGMA2]);
      fl_set_input(Double->input_sigma2, s9);

      sprintf(s10, "%g", (180.0 * parms[P_PHI2]) / M_PI);
      fl_set_input(Double->input_phi2, s10);  

      sprintf(s17, "%g", parms[P_BETA]);
      fl_set_input(Double->input_beta, s17);  

      sprintf(s21, "%g", parms[P_X_1]);
      fl_set_input(Double->input_x1, s21);  

      sprintf(s22, "%g", parms[P_Y_1]);
      fl_set_input(Double->input_y1, s22);  

      sprintf(s23, "%g", parms[P_M_1]);
      fl_set_input(Double->input_m1, s23);  

      sprintf(s24, "%g", parms[P_X_2]);
      fl_set_input(Double->input_x2, s24);  

      sprintf(s25, "%g", parms[P_Y_2]);  
      fl_set_input(Double->input_y2, s25);

      sprintf(s26, "%g", parms[P_M_2]);
      fl_set_input(Double->input_m2, s26);  
    
      fl_set_positioner_xvalue(GLcp->source_pos, xl);
      fl_set_positioner_yvalue(GLcp->source_pos, yl);
      fl_set_counter_value(GLcp->x_pos, xl);
      fl_set_counter_value(GLcp->y_pos, yl);

      fl_set_slider_value(GLcp->p_E, Xprmt[2]);

      // fl_set_slider_value(GLcp->p_theta, (180.0 * Xprmt[3]) / M_PI);

      fl_set_slider_value(GLcp->p_theta, Xprmt[3]);
      fl_set_slider_value(GLcp->p_gamma, Xprmt[4]);
      fl_set_slider_value(GLcp->p_sigma, Xprmt[5]);

      // fl_set_slider_value(GLcp->p_phi, (180.0 * Xprmt[6]) / M_PI);

      fl_set_slider_value(GLcp->p_phi, Xprmt[6]);
      fl_set_slider_value(GLcp->p_x_1, Xprmt[7]);
      fl_set_slider_value(GLcp->p_y_1, Xprmt[8]);
      fl_set_slider_value(GLcp->p_x_2, Xprmt[9]);
      fl_set_slider_value(GLcp->p_y_2, Xprmt[10]);
      fl_set_slider_value(GLcp->p_m_1, Xprmt[11]);
      fl_set_slider_value(GLcp->p_m_2, Xprmt[12]);
      fl_set_slider_value(GLcp->p_beta, Xprmt[13]);
      fl_set_slider_value(GLcp->p_gamma2, Xprmt[14]);
      fl_set_slider_value(GLcp->p_sigma2, Xprmt[15]);

      // fl_set_slider_value(GLcp->p_phi2, (180.0 * Xprmt[16]) / M_PI);

      fl_set_slider_value(GLcp->p_phi2, Xprmt[16]);

      break;
    case M_UNIFORM_RING:
      sprintf(s1, "%g", xl);
      fl_set_input(Uring->input_x, s1);  

      sprintf(s2, "%g", yl);
      fl_set_input(Uring->input_y, s2);  

      sprintf(s3, "%g", parms[P_E]);
      fl_set_input(Uring->input_E, s3);  

      sprintf(s4, "%g", (180.0 * parms[P_THETA]) / M_PI);
      fl_set_input(Uring->input_theta, s4);  

      sprintf(s5, "%g", parms[P_GAMMA]);
      fl_set_input(Uring->input_gamma, s5);  

      sprintf(s6, "%g", parms[P_SIGMA]);
      fl_set_input(Uring->input_sigma, s6);  

      sprintf(s7, "%g", (180.0 * parms[P_PHI]) / M_PI);
      fl_set_input(Uring->input_phi, s7);  

      sprintf(s13, "%g", parms[P_KAPPA]);
      fl_set_input(Uring->input_kappa, s13);  

      sprintf(s19, "%g", parms[P_Ri]);
      fl_set_input(Uring->input_ri, s19);  

      sprintf(s20, "%g", parms[P_Ro]);
      fl_set_input(Uring->input_ro, s20);  

      fl_set_positioner_xvalue(GLcp->source_pos, xl);
      fl_set_positioner_yvalue(GLcp->source_pos, yl);
      fl_set_counter_value(GLcp->x_pos, xl);
      fl_set_counter_value(GLcp->y_pos, yl);

      fl_set_slider_value(GLcp->p_E, Xprmt[2]);

      // fl_set_slider_value(GLcp->p_theta, (180.0 * Xprmt[3]) / M_PI);

      fl_set_slider_value(GLcp->p_theta, Xprmt[3]);
      fl_set_slider_value(GLcp->p_gamma, Xprmt[4]);
      fl_set_slider_value(GLcp->p_sigma, Xprmt[5]);

      // fl_set_slider_value(GLcp->p_phi, (180.0 * Xprmt[6]) / M_PI);

      fl_set_slider_value(GLcp->p_phi, Xprmt[6]);
      fl_set_slider_value(GLcp->p_kappa, Xprmt[7]);
      fl_set_slider_value(GLcp->p_rad_i, Xprmt[8]);
      fl_set_slider_value(GLcp->p_rad_o, Xprmt[9]);

      break;
    default:
      break;
    }
  }
  
  /* Refresh */     

  /* handle_expose(0, 0); */
  
  glXSwapBuffers(fl_display, GLwin);
}

void set_opt(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  char s[10];

  /* If w_p = 1 then w_a = 0 and vice versa */
  
  w_p = fl_get_slider_value(Optimum->wg_p);
  w_a = fl_get_slider_value(Optimum->wg_a);
  
  if(w_p == 1.0) {
    fl_set_slider_value(Optimum->wg_a, 0.0);
  }     

  if(w_a == 1.0 && w_p == 0.0) {
    fl_set_slider_value(Optimum->wg_p, 0.0);
  } else {
    fl_set_slider_value(Optimum->wg_a, 0.0);    
  }

  sprintf(s, "%d", Number_of_params);
  
  fl_set_input(Optimum->inp_nop, s);

  /* printf("Number_of_params = %d \n", Number_of_params); */

  N_constraints = atoi(fl_get_input(Optimum->n_consts));

  /* printf("N_constraints = %d \n", N_constraints); */

  // SIM_AN = TRUE;

  PRAXIS = TRUE;

  printf("PRAXIS = %d \n", PRAXIS); 
}

void reset_opt(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  char s[10];

  switch(current_model) {
  case M_MODEL_MENU:
    break;
  case M_CHANG_REFSDAL:    
    Number_of_params = 7;   
    break;
  case M_SING_ISOT_SPHERE:
    Number_of_params = 8;   
    break;
  case M_DE_VAUCOULEUR:
    Number_of_params = 8;   
    break;       
  case M_KING:
    Number_of_params = 8;   
    break;
  case M_HUBBLE:
    Number_of_params = 8;   
    break;
  case M_SPIRAL:
    Number_of_params = 9;           
    break;    
  case M_TRUNC_KING:
    Number_of_params = 9;   
    break;
  case M_NSING_ISOT_SPHERE:
    Number_of_params = 9;   
    break;
  case M_TRANSP_SPHERE:
    Number_of_params = 8;   
    break;
  case M_ELLIPTICAL:
    Number_of_params = 11;   
    break;
  case M_MULTIPOLE:
    Number_of_params = 13;
    break;
  case M_ROTATION_LENS:
    Number_of_params = 9;   
    break;
  case M_DOUBLE_LENS:
    Number_of_params = 17;   
    break;
  case M_UNIFORM_RING:
    Number_of_params = 10;   
    break;
  default:
    break;
  }

  sprintf(s, "%d", Number_of_params);

  fl_set_input(Optimum->inp_nop, s);

  // SIM_AN = FALSE;

  PRAXIS = FALSE;

  sl_model    = FALSE;
  sl_macro    = FALSE;
  sl_re       = FALSE;
  sl_position = FALSE;
  
  sl_1  = FALSE;
  sl_2  = FALSE;
  sl_3  = FALSE;
  sl_4  = FALSE;
  sl_5  = FALSE;
  sl_6  = FALSE;
  sl_7  = FALSE;
  sl_8  = FALSE;
  sl_9  = FALSE;
  sl_10 = FALSE;
  sl_11 = FALSE;
  sl_12 = FALSE;
  sl_13 = FALSE;
  sl_14 = FALSE;
  sl_15 = FALSE;
  sl_16 = FALSE;
  sl_17 = FALSE;
  sl_18 = FALSE;
  sl_19 = FALSE;
  sl_20 = FALSE;
  sl_21 = FALSE;
  sl_22 = FALSE;
  sl_23 = FALSE;
  sl_24 = FALSE;
  sl_25 = FALSE;
  sl_26 = FALSE;
  sl_27 = FALSE;
  sl_28 = FALSE;
  sl_29 = FALSE;
  sl_30 = FALSE;
  sl_31 = FALSE;
  sl_32 = FALSE;
  sl_33 = FALSE;
  sl_34 = FALSE;
}

void done_opt(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  switch(current_model) {
  case M_MODEL_MENU:
    fl_hide_form(Parametres->Parameters);
    
    //    fl_activate_object(GLcp->model_ps);  

    break;
  case M_CHANG_REFSDAL:    
    fl_hide_form(Chang->Model_Pars_Chang);
    
    //    fl_activate_object(GLcp->model_ps);  

    break;
  case M_SING_ISOT_SPHERE:
    fl_hide_form(SIS->Model_Pars_SIS);
    
    //    fl_activate_object(GLcp->model_ps);  

    break;
  case M_DE_VAUCOULEUR:
    fl_hide_form(DeVau->Model_Pars_DeVau);
    
    //    fl_activate_object(GLcp->model_ps);  

    break;       
  case M_KING:
    fl_hide_form(King->Model_Pars_King);
    
    //    fl_activate_object(GLcp->model_ps);  

    break;
  case M_HUBBLE:
    fl_hide_form(Hubble->Model_Pars_Hubble);
    
    //    fl_activate_object(GLcp->model_ps);  

    break;
  case M_SPIRAL:
    fl_hide_form(Spiral_M->Model_Pars_Spiral);
    
    //    fl_activate_object(GLcp->model_ps);  

    break;    
  case M_TRUNC_KING:
    fl_hide_form(TKing->Model_Pars_TKing);
    
    //    fl_activate_object(GLcp->model_ps);  

    break;
  case M_NSING_ISOT_SPHERE:
    fl_hide_form(NSIS->Model_Pars_NSIS);
    
    //    fl_activate_object(GLcp->model_ps);  

    break;
  case M_TRANSP_SPHERE:
    fl_hide_form(Sphere->Model_Pars_Sphere);
    
    //    fl_activate_object(GLcp->model_ps);  

    break;
  case M_ELLIPTICAL:
    fl_hide_form(Elliptic->Model_Pars_Ellip);
    
    //    fl_activate_object(GLcp->model_ps);  

    break;
  case M_MULTIPOLE:
    fl_hide_form(Multi->Model_Pars_Multi);
    
    //    fl_activate_object(GLcp->model_ps);  

    break;
  case M_ROTATION_LENS:
    fl_hide_form(Rotation->Model_Pars_Rot);
    
    //    fl_activate_object(GLcp->model_ps);  

    break;
  case M_DOUBLE_LENS:
    fl_hide_form(Double->Model_Pars_Double);
    
    //    fl_activate_object(GLcp->model_ps);  

    break;
  case M_UNIFORM_RING:
    fl_hide_form(Uring->Model_Pars_Uring);
    
    //    fl_activate_object(GLcp->model_ps);  

    break;
  default:
    break;
  }

  fl_activate_object(GLcp->model_ps);  
}

void model_opt(FL_OBJECT *ob, long data)
{
  sl_model = TRUE;

  printf("Model Parameters --> True \n");
}

void macro_opt(FL_OBJECT *ob, long data)
{
  sl_macro = TRUE;

  printf("Macro Parameters --> True \n");
}

void cb_scale(FL_OBJECT *ob, long data)
{
  sl_re = TRUE;
}

void cb_position(FL_OBJECT *ob, long data)
{
  sl_position = TRUE;
}

void cb_sl1(FL_OBJECT *ob, long data)
{

}

void cb_sl2(FL_OBJECT *ob, long data)
{

}

void cb_sl3(FL_OBJECT *ob, long data)
{

}

void cb_sl4(FL_OBJECT *ob, long data)
{

}

void cb_sl5(FL_OBJECT *ob, long data)
{

}

void cb_sl6(FL_OBJECT *ob, long data)
{

}

void cb_sl7(FL_OBJECT *ob, long data)
{

}

void cb_sl8(FL_OBJECT *ob, long data)
{

}

void cb_sl9(FL_OBJECT *ob, long data)
{
}

void cb_sl10(FL_OBJECT *ob, long data)
{

}

void cb_sl11(FL_OBJECT *ob, long data)
{

}

void cb_sl12(FL_OBJECT *ob, long data)
{

}

void cb_sl13(FL_OBJECT *ob, long data)
{

}

void cb_sl14(FL_OBJECT *ob, long data)
{

}

void cb_sl15(FL_OBJECT *ob, long data)
{

}

void cb_sl16(FL_OBJECT *ob, long data)
{

}

void cb_sl17(FL_OBJECT *ob, long data)
{

}

void cb_sl18(FL_OBJECT *ob, long data)
{

}

void cb_sl19(FL_OBJECT *ob, long data)
{

}

void cb_sl20(FL_OBJECT *ob, long data)
{

}

void cb_sl21(FL_OBJECT *ob, long data)
{

}

void cb_sl522(FL_OBJECT *ob, long data)
{

}

void cb_sl23(FL_OBJECT *ob, long data)
{

}

void cb_sl24(FL_OBJECT *ob, long data)
{

}

void cb_sl25(FL_OBJECT *ob, long data)
{

}

void cb_sl26(FL_OBJECT *ob, long data)
{
}

void cb_sl27(FL_OBJECT *ob, long data)
{

}

void cb_sl28(FL_OBJECT *ob, long data)
{

}

void cb_sl29(FL_OBJECT *ob, long data)
{

}

void cb_sl30(FL_OBJECT *ob, long data)
{

}

void cb_sl31(FL_OBJECT *ob, long data)
{

}

void cb_sl32(FL_OBJECT *ob, long data)
{

}

void cb_sl33(FL_OBJECT *ob, long data)
{

}

void cb_sl34(FL_OBJECT *ob, long data)
{

}

void cb_sl35(FL_OBJECT *ob, long data)
{

}

void cb_sl36(FL_OBJECT *ob, long data)
{

}

void cb_sl37(FL_OBJECT *ob, long data)
{

}

void cb_sl38(FL_OBJECT *ob, long data)
{

}

void cb_sl39(FL_OBJECT *ob, long data)
{

}

void cb_sl40(FL_OBJECT *ob, long data)
{

}

void cb_sa(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob)) {
    Number_of_params -= 1;
  }
}

void cb_sa1(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob)) {
    sl_1        = TRUE;
    sl_position = TRUE;
  } else {
    sl_1        = FALSE;
    sl_position = FALSE;
  }

  printf("X: It is not necessary! \n");
}

void cb_sa2(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob)) {
    sl_2        = TRUE;
    sl_position = TRUE;
  } else {
    sl_2        = FALSE;
    sl_position = FALSE;
  }

  printf("Y: It is not necessary! \n");
}

void cb_sa3(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob)) {
    sl_3 = TRUE;

    printf("Optimizing --> E \n");
  } else {
    sl_3 = FALSE;
  }
}

void cb_sa4(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
  
  if(fl_get_button(ob)) {
    sl_4 = TRUE;

    printf("Optimizing --> Theta \n");
  } else {
    sl_4 = FALSE;
  }
}

void cb_sa5(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob)) {
    sl_5 = TRUE;

    printf("Optimizing --> gamma \n");
  } else {
    sl_5 = FALSE;
  }
}

void cb_sa6(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob)) {
    sl_6 = TRUE;

    printf("Optimizing --> sigma \n");
  } else {
    sl_6 = FALSE;
  }
}

void cb_sa7(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob)) {
    sl_7 = TRUE;

    printf("Optimizing --> phi \n");
  } else {
    sl_7 = FALSE;
  }
}

void cb_sa8(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob)) {
    sl_8 = TRUE;

    printf("Optimizing --> kappa \n");
  } else {
    sl_8 = FALSE;
  }
}

void cb_sa9(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob)) {
    sl_9 = TRUE;

    printf("Optimizing --> epsilon \n");
  } else {
    sl_9 = FALSE;
  }
}

void cb_sa10(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob)) {
    sl_10 = TRUE;

    printf("Optimizing --> C \n");
  } else {
    sl_10 = FALSE;
  }
}

void cb_sa11(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob)) {
    sl_11 = TRUE;

    printf("Optimizing --> X1 \n");
  } else {
    sl_11 = FALSE;
  }
}

void cb_sa12(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob)) {
    sl_12 = TRUE;

    printf("Optimizing --> Y1 \n");
  } else {
    sl_12 = FALSE;
  }
}

void cb_sa13(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob)) {
    sl_13 = TRUE;

    printf("Optimizing --> X2 \n");
  } else {
    sl_13 = FALSE;
  }
}

void cb_sa14(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob)) {
    sl_14 = TRUE;

    printf("Optimizing --> Y2 \n");
  } else {
    sl_14 = FALSE;
  }
}

void cb_sa15(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob)) {
    sl_15 = TRUE;

    printf("Optimizing --> M1 \n");
  } else {
    sl_15 = FALSE;
  }
}

void cb_sa16(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob)) {
    sl_16 = TRUE;
    
    printf("Optimizing --> M2 \n");
  } else {
    sl_16 = FALSE;
  }
}

void cb_sa17(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob)) {
    sl_17 = TRUE;

    printf("Optimizing --> beta \n");
  } else {
    sl_17 = FALSE;
  }
}

void cb_sa18(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob)) {
    sl_18 = TRUE;

    printf("Optimizing --> gamma2 \n");
  } else {
    sl_18 = FALSE;
  }
}

void cb_sa19(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob)) {
    sl_19 = TRUE;

    printf("Optimizing --> sigma2 \n");
  } else {
    sl_19 = FALSE;
  }
}

void cb_sa20(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob)) {
    sl_20 = TRUE;

    printf("Optimizing --> phi2 \n");
  } else {
    sl_20 = FALSE;
  }
}

void cb_sa21(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob)) {
    sl_21 = TRUE;

    printf("Optimizing --> Sx \n");
  } else {
    sl_21 = FALSE;
  }
}

void cb_sa22(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob)) {
    sl_22 = TRUE;

    printf("Optimizing --> Sy \n");
  } else {
    sl_22 = FALSE;
  }
}

void cb_sa23(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob)) {
    sl_23 = TRUE;

    printf("Optimizing --> alpha \n");
  } else {
    sl_23 = FALSE;
  }
}

void cb_sa24(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob)) {
    sl_24 = TRUE;

    printf("Optimizing --> alpha2 \n");
  } else {
    sl_24 = FALSE;
  }
}

void cb_sa25(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob)) {
    sl_25 = TRUE;

    printf("Optimizing --> alpha3 \n");
  } else {
    sl_25 = FALSE;
  }
}

void cb_sa26(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob)) {
    sl_26 = TRUE;

    printf("Optimizing --> beta2 \n");
  } else {
    sl_26 = FALSE;
  }
}

void cb_sa27(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob)) {
    sl_27 = TRUE;

    printf("Optimizing --> kappa2 \n");
  } else {
    sl_27 = FALSE;
  }
}

void cb_sa28(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob)) {
    sl_28 = TRUE;

    printf("Optimizing --> Ri \n");
  } else {
    sl_28 = FALSE;
  }
}

void cb_sa29(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob)) {
    sl_29 = TRUE;

    printf("Optimizing --> Ro \n");
  } else {
    sl_29 = FALSE;
  }
}

void cb_sa30(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob)) {
    sl_30 = TRUE;

    printf("Optimizing --> K \n");
  } else {
    sl_30 = FALSE;
  }
}

void cb_sa31(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob)) {
    sl_31 = TRUE;

    printf("Optimizing --> kappa0 \n");
  } else {
    sl_31 = FALSE;
  }
}

void cb_sa32(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob)) {
    sl_32 = TRUE;

    printf("Optimizing --> Dx \n");
  } else {
    sl_32 = FALSE;
  }
}

void cb_sa33(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob)) {
    sl_33 = TRUE;

    printf("Optimizing --> Dy \n");
  } else {
    sl_33 = FALSE;
  }
}

void cb_sa34(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob)) {
    sl_34 = TRUE;

    printf("Optimizing --> Qxx \n");
  } else {
    sl_34 = FALSE;
  }
}

void cb_sa35(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob)) {
    sl_35 = TRUE;
    
    printf("Optimizing --> Qxy \n");
  } else {
    sl_35 = FALSE;
  }
}

void cb_sa36(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob)) {
    sl_36 = TRUE;

    printf("Optimizing --> Qyy \n");
  } else {
    sl_36 = FALSE;
  }
}

void cb_sa37(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob)) {
    sl_37 = TRUE;

    printf("Optimizing --> Thetai \n");
  } else {
    sl_37 = FALSE;
  }
}

void cb_sa38(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob)) {
    sl_38 = TRUE;

    printf("Optimizing --> q3 \n");
  } else {
    sl_38 = FALSE;
  }
}

void cb_sa39(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob)) {
    sl_39 = TRUE;

    printf("Optimizing --> epsilon2 \n");
  } else {
    sl_39 = FALSE;
  }
}

void cb_sa40(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob)) {
    sl_39 = TRUE;

    printf("Optimizing --> epsilon3 \n");
  } else {
    sl_39 = FALSE;
  }
}

/*
    
  sl_1  = FALSE;
  sl_2  = FALSE;
  sl_3  = FALSE;
  sl_4  = FALSE;
  sl_5  = FALSE;
  sl_6  = FALSE;
  sl_7  = FALSE;
  sl_8  = FALSE;
  sl_9  = FALSE;
  sl_10 = FALSE;
  sl_11 = FALSE;
  sl_12 = FALSE;
  sl_13 = FALSE;
  sl_14 = FALSE;
  sl_15 = FALSE;
  sl_16 = FALSE;
  sl_17 = FALSE;
  sl_18 = FALSE;
  sl_19 = FALSE;
  sl_20 = FALSE;
  sl_21 = FALSE;
  sl_22 = FALSE;
  sl_23 = FALSE;
  sl_24 = FALSE;
  sl_25 = FALSE;
  sl_26 = FALSE;
  sl_27 = FALSE;
  sl_28 = FALSE;
  sl_29 = FALSE;
  sl_30 = FALSE;
  sl_31 = FALSE;
  sl_32 = FALSE;
  sl_33 = FALSE;
  sl_34 = FALSE;

**/

void cb_track(FL_OBJECT *ob, long data)
{
  Track = create_form_track();
  
  if(fl_mouse_button())
    fl_show_form(Track->tracks, FL_PLACE_MOUSE|FL_FREE_SIZE, border2, 
		 "Track Window");

  fl_deactivate_object(GLcp->track);
}

void done_track(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  fl_hide_form(Track->tracks);
  fl_activate_object(GLcp->track);
}

void set_inpt(FL_OBJECT *ob, long data)
{
  A_X = fl_get_slider_value(Track->AX);
  A_Y = fl_get_slider_value(Track->AY);

  /* printf("Ax = %f, Ay = %f \n", A_X_i, A_X_f); */
}

void set_fipt(FL_OBJECT *ob, long data)
{
  B_X = fl_get_slider_value(Track->BX);
  B_Y = fl_get_slider_value(Track->BY);

  /* printf("Bx = %f, By = %f \n", B_Y_i, B_Y_f); */
}

/*

void anim_track(FL_OBJECT *ob, long data)
{
  h_line = 0.05;
  
  mtan = (B_Y - A_Y) / (B_X - A_X);
    
  b_line = A_Y - mtan * A_X;
      
  for(x_line = A_X; x_line <= B_X; x_line += h_line) {
    y_line = mtan * x_line + b_line;

    fl_set_positioner_xvalue(GLcp->source_pos, x_line);
    fl_set_positioner_yvalue(GLcp->source_pos, y_line);
    fl_set_counter_value(GLcp->x_pos, x_line);
    fl_set_counter_value(GLcp->y_pos, y_line);

    source_position.x = x_line;      
    source_position.y = y_line;
    
    Y[0] = source_position.x;
    Y[1] = source_position.y;

    handle_expose(0, 0);
  }
}

**/

void anim_track(FL_OBJECT *ob, long data)
{
  int n_line, ninit, nfin;

  /* FD_GLcp *main_form = (FD_GLcp *)data; */

  h_line = 0.05;

  ninit  = 0;
  nfin   = 80;
  n_line = ninit;

  x_line = A_X;
  y_line = A_Y;

  if(B_X - A_X != 0.0) {
    mtan = (B_Y - A_Y) / (B_X - A_X);

    h_line = h_line * (A_X > B_X ? - 1.0 : 1.0);

    b_line = A_Y - mtan * A_X;

    while(n_line < nfin) {
      x_line = x_line + h_line;
      y_line = mtan * x_line + b_line;
      
      fl_set_positioner_xvalue(GLcp->source_pos, x_line);
      fl_set_positioner_yvalue(GLcp->source_pos, y_line);
      fl_set_counter_value(GLcp->x_pos, x_line);
      fl_set_counter_value(GLcp->y_pos, y_line);
      
      source_position.x = x_line;      
      source_position.y = y_line;
      
      Y[0] = source_position.x;
      Y[1] = source_position.y;
      
      /* printf("x_line = %f, y_line = %f \n", x_line, y_line); */

      ++n_line;

      /* Refresh */
      
      handle_expose(0, 0);
    }
  } else {
    if(A_X == B_X) {
      while(n_line < nfin) {
	y_line += h_line * (A_Y < B_Y ? 1.0 : - 1.0);

	fl_set_positioner_xvalue(GLcp->source_pos, x_line);
	fl_set_positioner_yvalue(GLcp->source_pos, y_line);
	fl_set_counter_value(GLcp->x_pos, x_line);
	fl_set_counter_value(GLcp->y_pos, y_line);

	source_position.x = x_line;      
	source_position.y = y_line;
	
	Y[0] = source_position.x;
	Y[1] = source_position.y;
	
	++n_line; 

	/* Refresh */
	
	handle_expose(0, 0);
      } 
    }
    
    if(A_Y == B_Y) {
      while(n_line < nfin) {
	x_line += h_line * (A_X < B_X ? 1.0 : - 1.0);

	fl_set_positioner_xvalue(GLcp->source_pos, x_line);
	fl_set_positioner_yvalue(GLcp->source_pos, y_line);
	fl_set_counter_value(GLcp->x_pos, x_line);
	fl_set_counter_value(GLcp->y_pos, y_line);

	source_position.x = x_line;      
	source_position.y = y_line;
	
	Y[0] = source_position.x;
	Y[1] = source_position.y;
	
	++n_line;
	
	/* Refresh */
	
	handle_expose(0, 0);
      } 
    }
  }
}
