#ifndef GL_H_INCLUDED
#define GL_H_INCLUDED

#include <stdio.h>
#include <X11/Xlib.h>
#include <math.h>

/* #include <Imlib.h> */

/*

#include "Imlib.h"
#include "gsl_errno.h"
#include "gsl_precision.h"
#include "gsl_math.h"
#include "gsl_linalg.h"
#include "gsl_block.h"
#include "gsl_vector.h"
#include "gsl_matrix.h"
#include "gsl_multiroots.h"

**/

/*

#include "/temp/local/frutos/Lentes/gsl-1.0/gsl/gsl_errno.h"
#include "/temp/local/frutos/Lentes/gsl-1.0/gsl/gsl_precision.h"
#include "/temp/local/frutos/Lentes/gsl-1.0/gsl/gsl_math.h"
#include "/temp/local/frutos/Lentes/gsl-1.0/gsl/gsl_linalg.h"
#include "/temp/local/frutos/Lentes/gsl-1.0/gsl/gsl_blas.h"
#include "/temp/local/frutos/Lentes/gsl-1.0/gsl/gsl_cblas.h"
#include "/temp/local/frutos/Lentes/gsl-1.0/gsl/gsl_block.h"
#include "/temp/local/frutos/Lentes/gsl-1.0/gsl/gsl_vector.h"
#include "/temp/local/frutos/Lentes/gsl-1.0/gsl/gsl_matrix.h"
#include "/temp/local/frutos/Lentes/gsl-1.0/gsl/gsl_min.h"
#include "/temp/local/frutos/Lentes/gsl-1.0/gsl/gsl_multiroots.h"
#include "/temp/local/frutos/Lentes/gsl-1.0/gsl/gsl_multimin.h"
#include "/temp/local/frutos/Lentes/gsl-1.0/gsl/gsl_rng.h"
#include "/temp/local/frutos/Lentes/gsl-1.0/gsl/gsl_siman.h" 

**/

#define Ne           2
#define Nf           5
#define N_opt        20
#define N_params     50
#define N_pr         50
#define Nint         100
#define NG           500

#define Nwin         500
#define Mwin         500

/* Widescreen 16:9 */

// #define Nwin         450
// #define Mwin         800

#define Num          2000
#define Numc        50000
#define Numx     10000000
#define R_MIN        0.01

#define SEED     12345
#define RANDMAX  2147483648.0

#define tau          7.67
#define tau2         pow(tau, 2.0)
#define tau3         pow(tau, 3.0)
#define tau4         pow(tau, 4.0)
#define tau5         pow(tau, 5.0)
#define tau6         pow(tau, 6.0)
#define tau7         pow(tau, 7.0)
#define tau8         pow(tau, 8.0)
#define Ftau         exp(tau)

#define One          ((double)    1.0)
#define Two          ((double)    2.0)
#define Three        ((double)    3.0)
#define Four         ((double)    4.0)
#define Five         ((double)    5.0)
#define Six          ((double)    6.0)
#define Seven        ((double)    7.0)
#define Eight        ((double)    8.0)
#define Nine         ((double)    9.0)
#define Ten          ((double)   10.0)
#define Cien         ((double)  100.0)
#define Mil          ((double) 1000.0)

#define BOUND        ((double) 5.0)

/* Widescreen 16:9 */

#define BOUND_1      ((double) 4.5)
#define BOUND_2      ((double) 8.0)

#define Half         ((double) 0.5)

/* #define Deltaxy      ((double) 0.5) */

#define S_SOURCE        (1)
#define S_IMAGES        (2)
#define S_GRID          (4)
#define S_RPLOT         (8)
#define S_SMOOTH       (16)
#define S_EINSTEIN     (32)
#define S_OBIP         (64)
#define S_FILE        (128)
#define S_WINDOW      (256)
#define S_INVERT      (512)
#define S_CONTOUR    (1024)
#define S_TIMEDELAY  (2048)
#define S_ROOTS      (4096)

/*
  
#define S_GRID       (3)
#define S_RPLOT      (4)
#define S_SMOOTH     (5)
#define S_EINSTEIN   (6)
#define S_OBIP       (7)
#define S_FILE       (8)
#define S_WINDOW     (9)
#define S_INVERT     (10)

**/

/* CONSTANTS */

#define ZERO         1.0E-40
#define ZERO2        1.0E-20
#define Lim          1.0E-10
#define TOL          1.0E-6
#define TOL2         1.0E-5
#define TOL3         1.0E-4
#define TOL4         1.0E-3
#define TOL5         1.0E-2
#define TOL6         1.0E-1
#define IT           1000
#define Pi           M_PI 

#define boolean      int
#define FALSE        0
#define TRUE         1

#define sqr(x)       ((x) * (x))
#define fs(x)        sin((x))
#define fc(x)        cos((x))
#define fe(x)        exp((x))
#define fr(x)        sqrt((x))
#define pw(x, y)     pow((x), (y))
#define sign(x)      ((x) < 0.0 ? -1 : 1)

typedef double VEC[Ne];
VEC Y, Y_L, pars;

typedef double MAT2[Ne][Ne];
MAT2 M;

typedef double MAT[N_params][Ne];
MAT Xr;

typedef double MATN[N_params][N_params];
MATN M_O;

typedef double VECN[N_params];
VECN x_root, y_root, x_obs, y_obs, mu, mu_obs;
VECN Prmt, Xprmt, Zero, M_T, Y_x, Y_y;

float X_optimum[N_params];

typedef double VECNG[NG];
VECNG root_x, root_y, troot_x, troot_y;

typedef void (*Model)(double, double);

/* typedef void (*Lens_Model) (double *, int); */

typedef struct {
  double x, y;
} GL_pos;

typedef double GL_parms;

typedef enum {
  P_E,       
  P_THETA,   
  P_GAMMA,   
  P_SIGMA,   
  P_PHI,     
  P_R,       
  P_KAPPA,
  P_KAPPA2,  
  P_EXP,
  P_C,
  P_XT,
  P_EPSILON, 
  P_EPSILON2, 
  P_EPSILON3, 
  P_ALPHA,
  P_ALPHA2,  
  P_ALPHA3,  
  P_KAPPA0,
  P_DX_QP,   
  P_DY_QP,   
  P_QXX,      
  P_QXY,
  P_QYY,
  P_M_1,     
  P_X_1,     
  P_Y_1,     
  P_BETA,
  P_GAMMA2,   
  P_SIGMA2,   
  P_PHI2,     
  P_M_2,     
  P_X_2,     
  P_Y_2,     
  P_SX,      
  P_SY,      
  P_Ri,       
  P_Ro,
  P_Ko, 
  P_Q3,
  P_THETA_INC
} parameter_list;

typedef enum {
  M_MODEL_MENU,
  M_CHANG_REFSDAL,
  M_SING_ISOT_SPHERE, 
  M_NSING_ISOT_SPHERE,
  M_TRANSP_SPHERE,    
  M_ELLIPTICAL,       
  M_KING,             
  M_TRUNC_KING,       
  M_HUBBLE,           
  M_DE_VAUCOULEUR,     
  M_SPIRAL,           
  M_MULTIPOLE,        
  M_ROTATION_LENS,    
  M_DOUBLE_LENS,
  M_UNIFORM_RING,
  M_SECOND,
  M_ELL_SIS_KK,
  M_ELL_KING,       
  M_ELL_HUBBLE,           
  M_ELL_NIS,
  M_ELL_PLUMMER,
  M_ELL_KK,  
  M_N_F_W,
  M_BARKANA                        
} model_list;

/*

typedef enum {
  F_MODEL,
  F_FULL_CIRCLE,
  F_RINGS,
  F_CIRCLE,
  F_CON_CIRCLE,
  F_ELLIPSE,
  F_CON_ELLIPSE,
  F_SPIRAL,
  F_PATTERN,
  F_RAN_PATTERN,
  F_IMAGE
} source_figure_list;

**/

typedef enum {
  F_MODEL,
  F_FULL_CIRCLE,
  F_RINGS,
  F_IMAGE
} source_figure_list;

static int SWEPT = 0;
static int Index = 0, Index2 = 0;

// static int SIM_AN = 0;
// static int PRAXIS = 0;

static int EVOLUTION = 0;
static int SIMPLEX   = 0;

// static int POWELL = 0;
// static int PIKAIA = 0;

/* var2 = var^2: x12 == x1^2, x22 == x2^2 */

static double x12, x22;   

/* r2 == r^2 = x1^2 + x2^2; r4 == r^4; r6 == r^6 */

static double rd, r2, r4, r6; 

/* var_E == var / R_E */

static double x1_E, x2_E, x1_E2, x2_E2;

/* dif = x2^2 - x1^2, difE = x2_E2 - x1_E2 = (x2/R_E)^2 - (x1/R_E)^2 */

static double dif;  

static double R_E2, R_C2, R_E3, R_E4, R_E6;

/* (r / R_E) */

static double r_E, r_E2, r_E3, r_E4, r_E6; 

/* R_C / R_E */

static double xc, xc2, xt, xt2; 

static double Ri_E, Ro_E, Ri_E2, Ro_E2, Mkapr, Mkapt;

static double A1, A2, D, B1, B2, B3, C1, C2, C3;

static double yeq1, yeq2;
static double alpha1, alpha2;

static double func;

static double z1, z2;

/* static double xl, yl, x_l, y_l; */

static double xl = 0.0, yl = 0.0;

static double dist_1 = 0.0, dist_2 = 0.0, sdist2 = 0.0;

static double cs, ss, CS, SS;
static double xb0 = BOUND;

// static double xb1 = BOUND_1;
// static double xb2 = BOUND_2;

static int Number_of_params = N_params, Number_of_roots = 5;

// static int Number_of_images = 5, N_constraints = 0;

static int Number_of_images = 5;

static double w_a = 0.0, w_p = 1.0;

/* static double Delta_M, Delta_M2 = 1.0, Delta_Y, Delta_Y2 = 1.0; */

static double Delta_M2 = 1.0, Delta_Y2 = 4.0;

static double Swept = 2.0;

static int image_switch = 0;
static int sl_1  = 0, sl_2  = 0, sl_3  = 0, sl_4  = 0, sl_5  = 0;
static int sl_6  = 0, sl_7  = 0, sl_8  = 0, sl_9  = 0, sl_10 = 0;
static int sl_11 = 0, sl_12 = 0, sl_13 = 0, sl_14 = 0, sl_15 = 0, sl_16 = 0;
static int sl_17 = 0, sl_18 = 0, sl_19 = 0, sl_20 = 0, sl_21 = 0, sl_22 = 0;
static int sl_23 = 0, sl_24 = 0, sl_25 = 0, sl_26 = 0, sl_27 = 0, sl_28 = 0;
static int sl_29 = 0, sl_30 = 0, sl_31 = 0, sl_32 = 0, sl_33 = 0, sl_34 = 0;
static int sl_35 = 0, sl_36 = 0, sl_37 = 0, sl_38 = 0, sl_39 = 0, sl_40 = 0;
static int sl_re = 0, sl_model = 0, sl_macro = 0, sl_position = 0, sl_opt = 0;

// For the moment is bh_beta = parms[P_ALPHA2]

static int black_hole = 0;
static double bh_beta = 0.01;

static double A_X, A_Y, B_X, B_Y;
static double x_line, y_line, b_line, h_line, mtan;

static double E_rad, E2_rad, E3_rad, E4_rad;

static double x_tol = TOL6;
static double dxy_critic = 0.01;

double square(double x) 
{ 
  return(x * x); 
}

extern void model_menu(double, double);
extern void chang_refsdal(double, double);
extern void singular_isothermal_sphere(double, double);
extern void nonsingular_isothermal_sphere(double, double);
extern void transparent_sphere(double, double);
extern void elliptical(double, double);
extern void king(double, double);
extern void truncated_king(double, double);
extern void hubble(double, double);
extern void de_vaucouleur(double, double);
extern void spiral(double, double);
extern void multipole(double, double);
extern void rotation_lens(double, double);
extern void double_lens(double, double);
extern void uniform_ring(double, double);
extern void second_order(double x1, double x2);
extern void Navarro_Frenk_White(double x1, double x2);
extern void Elliptic_SIS_KK(double x1, double x2);
extern void Elliptic_King(double x1, double x2);
extern void Elliptic_Hubble(double x1, double x2);
extern void Elliptic_NIS(double x1, double x2);
extern void Elliptic_KK(double x1, double x2);
extern void Elliptic_Plummer(double x1, double x2);
extern void Barkana(double x1, double x2);

/*
  
extern void model_menu_siman(double *, int);
extern void chang_refsdal_siman(double *, int);
extern void singular_isothermal_sphere_siman(double *, int);
extern void nonsingular_isothermal_sphere_siman(double *, int);
extern void transparent_sphere_siman(double *, int);
extern void elliptical_siman(double *, int);
extern void king_siman(double *, int);
extern void truncated_king_siman(double *, int);
extern void hubble_siman(double *, int);
extern void de_vaucouleur_siman(double *, int);
extern void spiral_siman(double *, int);
extern void multipole_siman(double *, int);
extern void rotation_lens_siman(double *, int);
extern void double_lens_siman(double *, int);
extern void uniform_ring_siman(double *, int);

*/

extern void lens_equation(double, double, double *, double *);
extern void function(double, double, double, double);

extern int handle_expose(XEvent *, void *); 
extern void initialize();

extern Model models[];

/* extern Lens_Model lens_models[]; */

extern GL_parms parms[];
extern GL_pos source_position;

extern long switches;
extern int precision;
extern int current_model;
extern int source_figure;

extern void colormap(float, float, GLfloat *);
extern void colormap_s(float, float, GLfloat *);
extern void color_point(int i);
extern void draw_circle(double x, double y, double rad);
extern void draw_data(void);
extern void draw_grid(void);
extern void draw_images(void);
extern void draw_invert(void);
extern void draw_photo(void);
extern void draw_photo_invert(void);
extern void draw_point(double x, double y, double rad, int color);
extern void draw_rplot(void);

/* extern void draw_rings(void); */

// extern void draw_ring(double x, double y, double rad);

extern void draw_ring(double x, double y, double radi, double rado);
extern void draw_source(double);

/*
  
extern void roots(VEC x_init); 
extern void root_finder();

extern int print_state(size_t iter, gsl_multiroot_fsolver *s);

extern int chang_refsdal_f(gsl_vector *x, void *params, gsl_vector *f);
extern int singular_isothermal_sphere_f(gsl_vector *x, void *params,
                                        gsl_vector *f);
extern int nonsingular_isothermal_sphere_f(gsl_vector *x, void *params,
                                           gsl_vector *f);
extern int transparent_sphere_f(gsl_vector *x, void *params, gsl_vector *f);
extern int elliptical_f(gsl_vector *x, void *params, gsl_vector *f);
extern int king_f(gsl_vector *x, void *params, gsl_vector *f);
extern int truncated_king_f(gsl_vector *x, void *params, gsl_vector *f);
extern int hubble_f(gsl_vector *x, void *params, gsl_vector *f);
extern int de_vaucouleur_f(gsl_vector *x, void *params, gsl_vector *f);
extern int spiral_f(gsl_vector *x, void *params, gsl_vector *f);
extern int multipole_f(gsl_vector *x, void *params, gsl_vector *f);
extern int rotation_lens_f(gsl_vector *x, void *params, gsl_vector *f);
extern int double_lens_f(gsl_vector *x, void *params, gsl_vector *f);
extern int uniform_ring_f(gsl_vector *x, void *params, gsl_vector *f);

**/

extern void Circle(float r, float Size, int color);
extern void Con_Circ(float r, float Size);
extern void Con_Ellip(float r, float Size, float angle);
extern void Ellipse(float r, float Size, int color, float angle);
extern void Pattern(float r, float Size, int color, float angle);
extern void Pattern2(float r, float Size, int color, float angle);
extern void Spiral(float r, float Size, int color, float angle);

extern float hrand(float low, float high);

extern void images();
     
#endif
