#include <math.h>
#include <stdio.h>
#include <string.h>

double model_function(float *x_opt);
void lens_model_opt(float *x_opt, int i);

double model_function(float *x_opt) 
{
  int i, j;    
  double temp1 = 0.0, temp2 = 0.0, temp3 = 0.0, temp4 = 0.0;
  double model_function = 0.0;
  
  for(i = 0; i < Number_of_images; i++) {
    lens_model_opt(x_opt, i);
  }
  
  for(i = 0; i < Number_of_images; i++) {
    for(j = 0; j < Number_of_images; j++) {
      temp1 = (Y_x[i] - Y_x[j]) * (Y_x[i] - Y_x[j]);
      temp2 = (Y_y[i] - Y_y[j]) * (Y_y[i] - Y_y[j]);

      if(w_p != 0.0) {
	if(x_opt[0] < 0.0) {
	  model_function += 100.0;
	} else if(x_opt[2] < 0.0 || x_opt[3] < 0.0) {  
	  model_function += 100.0;
	} else if(x_opt[5] < 0.0 || x_opt[6] < 0.0) {
	  model_function += 100.0;
	} else if(x_opt[7] < 0.0 || x_opt[7] > 0.5) {
	  model_function += 100.0;
	} else if(x_opt[8] < 0.0 || x_opt[8] > 1.0) {
	  model_function += 100.0;
	} else {		
	  model_function += (w_p * (temp1 + temp2)) / Delta_Y2;
	}               
      }
      
      if(w_a != 0.0) {
	temp3 = (M_O[i][j] - M_T[i] / M_T[j]);
	temp4 = temp3 * temp3;
	
	model_function += (w_a * temp4) / Delta_M2;
      }         
      
      if(w_p != 0.0 && w_a != 0.0) {
	temp3 = (M_O[i][j] - M_T[i] / M_T[j]);
	temp4 = temp3 * temp3;
	
	model_function += (w_p * (temp1 + temp2)) / Delta_Y2;
	model_function += (w_a * temp4) / Delta_M2;
      }
    }
  }

  // printf("Model_function = %g \n", model_function);

  return(model_function);
}

void lens_model_opt(float *x_opt, int i)
{
  double xbar0 = 0.0, xbar1 = 0.0, alpha0 = 0.0, alpha1 = 0.0;

  /* double radius_E, radius_E2, radius_E3, radius_E4; */

  double radius_E, radius_E2, radius_E4; 

  double Mkaprp, Mkapto, rbeta, rs12, xd1, xd2, yp1, yp2, rd2, s2 = 0.0;
  double poly1, poly2, poly3, poly4, poly5, poly6, poly7;
  double funcnis, functs,func1, func2, func3, funchb, funcs, funcrl;
  double dipolm1, dipolm2, quadrupolm1, quadrupolm2; 
  double Epsilon1, Epsilon2, delta;
  
  double x0 = x_obs[i];
  double x1 = y_obs[i];

  // switch(SIMPLEX) {

  switch(EVOLUTION) {
  case FALSE:
    break;
  case TRUE:
    switch(current_model) {
    case M_CHANG_REFSDAL:
      if(sl_macro == TRUE && sl_re == TRUE && sl_model == TRUE) {
	Xprmt[P_E]     = x_opt[0];
	Xprmt[P_THETA] = x_opt[1];
	Xprmt[P_GAMMA] = x_opt[2];
	Xprmt[P_SIGMA] = x_opt[3];
        Xprmt[P_PHI]   = x_opt[4];
      } else if(sl_macro == TRUE && sl_re == TRUE && sl_model == FALSE) {
	Xprmt[P_E]     = x_opt[0];
	Xprmt[P_GAMMA] = x_opt[1];
	Xprmt[P_SIGMA] = x_opt[2];
	Xprmt[P_PHI]   = x_opt[3];
      } else if(sl_macro == TRUE && sl_re == FALSE && sl_model == TRUE) {
	Xprmt[P_THETA] = x_opt[0];
	Xprmt[P_GAMMA] = x_opt[1];
	Xprmt[P_SIGMA] = x_opt[2];
	Xprmt[P_PHI]   = x_opt[3];
      } else if(sl_macro == TRUE && sl_re == FALSE && sl_model == FALSE) {
	Xprmt[P_GAMMA] = x_opt[0];
	Xprmt[P_SIGMA] = x_opt[1];
	Xprmt[P_PHI]   = x_opt[2];
      } else if(sl_macro == FALSE && sl_re == TRUE && sl_model == TRUE) {
	Xprmt[P_E]     = x_opt[0];
	Xprmt[P_THETA] = x_opt[1];
      } else if(sl_macro == FALSE && sl_re == TRUE && sl_model == FALSE) {
	Xprmt[P_E] = x_opt[0];
      } else if(sl_macro == FALSE && sl_re == FALSE && sl_model == TRUE) {
	Xprmt[P_THETA] = x_opt[0];
      } else if(sl_macro == FALSE && sl_re == FALSE && sl_model == FALSE) {
	printf("None parameter to optimize! \n");

	break;
      }
      
      E_rad  = Xprmt[P_E];
      E2_rad = E_rad * E_rad;
      E3_rad = E_rad * E2_rad;
      E4_rad = E_rad * E3_rad;
      
      CS = cos((M_PI * Xprmt[P_THETA]) / 180.0);
      SS = sin((M_PI * Xprmt[P_THETA]) / 180.0);
      
      B1 = 1.0 - Xprmt[P_SIGMA] 
	- Xprmt[P_GAMMA] * cos((M_PI * Xprmt[P_PHI]) / 180.0);
      B2 = 1.0 - Xprmt[P_SIGMA] 
	+ Xprmt[P_GAMMA] * cos((M_PI * Xprmt[P_PHI]) / 180.0);
      B3 = - Xprmt[P_GAMMA] * sin((M_PI * Xprmt[P_PHI]) / 180.0);
      
      xbar0 =   x0 * CS + x1 * SS;
      xbar1 = - x0 * SS + x1 * CS;
      
      radius_E2 = (xbar0 * xbar0 + xbar1 * xbar1) / E2_rad;
      
      alpha0 = xbar0 / radius_E2;
      alpha1 = xbar1 / radius_E2;

      break;   
    case M_SING_ISOT_SPHERE:
      if(sl_macro == TRUE && sl_re == TRUE && sl_model == TRUE) {
	Xprmt[P_E]     = x_opt[0];
	Xprmt[P_THETA] = x_opt[1];
	Xprmt[P_GAMMA] = x_opt[2];
	Xprmt[P_SIGMA] = x_opt[3];
	Xprmt[P_PHI]   = x_opt[4];
	Xprmt[P_EXP]   = x_opt[5];
      } else if(sl_macro == TRUE && sl_re == TRUE && sl_model == FALSE) {
	Xprmt[P_E]     = x_opt[0];
	Xprmt[P_GAMMA] = x_opt[1];
	Xprmt[P_SIGMA] = x_opt[2];
	Xprmt[P_PHI]   = x_opt[3];
      } else if(sl_macro == TRUE && sl_re == FALSE && sl_model == TRUE) {
	Xprmt[P_THETA] = x_opt[0];
	Xprmt[P_GAMMA] = x_opt[1];
        Xprmt[P_SIGMA] = x_opt[2];
	Xprmt[P_PHI]   = x_opt[3];
	Xprmt[P_EXP]   = x_opt[4];
      } else if(sl_macro == TRUE && sl_re == FALSE && sl_model == FALSE) {
	Xprmt[P_GAMMA] = x_opt[0];
	Xprmt[P_SIGMA] = x_opt[1];
	Xprmt[P_PHI]   = x_opt[2];
      } else if(sl_macro == FALSE && sl_re == TRUE && sl_model == TRUE) {
	Xprmt[P_E]     = x_opt[0];
	Xprmt[P_THETA] = x_opt[1];
	Xprmt[P_EXP]   = x_opt[2];
      } else if(sl_macro == FALSE && sl_re == TRUE && sl_model == FALSE) {
	Xprmt[P_E] = x_opt[0];
      } else if(sl_macro == FALSE && sl_re == FALSE && sl_model == TRUE) {
	Xprmt[P_THETA] = x_opt[0];
	Xprmt[P_EXP]   = x_opt[1];
      } else if(sl_macro == FALSE && sl_re == FALSE && sl_model == FALSE) {
	printf("None parameter to optimize! \n");

	break;
      }
      
      E_rad  = Xprmt[P_E];
      E2_rad = E_rad * E_rad;
      E3_rad = E_rad * E2_rad;
      E4_rad = E_rad * E3_rad;
      
      CS = cos((M_PI * Xprmt[P_PHI]) / 180.0);
      SS = sin((M_PI * Xprmt[P_PHI]) / 180.0);
      
      B1 = 1.0 - Xprmt[P_SIGMA] 
	- Xprmt[P_GAMMA] * cos((M_PI * Xprmt[P_PHI]) / 180.0);
      B2 = 1.0 - Xprmt[P_SIGMA] 
	+ Xprmt[P_GAMMA] * cos((M_PI * Xprmt[P_PHI]) / 180.0);
      B3 = - Xprmt[P_GAMMA] * sin((M_PI * Xprmt[P_PHI]) / 180.0);
      
      xbar0 =   x0 * CS + x1 * SS;
      xbar1 = - x0 * SS + x1 * CS;

      radius_E2 = (xbar0 * xbar0 + xbar1 * xbar1) / E2_rad;
      radius_E  = sqrt(radius_E2);

      rbeta = pow(radius_E, (Xprmt[P_EXP] - 1.0));
    
      alpha0 = rbeta * xbar0;
      alpha1 = rbeta * xbar1;  

      break;
    case M_NSING_ISOT_SPHERE:
      if(sl_macro == TRUE && sl_re == TRUE && sl_model == TRUE) {
	Xprmt[P_E]     = x_opt[0];
	Xprmt[P_THETA] = x_opt[1];
	Xprmt[P_GAMMA] = x_opt[2];
	Xprmt[P_SIGMA] = x_opt[3];
	Xprmt[P_PHI]   = x_opt[4];
	Xprmt[P_KAPPA] = x_opt[5];
	Xprmt[P_C]     = x_opt[6];
      } else if(sl_macro == TRUE && sl_re == TRUE && sl_model == FALSE) {
	Xprmt[P_E]     = x_opt[0];
	Xprmt[P_GAMMA] = x_opt[1];
	Xprmt[P_SIGMA] = x_opt[2];
	Xprmt[P_PHI]   = x_opt[3];
      } else if(sl_macro == TRUE && sl_re == FALSE && sl_model == TRUE) {
	Xprmt[P_THETA] = x_opt[0];
	Xprmt[P_GAMMA] = x_opt[1];
	Xprmt[P_SIGMA] = x_opt[2];
	Xprmt[P_PHI]   = x_opt[3];
	Xprmt[P_KAPPA] = x_opt[4];
	Xprmt[P_C]     = x_opt[5];
      } else if(sl_macro == TRUE && sl_re == FALSE && sl_model == FALSE) {
	Xprmt[P_GAMMA] = x_opt[0];
	Xprmt[P_SIGMA] = x_opt[1];
	Xprmt[P_PHI]   = x_opt[2];
      } else if(sl_macro == FALSE && sl_re == TRUE && sl_model == TRUE) {
	Xprmt[P_E]     = x_opt[0];
	Xprmt[P_THETA] = x_opt[1];
	Xprmt[P_KAPPA] = x_opt[2];
	Xprmt[P_C]     = x_opt[3];
      } else if(sl_macro == FALSE && sl_re == TRUE && sl_model == FALSE) {
	Xprmt[P_E] = x_opt[0];
      } else if(sl_macro == FALSE && sl_re == FALSE && sl_model == TRUE) {
	Xprmt[P_THETA] = x_opt[0];
	Xprmt[P_KAPPA] = x_opt[1];
	Xprmt[P_C]     = x_opt[2];
      } else if(sl_macro == FALSE && sl_re == FALSE && sl_model == FALSE) {
	printf("None parameter to optimize! \n");

	break;
      }

      E_rad  = Xprmt[P_E];
      E2_rad = E_rad * E_rad;
      E3_rad = E_rad * E2_rad;
      E4_rad = E_rad * E3_rad;
      
      CS = cos((M_PI * Xprmt[P_PHI]) / 180.0);
      SS = sin((M_PI * Xprmt[P_PHI]) / 180.0);
      
      B1 = 1.0 - Xprmt[P_SIGMA] 
	- Xprmt[P_GAMMA] * cos((M_PI * Xprmt[P_PHI]) / 180.0);
      B2 = 1.0 - Xprmt[P_SIGMA] 
	+ Xprmt[P_GAMMA] * cos((M_PI * Xprmt[P_PHI]) / 180.0);
      B3 = - Xprmt[P_GAMMA] * sin((M_PI * Xprmt[P_PHI]) / 180.0);
      
      xbar0 =   x0 * CS + x1 * SS;
      xbar1 = - x0 * SS + x1 * CS;

      radius_E2 = xbar0 * xbar0 + xbar1 * xbar1;

      s2 = (Xprmt[P_C] * Xprmt[P_C] + radius_E2) / E2_rad;
    
      funcnis = sqrt(s2) - Xprmt[P_C] / Xprmt[P_E];

      alpha0 = (Xprmt[P_KAPPA] * funcnis * xbar0) / radius_E2;
      alpha1 = (Xprmt[P_KAPPA] * funcnis * xbar1) / radius_E2;

      break;
    case M_TRANSP_SPHERE:
      if(sl_macro == TRUE && sl_re == TRUE && sl_model == TRUE) {
	Xprmt[P_E]     = x_opt[0];
	Xprmt[P_THETA] = x_opt[1];
	Xprmt[P_GAMMA] = x_opt[2];
	Xprmt[P_SIGMA] = x_opt[3];
	Xprmt[P_PHI]   = x_opt[4];
	Xprmt[P_C]     = x_opt[5];
      } else if(sl_macro == TRUE && sl_re == TRUE && sl_model == FALSE) {
	Xprmt[P_E]     = x_opt[0];
	Xprmt[P_GAMMA] = x_opt[1];
	Xprmt[P_SIGMA] = x_opt[2];
	Xprmt[P_PHI]   = x_opt[3];
      } else if(sl_macro == TRUE && sl_re == FALSE && sl_model == TRUE) {
	Xprmt[P_THETA] = x_opt[0];
	Xprmt[P_GAMMA] = x_opt[1];
	Xprmt[P_SIGMA] = x_opt[2];
	Xprmt[P_PHI]   = x_opt[3];
	Xprmt[P_C]     = x_opt[4];
      } else if(sl_macro == TRUE && sl_re == FALSE && sl_model == FALSE) {
	Xprmt[P_GAMMA] = x_opt[0];
	Xprmt[P_SIGMA] = x_opt[1];
	Xprmt[P_PHI]   = x_opt[2];
      } else if(sl_macro == FALSE && sl_re == TRUE && sl_model == TRUE) {
	Xprmt[P_E]     = x_opt[0];
	Xprmt[P_THETA] = x_opt[1];
	Xprmt[P_C]     = x_opt[2];
      } else if(sl_macro == FALSE && sl_re == TRUE && sl_model == FALSE) {
	Xprmt[P_E] = x_opt[0];
      } else if(sl_macro == FALSE && sl_re == FALSE && sl_model == TRUE) {
	Xprmt[P_THETA] = x_opt[0];
	Xprmt[P_C]     = x_opt[1];
      } else if(sl_macro == FALSE && sl_re == FALSE && sl_model == FALSE) {
	printf("None parameter to optimize! \n");

	break;
      }
      
      E_rad  = Xprmt[P_E];
      E2_rad = E_rad * E_rad;
      E3_rad = E_rad * E2_rad;
      E4_rad = E_rad * E3_rad;
      
      CS = cos((M_PI * Xprmt[P_PHI]) / 180.0);
      SS = sin((M_PI * Xprmt[P_PHI]) / 180.0);
      
      B1 = 1.0 - Xprmt[P_SIGMA] 
	- Xprmt[P_GAMMA] * cos((M_PI * Xprmt[P_PHI]) / 180.0);
      B2 = 1.0 - Xprmt[P_SIGMA] 
	+ Xprmt[P_GAMMA] * cos((M_PI * Xprmt[P_PHI]) / 180.0);
      B3 = - Xprmt[P_GAMMA] * sin((M_PI * Xprmt[P_PHI]) / 180.0);
      
      xbar0 =   x0 * CS + x1 * SS;
      xbar1 = - x0 * SS + x1 * CS;      

      radius_E2 = xbar0 * xbar0 + xbar1 * xbar1;
      radius_E  = sqrt(radius_E2);

      s2 = 1.0 - radius_E2 / (Xprmt[P_C] * Xprmt[P_C]);

      functs = 1.0 - pow(s2, (3.0 / 2.0));

      if(Xprmt[P_C] > radius_E){
        alpha0 = (functs * xbar0) / (radius_E2 / E2_rad);
        alpha1 = (functs * xbar1) / (radius_E2 / E2_rad);    
      } else {
        alpha0 = xbar0 / (radius_E2 / E2_rad);
        alpha1 = xbar1 / (radius_E2 / E2_rad); 
      }   

      break;
    case M_ELLIPTICAL:
      if(sl_macro == TRUE && sl_re == TRUE && sl_model == TRUE) {
	Xprmt[P_E]       = x_opt[0];
	Xprmt[P_THETA]   = x_opt[1];
	Xprmt[P_GAMMA]   = x_opt[2];
	Xprmt[P_SIGMA]   = x_opt[3];
	Xprmt[P_PHI]     = x_opt[4];
	Xprmt[P_KAPPA]   = x_opt[5];
	Xprmt[P_C]       = x_opt[6];
	Xprmt[P_ALPHA]   = x_opt[7];
	Xprmt[P_EPSILON] = x_opt[8];

	/*

	printf("Xprmt[P_E]       = %g \n", Xprmt[P_E]);	
	printf("Xprmt[P_THETA]   = %g \n", Xprmt[P_THETA]);
	printf("Xprmt[P_GAMMA]   = %g \n", Xprmt[P_GAMMA]);
	printf("Xprmt[P_SIGMA]   = %g \n", Xprmt[P_SIGMA]);
	printf("Xprmt[P_PHI]     = %g \n", Xprmt[P_PHI]);
	printf("Xprmt[P_KAPPA]   = %g \n", Xprmt[P_KAPPA]);
	printf("Xprmt[P_C]       = %g \n", Xprmt[P_C]);
	printf("Xprmt[P_ALPHA]   = %g \n", Xprmt[P_ALPHA]);
	printf("Xprmt[P_EPSILON] = %g \n", Xprmt[P_EPSILON]);

	**/
      } else if(sl_macro == TRUE && sl_re == TRUE && sl_model == FALSE) {
	Xprmt[P_E]     = x_opt[0];
	Xprmt[P_GAMMA] = x_opt[1];
	Xprmt[P_SIGMA] = x_opt[2];
	Xprmt[P_PHI]   = x_opt[3];
      } else if(sl_macro == TRUE && sl_re == FALSE && sl_model == TRUE) {
        Xprmt[P_THETA]   = x_opt[0];
	Xprmt[P_GAMMA]   = x_opt[1];
	Xprmt[P_SIGMA]   = x_opt[2];
	Xprmt[P_PHI]     = x_opt[3];
	Xprmt[P_KAPPA]   = x_opt[4];
	Xprmt[P_C]       = x_opt[5];
	Xprmt[P_ALPHA]   = x_opt[6];
	Xprmt[P_EPSILON] = x_opt[7];
      } else if(sl_macro == TRUE && sl_re == FALSE && sl_model == FALSE) {
	Xprmt[P_GAMMA] = x_opt[0];
	Xprmt[P_SIGMA] = x_opt[1];
	Xprmt[P_PHI]   = x_opt[2];
      } else if(sl_macro == FALSE && sl_re == TRUE && sl_model == TRUE) {
	Xprmt[P_E]       = x_opt[0];
	Xprmt[P_THETA]   = x_opt[1];
	Xprmt[P_KAPPA]   = x_opt[2];
	Xprmt[P_C]       = x_opt[3];
	Xprmt[P_ALPHA]   = x_opt[4];
	Xprmt[P_EPSILON] = x_opt[5];
      } else if(sl_macro == FALSE && sl_re == TRUE && sl_model == FALSE) {
	Xprmt[P_E] = x_opt[0];
      } else if(sl_macro == FALSE && sl_re == FALSE && sl_model == TRUE) {
	Xprmt[P_THETA]   = x_opt[0];
        Xprmt[P_KAPPA]   = x_opt[1];
	Xprmt[P_C]       = x_opt[2];
	Xprmt[P_ALPHA]   = x_opt[3];
	Xprmt[P_EPSILON] = x_opt[4];
      } else if(sl_macro == FALSE && sl_re == FALSE && sl_model == FALSE) {
	printf("None parameter to optimize! \n");

	break;
      }


      /*

      if(Xprmt[P_E] < 0.0) {
	Y_x[i] = 100.0;    
	Y_y[i] = 100.0;
      } else if(Xprmt[P_GAMMA] < 0.0 || Xprmt[P_SIGMA] < 0.0) {  
	Y_x[i] = 100.0;    
	Y_y[i] = 100.0;
      } else if(Xprmt[P_KAPPA] < 0.0 || Xprmt[P_C] < 0.0) {
	Y_x[i] = 100.0;    
	Y_y[i] = 100.0;
      } else if(Xprmt[P_ALPHA] < 0.0 || Xprmt[P_ALPHA] > 0.5) {
 	Y_x[i] = 100.0;    
	Y_y[i] = 100.0;
      } else if(Xprmt[P_EPSILON] < 0.0 || Xprmt[P_EPSILON] > 1.0) {
	Y_x[i] = 100.0;    
	Y_y[i] = 100.0;
      } 	

      **/

      E_rad  = Xprmt[P_E];
      E2_rad = E_rad * E_rad;
      
      CS = cos((M_PI * Xprmt[P_THETA]) / 180.0);
      SS = sin((M_PI * Xprmt[P_THETA]) / 180.0);
      
      B1 = 1.0 - Xprmt[P_SIGMA] 
	- Xprmt[P_GAMMA] * cos((M_PI * Xprmt[P_PHI]) / 180.0);
      B2 = 1.0 - Xprmt[P_SIGMA] 
	+ Xprmt[P_GAMMA] * cos((M_PI * Xprmt[P_PHI]) / 180.0);
      B3 = - Xprmt[P_GAMMA] * sin((M_PI * Xprmt[P_PHI]) / 180.0);
      
      xbar0 =   x0 * CS + x1 * SS;
      xbar1 = - x0 * SS + x1 * CS;

      Epsilon1 = 1.0 - Xprmt[P_EPSILON];
      Epsilon2 = 1.0 + Xprmt[P_EPSILON];

      delta  = 1.0 - Xprmt[P_ALPHA];

      s2 = (Xprmt[P_C] * Xprmt[P_C]
        + Epsilon1 * xbar0 * xbar0 + Epsilon2 * xbar1 * xbar1) / E2_rad;
  
      alpha0 = (Xprmt[P_KAPPA] * Epsilon1 * xbar0) / pow(s2, delta);
      alpha1 = (Xprmt[P_KAPPA] * Epsilon2 * xbar1) / pow(s2, delta);

      break;
    case M_KING:
      if(sl_macro == TRUE && sl_re == TRUE && sl_model == TRUE) {
	Xprmt[P_E]     = x_opt[0];
	Xprmt[P_THETA] = x_opt[1];
	Xprmt[P_GAMMA] = x_opt[2];
	Xprmt[P_SIGMA] = x_opt[3];
	Xprmt[P_PHI]   = x_opt[4];
	Xprmt[P_KAPPA] = x_opt[5];
      } else if(sl_macro == TRUE && sl_re == TRUE && sl_model == FALSE) {
	Xprmt[P_E]     = x_opt[0];
	Xprmt[P_GAMMA] = x_opt[1];
	Xprmt[P_SIGMA] = x_opt[2];
	Xprmt[P_PHI]   = x_opt[3];
      } else if(sl_macro == TRUE && sl_re == FALSE && sl_model == TRUE) {
	Xprmt[P_THETA] = x_opt[0];
	Xprmt[P_GAMMA] = x_opt[1];
	Xprmt[P_SIGMA] = x_opt[2];
	Xprmt[P_PHI]   = x_opt[3];
	Xprmt[P_KAPPA] = x_opt[4];
      } else if(sl_macro == TRUE && sl_re == FALSE && sl_model == FALSE) {
	Xprmt[P_GAMMA] = x_opt[0];
	Xprmt[P_SIGMA] = x_opt[1];
	Xprmt[P_PHI]   = x_opt[2];
      } else if(sl_macro == FALSE && sl_re == TRUE && sl_model == TRUE) {
	Xprmt[P_E]     = x_opt[0];
	Xprmt[P_THETA] = x_opt[1];
	Xprmt[P_KAPPA] = x_opt[2];
      } else if(sl_macro == FALSE && sl_re == TRUE && sl_model == FALSE) {
	Xprmt[P_E] = x_opt[0];
      } else if(sl_macro == FALSE && sl_re == FALSE && sl_model == TRUE) {
	Xprmt[P_THETA] = x_opt[0];
	Xprmt[P_KAPPA] = x_opt[1];
      } else if(sl_macro == FALSE && sl_re == FALSE && sl_model == FALSE) {
	printf("None parameter to optimize! \n");

	break;
      }
      
      E_rad  = Xprmt[P_E];
      E2_rad = E_rad * E_rad;
      E3_rad = E_rad * E2_rad;
      E4_rad = E_rad * E3_rad;
      
      CS = cos((M_PI * Xprmt[P_PHI]) / 180.0);
      SS = sin((M_PI * Xprmt[P_PHI]) / 180.0);
      
      B1 = 1.0 - Xprmt[P_SIGMA] 
	- Xprmt[P_GAMMA] * cos((M_PI * Xprmt[P_PHI]) / 180.0);
      B2 = 1.0 - Xprmt[P_SIGMA] 
	+ Xprmt[P_GAMMA] * cos((M_PI * Xprmt[P_PHI]) / 180.0);
      B3 = - Xprmt[P_GAMMA] * sin((M_PI * Xprmt[P_PHI]) / 180.0);
      
      xbar0 =   x0 * CS + x1 * SS;
      xbar1 = - x0 * SS + x1 * CS;

      radius_E2 = (xbar0 * xbar0 + xbar1 * xbar1) / E2_rad;

      alpha0 = (Xprmt[P_KAPPA] * xbar0 * log1p(radius_E2)) / radius_E2;
      alpha1 = (Xprmt[P_KAPPA] * xbar1 * log1p(radius_E2)) / radius_E2;

      break;
    case M_TRUNC_KING:
      if(sl_macro == TRUE && sl_re == TRUE && sl_model == TRUE) {
	Xprmt[P_E]     = x_opt[0];
	Xprmt[P_THETA] = x_opt[1];
	Xprmt[P_GAMMA] = x_opt[2];
	Xprmt[P_SIGMA] = x_opt[3];
	Xprmt[P_PHI]   = x_opt[4];
	Xprmt[P_KAPPA] = x_opt[5];
	Xprmt[P_C]     = x_opt[6];
      } else if(sl_macro == TRUE && sl_re == TRUE && sl_model == FALSE) {
	Xprmt[P_E]     = x_opt[0];
	Xprmt[P_GAMMA] = x_opt[1];
	Xprmt[P_SIGMA] = x_opt[2];
	Xprmt[P_PHI]   = x_opt[3];
      } else if(sl_macro == TRUE && sl_re == FALSE && sl_model == TRUE) {
	Xprmt[P_THETA] = x_opt[0];
        Xprmt[P_GAMMA] = x_opt[1];
	Xprmt[P_SIGMA] = x_opt[2];
	Xprmt[P_PHI]   = x_opt[3];
	Xprmt[P_KAPPA] = x_opt[4];
	Xprmt[P_C]     = x_opt[5];
      } else if(sl_macro == TRUE && sl_re == FALSE && sl_model == FALSE) {
	Xprmt[P_GAMMA] = x_opt[0];
	Xprmt[P_SIGMA] = x_opt[1];
	Xprmt[P_PHI]   = x_opt[2];
      } else if(sl_macro == FALSE && sl_re == TRUE && sl_model == TRUE) {
	Xprmt[P_E]     = x_opt[0];
	Xprmt[P_THETA] = x_opt[1];
	Xprmt[P_KAPPA] = x_opt[2];
	Xprmt[P_C]     = x_opt[3];
      } else if(sl_macro == FALSE && sl_re == TRUE && sl_model == FALSE) {
	Xprmt[P_E] = x_opt[0];
      } else if(sl_macro == FALSE && sl_re == FALSE && sl_model == TRUE) {
	Xprmt[P_THETA] = x_opt[0];
	Xprmt[P_KAPPA] = x_opt[1];
	Xprmt[P_C]     = x_opt[2];
      } else if(sl_macro == FALSE && sl_re == FALSE && sl_model == FALSE) {
	printf("None parameter to optimize! \n");

	break;
      }
      
      E_rad  = Xprmt[P_E];
      E2_rad = E_rad * E_rad;
      E3_rad = E_rad * E2_rad;
      E4_rad = E_rad * E3_rad;
      
      CS = cos((M_PI * Xprmt[P_PHI]) / 180.0);
      SS = sin((M_PI * Xprmt[P_PHI]) / 180.0);
      
      B1 = 1.0 - Xprmt[P_SIGMA] 
	- Xprmt[P_GAMMA] * cos((M_PI * Xprmt[P_PHI]) / 180.0);
      B2 = 1.0 - Xprmt[P_SIGMA] 
	+ Xprmt[P_GAMMA] * cos((M_PI * Xprmt[P_PHI]) / 180.0);
      B3 = - Xprmt[P_GAMMA] * sin((M_PI * Xprmt[P_PHI]) / 180.0);
      
      xbar0 =   x0 * CS + x1 * SS;
      xbar1 = - x0 * SS + x1 * CS;
      

      radius_E2 = (xbar0 * xbar0 + xbar1 * xbar1) / E2_rad;
      radius_E  = sqrt(radius_E2);

      func1 = log1p(radius_E2)
        + radius_E2 / (1.0 + (Xprmt[P_C] * Xprmt[P_C]) / E2_rad); 
      func2 = (4.0 *
               (hypot(1.0, radius_E) - 1.0)) / hypot(1.0, Xprmt[P_C] / E_rad);
      func3 = func1 - func2;
  
      alpha0 = (Xprmt[P_KAPPA] * xbar0 * func3) / radius_E2; 
      alpha1 = (Xprmt[P_KAPPA] * xbar1 * func3) / radius_E2;

      break;
    case M_HUBBLE:
      if(sl_macro == TRUE && sl_re == TRUE && sl_model == TRUE) {
	Xprmt[P_E]     = x_opt[0];
	Xprmt[P_THETA] = x_opt[1];
	Xprmt[P_GAMMA] = x_opt[2];
	Xprmt[P_SIGMA] = x_opt[3];
	Xprmt[P_PHI]   = x_opt[4];
	Xprmt[P_KAPPA] = x_opt[5];
      } else if(sl_macro == TRUE && sl_re == TRUE && sl_model == FALSE) {
	Xprmt[P_E]     = x_opt[0];
	Xprmt[P_GAMMA] = x_opt[1];
	Xprmt[P_SIGMA] = x_opt[2];
	Xprmt[P_PHI]   = x_opt[3];
      } else if(sl_macro == TRUE && sl_re == FALSE && sl_model == TRUE) {
	Xprmt[P_THETA] = x_opt[0];
	Xprmt[P_GAMMA] = x_opt[1];
	Xprmt[P_SIGMA] = x_opt[2];
	Xprmt[P_PHI]   = x_opt[3];
	Xprmt[P_KAPPA] = x_opt[4];
      } else if(sl_macro == TRUE && sl_re == FALSE && sl_model == FALSE) {
	Xprmt[P_GAMMA] = x_opt[0];
	Xprmt[P_SIGMA] = x_opt[1];
	Xprmt[P_PHI]   = x_opt[2];
      } else if(sl_macro == FALSE && sl_re == TRUE && sl_model == TRUE) {
	Xprmt[P_E]     = x_opt[0];
	Xprmt[P_THETA] = x_opt[1];
	Xprmt[P_KAPPA] = x_opt[2];
      } else if(sl_macro == FALSE && sl_re == TRUE && sl_model == FALSE) {
	Xprmt[P_E] = x_opt[0];
      } else if(sl_macro == FALSE && sl_re == FALSE && sl_model == TRUE) {
	Xprmt[P_THETA] = x_opt[0];
	Xprmt[P_KAPPA] = x_opt[1];
      } else if(sl_macro == FALSE && sl_re == FALSE && sl_model == FALSE) {
	printf("None parameter to optimize! \n");

	break;
      }

      radius_E2 = (xbar0 * xbar0 + xbar1 * xbar1) / E2_rad;
      radius_E  = sqrt(radius_E2);
  
      funchb = log1p(radius_E) - radius_E / (1.0 + radius_E);

      alpha0 = (2.0 * Xprmt[P_KAPPA] * xbar0 * funchb) / radius_E2;
      alpha1 = (2.0 * Xprmt[P_KAPPA] * xbar1 * funchb) / radius_E2;  

      break;
    case M_DE_VAUCOULEUR:
      if(sl_macro == TRUE && sl_re == TRUE && sl_model == TRUE) {
	Xprmt[P_E]     = x_opt[0];
	Xprmt[P_THETA] = x_opt[1];
	Xprmt[P_GAMMA] = x_opt[2];
	Xprmt[P_SIGMA] = x_opt[3];
	Xprmt[P_PHI]   = x_opt[4];
	Xprmt[P_KAPPA] = x_opt[5];
      } else if(sl_macro == TRUE && sl_re == TRUE && sl_model == FALSE) {
	Xprmt[P_E]     = x_opt[0];
	Xprmt[P_GAMMA] = x_opt[1];
	Xprmt[P_SIGMA] = x_opt[2];
	Xprmt[P_PHI]   = x_opt[3];
      } else if(sl_macro == TRUE && sl_re == FALSE && sl_model == TRUE) {
	Xprmt[P_THETA] = x_opt[0];
	Xprmt[P_GAMMA] = x_opt[1];
	Xprmt[P_SIGMA] = x_opt[2];
	Xprmt[P_PHI] = x_opt[3];
	Xprmt[P_KAPPA] = x_opt[4];
      } else if(sl_macro == TRUE && sl_re == FALSE && sl_model == FALSE) {
	Xprmt[P_GAMMA] = x_opt[0];
	Xprmt[P_SIGMA] = x_opt[1];
	Xprmt[P_PHI]   = x_opt[2];
      } else if(sl_macro == FALSE && sl_re == TRUE && sl_model == TRUE) {
        Xprmt[P_E]     = x_opt[0];
	Xprmt[P_THETA] = x_opt[1];
	Xprmt[P_KAPPA] = x_opt[2];
      } else if(sl_macro == FALSE && sl_re == TRUE && sl_model == FALSE) {
	Xprmt[P_E] = x_opt[0];
      } else if(sl_macro == FALSE && sl_re == FALSE && sl_model == TRUE) {
	Xprmt[P_THETA] = x_opt[0];
	Xprmt[P_KAPPA] = x_opt[1];
      } else if(sl_macro == FALSE && sl_re == FALSE && sl_model == FALSE) {
	printf("None parameter to optimize! \n");

	break;
      }

      radius_E2 = (xbar0 * xbar0 + xbar1 * xbar1) / E2_rad;
      radius_E  = sqrt(radius_E2);
 
      poly1 = 720.0 / tau8 + (720.0 * pow(radius_E, (1.0 / 4.0))) / tau7;
      poly2 = poly1 + pow(radius_E, (3.0 / 2.0)) / tau2;
      poly3 = poly2 + (6.0 * pow(radius_E, (5.0 / 4.0))) / tau3;
      poly4 = poly3 + (30.0 * radius_E) / tau4;
      poly5 = poly4 + (120.0 * pow(radius_E, (3.0 / 4.0))) / tau5;
      poly6 = poly5 + (360.0 * sqrt(radius_E)) / tau6;
      poly7 = 7.0 * poly6 + pow(radius_E, (7.0 / 4.0)) / tau;

      func1 = poly7 * exp(- tau * (pow(radius_E, (1.0 / 4.0)) - 1.0));
      func2 = func1 - (5040.0 * Ftau) / tau8;

      alpha0 = - (8.0 * Xprmt[P_KAPPA] * xbar0 * func2) / radius_E2;
      alpha1 = - (8.0 * Xprmt[P_KAPPA] * xbar1 * func2) / radius_E2;

      break;
    case M_SPIRAL:
      if(sl_macro == TRUE && sl_re == TRUE && sl_model == TRUE) {
	Xprmt[P_E]      = x_opt[0];
	Xprmt[P_THETA]  = x_opt[1];
	Xprmt[P_GAMMA]  = x_opt[2];
	Xprmt[P_SIGMA]  = x_opt[3];
	Xprmt[P_PHI]    = x_opt[4];
	Xprmt[P_KAPPA]  = x_opt[5];
	Xprmt[P_ALPHA2] = x_opt[6];
      } else if(sl_macro == TRUE && sl_re == TRUE && sl_model == FALSE) {
	Xprmt[P_E]     = x_opt[0];
	Xprmt[P_GAMMA] = x_opt[1];
	Xprmt[P_SIGMA] = x_opt[2];
	Xprmt[P_PHI]   = x_opt[3];
      } else if(sl_macro == TRUE && sl_re == FALSE && sl_model == TRUE) {
	Xprmt[P_THETA]  = x_opt[0];
	Xprmt[P_GAMMA]  = x_opt[1];
	Xprmt[P_SIGMA]  = x_opt[2];
	Xprmt[P_PHI]    = x_opt[3];
	Xprmt[P_KAPPA]  = x_opt[4];
	Xprmt[P_ALPHA2] = x_opt[5];
      } else if(sl_macro == TRUE && sl_re == FALSE && sl_model == FALSE) {
	Xprmt[P_GAMMA] = x_opt[0];
	Xprmt[P_SIGMA] = x_opt[1];
	Xprmt[P_PHI]   = x_opt[2];
      } else if(sl_macro == FALSE && sl_re == TRUE && sl_model == TRUE) {
	Xprmt[P_E]      = x_opt[0];
	Xprmt[P_THETA]  = x_opt[1];
	Xprmt[P_KAPPA]  = x_opt[2];
	Xprmt[P_ALPHA2] = x_opt[3];
      } else if(sl_macro == FALSE && sl_re == TRUE && sl_model == FALSE) {
        Xprmt[P_E] = x_opt[0];
      } else if(sl_macro == FALSE && sl_re == FALSE && sl_model == TRUE) {
	Xprmt[P_THETA]  = x_opt[0];
	Xprmt[P_KAPPA]  = x_opt[1];
	Xprmt[P_ALPHA2] = x_opt[2];
      } else if(sl_macro == FALSE && sl_re == FALSE && sl_model == FALSE) {
	printf("None parameter to optimize! \n");

	break;
      }

      radius_E2 = (xbar0 * xbar0 + xbar1 * xbar1) / E2_rad;
      radius_E  = sqrt(radius_E2);

      funcs = 2.0 * Xprmt[P_KAPPA] * (1.0 - exp(- Xprmt[P_ALPHA2] * radius_E)
                               * (Xprmt[P_ALPHA2] * radius_E + 1.0));

      alpha0 = (funcs * xbar0) / (Xprmt[P_ALPHA2] 
				  * Xprmt[P_ALPHA2] * radius_E2);
      alpha1 = (funcs * xbar1) / (Xprmt[P_ALPHA2] 
				  * Xprmt[P_ALPHA2] * radius_E2);  

      break;
    case M_MULTIPOLE:
      if(sl_macro == TRUE && sl_re == TRUE && sl_model == TRUE) {
	Xprmt[P_E]      = x_opt[0];
	Xprmt[P_THETA]  = x_opt[1];
	Xprmt[P_GAMMA]  = x_opt[2];
	Xprmt[P_SIGMA]  = x_opt[3];
	Xprmt[P_PHI]    = x_opt[4];
	Xprmt[P_KAPPA0] = x_opt[5];
	Xprmt[P_DX_QP]  = x_opt[6];
	Xprmt[P_DY_QP]  = x_opt[7];
	Xprmt[P_QXX]    = x_opt[8];
	Xprmt[P_QXY]    = x_opt[9];
	Xprmt[P_QYY]    = x_opt[10];
      } else if(sl_macro == TRUE && sl_re == TRUE && sl_model == FALSE) {
	Xprmt[P_E]     = x_opt[0];
	Xprmt[P_GAMMA] = x_opt[1];
	Xprmt[P_SIGMA] = x_opt[2];
	Xprmt[P_PHI]   = x_opt[3];
      } else if(sl_macro == TRUE && sl_re == FALSE && sl_model == TRUE) {
	Xprmt[P_THETA]  = x_opt[0];
	Xprmt[P_GAMMA]  = x_opt[1];
	Xprmt[P_SIGMA]  = x_opt[2];
	Xprmt[P_PHI]    = x_opt[3];
	Xprmt[P_KAPPA0] = x_opt[4];
	Xprmt[P_DX_QP]  = x_opt[5];
	Xprmt[P_DY_QP]  = x_opt[6];
	Xprmt[P_QXX]    = x_opt[7];
	Xprmt[P_QXY]    = x_opt[8];
	Xprmt[P_QYY]    = x_opt[9];
      } else if(sl_macro == TRUE && sl_re == FALSE && sl_model == FALSE) {
	Xprmt[P_GAMMA] = x_opt[0];
	Xprmt[P_SIGMA] = x_opt[1];
	Xprmt[P_PHI]   = x_opt[2];
      } else if(sl_macro == FALSE && sl_re == TRUE && sl_model == TRUE) {
	Xprmt[P_E]      = x_opt[0];
	Xprmt[P_THETA]  = x_opt[1];
	Xprmt[P_KAPPA0] = x_opt[2];
	Xprmt[P_DX_QP]  = x_opt[3];
	Xprmt[P_DY_QP]  = x_opt[4];
	Xprmt[P_QXX]    = x_opt[5];
	Xprmt[P_QXY]    = x_opt[6];
	Xprmt[P_QYY]    = x_opt[7];
      } else if(sl_macro == FALSE && sl_re == TRUE && sl_model == FALSE) {
        Xprmt[P_E] = x_opt[0];
      } else if(sl_macro == FALSE && sl_re == FALSE && sl_model == TRUE) {
	Xprmt[P_THETA]  = x_opt[0];
	Xprmt[P_KAPPA0] = x_opt[1];
	Xprmt[P_DX_QP]  = x_opt[2];
	Xprmt[P_DY_QP]  = x_opt[3];
	Xprmt[P_QXX]    = x_opt[4];
	Xprmt[P_QXY]    = x_opt[5];
	Xprmt[P_QYY]    = x_opt[6];
      } else if(sl_macro == FALSE && sl_re == FALSE && sl_model == FALSE) {
	printf("None parameter to optimize! \n");

	break;
      }

      radius_E2 = (xbar0 * xbar0 + xbar1 * xbar1) / E2_rad;
      radius_E4 = radius_E2 * radius_E2;

      dipolm1 = E3_rad * (Xprmt[P_DX_QP] * (xbar1 * xbar1 - xbar0 * xbar0)
                          - 2.0 * Xprmt[P_DY_QP] * xbar0 *
                          xbar1) / pow((xbar0 * xbar0 + xbar1 * xbar1), 2.0);
    
      dipolm2 = - E3_rad * (Xprmt[P_DY_QP] * (xbar1 * xbar1 - xbar0 * xbar0)
                            + 2.0 * Xprmt[P_DX_QP] * xbar0 *
                            xbar1) / pow((xbar0 * xbar0 + xbar1 * xbar1), 2.0);

      quadrupolm1 = 2.0 * E4_rad *
        (Xprmt[P_QXX] * xbar0 * (3.0 * xbar1 * xbar1 - xbar0 * xbar0)
         + Xprmt[P_QXY] * xbar1 *
         (xbar1 * xbar1
          - 3.0 * xbar0 * xbar0)) / pow((xbar0 * xbar0 + xbar1 * xbar1), 3.0);

      quadrupolm2 = 2.0 * E4_rad *
        (Xprmt[P_QYY] * xbar1 * (3.0 * xbar0 * xbar0 - xbar1 * xbar1)
         + Xprmt[P_QXY] * xbar0 *
         (xbar0 * xbar0
          - 3.0 * xbar1 * xbar1)) / pow((xbar0 * xbar0 + xbar1 * xbar1), 3.0);
    
      alpha0 = (Xprmt[P_KAPPA0] * xbar0) / radius_E2 + dipolm1 + quadrupolm1; 
      alpha1 = (Xprmt[P_KAPPA0] * xbar1) / radius_E2 + dipolm2 + quadrupolm2;

      break;
    case M_ROTATION_LENS:
      if(sl_macro == TRUE && sl_re == TRUE && sl_model == TRUE) {
	Xprmt[P_E]      = x_opt[0];
	Xprmt[P_THETA]  = x_opt[1];
	Xprmt[P_GAMMA]  = x_opt[2];
	Xprmt[P_SIGMA]  = x_opt[3];
	Xprmt[P_PHI]    = x_opt[4];
	Xprmt[P_KAPPA]  = x_opt[5];
	Xprmt[P_ALPHA2] = x_opt[6];
      } else if(sl_macro == TRUE && sl_re == TRUE && sl_model == FALSE) {
	Xprmt[P_E]     = x_opt[0];
	Xprmt[P_GAMMA] = x_opt[1];
	Xprmt[P_SIGMA] = x_opt[2];
	Xprmt[P_PHI]   = x_opt[3];
      } else if(sl_macro == TRUE && sl_re == FALSE && sl_model == TRUE) {
	Xprmt[P_THETA]  = x_opt[0];
	Xprmt[P_GAMMA]  = x_opt[1];
	Xprmt[P_SIGMA]  = x_opt[2];
	Xprmt[P_PHI]    = x_opt[3];
	Xprmt[P_KAPPA]  = x_opt[4];
	Xprmt[P_ALPHA2] = x_opt[5];
      } else if(sl_macro == TRUE && sl_re == FALSE && sl_model == FALSE) {
	Xprmt[P_GAMMA] = x_opt[0];
	Xprmt[P_SIGMA] = x_opt[1];
	Xprmt[P_PHI]   = x_opt[2];
      } else if(sl_macro == FALSE && sl_re == TRUE && sl_model == TRUE) {
	Xprmt[P_E]      = x_opt[0];
	Xprmt[P_THETA]  = x_opt[1];
	Xprmt[P_KAPPA]  = x_opt[2];
	Xprmt[P_ALPHA2] = x_opt[3];
      } else if(sl_macro == FALSE && sl_re == TRUE && sl_model == FALSE) {
        Xprmt[P_E] = x_opt[0];
      } else if(sl_macro == FALSE && sl_re == FALSE && sl_model == TRUE) {
	Xprmt[P_THETA]  = x_opt[0];
	Xprmt[P_KAPPA]  = x_opt[1];
	Xprmt[P_ALPHA2] = x_opt[2];
      } else if(sl_macro == FALSE && sl_re == FALSE && sl_model == FALSE) {
	printf("None parameter to optimize! \n");

	break;
      }

      radius_E2 = (xbar0 * xbar0 + xbar1 * xbar1) / E2_rad;
      radius_E4 = radius_E2 * radius_E2;

      funcrl = (Xprmt[7] * xbar1 - Xprmt[8] * xbar0) / E_rad;

      alpha0 = xbar0 / radius_E2 + (2.0 * funcrl * xbar0) / radius_E4
        + Xprmt[8] / (E_rad * radius_E2);
      alpha1 = xbar1 / radius_E2 + (2.0 * funcrl * xbar1) / radius_E4
        - Xprmt[7] / (E_rad * radius_E2);
      
      break;
    case M_DOUBLE_LENS:
      if(sl_macro == TRUE && sl_re == TRUE && sl_model == TRUE) {
	Xprmt[P_E]      = x_opt[0];
	Xprmt[P_THETA]  = x_opt[1];
	Xprmt[P_GAMMA]  = x_opt[2];
	Xprmt[P_SIGMA]  = x_opt[3];
	Xprmt[P_PHI]    = x_opt[4];
	Xprmt[P_KAPPA]  = x_opt[5];
	Xprmt[P_ALPHA2] = x_opt[6];
      } else if(sl_macro == TRUE && sl_re == TRUE && sl_model == FALSE) {
	Xprmt[P_E]     = x_opt[0];
	Xprmt[P_GAMMA] = x_opt[1];
	Xprmt[P_SIGMA] = x_opt[2];
	Xprmt[P_PHI]   = x_opt[3];
      } else if(sl_macro == TRUE && sl_re == FALSE && sl_model == TRUE) {
	Xprmt[P_THETA]  = x_opt[0];
	Xprmt[P_GAMMA]  = x_opt[1];
	Xprmt[P_SIGMA]  = x_opt[2];
	Xprmt[P_PHI]    = x_opt[3];
	Xprmt[P_KAPPA]  = x_opt[4];
	Xprmt[P_ALPHA2] = x_opt[5];
      } else if(sl_macro == TRUE && sl_re == FALSE && sl_model == FALSE) {
	Xprmt[P_GAMMA] = x_opt[0];
	Xprmt[P_SIGMA] = x_opt[1];
	Xprmt[P_PHI]   = x_opt[2];
      } else if(sl_macro == FALSE && sl_re == TRUE && sl_model == TRUE) {
	Xprmt[P_E]      = x_opt[0];
	Xprmt[P_THETA]  = x_opt[1];
	Xprmt[P_KAPPA]  = x_opt[2];
	Xprmt[P_ALPHA2] = x_opt[3];
      } else if(sl_macro == FALSE && sl_re == TRUE && sl_model == FALSE) {
        Xprmt[P_E] = x_opt[0];
      } else if(sl_macro == FALSE && sl_re == FALSE && sl_model == TRUE) {
	Xprmt[P_THETA]  = x_opt[0];
	Xprmt[P_KAPPA]  = x_opt[1];
	Xprmt[P_ALPHA2] = x_opt[2];
      } else if(sl_macro == FALSE && sl_re == FALSE && sl_model == FALSE) {
	printf("None parameter to optimize! \n");

	break;
      }

      C1 = 1.0 - Xprmt[15] - Xprmt[14] * cos((M_PI * Xprmt[16]) / 180.0);
      C2 = 1.0 - Xprmt[15] + Xprmt[14] * cos((M_PI * Xprmt[16]) / 180.0);
      C3 =                 - Xprmt[14] * sin((M_PI * Xprmt[16]) / 180.0);

      radius_E2 = (xbar0 * xbar0 + xbar1 * xbar1) / E2_rad;

      rs12 = ((xbar0 - Xprmt[7]) * (xbar0 - Xprmt[7])
              + (xbar1 - Xprmt[8]) * (xbar1 - Xprmt[8])) / E2_rad;

      yp1 = C1 * xbar0 + C3 * xbar1;
      yp2 = C2 * xbar1 + C3 * xbar0; 
  
      xd1 = yp1 - Xprmt[11] * Xprmt[13] * (xbar0 - Xprmt[7]) / rs12; 
      xd2 = yp2 - Xprmt[11] * Xprmt[13] * (xbar1 - Xprmt[8]) / rs12; 

      rd2 = ((xd1 - Xprmt[9]) * (xd1 - Xprmt[9])
             + (xd2 - Xprmt[10]) * (xd2 - Xprmt[10])) / E2_rad;

      alpha0 = Xprmt[11] * (xbar0 - Xprmt[7]) / rs12
        + Xprmt[12] * (xd1 - Xprmt[9]) / rd2;  
      alpha1 = Xprmt[11] * (xbar1 - Xprmt[8]) / rs12
        + Xprmt[12] * (xd2 - Xprmt[10]) / rd2;          

      break;
    case M_UNIFORM_RING:
      if(sl_macro == TRUE && sl_re == TRUE && sl_model == TRUE) {
	Xprmt[P_E]      = x_opt[0];
	Xprmt[P_THETA]  = x_opt[1];
	Xprmt[P_GAMMA]  = x_opt[2];
	Xprmt[P_SIGMA]  = x_opt[3];
	Xprmt[P_PHI]    = x_opt[4];
	Xprmt[P_KAPPA]  = x_opt[5];
	Xprmt[P_ALPHA2] = x_opt[6];
      } else if(sl_macro == TRUE && sl_re == TRUE && sl_model == FALSE) {
	Xprmt[P_E]     = x_opt[0];
	Xprmt[P_GAMMA] = x_opt[1];
	Xprmt[P_SIGMA] = x_opt[2];
	Xprmt[P_PHI]   = x_opt[3];
      } else if(sl_macro == TRUE && sl_re == FALSE && sl_model == TRUE) {
	Xprmt[P_THETA]  = x_opt[0];
	Xprmt[P_GAMMA]  = x_opt[1];
	Xprmt[P_SIGMA]  = x_opt[2];
	Xprmt[P_PHI]    = x_opt[3];
	Xprmt[P_KAPPA]  = x_opt[4];
	Xprmt[P_ALPHA2] = x_opt[5];
      } else if(sl_macro == TRUE && sl_re == FALSE && sl_model == FALSE) {
	Xprmt[P_GAMMA] = x_opt[0];
	Xprmt[P_SIGMA] = x_opt[1];
	Xprmt[P_PHI]   = x_opt[2];
      } else if(sl_macro == FALSE && sl_re == TRUE && sl_model == TRUE) {
	Xprmt[P_E]      = x_opt[0];
	Xprmt[P_THETA]  = x_opt[1];
	Xprmt[P_KAPPA]  = x_opt[2];
	Xprmt[P_ALPHA2] = x_opt[3];
      } else if(sl_macro == FALSE && sl_re == TRUE && sl_model == FALSE) {
        Xprmt[P_E] = x_opt[0];
      } else if(sl_macro == FALSE && sl_re == FALSE && sl_model == TRUE) {
	Xprmt[P_THETA]  = x_opt[0];
	Xprmt[P_KAPPA]  = x_opt[1];
	Xprmt[P_ALPHA2] = x_opt[2];
      } else if(sl_macro == FALSE && sl_re == FALSE && sl_model == FALSE) {
	printf("None parameter to optimize! \n");

	break;
      }

      radius_E2 = (xbar0 * xbar0 + xbar1 * xbar1) / E2_rad;
      radius_E  = sqrt(radius_E2);
  
      Mkaprp = 10.0 * Xprmt[7] * (radius_E2 - Xprmt[8] * Xprmt[8]);
      Mkapto = 10.0 * Xprmt[7] * (Xprmt[9] * Xprmt[9] - Xprmt[8] * Xprmt[8]);
  
      if(radius_E >= Xprmt[9]) {
        alpha0 = (Mkapto * xbar0) / radius_E2;
        alpha1 = (Mkapto * xbar1) / radius_E2; 	     
      } else {
        if(radius_E >= Xprmt[8]) {
          alpha0 = (Mkaprp * xbar0) / radius_E2;
          alpha1 = (Mkaprp * xbar1) / radius_E2; 	
        } else {
          alpha0 = 0.0;
          alpha1 = 0.0; 
        }   
      }

      break; 
      
    } 

    Y_x[i] = B1 * xbar0 + B3 * xbar1 - alpha0;    
    Y_y[i] = B2 * xbar1 + B3 * xbar0 - alpha1;
    
    break;
  default:
    break;    
  }
}

