#include <math.h>
#include <stdio.h>
#include <string.h>

void choice_initial();
double restrict_func(double *x);
void choice_final();

void choice_initial()
{
  if(sl_position == TRUE && sl_re == TRUE &&
     sl_macro == TRUE && sl_model == TRUE) {
    switch(current_model) {
    case M_CHANG_REFSDAL:
      cprax.n = 7;

      cprax.x[0] = xl;
      cprax.x[1] = yl; 
      cprax.x[2] = parms[P_E]; 
      cprax.x[3] = parms[P_THETA];
      cprax.x[4] = parms[P_GAMMA];
      cprax.x[5] = parms[P_SIGMA];
      cprax.x[6] = parms[P_PHI];

      break;   
    case M_SING_ISOT_SPHERE:
      cprax.n = 8;

      cprax.x[0] = xl;
      cprax.x[1] = yl; 
      cprax.x[2] = parms[P_E]; 
      cprax.x[3] = parms[P_THETA];
      cprax.x[4] = parms[P_GAMMA];
      cprax.x[5] = parms[P_SIGMA];
      cprax.x[6] = parms[P_PHI];
      cprax.x[7] = parms[P_EXP];

      break;   
    case M_NSING_ISOT_SPHERE:
      cprax.n = 9;

      cprax.x[0] = xl;
      cprax.x[1] = yl; 
      cprax.x[2] = parms[P_E]; 
      cprax.x[3] = parms[P_THETA];
      cprax.x[4] = parms[P_GAMMA];
      cprax.x[5] = parms[P_SIGMA];
      cprax.x[6] = parms[P_PHI];
      cprax.x[7] = parms[P_KAPPA];
      cprax.x[8] = parms[P_C];

      break;   
    case M_TRANSP_SPHERE:
      cprax.n = 8;

      cprax.x[0] = xl;
      cprax.x[1] = yl; 
      cprax.x[2] = parms[P_E]; 
      cprax.x[3] = parms[P_THETA];
      cprax.x[4] = parms[P_GAMMA];
      cprax.x[5] = parms[P_SIGMA];
      cprax.x[6] = parms[P_PHI];
      cprax.x[7] = parms[P_C];
      
      break;   
    case M_ELLIPTICAL:         
      cprax.n = 11;

      cprax.x[0]  = xl;
      cprax.x[1]  = yl;
      cprax.x[2]  = parms[P_E];
      cprax.x[3]  = parms[P_THETA];
      cprax.x[4]  = parms[P_GAMMA];
      cprax.x[5]  = parms[P_SIGMA];
      cprax.x[6]  = parms[P_PHI];
      cprax.x[7]  = parms[P_KAPPA];
      cprax.x[8]  = parms[P_EPSILON];
      cprax.x[9]  = parms[P_C];
      cprax.x[10] = parms[P_ALPHA];

      break;
    case M_KING:
      cprax.n = 8;

      cprax.x[0] = xl;
      cprax.x[1] = yl;
      cprax.x[2] = parms[P_E];
      cprax.x[3] = parms[P_THETA];
      cprax.x[4] = parms[P_GAMMA];
      cprax.x[5] = parms[P_SIGMA];
      cprax.x[6] = parms[P_PHI];
      cprax.x[7] = parms[P_KAPPA];

      break;
    case M_TRUNC_KING:
      cprax.n = 9;

      cprax.x[0] = xl;
      cprax.x[1] = yl;
      cprax.x[2] = parms[P_E];
      cprax.x[3] = parms[P_THETA];
      cprax.x[4] = parms[P_GAMMA];
      cprax.x[5] = parms[P_SIGMA];
      cprax.x[6] = parms[P_PHI];
      cprax.x[7] = parms[P_C];
      cprax.x[8] = parms[P_KAPPA2];

      break;
    case M_HUBBLE:
      cprax.n = 8;

      cprax.x[0] = xl;
      cprax.x[1] = yl;
      cprax.x[2] = parms[P_E];
      cprax.x[3] = parms[P_THETA];
      cprax.x[4] = parms[P_GAMMA];
      cprax.x[5] = parms[P_SIGMA];
      cprax.x[6] = parms[P_PHI];
      cprax.x[7] = parms[P_KAPPA];
      
      break;
    case M_DE_VAUCOULEUR:
      cprax.n = 8;

      cprax.x[0] = xl;
      cprax.x[1] = yl;
      cprax.x[2] = parms[P_E];
      cprax.x[3] = parms[P_THETA];
      cprax.x[4] = parms[P_GAMMA];
      cprax.x[5] = parms[P_SIGMA];
      cprax.x[6] = parms[P_PHI];
      cprax.x[7] = parms[P_KAPPA];

      break;
    case M_SPIRAL:
      cprax.n = 9;

      cprax.x[0] = xl;
      cprax.x[1] = yl;
      cprax.x[2] = parms[P_E];
      cprax.x[3] = parms[P_THETA];
      cprax.x[4] = parms[P_GAMMA];
      cprax.x[5] = parms[P_SIGMA];
      cprax.x[6] = parms[P_PHI];
      cprax.x[7] = parms[P_KAPPA];
      cprax.x[8] = parms[P_ALPHA2];

      break;
    case M_MULTIPOLE:
      cprax.n = 13;

      cprax.x[0]  = xl;
      cprax.x[1]  = yl;
      cprax.x[2]  = parms[P_E];
      cprax.x[3]  = parms[P_THETA];
      cprax.x[4]  = parms[P_GAMMA];
      cprax.x[5]  = parms[P_SIGMA];
      cprax.x[6]  = parms[P_PHI];
      cprax.x[7]  = parms[P_KAPPA0];
      cprax.x[8]  = parms[P_DX_QP];
      cprax.x[9]  = parms[P_DY_QP];
      cprax.x[10] = parms[P_QXX];
      cprax.x[11] = parms[P_QXY];
      cprax.x[12] = parms[P_QYY];

      break;
    case M_ROTATION_LENS:
      cprax.n = 9;

      cprax.x[0] = xl;
      cprax.x[1] = yl;
      cprax.x[2] = parms[P_E];
      cprax.x[3] = parms[P_THETA];
      cprax.x[4] = parms[P_GAMMA];
      cprax.x[5] = parms[P_SIGMA];
      cprax.x[6] = parms[P_PHI];
      cprax.x[7] = parms[P_SX];
      cprax.x[8] = parms[P_SY];

      break;
    case M_DOUBLE_LENS:
      cprax.n = 17;
      
      cprax.x[0]  = xl;
      cprax.x[1]  = yl;
      cprax.x[2]  = parms[P_E];
      cprax.x[3]  = parms[P_THETA];
      cprax.x[4]  = parms[P_GAMMA];
      cprax.x[5]  = parms[P_SIGMA];
      cprax.x[6]  = parms[P_PHI];
      cprax.x[7]  = parms[P_X_1];
      cprax.x[8]  = parms[P_Y_1];
      cprax.x[9]  = parms[P_X_2];
      cprax.x[10] = parms[P_Y_2];
      cprax.x[11] = parms[P_M_1];
      cprax.x[12] = parms[P_M_2];
      cprax.x[13] = parms[P_BETA];
      cprax.x[14] = parms[P_GAMMA2];
      cprax.x[15] = parms[P_SIGMA2];
      cprax.x[16] = parms[P_PHI2];

      break;
    case M_UNIFORM_RING:
      cprax.n = 10;

      cprax.x[0] = xl;
      cprax.x[1] = yl;
      cprax.x[2] = parms[P_E];
      cprax.x[3] = parms[P_THETA];
      cprax.x[4] = parms[P_GAMMA];
      cprax.x[5] = parms[P_SIGMA];
      cprax.x[6] = parms[P_PHI];
      cprax.x[7] = parms[P_KAPPA];
      cprax.x[8] = parms[P_Ri];
      cprax.x[9] = parms[P_Ro];

      break;
    default:
      break; 
    }           
  } else if(sl_position == TRUE && sl_re == TRUE &&
            sl_macro == TRUE && sl_model == FALSE) {
    cprax.n = 6;

    cprax.x[0] = xl;
    cprax.x[1] = yl; 
    cprax.x[2] = parms[P_E]; 
    cprax.x[3] = parms[P_GAMMA];
    cprax.x[4] = parms[P_SIGMA];
    cprax.x[5] = parms[P_PHI];

    Xprmt[3] = parms[P_THETA];

    switch(current_model) {
    case M_CHANG_REFSDAL:

      break;
    case M_SING_ISOT_SPHERE:
      Xprmt[7] = parms[P_EXP];

      break;
    case M_NSING_ISOT_SPHERE:
      Xprmt[7] = parms[P_KAPPA];

      break;
    case M_TRANSP_SPHERE:
      Xprmt[7] = parms[P_C];

      break;
    case M_ELLIPTICAL:         
      Xprmt[7]  = parms[P_KAPPA];
      Xprmt[8]  = parms[P_EPSILON];
      Xprmt[9]  = parms[P_C];
      Xprmt[10] = parms[P_ALPHA];

      break;
    case M_KING:
      Xprmt[7] = parms[P_KAPPA];

      break;    
    case M_TRUNC_KING:
      Xprmt[7] = parms[P_C];
      Xprmt[8] = parms[P_KAPPA2];

      break;
    case M_HUBBLE:
      Xprmt[7] = parms[P_KAPPA];

      break;
    case M_DE_VAUCOULEUR:
      Xprmt[7] = parms[P_KAPPA];

      break;
    case M_SPIRAL:
      Xprmt[7] = parms[P_KAPPA];
      Xprmt[8] = parms[P_ALPHA2];
      
      break;      
    case M_MULTIPOLE:
      Xprmt[7]  = parms[P_KAPPA0];
      Xprmt[8]  = parms[P_DX_QP];
      Xprmt[9]  = parms[P_DY_QP];
      Xprmt[10] = parms[P_QXX];
      Xprmt[11] = parms[P_QXY];
      Xprmt[12] = parms[P_QYY];
      
      break;      
    case M_ROTATION_LENS:
      Xprmt[7] = parms[P_SX];
      Xprmt[8] = parms[P_SY];

      break;      
    case M_DOUBLE_LENS:
      Xprmt[7]  = parms[P_X_1];
      Xprmt[8]  = parms[P_Y_1];
      Xprmt[9]  = parms[P_X_2];
      Xprmt[10] = parms[P_Y_2];
      Xprmt[11] = parms[P_M_1];
      Xprmt[12] = parms[P_M_2];
      Xprmt[13] = parms[P_BETA];
      Xprmt[14] = parms[P_GAMMA2];
      Xprmt[15] = parms[P_SIGMA2];
      Xprmt[16] = parms[P_PHI2];

      break;      
    case M_UNIFORM_RING:
      Xprmt[7] = parms[P_KAPPA];
      Xprmt[8] = parms[P_Ri];
      Xprmt[9] = parms[P_Ro];

      break;
    default:
      break; 
    }           
  } else if(sl_position == TRUE && sl_re == TRUE &&
            sl_macro == FALSE && sl_model == TRUE) {
    Xprmt[4]  = parms[P_GAMMA];
    Xprmt[5]  = parms[P_SIGMA];
    Xprmt[6]  = parms[P_PHI];

    switch(current_model) {
    case M_CHANG_REFSDAL:
      cprax.n = 4;

      cprax.x[0] = xl;
      cprax.x[1] = yl;
      cprax.x[2] = parms[P_E];
      cprax.x[3] = parms[P_THETA];

      break;   
    case M_SING_ISOT_SPHERE:
      cprax.n = 5;

      cprax.x[0] = xl;
      cprax.x[1] = yl;
      cprax.x[2] = parms[P_E];
      cprax.x[3] = parms[P_THETA];
      cprax.x[4] = parms[P_EXP];

      break;   
    case M_NSING_ISOT_SPHERE:
      cprax.n = 6;

      cprax.x[0] = xl;
      cprax.x[1] = yl;
      cprax.x[2] = parms[P_E];
      cprax.x[3] = parms[P_THETA];
      cprax.x[4] = parms[P_KAPPA];
      cprax.x[5] = parms[P_C];

      break;   
    case M_TRANSP_SPHERE:
      cprax.n = 5;

      cprax.x[0] = xl;
      cprax.x[1] = yl;
      cprax.x[2] = parms[P_E];
      cprax.x[3] = parms[P_THETA];
      cprax.x[4] = parms[P_C];
      
      break;   
    case M_ELLIPTICAL:         
      cprax.n = 8;

      cprax.x[0] = xl;
      cprax.x[1] = yl;
      cprax.x[2] = parms[P_E];
      cprax.x[3] = parms[P_THETA];
      cprax.x[4] = parms[P_KAPPA];
      cprax.x[5] = parms[P_EPSILON];
      cprax.x[6] = parms[P_C];
      cprax.x[7] = parms[P_ALPHA];

      break;
    case M_KING:
      cprax.n = 5;

      cprax.x[0] = xl;
      cprax.x[1] = yl;
      cprax.x[2] = parms[P_E];
      cprax.x[3] = parms[P_THETA];
      cprax.x[4] = parms[P_KAPPA];

      break;
    case M_TRUNC_KING:
      cprax.n = 6;

      cprax.x[0] = xl;
      cprax.x[1] = yl;
      cprax.x[2] = parms[P_E];
      cprax.x[3] = parms[P_THETA];
      cprax.x[4] = parms[P_C];
      cprax.x[5] = parms[P_KAPPA2];

      break;
    case M_HUBBLE:
      cprax.n = 5;

      cprax.x[0] = xl;
      cprax.x[1] = yl;
      cprax.x[2] = parms[P_E];
      cprax.x[3] = parms[P_THETA];
      cprax.x[4] = parms[P_KAPPA];

      break;
    case M_DE_VAUCOULEUR:
      cprax.n = 5;

      cprax.x[0] = xl;
      cprax.x[1] = yl;
      cprax.x[2] = parms[P_E];
      cprax.x[3] = parms[P_THETA];
      cprax.x[4] = parms[P_KAPPA];

      break;
    case M_SPIRAL:
      cprax.n = 6;

      cprax.x[0] = xl;
      cprax.x[1] = yl;
      cprax.x[2] = parms[P_E];
      cprax.x[3] = parms[P_THETA];
      cprax.x[4] = parms[P_KAPPA];
      cprax.x[5] = parms[P_ALPHA2];

      break;
    case M_MULTIPOLE:
      cprax.n = 10;

      cprax.x[0]  = xl;
      cprax.x[1]  = yl;
      cprax.x[2]  = parms[P_E];
      cprax.x[3]  = parms[P_THETA];
      cprax.x[4]  = parms[P_KAPPA0];
      cprax.x[5]  = parms[P_DX_QP];
      cprax.x[6]  = parms[P_DY_QP];
      cprax.x[7]  = parms[P_QXX];
      cprax.x[8]  = parms[P_QXY];
      cprax.x[9]  = parms[P_QYY];

      break;
    case M_ROTATION_LENS:
      cprax.n = 6;

      cprax.x[0] = xl;
      cprax.x[1] = yl;
      cprax.x[2] = parms[P_E];
      cprax.x[3] = parms[P_THETA];
      cprax.x[4] = parms[P_SX];
      cprax.x[5] = parms[P_SY];

      break;
    case M_DOUBLE_LENS:
      cprax.n = 11;

      cprax.x[0]  = xl;
      cprax.x[1]  = yl;
      cprax.x[2]  = parms[P_E];
      cprax.x[3]  = parms[P_THETA];
      cprax.x[4]  = parms[P_X_1];
      cprax.x[5]  = parms[P_Y_1];
      cprax.x[6]  = parms[P_X_2];
      cprax.x[7]  = parms[P_Y_2];
      cprax.x[8]  = parms[P_M_1];
      cprax.x[9]  = parms[P_M_2];
      cprax.x[10] = parms[P_BETA];
      
      Xprmt[14] = parms[P_GAMMA2];
      Xprmt[15] = parms[P_SIGMA2];
      Xprmt[16] = parms[P_PHI2];

      break;
    case M_UNIFORM_RING:
      cprax.n = 7;

      cprax.x[0] = xl;
      cprax.x[1] = yl;
      cprax.x[2] = parms[P_E];
      cprax.x[3] = parms[P_THETA];
      cprax.x[4] = parms[P_KAPPA];
      cprax.x[5] = parms[P_Ri];
      cprax.x[6] = parms[P_Ro];

      break;
    default:
      break; 
    }
  } else if(sl_position == TRUE && sl_re == TRUE &&
            sl_macro == FALSE && sl_model == FALSE) {
    cprax.n = 3;

    cprax.x[0] = xl;
    cprax.x[1] = yl;
    cprax.x[2] = parms[P_E];
    
    switch(current_model) {
    case M_CHANG_REFSDAL:
      Xprmt[3] = parms[P_THETA];
      Xprmt[4] = parms[P_GAMMA];
      Xprmt[5] = parms[P_SIGMA];
      Xprmt[6] = parms[P_PHI];

      break;   
    case M_SING_ISOT_SPHERE:
      Xprmt[3] = parms[P_THETA];
      Xprmt[4] = parms[P_GAMMA];
      Xprmt[5] = parms[P_SIGMA];
      Xprmt[6] = parms[P_PHI];
      Xprmt[7] = parms[P_EXP];

      break;   
    case M_NSING_ISOT_SPHERE:
      Xprmt[3] = parms[P_THETA];
      Xprmt[4] = parms[P_GAMMA];
      Xprmt[5] = parms[P_SIGMA];
      Xprmt[6] = parms[P_PHI];
      Xprmt[7] = parms[P_KAPPA];
      Xprmt[8] = parms[P_C];

      break;   
    case M_TRANSP_SPHERE:
      Xprmt[3] = parms[P_THETA];
      Xprmt[4] = parms[P_GAMMA];
      Xprmt[5] = parms[P_SIGMA];
      Xprmt[6] = parms[P_PHI];
      Xprmt[7] = parms[P_C];
      
      break;   
    case M_ELLIPTICAL:         
      Xprmt[3]  = parms[P_THETA];
      Xprmt[4]  = parms[P_GAMMA];
      Xprmt[5]  = parms[P_SIGMA];
      Xprmt[6]  = parms[P_PHI];
      Xprmt[7]  = parms[P_KAPPA];
      Xprmt[8]  = parms[P_EPSILON];
      Xprmt[9]  = parms[P_C];
      Xprmt[10] = parms[P_ALPHA];

      break;
    case M_KING:
      Xprmt[3] = parms[P_THETA];
      Xprmt[4] = parms[P_GAMMA];
      Xprmt[5] = parms[P_SIGMA];
      Xprmt[6] = parms[P_PHI];
      Xprmt[7] = parms[P_KAPPA];

      break;
    case M_TRUNC_KING:
      Xprmt[3] = parms[P_THETA];
      Xprmt[4] = parms[P_GAMMA];
      Xprmt[5] = parms[P_SIGMA];
      Xprmt[6] = parms[P_PHI];
      Xprmt[7] = parms[P_C];
      Xprmt[8] = parms[P_KAPPA2];

      break;
    case M_HUBBLE:
      Xprmt[3] = parms[P_THETA];
      Xprmt[4] = parms[P_GAMMA];
      Xprmt[5] = parms[P_SIGMA];
      Xprmt[6] = parms[P_PHI];
      Xprmt[7] = parms[P_KAPPA];
      
      break;
    case M_DE_VAUCOULEUR:
      Xprmt[3] = parms[P_THETA];
      Xprmt[4] = parms[P_GAMMA];
      Xprmt[5] = parms[P_SIGMA];
      Xprmt[6] = parms[P_PHI];
      Xprmt[7] = parms[P_KAPPA];

      break;
    case M_SPIRAL:
      Xprmt[3] = parms[P_THETA];
      Xprmt[4] = parms[P_GAMMA];
      Xprmt[5] = parms[P_SIGMA];
      Xprmt[6] = parms[P_PHI];
      Xprmt[7] = parms[P_KAPPA];
      Xprmt[8] = parms[P_ALPHA2];

      break;
    case M_MULTIPOLE:
      Xprmt[3]  = parms[P_THETA];
      Xprmt[4]  = parms[P_GAMMA];
      Xprmt[5]  = parms[P_SIGMA];
      Xprmt[6]  = parms[P_PHI];
      Xprmt[7]  = parms[P_KAPPA0];
      Xprmt[8]  = parms[P_DX_QP];
      Xprmt[9]  = parms[P_DY_QP];
      Xprmt[10] = parms[P_QXX];
      Xprmt[11] = parms[P_QXY];
      Xprmt[12] = parms[P_QYY];

      break;
    case M_ROTATION_LENS:
      Xprmt[3] = parms[P_THETA];
      Xprmt[4] = parms[P_GAMMA];
      Xprmt[5] = parms[P_SIGMA];
      Xprmt[6] = parms[P_PHI];
      Xprmt[7] = parms[P_SX];
      Xprmt[8] = parms[P_SY];

      break;
    case M_DOUBLE_LENS:
      Xprmt[3]  = parms[P_THETA];
      Xprmt[4]  = parms[P_GAMMA];
      Xprmt[5]  = parms[P_SIGMA];
      Xprmt[6]  = parms[P_PHI];
      Xprmt[7]  = parms[P_X_1];
      Xprmt[8]  = parms[P_Y_1];
      Xprmt[9]  = parms[P_X_2];
      Xprmt[10] = parms[P_Y_2];
      Xprmt[11] = parms[P_M_1];
      Xprmt[12] = parms[P_M_2];
      Xprmt[13] = parms[P_BETA];
      Xprmt[14] = parms[P_GAMMA2];
      Xprmt[15] = parms[P_SIGMA2];
      Xprmt[16] = parms[P_PHI2];

      break;
    case M_UNIFORM_RING:
      Xprmt[3] = parms[P_THETA];
      Xprmt[4] = parms[P_GAMMA];
      Xprmt[5] = parms[P_SIGMA];
      Xprmt[6] = parms[P_PHI];
      Xprmt[7] = parms[P_KAPPA];
      Xprmt[8] = parms[P_Ri];
      Xprmt[9] = parms[P_Ro];

      break;
    default:
      break; 
    }
  } else if(sl_position == TRUE && sl_re == FALSE &&
            sl_macro == TRUE && sl_model == TRUE) {
    Xprmt[2] = parms[P_E];

    switch(current_model) {
    case M_CHANG_REFSDAL:
      cprax.n = 6;

      cprax.x[0] = xl;
      cprax.x[1] = yl;
      cprax.x[2] = parms[P_THETA];
      cprax.x[3] = parms[P_GAMMA];
      cprax.x[4] = parms[P_SIGMA];
      cprax.x[5] = parms[P_PHI];

      break;   
    case M_SING_ISOT_SPHERE:
      cprax.n = 7;

      cprax.x[0] = xl;
      cprax.x[1] = yl;
      cprax.x[2] = parms[P_THETA];
      cprax.x[3] = parms[P_GAMMA];
      cprax.x[4] = parms[P_SIGMA];
      cprax.x[5] = parms[P_PHI];
      cprax.x[6] = parms[P_EXP];

      break;   
    case M_NSING_ISOT_SPHERE:
      cprax.n = 8;

      cprax.x[0] = xl;
      cprax.x[1] = yl;
      cprax.x[2] = parms[P_THETA];
      cprax.x[3] = parms[P_GAMMA];
      cprax.x[4] = parms[P_SIGMA];
      cprax.x[5] = parms[P_PHI];
      cprax.x[6] = parms[P_KAPPA];
      cprax.x[7] = parms[P_C];

      break;   
    case M_TRANSP_SPHERE:
      cprax.n = 7;

      cprax.x[0] = xl;
      cprax.x[1] = yl;
      cprax.x[2] = parms[P_THETA];
      cprax.x[3] = parms[P_GAMMA];
      cprax.x[4] = parms[P_SIGMA];
      cprax.x[5] = parms[P_PHI];
      cprax.x[6] = parms[P_C];
      
      break;   
    case M_ELLIPTICAL:         
      cprax.n = 10;

      cprax.x[0] = xl;
      cprax.x[1] = yl;
      cprax.x[2] = parms[P_THETA];
      cprax.x[3] = parms[P_GAMMA];
      cprax.x[4] = parms[P_SIGMA];
      cprax.x[5] = parms[P_PHI];
      cprax.x[6] = parms[P_KAPPA];
      cprax.x[7] = parms[P_EPSILON];
      cprax.x[8] = parms[P_C];
      cprax.x[9] = parms[P_ALPHA];

      break;
    case M_KING:
      cprax.n = 7;

      cprax.x[0] = xl;
      cprax.x[1] = yl;
      cprax.x[2] = parms[P_THETA];
      cprax.x[3] = parms[P_GAMMA];
      cprax.x[4] = parms[P_SIGMA];
      cprax.x[5] = parms[P_PHI];
      cprax.x[6] = parms[P_KAPPA];

      break;
    case M_TRUNC_KING:
      cprax.n = 8;

      cprax.x[0] = xl;
      cprax.x[1] = yl;
      cprax.x[2] = parms[P_THETA];
      cprax.x[3] = parms[P_GAMMA];
      cprax.x[4] = parms[P_SIGMA];
      cprax.x[5] = parms[P_PHI];
      cprax.x[6] = parms[P_C];
      cprax.x[7] = parms[P_KAPPA2];

      break;
    case M_HUBBLE:
      cprax.n = 7;

      cprax.x[0] = xl;
      cprax.x[1] = yl;
      cprax.x[2] = parms[P_THETA];
      cprax.x[3] = parms[P_GAMMA];
      cprax.x[4] = parms[P_SIGMA];
      cprax.x[5] = parms[P_PHI];
      cprax.x[6] = parms[P_KAPPA];
      
      break;
    case M_DE_VAUCOULEUR:
      cprax.n = 7;

      cprax.x[0] = xl;
      cprax.x[1] = yl;
      cprax.x[2] = parms[P_THETA];
      cprax.x[3] = parms[P_GAMMA];
      cprax.x[4] = parms[P_SIGMA];
      cprax.x[5] = parms[P_PHI];
      cprax.x[6] = parms[P_KAPPA];

      break;
    case M_SPIRAL:
      cprax.n = 8;

      cprax.x[0] = xl;
      cprax.x[1] = yl;
      cprax.x[2] = parms[P_THETA];
      cprax.x[3] = parms[P_GAMMA];
      cprax.x[4] = parms[P_SIGMA];
      cprax.x[5] = parms[P_PHI];
      cprax.x[6] = parms[P_KAPPA];
      cprax.x[7] = parms[P_ALPHA2];

      break;
    case M_MULTIPOLE:
      cprax.n = 12;

      cprax.x[0]  = xl;
      cprax.x[1]  = yl;
      cprax.x[2]  = parms[P_THETA];
      cprax.x[3]  = parms[P_GAMMA];
      cprax.x[4]  = parms[P_SIGMA];
      cprax.x[5]  = parms[P_PHI];
      cprax.x[6]  = parms[P_KAPPA0];
      cprax.x[7]  = parms[P_DX_QP];
      cprax.x[8]  = parms[P_DY_QP];
      cprax.x[9]  = parms[P_QXX];
      cprax.x[10] = parms[P_QXY];
      cprax.x[11] = parms[P_QYY];

      break;
    case M_ROTATION_LENS:
      cprax.n = 8;

      cprax.x[0]  = xl;
      cprax.x[1]  = yl;
      cprax.x[2]  = parms[P_THETA];
      cprax.x[3]  = parms[P_GAMMA];
      cprax.x[4]  = parms[P_SIGMA];
      cprax.x[5]  = parms[P_PHI];
      cprax.x[6]  = parms[P_SX];
      cprax.x[7]  = parms[P_SY];

      break;
    case M_DOUBLE_LENS:
      cprax.n = 16;

      cprax.x[0]  = xl;
      cprax.x[1]  = yl;
      cprax.x[2]  = parms[P_THETA];
      cprax.x[3]  = parms[P_GAMMA];
      cprax.x[4]  = parms[P_SIGMA];
      cprax.x[5]  = parms[P_PHI];
      cprax.x[6]  = parms[P_X_1];
      cprax.x[7]  = parms[P_Y_1];
      cprax.x[8]  = parms[P_X_2];
      cprax.x[9]  = parms[P_Y_2];
      cprax.x[10] = parms[P_M_1];
      cprax.x[11] = parms[P_M_2];
      cprax.x[12] = parms[P_BETA];
      cprax.x[13] = parms[P_GAMMA2];
      cprax.x[14] = parms[P_SIGMA2];
      cprax.x[15] = parms[P_PHI2];

      break;
    case M_UNIFORM_RING:
      cprax.n = 9;

      cprax.x[0]  = xl;
      cprax.x[1]  = yl;
      cprax.x[2]  = parms[P_THETA];
      cprax.x[3]  = parms[P_GAMMA];
      cprax.x[4]  = parms[P_SIGMA];
      cprax.x[5]  = parms[P_PHI];
      cprax.x[6]  = parms[P_KAPPA];
      cprax.x[7]  = parms[P_Ri];
      cprax.x[8]  = parms[P_Ro];

      break;
    default:
      break; 
    }           
  } else if(sl_position == TRUE && sl_re == FALSE &&
            sl_macro == TRUE && sl_model == FALSE) {
    cprax.n = 5;

    cprax.x[0]  = xl;
    cprax.x[1]  = yl;
    cprax.x[2]  = parms[P_GAMMA];
    cprax.x[3]  = parms[P_SIGMA];
    cprax.x[4]  = parms[P_PHI];

    Xprmt[2] = parms[P_E];
    Xprmt[3] = parms[P_THETA];

    switch(current_model) {
    case M_CHANG_REFSDAL:

      break;   
    case M_SING_ISOT_SPHERE:
      Xprmt[7] = parms[P_EXP];

      break;   
    case M_NSING_ISOT_SPHERE:
      Xprmt[7] = parms[P_KAPPA];
      Xprmt[8] = parms[P_C];

      break;   
    case M_TRANSP_SPHERE:
      Xprmt[7] = parms[P_C];
            
      break;   
    case M_ELLIPTICAL:         
      Xprmt[7]  = parms[P_KAPPA];
      Xprmt[8]  = parms[P_EPSILON];
      Xprmt[9]  = parms[P_C];
      Xprmt[10] = parms[P_ALPHA];

      break;
    case M_KING:
      Xprmt[7] = parms[P_KAPPA];

      break;
    case M_TRUNC_KING:
      Xprmt[7] = parms[P_C];
      Xprmt[8] = parms[P_KAPPA2];

      break;
    case M_HUBBLE:
      Xprmt[7] = parms[P_KAPPA];
      
      break;
    case M_DE_VAUCOULEUR:
      Xprmt[7] = parms[P_KAPPA];

      break;
    case M_SPIRAL:
      Xprmt[7] = parms[P_KAPPA];
      Xprmt[8] = parms[P_ALPHA2];

      break;
    case M_MULTIPOLE:
      Xprmt[7]  = parms[P_KAPPA0];
      Xprmt[8]  = parms[P_DX_QP];
      Xprmt[9]  = parms[P_DY_QP];
      Xprmt[10] = parms[P_QXX];
      Xprmt[11] = parms[P_QXY];
      Xprmt[12] = parms[P_QYY];

      break;
    case M_ROTATION_LENS:
      Xprmt[7] = parms[P_SX];
      Xprmt[8] = parms[P_SY];

      break;
    case M_DOUBLE_LENS:
      Xprmt[7]  = parms[P_X_1];
      Xprmt[8]  = parms[P_Y_1];
      Xprmt[9]  = parms[P_X_2];
      Xprmt[10] = parms[P_Y_2];
      Xprmt[11] = parms[P_M_1];
      Xprmt[12] = parms[P_M_2];
      Xprmt[13] = parms[P_BETA];
      Xprmt[4]  = parms[P_GAMMA2];
      Xprmt[5]  = parms[P_SIGMA2];
      Xprmt[6]  = parms[P_PHI2];

      break;
    case M_UNIFORM_RING:
      Xprmt[7] = parms[P_KAPPA];
      Xprmt[8] = parms[P_Ri];
      Xprmt[9] = parms[P_Ro];

      break;
    default:
      break; 
    }
  } else if(sl_position == TRUE && sl_re == FALSE &&
            sl_macro == FALSE && sl_model == TRUE) {    
    Xprmt[2] = parms[P_E];
    Xprmt[4] = parms[P_GAMMA];
    Xprmt[5] = parms[P_SIGMA];
    Xprmt[6] = parms[P_PHI];

    switch(current_model) {
    case M_CHANG_REFSDAL:
      cprax.n = 3;

      cprax.x[0] = xl;
      cprax.x[1] = yl;
      cprax.x[2] = parms[P_THETA];

      break;   
    case M_SING_ISOT_SPHERE:
      cprax.n = 4;

      cprax.x[0] = xl;
      cprax.x[1] = yl;
      cprax.x[2] = parms[P_THETA];
      cprax.x[3] = parms[P_EXP];

      break;   
    case M_NSING_ISOT_SPHERE:
      cprax.n = 5;

      cprax.x[0] = xl;
      cprax.x[1] = yl;
      cprax.x[2] = parms[P_THETA];
      cprax.x[3] = parms[P_KAPPA];
      cprax.x[4] = parms[P_C];

      break;   
    case M_TRANSP_SPHERE:
      cprax.n = 4;

      cprax.x[0] = xl;
      cprax.x[1] = yl;
      cprax.x[2] = parms[P_THETA];
      cprax.x[3] = parms[P_C];
      
      break;   
    case M_ELLIPTICAL:         
      cprax.n = 7;

      cprax.x[0] = xl;
      cprax.x[1] = yl;
      cprax.x[2] = parms[P_THETA];
      cprax.x[3] = parms[P_KAPPA];
      cprax.x[4] = parms[P_EPSILON];
      cprax.x[5] = parms[P_C];
      cprax.x[6] = parms[P_ALPHA];

      break;
    case M_KING:
      cprax.n = 4;

      cprax.x[0] = xl;
      cprax.x[1] = yl;
      cprax.x[2] = parms[P_THETA];
      cprax.x[3] = parms[P_KAPPA];

      break;
    case M_TRUNC_KING:
      cprax.n = 5;

      cprax.x[0] = xl;
      cprax.x[1] = yl;
      cprax.x[2] = parms[P_THETA];
      cprax.x[3] = parms[P_C];
      cprax.x[4] = parms[P_KAPPA2];

      break;
    case M_HUBBLE:
      cprax.n = 4;

      cprax.x[0] = xl;
      cprax.x[1] = yl;
      cprax.x[2] = parms[P_THETA];
      cprax.x[3] = parms[P_KAPPA];
      
      break;
    case M_DE_VAUCOULEUR:
      cprax.n = 4;

      cprax.x[0] = xl;
      cprax.x[1] = yl;
      cprax.x[2] = parms[P_THETA];
      cprax.x[3] = parms[P_KAPPA];

      break;
    case M_SPIRAL:
      cprax.n = 5;

      cprax.x[0] = xl;
      cprax.x[1] = yl;
      cprax.x[2] = parms[P_THETA];
      cprax.x[3] = parms[P_KAPPA];
      cprax.x[4] = parms[P_ALPHA2];

      break;
    case M_MULTIPOLE:
      cprax.n = 9;

      cprax.x[0] = xl;
      cprax.x[1] = yl;
      cprax.x[2] = parms[P_THETA];
      cprax.x[3] = parms[P_KAPPA0];
      cprax.x[4] = parms[P_DX_QP];
      cprax.x[5] = parms[P_DY_QP];
      cprax.x[6] = parms[P_QXX];
      cprax.x[7] = parms[P_QXY];
      cprax.x[8] = parms[P_QYY];

      break;
    case M_ROTATION_LENS:
      cprax.n = 5;

      cprax.x[0] = xl;
      cprax.x[1] = yl;
      cprax.x[2] = parms[P_THETA];
      cprax.x[3] = parms[P_SX];
      cprax.x[4] = parms[P_SY];

      break;
    case M_DOUBLE_LENS:
      cprax.n = 13;

      cprax.x[0]  = xl;
      cprax.x[1]  = yl;
      cprax.x[2]  = parms[P_THETA];
      cprax.x[3]  = parms[P_X_1];
      cprax.x[4]  = parms[P_Y_1];
      cprax.x[5]  = parms[P_X_2];
      cprax.x[6]  = parms[P_Y_2];
      cprax.x[7]  = parms[P_M_1];
      cprax.x[8]  = parms[P_M_2];
      cprax.x[9]  = parms[P_BETA];
      cprax.x[10] = parms[P_GAMMA2];
      cprax.x[11] = parms[P_SIGMA2];
      cprax.x[12] = parms[P_PHI2];

      break;
    case M_UNIFORM_RING:
      cprax.n = 6;

      cprax.x[0] = xl;
      cprax.x[1] = yl;
      cprax.x[2] = parms[P_THETA];
      cprax.x[3] = parms[P_KAPPA];
      cprax.x[4] = parms[P_Ri];
      cprax.x[5] = parms[P_Ro];

      break;
    default:
      break; 
    }
  } else if(sl_position == TRUE && sl_re == FALSE &&
            sl_macro == FALSE && sl_model == FALSE) {      
    cprax.n = 2;

    cprax.x[0] = xl;
    cprax.x[1] = yl;

    Xprmt[2] = parms[P_E];
    Xprmt[3] = parms[P_THETA];
    Xprmt[4] = parms[P_GAMMA];
    Xprmt[5] = parms[P_SIGMA];
    Xprmt[6] = parms[P_PHI];

    switch(current_model) {
    case M_CHANG_REFSDAL:

      break;   
    case M_SING_ISOT_SPHERE:
      Xprmt[7] = parms[P_EXP];

      break;   
    case M_NSING_ISOT_SPHERE:
      Xprmt[7] = parms[P_KAPPA];
      Xprmt[8] = parms[P_C];

      break;   
    case M_TRANSP_SPHERE:
      Xprmt[7] = parms[P_C];
      
      break;   
    case M_ELLIPTICAL:         
      Xprmt[7]  = parms[P_KAPPA];
      Xprmt[8]  = parms[P_EPSILON];
      Xprmt[9]  = parms[P_C];
      Xprmt[10] = parms[P_ALPHA];

      break;
    case M_KING:
      Xprmt[7] = parms[P_KAPPA];

      break;
    case M_TRUNC_KING:
      Xprmt[7] = parms[P_C];
      Xprmt[8] = parms[P_KAPPA2];

      break;
    case M_HUBBLE:
      Xprmt[7] = parms[P_KAPPA];
      
      break;
    case M_DE_VAUCOULEUR:
      Xprmt[7] = parms[P_KAPPA];

      break;
    case M_SPIRAL:
      Xprmt[7] = parms[P_KAPPA];
      Xprmt[8] = parms[P_ALPHA2];

      break;
    case M_MULTIPOLE:
      Xprmt[7]  = parms[P_KAPPA0];
      Xprmt[8]  = parms[P_DX_QP];
      Xprmt[9]  = parms[P_DY_QP];
      Xprmt[10] = parms[P_QXX];
      Xprmt[11] = parms[P_QXY];
      Xprmt[12] = parms[P_QYY];

      break;
    case M_ROTATION_LENS:
      Xprmt[7] = parms[P_SX];
      Xprmt[8] = parms[P_SY];

      break;
    case M_DOUBLE_LENS:
      Xprmt[13] = parms[P_BETA];
      Xprmt[14] = parms[P_GAMMA2];
      Xprmt[15] = parms[P_SIGMA2];
      Xprmt[16] = parms[P_PHI2];

      break;
    case M_UNIFORM_RING:
      Xprmt[7] = parms[P_KAPPA];
      Xprmt[8] = parms[P_Ri];
      Xprmt[9] = parms[P_Ro];

      break;
    default:
      break; 
    }
  } else if(sl_position == FALSE && sl_re == TRUE &&
            sl_macro == TRUE && sl_model == TRUE) {
    Xprmt[0] = xl;
    Xprmt[1] = yl;
    
    switch(current_model) {
    case M_CHANG_REFSDAL:
      cprax.n = 5;

      cprax.x[0] = parms[P_E];
      cprax.x[1] = parms[P_THETA];
      cprax.x[2] = parms[P_GAMMA];
      cprax.x[3] = parms[P_SIGMA];
      cprax.x[4] = parms[P_PHI];

      break;   
    case M_SING_ISOT_SPHERE:
      cprax.n = 6;

      cprax.x[0] = parms[P_E];
      cprax.x[1] = parms[P_THETA];
      cprax.x[2] = parms[P_GAMMA];
      cprax.x[3] = parms[P_SIGMA];
      cprax.x[4] = parms[P_PHI];
      cprax.x[5] = parms[P_EXP];

      break;   
    case M_NSING_ISOT_SPHERE:
      cprax.n = 7;

      cprax.x[0] = parms[P_E];
      cprax.x[1] = parms[P_THETA];
      cprax.x[2] = parms[P_GAMMA];
      cprax.x[3] = parms[P_SIGMA];
      cprax.x[4] = parms[P_PHI];
      cprax.x[5] = parms[P_KAPPA];
      cprax.x[6] = parms[P_C];

      break;   
    case M_TRANSP_SPHERE:
      cprax.n = 6;

      cprax.x[0] = parms[P_E];
      cprax.x[1] = parms[P_THETA];
      cprax.x[2] = parms[P_GAMMA];
      cprax.x[3] = parms[P_SIGMA];
      cprax.x[4] = parms[P_PHI];
      cprax.x[5] = parms[P_C];

      break;   
    case M_ELLIPTICAL:         
      cprax.n = 9;

      cprax.x[0] = parms[P_E];
      cprax.x[1] = parms[P_THETA];
      cprax.x[2] = parms[P_GAMMA];
      cprax.x[3] = parms[P_SIGMA];
      cprax.x[4] = parms[P_PHI];
      cprax.x[5] = parms[P_KAPPA];
      cprax.x[6] = parms[P_EPSILON];
      cprax.x[7] = parms[P_C];
      cprax.x[8] = parms[P_ALPHA];

      break;
    case M_KING:
      cprax.n = 6;

      cprax.x[0] = parms[P_E];
      cprax.x[1] = parms[P_THETA];
      cprax.x[2] = parms[P_GAMMA];
      cprax.x[3] = parms[P_SIGMA];
      cprax.x[4] = parms[P_PHI];
      cprax.x[5] = parms[P_KAPPA];

      break;
    case M_TRUNC_KING:
      cprax.n = 7;

      cprax.x[0] = parms[P_E];
      cprax.x[1] = parms[P_THETA];
      cprax.x[2] = parms[P_GAMMA];
      cprax.x[3] = parms[P_SIGMA];
      cprax.x[4] = parms[P_PHI];
      cprax.x[5] = parms[P_C];
      cprax.x[6] = parms[P_KAPPA2];

      break;
    case M_HUBBLE:
      cprax.n = 6;

      cprax.x[0] = parms[P_E];
      cprax.x[1] = parms[P_THETA];
      cprax.x[2] = parms[P_GAMMA];
      cprax.x[3] = parms[P_SIGMA];
      cprax.x[4] = parms[P_PHI];
      cprax.x[5] = parms[P_KAPPA];

      break;
    case M_DE_VAUCOULEUR:
      cprax.n = 6;

      cprax.x[0] = parms[P_E];
      cprax.x[1] = parms[P_THETA];
      cprax.x[2] = parms[P_GAMMA];
      cprax.x[3] = parms[P_SIGMA];
      cprax.x[4] = parms[P_PHI];
      cprax.x[5] = parms[P_KAPPA];

      break;
    case M_SPIRAL:
      cprax.n = 7;

      cprax.x[0] = parms[P_E];
      cprax.x[1] = parms[P_THETA];
      cprax.x[2] = parms[P_GAMMA];
      cprax.x[3] = parms[P_SIGMA];
      cprax.x[4] = parms[P_PHI];
      cprax.x[5] = parms[P_KAPPA];
      cprax.x[6] = parms[P_ALPHA2];

      break;
    case M_MULTIPOLE:
      cprax.n = 11;

      cprax.x[0]  = parms[P_E];
      cprax.x[1]  = parms[P_THETA];
      cprax.x[2]  = parms[P_GAMMA];
      cprax.x[3]  = parms[P_SIGMA];
      cprax.x[4]  = parms[P_PHI];
      cprax.x[5]  = parms[P_KAPPA0];
      cprax.x[6]  = parms[P_DX_QP];
      cprax.x[7]  = parms[P_DY_QP];
      cprax.x[8]  = parms[P_QXX];
      cprax.x[9]  = parms[P_QXY];
      cprax.x[10] = parms[P_QYY];

      break;
    case M_ROTATION_LENS:
      cprax.n = 7;

      cprax.x[0]  = parms[P_E];
      cprax.x[1]  = parms[P_THETA];
      cprax.x[2]  = parms[P_GAMMA];
      cprax.x[3]  = parms[P_SIGMA];
      cprax.x[4]  = parms[P_PHI];
      cprax.x[5]  = parms[P_SX];
      cprax.x[6]  = parms[P_SY];

      break;
    case M_DOUBLE_LENS:
      cprax.n = 15;

      cprax.x[0]  = parms[P_E];
      cprax.x[1]  = parms[P_THETA];
      cprax.x[2]  = parms[P_GAMMA];
      cprax.x[3]  = parms[P_SIGMA];
      cprax.x[4]  = parms[P_PHI];
      cprax.x[5]  = parms[P_X_1];
      cprax.x[6]  = parms[P_Y_1];
      cprax.x[7]  = parms[P_X_2];
      cprax.x[8]  = parms[P_Y_2];
      cprax.x[9]  = parms[P_M_1];
      cprax.x[10] = parms[P_M_2];
      cprax.x[11] = parms[P_BETA];
      cprax.x[12] = parms[P_GAMMA2];
      cprax.x[13] = parms[P_SIGMA2];
      cprax.x[14] = parms[P_PHI2];

      break;
    case M_UNIFORM_RING:
      cprax.n = 8;

      cprax.x[0] = parms[P_E];
      cprax.x[1] = parms[P_THETA];
      cprax.x[2] = parms[P_GAMMA];
      cprax.x[3] = parms[P_SIGMA];
      cprax.x[4] = parms[P_PHI];
      cprax.x[5] = parms[P_KAPPA];
      cprax.x[6] = parms[P_Ri];
      cprax.x[7] = parms[P_Ro];

      break;
    default:
      break; 
    }
  } else if(sl_position == FALSE && sl_re == TRUE &&
            sl_macro == TRUE && sl_model == FALSE) {
    cprax.n = 4;

    cprax.x[0] = parms[P_E];
    cprax.x[1] = parms[P_GAMMA];
    cprax.x[2] = parms[P_SIGMA];
    cprax.x[3] = parms[P_PHI];

    Xprmt[0] = xl;
    Xprmt[1] = yl;
    Xprmt[3] = parms[P_THETA];
    
    switch(current_model) {   
    case M_CHANG_REFSDAL:

      break;   
    case M_SING_ISOT_SPHERE:
      Xprmt[8] = parms[P_EXP];

      break;   
    case M_NSING_ISOT_SPHERE:
      Xprmt[7] = parms[P_KAPPA];
      Xprmt[9] = parms[P_C];

      break;   
    case M_TRANSP_SPHERE:
      Xprmt[7] = parms[P_C];
      
      break;   
    case M_ELLIPTICAL:         
      Xprmt[7]  = parms[P_KAPPA];
      Xprmt[8]  = parms[P_EPSILON];
      Xprmt[9]  = parms[P_C];
      Xprmt[10] = parms[P_ALPHA];    

      break;
    case M_KING:
      Xprmt[7] = parms[P_KAPPA];

      break;
    case M_TRUNC_KING:
      Xprmt[7] = parms[P_C];
      Xprmt[8] = parms[P_KAPPA2];

      break;
    case M_HUBBLE:
      Xprmt[7] = parms[P_KAPPA];
      
      break;
    case M_DE_VAUCOULEUR:
      Xprmt[7] = parms[P_KAPPA];

      break;
    case M_SPIRAL:
      Xprmt[7] = parms[P_KAPPA];
      Xprmt[8] = parms[P_ALPHA2];    

      break;
    case M_MULTIPOLE:
      Xprmt[7]  = parms[P_KAPPA0];
      Xprmt[8]  = parms[P_DX_QP];
      Xprmt[9]  = parms[P_DY_QP];
      Xprmt[10] = parms[P_QXX];
      Xprmt[11] = parms[P_QXY];
      Xprmt[12] = parms[P_QYY];

      break;
    case M_ROTATION_LENS:
      Xprmt[7] = parms[P_SX];
      Xprmt[8] = parms[P_SY];

      break;
    case M_DOUBLE_LENS:
      Xprmt[7]  = parms[P_X_1];
      Xprmt[8]  = parms[P_Y_1];
      Xprmt[9]  = parms[P_X_2];
      Xprmt[10] = parms[P_Y_2];
      Xprmt[11] = parms[P_M_1];
      Xprmt[12] = parms[P_M_2];
      Xprmt[13] = parms[P_BETA];
      Xprmt[14] = parms[P_GAMMA2];
      Xprmt[15] = parms[P_SIGMA2];
      Xprmt[16] = parms[P_PHI2];

      break;
    case M_UNIFORM_RING:
      Xprmt[7] = parms[P_KAPPA];
      Xprmt[8] = parms[P_Ri];
      Xprmt[9] = parms[P_Ro];

      break;
    default:
      break;     
    }
  } else if(sl_position == FALSE && sl_re == TRUE &&
            sl_macro == FALSE && sl_model == TRUE) { 
    Xprmt[0] = xl;
    Xprmt[1] = yl;
    Xprmt[4] = parms[P_GAMMA];
    Xprmt[5] = parms[P_SIGMA];
    Xprmt[6] = parms[P_PHI];

    switch(current_model) {
    case M_CHANG_REFSDAL:
      cprax.n = 2;

      cprax.x[0] = parms[P_E];
      cprax.x[1] = parms[P_THETA];

      break;   
    case M_SING_ISOT_SPHERE:
      cprax.n = 3;

      cprax.x[0] = parms[P_E];
      cprax.x[1] = parms[P_THETA];
      cprax.x[2] = parms[P_EXP];

      break;   
    case M_NSING_ISOT_SPHERE:
      cprax.n = 4;

      cprax.x[0] = parms[P_E];
      cprax.x[1] = parms[P_THETA];
      cprax.x[2] = parms[P_KAPPA];
      cprax.x[3] = parms[P_C];

      break;   
    case M_TRANSP_SPHERE:
      cprax.n = 3;

      cprax.x[0] = parms[P_E];
      cprax.x[1] = parms[P_THETA];
      cprax.x[2] = parms[P_C];

      break;   
    case M_ELLIPTICAL:         
      cprax.n = 6;

      cprax.x[0] = parms[P_E];
      cprax.x[1] = parms[P_THETA];
      cprax.x[2] = parms[P_KAPPA];
      cprax.x[3] = parms[P_EPSILON];
      cprax.x[4] = parms[P_C];
      cprax.x[5] = parms[P_ALPHA];

      break;
    case M_KING:
      cprax.n = 3;

      cprax.x[0] = parms[P_E];
      cprax.x[1] = parms[P_THETA];
      cprax.x[2] = parms[P_KAPPA];

      break;
    case M_TRUNC_KING:
      cprax.n = 4;

      cprax.x[0] = parms[P_E];
      cprax.x[1] = parms[P_THETA];
      cprax.x[2] = parms[P_C];
      cprax.x[3] = parms[P_KAPPA2];

      break;
    case M_HUBBLE:
      cprax.n = 3;

      cprax.x[0] = parms[P_E];
      cprax.x[1] = parms[P_THETA];
      cprax.x[2] = parms[P_KAPPA];

      break;
    case M_DE_VAUCOULEUR:
      cprax.n = 3;

      cprax.x[0] = parms[P_E];
      cprax.x[1] = parms[P_THETA];
      cprax.x[2] = parms[P_KAPPA];

      break;
    case M_SPIRAL:
      cprax.n = 4;

      cprax.x[0] = parms[P_E];
      cprax.x[1] = parms[P_THETA];
      cprax.x[2] = parms[P_KAPPA];
      cprax.x[3] = parms[P_ALPHA2];

      break;
    case M_MULTIPOLE:
      cprax.n = 8;

      cprax.x[0] = parms[P_E];
      cprax.x[1] = parms[P_THETA];
      cprax.x[2] = parms[P_KAPPA0];
      cprax.x[3] = parms[P_DX_QP];
      cprax.x[4] = parms[P_DY_QP];
      cprax.x[5] = parms[P_QXX];
      cprax.x[6] = parms[P_QXY];
      cprax.x[7] = parms[P_QYY];

      break;
    case M_ROTATION_LENS:
      cprax.n = 4;

      cprax.x[0] = parms[P_E];
      cprax.x[1] = parms[P_THETA];
      cprax.x[2] = parms[P_SX];
      cprax.x[3] = parms[P_SY];

      break;
    case M_DOUBLE_LENS:
      cprax.n = 12;

      cprax.x[0]  = parms[P_E];
      cprax.x[1]  = parms[P_THETA];
      cprax.x[2]  = parms[P_X_1];
      cprax.x[3]  = parms[P_Y_1];
      cprax.x[4]  = parms[P_X_2];
      cprax.x[5]  = parms[P_Y_2];
      cprax.x[6]  = parms[P_M_1];
      cprax.x[7]  = parms[P_M_2];
      cprax.x[8]  = parms[P_BETA];
      cprax.x[9]  = parms[P_GAMMA2];
      cprax.x[10] = parms[P_SIGMA2];
      cprax.x[11] = parms[P_PHI2];
      
      break;
    case M_UNIFORM_RING:
      cprax.n = 5;

      cprax.x[0] = parms[P_E];
      cprax.x[1] = parms[P_THETA];
      cprax.x[2] = parms[P_KAPPA];
      cprax.x[3] = parms[P_Ri];
      cprax.x[4] = parms[P_Ro];

      break;
    default:
      break; 
    }
  } else if(sl_position == FALSE && sl_re == TRUE &&
            sl_macro == FALSE && sl_model == FALSE) {
    /* We have to avoid this case because cprax.n >= 2 */

    cprax.n = 1;

    cprax.x[0] = parms[P_E];

    Xprmt[0] = xl;
    Xprmt[1] = yl;
    Xprmt[3] = parms[P_THETA];
    Xprmt[4] = parms[P_GAMMA];
    Xprmt[5] = parms[P_SIGMA];
    Xprmt[6] = parms[P_PHI];

    switch(current_model) {
    case M_CHANG_REFSDAL:
      
      break;   
    case M_SING_ISOT_SPHERE:
      Xprmt[7] = parms[P_EXP];

      break;   
    case M_NSING_ISOT_SPHERE:
      Xprmt[7] = parms[P_KAPPA];
      Xprmt[8] = parms[P_C];

      break;   
    case M_TRANSP_SPHERE:
      Xprmt[7] = parms[P_C];
      
      break;   
    case M_ELLIPTICAL:         
      Xprmt[7]  = parms[P_KAPPA];
      Xprmt[8]  = parms[P_EPSILON];
      Xprmt[9]  = parms[P_C];
      Xprmt[10] = parms[P_ALPHA];    

      break;
    case M_KING:
      Xprmt[7] = parms[P_KAPPA];

      break;
    case M_TRUNC_KING:
      Xprmt[7] = parms[P_C];
      Xprmt[8] = parms[P_KAPPA2];

      break;
    case M_HUBBLE:
      Xprmt[7] = parms[P_KAPPA];
      
      break;
    case M_DE_VAUCOULEUR:
      Xprmt[7] = parms[P_KAPPA];

      break;
    case M_SPIRAL:
      Xprmt[7] = parms[P_KAPPA];
      Xprmt[8] = parms[P_ALPHA2];

      break;
    case M_MULTIPOLE:
      Xprmt[7]  = parms[P_KAPPA0];
      Xprmt[8]  = parms[P_DX_QP];
      Xprmt[9]  = parms[P_DY_QP];
      Xprmt[10] = parms[P_QXX];
      Xprmt[11] = parms[P_QXY];
      Xprmt[12] = parms[P_QYY];

      break;
    case M_ROTATION_LENS:
      Xprmt[7] = parms[P_SX];
      Xprmt[8] = parms[P_SY];

      break;
    case M_DOUBLE_LENS:
      Xprmt[7]  = parms[P_X_1];
      Xprmt[8]  = parms[P_Y_1];
      Xprmt[9]  = parms[P_X_2];
      Xprmt[10] = parms[P_Y_2];
      Xprmt[11] = parms[P_M_1];
      Xprmt[12] = parms[P_M_2];
      Xprmt[13] = parms[P_BETA];
      Xprmt[14] = parms[P_GAMMA2];
      Xprmt[15] = parms[P_SIGMA2];
      Xprmt[16] = parms[P_PHI2];

      break;
    case M_UNIFORM_RING:
      Xprmt[7] = parms[P_KAPPA];
      Xprmt[8] = parms[P_Ri];
      Xprmt[9] = parms[P_Ro];

      break;
    default:
      break;
    }
  } else if(sl_position == FALSE && sl_re == FALSE &&
            sl_macro == TRUE && sl_model == TRUE) {      
    Xprmt[0] = xl;
    Xprmt[1] = yl;
    Xprmt[2] = parms[P_E];

    switch(current_model) {
    case M_CHANG_REFSDAL:
      cprax.n = 4;

      cprax.x[0] = parms[P_THETA]; 
      cprax.x[1] = parms[P_GAMMA];
      cprax.x[2] = parms[P_SIGMA];
      cprax.x[3] = parms[P_PHI];

      break;   
    case M_SING_ISOT_SPHERE:
      cprax.n = 5;

      cprax.x[0] = parms[P_THETA]; 
      cprax.x[1] = parms[P_GAMMA];
      cprax.x[2] = parms[P_SIGMA];
      cprax.x[3] = parms[P_PHI];
      cprax.x[4] = parms[P_EXP];

      break;   
    case M_NSING_ISOT_SPHERE:
      cprax.n = 6;

      cprax.x[0] = parms[P_THETA]; 
      cprax.x[1] = parms[P_GAMMA];
      cprax.x[2] = parms[P_SIGMA];
      cprax.x[3] = parms[P_PHI];
      cprax.x[4] = parms[P_KAPPA];
      cprax.x[5] = parms[P_C];

      break;   
    case M_TRANSP_SPHERE:
      cprax.n = 5;

      cprax.x[0] = parms[P_THETA]; 
      cprax.x[1] = parms[P_GAMMA];
      cprax.x[2] = parms[P_SIGMA];
      cprax.x[3] = parms[P_PHI];
      cprax.x[4] = parms[P_C];
      
      break;   
    case M_ELLIPTICAL:         
      cprax.n = 8;

      cprax.x[0] = parms[P_THETA]; 
      cprax.x[1] = parms[P_GAMMA];
      cprax.x[2] = parms[P_SIGMA];
      cprax.x[3] = parms[P_PHI];
      cprax.x[4] = parms[P_KAPPA];
      cprax.x[5] = parms[P_EPSILON];
      cprax.x[6] = parms[P_C];
      cprax.x[7] = parms[P_ALPHA];

      break;
    case M_KING:
      cprax.n = 5;

      cprax.x[0] = parms[P_THETA]; 
      cprax.x[1] = parms[P_GAMMA];
      cprax.x[2] = parms[P_SIGMA];
      cprax.x[3] = parms[P_PHI];
      cprax.x[4] = parms[P_KAPPA];

      break;
    case M_TRUNC_KING:
      cprax.n = 6;

      cprax.x[0] = parms[P_THETA]; 
      cprax.x[1] = parms[P_GAMMA];
      cprax.x[2] = parms[P_SIGMA];
      cprax.x[3] = parms[P_PHI];
      cprax.x[4] = parms[P_C];
      cprax.x[5] = parms[P_KAPPA2];

      break;
    case M_HUBBLE:
      cprax.n = 5;

      cprax.x[0] = parms[P_THETA]; 
      cprax.x[1] = parms[P_GAMMA];
      cprax.x[2] = parms[P_SIGMA];
      cprax.x[3] = parms[P_PHI];
      cprax.x[4] = parms[P_KAPPA];
      
      break;
    case M_DE_VAUCOULEUR:
      cprax.n = 5;

      cprax.x[0] = parms[P_THETA]; 
      cprax.x[1] = parms[P_GAMMA];
      cprax.x[2] = parms[P_SIGMA];
      cprax.x[3] = parms[P_PHI];
      cprax.x[4] = parms[P_KAPPA];

      break;
    case M_SPIRAL:
      cprax.n = 6;

      cprax.x[0] = parms[P_THETA]; 
      cprax.x[1] = parms[P_GAMMA];
      cprax.x[2] = parms[P_SIGMA];
      cprax.x[3] = parms[P_PHI];
      cprax.x[4] = parms[P_KAPPA];
      cprax.x[5] = parms[P_ALPHA2];

      break;
    case M_MULTIPOLE:
      cprax.n = 10;

      cprax.x[0] = parms[P_THETA]; 
      cprax.x[1] = parms[P_GAMMA];
      cprax.x[2] = parms[P_SIGMA];
      cprax.x[3] = parms[P_PHI];
      cprax.x[4] = parms[P_KAPPA0];
      cprax.x[5] = parms[P_DX_QP];
      cprax.x[6] = parms[P_DY_QP];
      cprax.x[7] = parms[P_QXX];
      cprax.x[8] = parms[P_QXY];
      cprax.x[9] = parms[P_QYY];

      break;
    case M_ROTATION_LENS:
      cprax.n = 6;

      cprax.x[0] = parms[P_THETA]; 
      cprax.x[1] = parms[P_GAMMA];
      cprax.x[2] = parms[P_SIGMA];
      cprax.x[3] = parms[P_PHI];
      cprax.x[4] = parms[P_SX];
      cprax.x[5] = parms[P_SY];

      break;
    case M_DOUBLE_LENS:
      cprax.n = 14;

      cprax.x[0]  = parms[P_THETA]; 
      cprax.x[1]  = parms[P_GAMMA];
      cprax.x[2]  = parms[P_SIGMA];
      cprax.x[3]  = parms[P_PHI];
      cprax.x[4]  = parms[P_X_1];
      cprax.x[5]  = parms[P_Y_1];
      cprax.x[6]  = parms[P_X_2];
      cprax.x[7]  = parms[P_Y_2];
      cprax.x[8]  = parms[P_M_1];
      cprax.x[9]  = parms[P_M_2];
      cprax.x[10] = parms[P_BETA];
      cprax.x[11] = parms[P_GAMMA2];
      cprax.x[12] = parms[P_SIGMA2];
      cprax.x[13] = parms[P_PHI2];

      break;
    case M_UNIFORM_RING:
      cprax.n = 7;

      cprax.x[0] = parms[P_THETA]; 
      cprax.x[1] = parms[P_GAMMA];
      cprax.x[2] = parms[P_SIGMA];
      cprax.x[3] = parms[P_PHI];
      cprax.x[4] = parms[P_KAPPA];
      cprax.x[5] = parms[P_Ri];
      cprax.x[6] = parms[P_Ro];

      break;
    default:
      break; 
    }
  } else if(sl_position == FALSE && sl_re == FALSE &&
            sl_macro == TRUE && sl_model == FALSE) {
    cprax.n = 3;

    cprax.x[0] = parms[P_GAMMA];
    cprax.x[1] = parms[P_SIGMA];
    cprax.x[2] = parms[P_PHI];

    switch(current_model) {
    case M_CHANG_REFSDAL:
      Xprmt[0] = xl;
      Xprmt[1] = yl;
      Xprmt[2] = parms[P_E];
      Xprmt[3] = parms[P_THETA]; 

      break;   
    case M_SING_ISOT_SPHERE:
      Xprmt[0] = xl;
      Xprmt[1] = yl;
      Xprmt[2] = parms[P_E];
      Xprmt[3] = parms[P_THETA]; 
      Xprmt[7] = parms[P_EXP];

      break;   
    case M_NSING_ISOT_SPHERE:
      Xprmt[0] = xl;
      Xprmt[1] = yl;
      Xprmt[2] = parms[P_E];
      Xprmt[3] = parms[P_THETA]; 
      Xprmt[7] = parms[P_KAPPA];
      Xprmt[8] = parms[P_C];

      break;   
    case M_TRANSP_SPHERE:
      Xprmt[0] = xl;
      Xprmt[1] = yl;
      Xprmt[2] = parms[P_E];
      Xprmt[3] = parms[P_THETA]; 
      Xprmt[7] = parms[P_C];
      
      break;   
    case M_ELLIPTICAL:         
      Xprmt[0]  = xl;
      Xprmt[1]  = yl;
      Xprmt[2]  = parms[P_E];
      Xprmt[3]  = parms[P_THETA]; 
      Xprmt[7]  = parms[P_KAPPA];
      Xprmt[8]  = parms[P_EPSILON];
      Xprmt[9]  = parms[P_C];
      Xprmt[10] = parms[P_ALPHA];        
      
      break;
    case M_KING:
      Xprmt[0] = xl;
      Xprmt[1] = yl;
      Xprmt[2] = parms[P_E];
      Xprmt[3] = parms[P_THETA]; 
      Xprmt[7] = parms[P_KAPPA];

      break;
    case M_TRUNC_KING:
      Xprmt[0] = xl;
      Xprmt[1] = yl;
      Xprmt[2] = parms[P_E];
      Xprmt[3] = parms[P_THETA]; 
      Xprmt[7] = parms[P_C];
      Xprmt[8] = parms[P_KAPPA2];

      break;
    case M_HUBBLE:
      Xprmt[0] = xl;
      Xprmt[1] = yl;
      Xprmt[2] = parms[P_E];
      Xprmt[3] = parms[P_THETA]; 
      Xprmt[7] = parms[P_KAPPA];
      
      break;
    case M_DE_VAUCOULEUR:
      Xprmt[0] = xl;
      Xprmt[1] = yl;
      Xprmt[2] = parms[P_E];
      Xprmt[3] = parms[P_THETA]; 
      Xprmt[7] = parms[P_KAPPA];

      break;
    case M_SPIRAL:
      Xprmt[0] = xl;
      Xprmt[1] = yl;
      Xprmt[2] = parms[P_E];
      Xprmt[3] = parms[P_THETA]; 
      Xprmt[7] = parms[P_KAPPA];
      Xprmt[8] = parms[P_ALPHA2];

      break;
    case M_MULTIPOLE:
      Xprmt[0]  = xl;
      Xprmt[1]  = yl;
      Xprmt[2]  = parms[P_E];
      Xprmt[3]  = parms[P_THETA];
      Xprmt[7]  = parms[P_KAPPA0];
      Xprmt[8]  = parms[P_DX_QP];
      Xprmt[9]  = parms[P_DY_QP];
      Xprmt[10] = parms[P_QXX];
      Xprmt[11] = parms[P_QXY];
      Xprmt[12] = parms[P_QYY];

      break;
    case M_ROTATION_LENS:
      Xprmt[0] = xl;
      Xprmt[1] = yl;
      Xprmt[2] = parms[P_E];
      Xprmt[3] = parms[P_THETA];
      Xprmt[7] = parms[P_SX];
      Xprmt[8] = parms[P_SY];

      break;
    case M_DOUBLE_LENS:
      cprax.n = 6;

      cprax.x[3] = parms[P_GAMMA2];
      cprax.x[4] = parms[P_SIGMA2];
      cprax.x[5] = parms[P_PHI2];

      Xprmt[0]  = xl;
      Xprmt[1]  = yl;
      Xprmt[2]  = parms[P_E];
      Xprmt[3]  = parms[P_THETA];
      Xprmt[7]  = parms[P_X_1];
      Xprmt[8]  = parms[P_Y_1];
      Xprmt[9]  = parms[P_X_2];
      Xprmt[10] = parms[P_Y_2];
      Xprmt[11] = parms[P_M_1];
      Xprmt[12] = parms[P_M_2];
      Xprmt[13] = parms[P_BETA];

      break;
    case M_UNIFORM_RING:
      Xprmt[0] = xl;
      Xprmt[1] = yl;
      Xprmt[2] = parms[P_E];
      Xprmt[3] = parms[P_THETA];
      Xprmt[7] = parms[P_KAPPA];
      Xprmt[8] = parms[P_Ri];
      Xprmt[9] = parms[P_Ro];

      break;
    default:
      break;
    }
  } else if(sl_position == FALSE && sl_re == FALSE &&
            sl_macro == FALSE && sl_model == TRUE) {
    Xprmt[0] = xl;
    Xprmt[1] = yl;
    Xprmt[2] = parms[P_E];
    Xprmt[4] = parms[P_GAMMA];
    Xprmt[5] = parms[P_SIGMA];
    Xprmt[6] = parms[P_PHI];

    switch(current_model) {
    case M_CHANG_REFSDAL:
      /* We have to avoid this case because cprax.n >= 2 */
      
      cprax.n = 1;

      cprax.x[0] = parms[P_THETA]; 

      break;   
    case M_SING_ISOT_SPHERE:
      cprax.n = 2;

      cprax.x[0] = parms[P_THETA]; 
      cprax.x[1] = parms[P_EXP]; 

      break;   
    case M_NSING_ISOT_SPHERE:
      cprax.n = 3;

      cprax.x[0] = parms[P_THETA]; 
      cprax.x[1] = parms[P_KAPPA]; 
      cprax.x[2] = parms[P_C]; 

      break;   
    case M_TRANSP_SPHERE:
      cprax.n = 2;

      cprax.x[0] = parms[P_THETA]; 
      cprax.x[1] = parms[P_C]; 

      break;   
    case M_ELLIPTICAL:         
      cprax.n = 5;

      cprax.x[0] = parms[P_THETA]; 
      cprax.x[1] = parms[P_KAPPA]; 
      cprax.x[2] = parms[P_EPSILON]; 
      cprax.x[3] = parms[P_C]; 
      cprax.x[4] = parms[P_ALPHA]; 

      break;
    case M_KING:
      cprax.n = 2;

      cprax.x[0] = parms[P_THETA]; 
      cprax.x[1] = parms[P_KAPPA]; 

      break;
    case M_TRUNC_KING:
      cprax.n = 3;

      cprax.x[0] = parms[P_THETA]; 
      cprax.x[1] = parms[P_C];
      cprax.x[2] = parms[P_KAPPA2]; 
      
      break;
    case M_HUBBLE:
      cprax.n = 2;

      cprax.x[0] = parms[P_THETA]; 
      cprax.x[1] = parms[P_KAPPA]; 

      break;
    case M_DE_VAUCOULEUR:
      cprax.n = 2;

      cprax.x[0] = parms[P_THETA]; 
      cprax.x[1] = parms[P_KAPPA]; 

      break;
    case M_SPIRAL:
      cprax.n = 3;

      cprax.x[0] = parms[P_THETA]; 
      cprax.x[1] = parms[P_KAPPA]; 
      cprax.x[2] = parms[P_ALPHA2]; 

      break;
    case M_MULTIPOLE:
      cprax.n = 7;

      cprax.x[0] = parms[P_THETA]; 
      cprax.x[1] = parms[P_KAPPA0]; 
      cprax.x[2] = parms[P_DX_QP]; 
      cprax.x[3] = parms[P_DY_QP]; 
      cprax.x[4] = parms[P_QXX]; 
      cprax.x[5] = parms[P_QXY]; 
      cprax.x[6] = parms[P_QYY]; 

      break;
    case M_ROTATION_LENS:
      cprax.n = 3;

      cprax.x[0] = parms[P_THETA]; 
      cprax.x[1] = parms[P_SX]; 
      cprax.x[2] = parms[P_SY]; 

      break;
    case M_DOUBLE_LENS:
      cprax.n = 11;

      cprax.x[0]  = parms[P_THETA]; 
      cprax.x[1]  = parms[P_X_1]; 
      cprax.x[2]  = parms[P_Y_1]; 
      cprax.x[3]  = parms[P_X_2]; 
      cprax.x[4]  = parms[P_Y_2]; 
      cprax.x[5]  = parms[P_M_1];
      cprax.x[6]  = parms[P_M_2];
      cprax.x[7]  = parms[P_BETA];
      cprax.x[8]  = parms[P_GAMMA2];
      cprax.x[9]  = parms[P_SIGMA2];
      cprax.x[10] = parms[P_PHI2];

      break;
    case M_UNIFORM_RING:
      cprax.n = 4;

      cprax.x[0] = parms[P_THETA]; 
      cprax.x[1] = parms[P_KAPPA0]; 
      cprax.x[2] = parms[P_Ri]; 
      cprax.x[3] = parms[P_Ro]; 

      break;
    default:
      break; 
    }
  } else if(sl_position == FALSE && sl_re == FALSE &&
            sl_macro == FALSE && sl_model == FALSE) {
    /* This case is impossible */
    
    cprax.n = 0;

    switch(current_model) {
    case M_CHANG_REFSDAL:
      Xprmt[0] = xl;
      Xprmt[1] = yl;
      Xprmt[2] = parms[P_E];
      Xprmt[3] = parms[P_THETA];
      Xprmt[4] = parms[P_GAMMA];
      Xprmt[5] = parms[P_SIGMA];
      Xprmt[6] = parms[P_PHI];

      break;   
    case M_SING_ISOT_SPHERE:
      Xprmt[0] = xl;
      Xprmt[1] = yl;
      Xprmt[2] = parms[P_E];
      Xprmt[3] = parms[P_THETA];
      Xprmt[4] = parms[P_GAMMA];
      Xprmt[5] = parms[P_SIGMA];
      Xprmt[6] = parms[P_PHI];
      Xprmt[7] = parms[P_EXP];

      break;   
    case M_NSING_ISOT_SPHERE:
      Xprmt[0] = xl;
      Xprmt[1] = yl;
      Xprmt[2] = parms[P_E];
      Xprmt[3] = parms[P_THETA];
      Xprmt[4] = parms[P_GAMMA];
      Xprmt[5] = parms[P_SIGMA];
      Xprmt[6] = parms[P_PHI];
      Xprmt[7] = parms[P_KAPPA];
      Xprmt[8] = parms[P_C];

      break;   
    case M_TRANSP_SPHERE:
      Xprmt[0] = xl;
      Xprmt[1] = yl;
      Xprmt[2] = parms[P_E];
      Xprmt[3] = parms[P_THETA];
      Xprmt[4] = parms[P_GAMMA];
      Xprmt[5] = parms[P_SIGMA];
      Xprmt[6] = parms[P_PHI];
      Xprmt[7] = parms[P_C];
      
      break;   
    case M_ELLIPTICAL:         
      Xprmt[0]  = xl;
      Xprmt[1]  = yl;
      Xprmt[2]  = parms[P_E];
      Xprmt[3]  = parms[P_THETA];
      Xprmt[4]  = parms[P_GAMMA];
      Xprmt[5]  = parms[P_SIGMA];
      Xprmt[6]  = parms[P_PHI];
      Xprmt[7]  = parms[P_KAPPA];
      Xprmt[8]  = parms[P_EPSILON];
      Xprmt[9]  = parms[P_C];
      Xprmt[10] = parms[P_ALPHA];

      break;
    case M_KING:
      Xprmt[0] = xl;
      Xprmt[1] = yl;
      Xprmt[2] = parms[P_E];
      Xprmt[3] = parms[P_THETA];
      Xprmt[4] = parms[P_GAMMA];
      Xprmt[5] = parms[P_SIGMA];
      Xprmt[6] = parms[P_PHI];
      Xprmt[7] = parms[P_KAPPA];

      break;
    case M_TRUNC_KING:
      Xprmt[0] = xl;
      Xprmt[1] = yl;
      Xprmt[2] = parms[P_E];
      Xprmt[3] = parms[P_THETA];
      Xprmt[4] = parms[P_GAMMA];
      Xprmt[5] = parms[P_SIGMA];
      Xprmt[6] = parms[P_PHI];
      Xprmt[7] = parms[P_C];
      Xprmt[8] = parms[P_KAPPA2];

      break;
    case M_HUBBLE:
      Xprmt[0] = xl;
      Xprmt[1] = yl;
      Xprmt[2] = parms[P_E];
      Xprmt[3] = parms[P_THETA];
      Xprmt[4] = parms[P_GAMMA];
      Xprmt[5] = parms[P_SIGMA];
      Xprmt[6] = parms[P_PHI];
      Xprmt[7] = parms[P_KAPPA];
      
      break;
    case M_DE_VAUCOULEUR:
      Xprmt[0] = xl;
      Xprmt[1] = yl;
      Xprmt[2] = parms[P_E];
      Xprmt[3] = parms[P_THETA];
      Xprmt[4] = parms[P_GAMMA];
      Xprmt[5] = parms[P_SIGMA];
      Xprmt[6] = parms[P_PHI];
      Xprmt[7] = parms[P_KAPPA];

      break;
    case M_SPIRAL:
      Xprmt[0] = xl;
      Xprmt[1] = yl;
      Xprmt[2] = parms[P_E];
      Xprmt[3] = parms[P_THETA];
      Xprmt[4] = parms[P_GAMMA];
      Xprmt[5] = parms[P_SIGMA];
      Xprmt[6] = parms[P_PHI];
      Xprmt[7] = parms[P_KAPPA];
      Xprmt[8] = parms[P_ALPHA2];

      break;
    case M_MULTIPOLE:
      Xprmt[0]  = xl;
      Xprmt[1]  = yl;
      Xprmt[2]  = parms[P_E];
      Xprmt[3]  = parms[P_THETA];
      Xprmt[4]  = parms[P_GAMMA];
      Xprmt[5]  = parms[P_SIGMA];
      Xprmt[6]  = parms[P_PHI];
      Xprmt[7]  = parms[P_KAPPA0];
      Xprmt[8]  = parms[P_DX_QP];
      Xprmt[9]  = parms[P_DY_QP];
      Xprmt[10] = parms[P_QXX];
      Xprmt[11] = parms[P_QXY];
      Xprmt[12] = parms[P_QYY];

      break;
    case M_ROTATION_LENS:
      Xprmt[0]  = xl;
      Xprmt[1]  = yl;
      Xprmt[2]  = parms[P_E];
      Xprmt[3]  = parms[P_THETA];
      Xprmt[4]  = parms[P_GAMMA];
      Xprmt[5]  = parms[P_SIGMA];
      Xprmt[6]  = parms[P_PHI];
      Xprmt[7]  = parms[P_SX];
      Xprmt[8]  = parms[P_SY];

      break;
    case M_DOUBLE_LENS:
      cprax.n = 6;
      
      Xprmt[0]  = xl;
      Xprmt[1]  = yl;
      Xprmt[2]  = parms[P_E];
      Xprmt[3]  = parms[P_THETA];
      Xprmt[4]  = parms[P_GAMMA];
      Xprmt[5]  = parms[P_SIGMA];
      Xprmt[6]  = parms[P_PHI];
      Xprmt[7]  = parms[P_X_1];
      Xprmt[8]  = parms[P_Y_1];
      Xprmt[9]  = parms[P_X_2];
      Xprmt[10] = parms[P_Y_2];
      Xprmt[11] = parms[P_M_1];
      Xprmt[12] = parms[P_M_2];
      Xprmt[13] = parms[P_BETA];
      Xprmt[4]  = parms[P_GAMMA2];
      Xprmt[5]  = parms[P_SIGMA2];
      Xprmt[6]  = parms[P_PHI2];

      break;
    case M_UNIFORM_RING:
      Xprmt[0] = xl;
      Xprmt[1] = yl;
      Xprmt[2] = parms[P_E];
      Xprmt[3] = parms[P_THETA];
      Xprmt[4] = parms[P_GAMMA];
      Xprmt[5] = parms[P_SIGMA];
      Xprmt[6] = parms[P_PHI];
      Xprmt[7] = parms[P_KAPPA];
      Xprmt[8] = parms[P_Ri];
      Xprmt[9] = parms[P_Ro];

      break;
    default:
      break; 
    }
  }
}

double restrict_func(double *x)
{
  int i, j;
  double temp1, temp2, temp3, temp4, Function = 0.0;
  
  switch(current_model) {
  case M_CHANG_REFSDAL:
    if(Xprmt[0] < - 4.0 || Xprmt[0] > 4.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[1] < - 4.0 || Xprmt[1] > 4.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[2] < 0.0 || Xprmt[2] > 4.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[4] < 0.0 || Xprmt[4] > 1.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[5] < 0.0 || Xprmt[5] > 1.0) {
      Function += pow(10.0, 4.0); 
    } else {
      for(i = 0; i < Number_of_images; i++) {
        for(j = 0; j < Number_of_images; j++) {
          temp1 = (Y_x[i] - Y_x[j]) * (Y_x[i] - Y_x[j]);
          temp2 = (Y_y[i] - Y_y[j]) * (Y_y[i] - Y_y[j]);
          
          if(w_p != 0.0) {
            Function += (w_p * (temp1 + temp2)) / Delta_Y2;
          } 

          if(w_a != 0.0) {
            temp3 = (M_O[i][j] - M_T[i] / M_T[j]);
            temp4 = temp3 * temp3;

            Function += (w_a * temp4) / Delta_M2;
          }         

          if(w_p != 0.0 && w_a != 0.0) {
            temp3 = (M_O[i][j] - M_T[i] / M_T[j]);
            temp4 = temp3 * temp3;

            Function += (w_p * (temp1 + temp2)) / Delta_Y2;
            Function += (w_a * temp4) / Delta_M2;
          }
        }             
      }         
    } 
    
    break;    
  case M_SING_ISOT_SPHERE:
    if(Xprmt[0] < - 4.0 || Xprmt[0] > 4.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[1] < - 4.0 || Xprmt[1] > 4.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[2] < 0.0 || Xprmt[2] > 4.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[4] < 0.0 || Xprmt[4] > 1.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[5] < 0.0 || Xprmt[5] > 1.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[7] < 0.0 || Xprmt[7] > 2.0) {
      Function += pow(10.0, 4.0); 
    } else {        
      for(i = 0; i < Number_of_images; i++) {
        for(j = 0; j < Number_of_images; j++) {
          temp1 = (Y_x[i] - Y_x[j]) * (Y_x[i] - Y_x[j]);
          temp2 = (Y_y[i] - Y_y[j]) * (Y_y[i] - Y_y[j]);
          
          if(w_p != 0.0) {
            Function += (w_p * (temp1 + temp2)) / Delta_Y2;
          } 

          if(w_a != 0.0) {
            temp3 = (M_O[i][j] - M_T[i] / M_T[j]);
            temp4 = temp3 * temp3;

            Function += (w_a * temp4) / Delta_M2;
          }         

          if(w_p != 0.0 && w_a != 0.0) {
            temp3 = (M_O[i][j] - M_T[i] / M_T[j]);
            temp4 = temp3 * temp3;

            Function += (w_p * (temp1 + temp2)) / Delta_Y2;
            Function += (w_a * temp4) / Delta_M2;
          }
        }       
      }         
    }
    
    break;    
  case M_NSING_ISOT_SPHERE:
    if(Xprmt[0] < - 4.0 || Xprmt[0] > 4.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[1] < - 4.0 || Xprmt[1] > 4.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[2] < 0.0 || Xprmt[2] > 4.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[4] < 0.0 || Xprmt[4] > 1.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[5] < 0.0 || Xprmt[5] > 1.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[7] < 0.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[8] < 0.0 || Xprmt[8] > Xprmt[2]) {
      Function += pow(10.0, 4.0); 
    } else {        
      for(i = 0; i < Number_of_images; i++) {
        for(j = 0; j < Number_of_images; j++) {
          temp1 = (Y_x[i] - Y_x[j]) * (Y_x[i] - Y_x[j]);
          temp2 = (Y_y[i] - Y_y[j]) * (Y_y[i] - Y_y[j]);
          
          if(w_p != 0.0) {
            Function += (w_p * (temp1 + temp2)) / Delta_Y2;
          } 

          if(w_a != 0.0) {
            temp3 = (M_O[i][j] - M_T[i] / M_T[j]);
            temp4 = temp3 * temp3;

            Function += (w_a * temp4) / Delta_M2;
          }         

          if(w_p != 0.0 && w_a != 0.0) {
            temp3 = (M_O[i][j] - M_T[i] / M_T[j]);
            temp4 = temp3 * temp3;

            Function += (w_p * (temp1 + temp2)) / Delta_Y2;
            Function += (w_a * temp4) / Delta_M2;
          }
        }             
      }               
    }
    
    break;    
  case M_TRANSP_SPHERE:
    if(Xprmt[0] < - 4.0 || Xprmt[0] > 4.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[1] < - 4.0 || Xprmt[1] > 4.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[2] < 0.0 || Xprmt[2] > 4.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[4] < 0.0 || Xprmt[4] > 1.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[5] < 0.0 || Xprmt[5] > 1.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[7] < 0.0 || Xprmt[7] > Xprmt[2]) {
      Function += pow(10.0, 4.0); 
    } else {        
      for(i = 0; i < Number_of_images; i++) {
        for(j = 0; j < Number_of_images; j++) {
          temp1 = (Y_x[i] - Y_x[j]) * (Y_x[i] - Y_x[j]);
          temp2 = (Y_y[i] - Y_y[j]) * (Y_y[i] - Y_y[j]);
          
          if(w_p != 0.0) {
            Function += (w_p * (temp1 + temp2)) / Delta_Y2;
          } 

          if(w_a != 0.0) {
            temp3 = (M_O[i][j] - M_T[i] / M_T[j]);
            temp4 = temp3 * temp3;

            Function += (w_a * temp4) / Delta_M2;
          }         

          if(w_p != 0.0 && w_a != 0.0) {
            temp3 = (M_O[i][j] - M_T[i] / M_T[j]);
            temp4 = temp3 * temp3;

            Function += (w_p * (temp1 + temp2)) / Delta_Y2;
            Function += (w_a * temp4) / Delta_M2;
          }
        }             
      }               
    }
    
    break;   
  case M_ELLIPTICAL:         
    if(Xprmt[0] < - 4.0 || Xprmt[0] > 4.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[1] < - 4.0 || Xprmt[1] > 4.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[2] < 0.0 || Xprmt[2] > 4.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[4] < 0.0 || Xprmt[4] > 1.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[5] < 0.0 || Xprmt[5] > 1.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[7] < 0.0) {
      Function += pow(10.0, 4.0);
    } else if(Xprmt[8] < 0.0 || Xprmt[8] > 1.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[9] < 0.0 || Xprmt[9] > Xprmt[2]) {
      Function += pow(10.0, 4.0);         
    } else if(Xprmt[10] < 0.0 || Xprmt[10] > 0.5) {
      Function += pow(10.0, 4.0); 
    } else {        
      for(i = 0; i < Number_of_images; i++) {
        for(j = 0; j < Number_of_images; j++) {
          temp1 = (Y_x[i] - Y_x[j]) * (Y_x[i] - Y_x[j]);
          temp2 = (Y_y[i] - Y_y[j]) * (Y_y[i] - Y_y[j]);
          
          if(w_p != 0.0) {
            Function += (w_p * (temp1 + temp2)) / Delta_Y2;
          } 

          if(w_a != 0.0) {
            temp3 = (M_O[i][j] - M_T[i] / M_T[j]);
            temp4 = temp3 * temp3;

            Function += (w_a * temp4) / Delta_M2;
          }         

          if(w_p != 0.0 && w_a != 0.0) {
            temp3 = (M_O[i][j] - M_T[i] / M_T[j]);
            temp4 = temp3 * temp3;

            Function += (w_p * (temp1 + temp2)) / Delta_Y2;
            Function += (w_a * temp4) / Delta_M2;
          }
        }       
      }         
    }
    
    break;    
  case M_KING:
    if(Xprmt[0] < - 4.0 || Xprmt[0] > 4.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[1] < - 4.0 || Xprmt[1] > 4.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[2] < 0.0 || Xprmt[2] > 4.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[4] < 0.0 || Xprmt[4] > 1.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[5] < 0.0 || Xprmt[5] > 1.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[7] < 0.0) {
      Function += pow(10.0, 4.0);
    } else {        
      for(i = 0; i < Number_of_images; i++) {
        for(j = 0; j < Number_of_images; j++) {
          temp1 = (Y_x[i] - Y_x[j]) * (Y_x[i] - Y_x[j]);
          temp2 = (Y_y[i] - Y_y[j]) * (Y_y[i] - Y_y[j]);
          
          if(w_p != 0.0) {
            Function += (w_p * (temp1 + temp2)) / Delta_Y2;
          } 

          if(w_a != 0.0) {
            temp3 = (M_O[i][j] - M_T[i] / M_T[j]);
            temp4 = temp3 * temp3;

            Function += (w_a * temp4) / Delta_M2;
          }         

          if(w_p != 0.0 && w_a != 0.0) {
            temp3 = (M_O[i][j] - M_T[i] / M_T[j]);
            temp4 = temp3 * temp3;

            Function += (w_p * (temp1 + temp2)) / Delta_Y2;
            Function += (w_a * temp4) / Delta_M2;
          }
        }             
      }               
    }
    
    break;
  case M_TRUNC_KING:
    if(Xprmt[0] < - 4.0 || Xprmt[0] > 4.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[1] < - 4.0 || Xprmt[1] > 4.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[2] < 0.0 || Xprmt[2] > 4.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[4] < 0.0 || Xprmt[4] > 1.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[5] < 0.0 || Xprmt[5] > 1.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[7] < 0.0 || Xprmt[7] > Xprmt[2]) {
      Function += pow(10.0, 4.0);
    } else if(Xprmt[8] < 0.0) {
      Function += pow(10.0, 4.0); 
    } else {        
      for(i = 0; i < Number_of_images; i++) {
        for(j = 0; j < Number_of_images; j++) {
          temp1 = (Y_x[i] - Y_x[j]) * (Y_x[i] - Y_x[j]);
          temp2 = (Y_y[i] - Y_y[j]) * (Y_y[i] - Y_y[j]);
          
          if(w_p != 0.0) {
            Function += (w_p * (temp1 + temp2)) / Delta_Y2;
          } 

          if(w_a != 0.0) {
            temp3 = (M_O[i][j] - M_T[i] / M_T[j]);
            temp4 = temp3 * temp3;

            Function += (w_a * temp4) / Delta_M2;
          }         

          if(w_p != 0.0 && w_a != 0.0) {
            temp3 = (M_O[i][j] - M_T[i] / M_T[j]);
            temp4 = temp3 * temp3;

            Function += (w_p * (temp1 + temp2)) / Delta_Y2;
            Function += (w_a * temp4) / Delta_M2;
          }
        }                   
      }                 
    }
    
    break;
  case M_HUBBLE:
    if(Xprmt[0] < - 4.0 || Xprmt[0] > 4.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[1] < - 4.0 || Xprmt[1] > 4.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[2] < 0.0 || Xprmt[2] > 4.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[4] < 0.0 || Xprmt[4] > 1.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[5] < 0.0 || Xprmt[5] > 1.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[7] < 0.0) {
      Function += pow(10.0, 4.0);
    } else {        
      for(i = 0; i < Number_of_images; i++) {
        for(j = 0; j < Number_of_images; j++) {
          temp1 = (Y_x[i] - Y_x[j]) * (Y_x[i] - Y_x[j]);
          temp2 = (Y_y[i] - Y_y[j]) * (Y_y[i] - Y_y[j]);
          
          if(w_p != 0.0) {
            Function += (w_p * (temp1 + temp2)) / Delta_Y2;
          } 

          if(w_a != 0.0) {
            temp3 = (M_O[i][j] - M_T[i] / M_T[j]);
            temp4 = temp3 * temp3;

            Function += (w_a * temp4) / Delta_M2;
          }         

          if(w_p != 0.0 && w_a != 0.0) {
            temp3 = (M_O[i][j] - M_T[i] / M_T[j]);
            temp4 = temp3 * temp3;

            Function += (w_p * (temp1 + temp2)) / Delta_Y2;
            Function += (w_a * temp4) / Delta_M2;
          }
        }             
      }         
    }
    
    break;
  case M_DE_VAUCOULEUR:
    if(Xprmt[0] < - 4.0 || Xprmt[0] > 4.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[1] < - 4.0 || Xprmt[1] > 4.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[2] < 0.0 || Xprmt[2] > 4.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[4] < 0.0 || Xprmt[4] > 1.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[5] < 0.0 || Xprmt[5] > 1.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[7] < 0.0) {
      Function += pow(10.0, 4.0);
    } else {        
      for(i = 0; i < Number_of_images; i++) {
        for(j = 0; j < Number_of_images; j++) {
          temp1 = (Y_x[i] - Y_x[j]) * (Y_x[i] - Y_x[j]);
          temp2 = (Y_y[i] - Y_y[j]) * (Y_y[i] - Y_y[j]);
          
          if(w_p != 0.0) {
            Function += (w_p * (temp1 + temp2)) / Delta_Y2;
          } 

          if(w_a != 0.0) {
            temp3 = (M_O[i][j] - M_T[i] / M_T[j]);
            temp4 = temp3 * temp3;

            Function += (w_a * temp4) / Delta_M2;
          }         

          if(w_p != 0.0 && w_a != 0.0) {
            temp3 = (M_O[i][j] - M_T[i] / M_T[j]);
            temp4 = temp3 * temp3;

            Function += (w_p * (temp1 + temp2)) / Delta_Y2;
            Function += (w_a * temp4) / Delta_M2;
          }
        }             
      }         
    }
    
    break;
  case M_SPIRAL:        
    if(Xprmt[0] < - 4.0 || Xprmt[0] > 4.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[1] < - 4.0 || Xprmt[1] > 4.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[2] < 0.0 || Xprmt[2] > 4.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[4] < 0.0 || Xprmt[4] > 1.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[5] < 0.0 || Xprmt[5] > 1.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[7] < 0.0) {
      Function += pow(10.0, 4.0);
    } else if(Xprmt[8] < 0.0) {
      Function += pow(10.0, 4.0); 
    } else {        
      for(i = 0; i < Number_of_images; i++) {
        for(j = 0; j < Number_of_images; j++) {
          temp1 = (Y_x[i] - Y_x[j]) * (Y_x[i] - Y_x[j]);
          temp2 = (Y_y[i] - Y_y[j]) * (Y_y[i] - Y_y[j]);
          
          if(w_p != 0.0) {
            Function += (w_p * (temp1 + temp2)) / Delta_Y2;
          } 

          if(w_a != 0.0) {
            temp3 = (M_O[i][j] - M_T[i] / M_T[j]);
            temp4 = temp3 * temp3;

            Function += (w_a * temp4) / Delta_M2;
          }         

          if(w_p != 0.0 && w_a != 0.0) {
            temp3 = (M_O[i][j] - M_T[i] / M_T[j]);
            temp4 = temp3 * temp3;

            Function += (w_p * (temp1 + temp2)) / Delta_Y2;
            Function += (w_a * temp4) / Delta_M2;
          }
        }             
      }         
    }

    break;
  case M_MULTIPOLE:
    if(Xprmt[0] < - 4.0 || Xprmt[0] > 4.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[1] < - 4.0 || Xprmt[1] > 4.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[2] < 0.0 || Xprmt[2] > 4.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[4] < 0.0 || Xprmt[4] > 1.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[5] < 0.0 || Xprmt[5] > 1.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[7] < 0.0) {
      Function += pow(10.0, 4.0);
    } else {        
      for(i = 0; i < Number_of_images; i++) {
        for(j = 0; j < Number_of_images; j++) {
          temp1 = (Y_x[i] - Y_x[j]) * (Y_x[i] - Y_x[j]);
          temp2 = (Y_y[i] - Y_y[j]) * (Y_y[i] - Y_y[j]);
          
          if(w_p != 0.0) {
            Function += (w_p * (temp1 + temp2)) / Delta_Y2;
          } 

          if(w_a != 0.0) {
            temp3 = (M_O[i][j] - M_T[i] / M_T[j]);
            temp4 = temp3 * temp3;

            Function += (w_a * temp4) / Delta_M2;
          }         

          if(w_p != 0.0 && w_a != 0.0) {
            temp3 = (M_O[i][j] - M_T[i] / M_T[j]);
            temp4 = temp3 * temp3;

            Function += (w_p * (temp1 + temp2)) / Delta_Y2;
            Function += (w_a * temp4) / Delta_M2;
          }
        }             
      }         
    }

    break;
  case M_ROTATION_LENS:
    if(Xprmt[0] < - 4.0 || Xprmt[0] > 4.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[1] < - 4.0 || Xprmt[1] > 4.0) {
      Function += pow(10.0, 4.0);
    } else if(Xprmt[2] < 0.0 || Xprmt[2] > 4.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[4] < 0.0 || Xprmt[4] > 1.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[5] < 0.0 || Xprmt[5] > 1.0) {
      Function += pow(10.0, 4.0); 
    } else {        
      for(i = 0; i < Number_of_images; i++) {
        for(j = 0; j < Number_of_images; j++) {
          temp1 = (Y_x[i] - Y_x[j]) * (Y_x[i] - Y_x[j]);
          temp2 = (Y_y[i] - Y_y[j]) * (Y_y[i] - Y_y[j]);
          
          if(w_p != 0.0) {
            Function += (w_p * (temp1 + temp2)) / Delta_Y2;
          } 

          if(w_a != 0.0) {
            temp3 = (M_O[i][j] - M_T[i] / M_T[j]);
            temp4 = temp3 * temp3;

            Function += (w_a * temp4) / Delta_M2;
          }         

          if(w_p != 0.0 && w_a != 0.0) {
            temp3 = (M_O[i][j] - M_T[i] / M_T[j]);
            temp4 = temp3 * temp3;

            Function += (w_p * (temp1 + temp2)) / Delta_Y2;
            Function += (w_a * temp4) / Delta_M2;
          }
        }                   
      }               
    }

    break;
  case M_DOUBLE_LENS:
    if(Xprmt[0] < - 4.0 || Xprmt[0] > 4.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[1] < - 4.0 || Xprmt[1] > 4.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[2] < 0.0 || Xprmt[2] > 4.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[4] < 0.0 || Xprmt[4] > 1.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[5] < 0.0 || Xprmt[5] > 1.0) {
      Function += pow(10.0, 4.0);
    } else if(Xprmt[7] < - 4.0 || Xprmt[7] > 4.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[8] < - 4.0 || Xprmt[8] > 4.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[9] < - 4.0 || Xprmt[9] > 4.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[10] < - 4.0 || Xprmt[10] > 4.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[11] < 0.0) {
      Function += pow(10.0, 4.0);
    } else if(Xprmt[12] < 0.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[13] < 0.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[14] < 0.0 || Xprmt[14] > 1.0) {
      Function += pow(10.0, 4.0);         
    } else if(Xprmt[15] < 0.0 || Xprmt[15] > 1.0) {
      Function += pow(10.0, 4.0); 
    } else {        
      for(i = 0; i < Number_of_images; i++) {
        for(j = 0; j < Number_of_images; j++) {
          temp1 = (Y_x[i] - Y_x[j]) * (Y_x[i] - Y_x[j]);
          temp2 = (Y_y[i] - Y_y[j]) * (Y_y[i] - Y_y[j]);
          
          if(w_p != 0.0) {
            Function += (w_p * (temp1 + temp2)) / Delta_Y2;
          } 

          if(w_a != 0.0) {
            temp3 = (M_O[i][j] - M_T[i] / M_T[j]);
            temp4 = temp3 * temp3;

            Function += (w_a * temp4) / Delta_M2;
          }         

          if(w_p != 0.0 && w_a != 0.0) {
            temp3 = (M_O[i][j] - M_T[i] / M_T[j]);
            temp4 = temp3 * temp3;

            Function += (w_p * (temp1 + temp2)) / Delta_Y2;
            Function += (w_a * temp4) / Delta_M2;
          }
        }             
      }                 
    }

    break;
  case M_UNIFORM_RING:
    if(Xprmt[0] < - 4.0 || Xprmt[0] > 4.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[1] < - 4.0 || Xprmt[1] > 4.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[2] < 0.0 || Xprmt[2] > 4.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[4] < 0.0 || Xprmt[4] > 1.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[5] < 0.0 || Xprmt[5] > 1.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[7] < 0.0) {
      Function += pow(10.0, 4.0);
    } else if(Xprmt[8] < 0.0 || Xprmt[8] > 2.0) {
      Function += pow(10.0, 4.0); 
    } else if(Xprmt[9] < 0.0 || Xprmt[9] <= Xprmt[8] || Xprmt[9] > 4.0) {
      Function += pow(10.0, 4.0);         
    } else {        
      for(i = 0; i < Number_of_images; i++) {
        for(j = 0; j < Number_of_images; j++) {
          temp1 = (Y_x[i] - Y_x[j]) * (Y_x[i] - Y_x[j]);
          temp2 = (Y_y[i] - Y_y[j]) * (Y_y[i] - Y_y[j]);
          
          if(w_p != 0.0) {
            Function += (w_p * (temp1 + temp2)) / Delta_Y2;
          } 

          if(w_a != 0.0) {
            temp3 = (M_O[i][j] - M_T[i] / M_T[j]);
            temp4 = temp3 * temp3;

            Function += (w_a * temp4) / Delta_M2;
          }         

          if(w_p != 0.0 && w_a != 0.0) {
            temp3 = (M_O[i][j] - M_T[i] / M_T[j]);
            temp4 = temp3 * temp3;

            Function += (w_p * (temp1 + temp2)) / Delta_Y2;
            Function += (w_a * temp4) / Delta_M2;
          }
        }             
      }         
    }
    
    break;
  default:
    break; 
  }

  return Function;
}
     
void choice_final()
{
  if(sl_position == TRUE && sl_re == TRUE &&
     sl_macro == TRUE && sl_model == TRUE) {
    switch(current_model) {
    case M_CHANG_REFSDAL:
      // cprax.n = 7;

      Y[0] = cprax.x[0];
      Y[1] = cprax.x[1];
      
      parms[P_E]     = cprax.x[2]; 
      parms[P_THETA] = cprax.x[3];
      parms[P_GAMMA] = cprax.x[4];     
      parms[P_SIGMA] = cprax.x[5];
      parms[P_PHI]   = cprax.x[6];

      break;   
    case M_SING_ISOT_SPHERE:
      // cprax.n = 8;

      Y[0] = cprax.x[0];
      Y[1] = cprax.x[1];
      
      parms[P_E]     = cprax.x[2]; 
      parms[P_THETA] = cprax.x[3];
      parms[P_GAMMA] = cprax.x[4];     
      parms[P_SIGMA] = cprax.x[5];
      parms[P_PHI]   = cprax.x[6];
      parms[P_PHI]   = cprax.x[6];
      parms[P_EXP]   = cprax.x[7];

      break;   
    case M_NSING_ISOT_SPHERE:
      // cprax.n = 9;

      Y[0] = cprax.x[0];
      Y[1] = cprax.x[1];
      
      parms[P_E]     = cprax.x[2]; 
      parms[P_THETA] = cprax.x[3];
      parms[P_GAMMA] = cprax.x[4];     
      parms[P_SIGMA] = cprax.x[5];
      parms[P_PHI]   = cprax.x[6];
      parms[P_KAPPA] = cprax.x[7];
      parms[P_C]     = cprax.x[8];

      break;   
    case M_TRANSP_SPHERE:
      // cprax.n = 8;

      Y[0] = cprax.x[0];
      Y[1] = cprax.x[1];
      
      parms[P_E]     = cprax.x[2]; 
      parms[P_THETA] = cprax.x[3];
      parms[P_GAMMA] = cprax.x[4];     
      parms[P_SIGMA] = cprax.x[5];
      parms[P_PHI]   = cprax.x[6];
      parms[P_C]     = cprax.x[7];

      break;   
    case M_ELLIPTICAL:         
      // cprax.n = 11;

      Y[0] = cprax.x[0];
      Y[1] = cprax.x[1];
      
      parms[P_E]       = cprax.x[2]; 
      parms[P_THETA]   = cprax.x[3];
      parms[P_GAMMA]   = cprax.x[4];     
      parms[P_SIGMA]   = cprax.x[5];
      parms[P_PHI]     = cprax.x[6];
      parms[P_KAPPA]   = cprax.x[7];
      parms[P_EPSILON] = cprax.x[8];
      parms[P_C]       = cprax.x[9];
      parms[P_ALPHA]   = cprax.x[10];

      break;
    case M_KING:
      // cprax.n = 8;

      Y[0] = cprax.x[0];
      Y[1] = cprax.x[1];
      
      parms[P_E]     = cprax.x[2]; 
      parms[P_THETA] = cprax.x[3];
      parms[P_GAMMA] = cprax.x[4];     
      parms[P_SIGMA] = cprax.x[5];
      parms[P_PHI]   = cprax.x[6];
      parms[P_KAPPA] = cprax.x[7];

      break;
    case M_TRUNC_KING:
      // cprax.n = 9;

      Y[0] = cprax.x[0];
      Y[1] = cprax.x[1];
      
      parms[P_E]      = cprax.x[2]; 
      parms[P_THETA]  = cprax.x[3];
      parms[P_GAMMA]  = cprax.x[4];     
      parms[P_SIGMA]  = cprax.x[5];
      parms[P_PHI]    = cprax.x[6];
      parms[P_C]      = cprax.x[7];
      parms[P_KAPPA2] = cprax.x[8];

      break;
    case M_HUBBLE:
      // cprax.n = 8;

      Y[0] = cprax.x[0];
      Y[1] = cprax.x[1];
      
      parms[P_E]     = cprax.x[2]; 
      parms[P_THETA] = cprax.x[3];
      parms[P_GAMMA] = cprax.x[4];     
      parms[P_SIGMA] = cprax.x[5];
      parms[P_PHI]   = cprax.x[6];
      parms[P_KAPPA] = cprax.x[7];
      
      break;
    case M_DE_VAUCOULEUR:
      // cprax.n = 8;

      Y[0] = cprax.x[0];
      Y[1] = cprax.x[1];
      
      parms[P_E]     = cprax.x[2]; 
      parms[P_THETA] = cprax.x[3];
      parms[P_GAMMA] = cprax.x[4];     
      parms[P_SIGMA] = cprax.x[5];
      parms[P_PHI]   = cprax.x[6];
      parms[P_KAPPA] = cprax.x[7];
      
      break;
    case M_SPIRAL:
      // cprax.n = 9;

      Y[0] = cprax.x[0];
      Y[1] = cprax.x[1];
      
      parms[P_E]      = cprax.x[2]; 
      parms[P_THETA]  = cprax.x[3];
      parms[P_GAMMA]  = cprax.x[4];     
      parms[P_SIGMA]  = cprax.x[5];
      parms[P_PHI]    = cprax.x[6];
      parms[P_KAPPA]  = cprax.x[7];
      parms[P_ALPHA2] = cprax.x[8];

      break;
    case M_MULTIPOLE:
      // cprax.n = 13;

      Y[0] = cprax.x[0];
      Y[1] = cprax.x[1];
      
      parms[P_E]      = cprax.x[2]; 
      parms[P_THETA]  = cprax.x[3];
      parms[P_GAMMA]  = cprax.x[4];     
      parms[P_SIGMA]  = cprax.x[5];
      parms[P_PHI]    = cprax.x[6];
      parms[P_KAPPA0] = cprax.x[7];
      parms[P_DX_QP]  = cprax.x[8];
      parms[P_DY_QP]  = cprax.x[9];
      parms[P_QXX]    = cprax.x[10];
      parms[P_QXY]    = cprax.x[11];
      parms[P_QYY]    = cprax.x[12];

      break;
    case M_ROTATION_LENS:
      // cprax.n = 9;

      Y[0] = cprax.x[0];
      Y[1] = cprax.x[1];

      parms[P_E]     = cprax.x[2]; 
      parms[P_THETA] = cprax.x[3];
      parms[P_GAMMA] = cprax.x[4];     
      parms[P_SIGMA] = cprax.x[5];
      parms[P_PHI]   = cprax.x[6];
      parms[P_SX]    = cprax.x[7];
      parms[P_SY]    = cprax.x[8];

      break;
    case M_DOUBLE_LENS:
      // cprax.n = 17;
      
      Y[0] = cprax.x[0];
      Y[1] = cprax.x[1];

      parms[P_E]      = cprax.x[2]; 
      parms[P_THETA]  = cprax.x[3];
      parms[P_GAMMA]  = cprax.x[4];     
      parms[P_SIGMA]  = cprax.x[5];
      parms[P_PHI]    = cprax.x[6];
      parms[P_X_1]    = cprax.x[7];
      parms[P_Y_1]    = cprax.x[8];
      parms[P_X_2]    = cprax.x[9];
      parms[P_Y_2]    = cprax.x[10];
      parms[P_M_1]    = cprax.x[11];
      parms[P_M_2]    = cprax.x[12];
      parms[P_BETA]   = cprax.x[13];
      parms[P_GAMMA2] = cprax.x[14];
      parms[P_SIGMA2] = cprax.x[15];
      parms[P_PHI2]   = cprax.x[16];

      break;
    case M_UNIFORM_RING:
      // cprax.n = 10;

      Y[0] = cprax.x[0];
      Y[1] = cprax.x[1];
      
      parms[P_E]     = cprax.x[2]; 
      parms[P_THETA] = cprax.x[3];
      parms[P_GAMMA] = cprax.x[4];     
      parms[P_SIGMA] = cprax.x[5];
      parms[P_PHI]   = cprax.x[6];
      parms[P_KAPPA] = cprax.x[7];
      parms[P_Ri]    = cprax.x[8];
      parms[P_Ro]    = cprax.x[9];

      break;
    default:
      break; 
    }           
  } else if(sl_position == TRUE && sl_re == TRUE &&
            sl_macro == TRUE && sl_model == FALSE) {
    // cprax.n = 6;

    Y[0] = cprax.x[0];
    Y[1] = cprax.x[1];

    parms[P_E]     = cprax.x[2]; 
    parms[P_GAMMA] = cprax.x[3];     
    parms[P_SIGMA] = cprax.x[4];
    parms[P_PHI]   = cprax.x[5];

    // Xprmt[3] = parms[P_THETA];

    switch(current_model) {
    case M_CHANG_REFSDAL:

      break;
    case M_SING_ISOT_SPHERE:
      // Xprmt[7] = parms[P_EXP];
           
      break;
    case M_NSING_ISOT_SPHERE:
      // Xprmt[7] = parms[P_KAPPA];

      break;
    case M_TRANSP_SPHERE:
      // Xprmt[7] = parms[P_C];

      break;
    case M_ELLIPTICAL:
      /*
        
      Xprmt[7]  = parms[P_KAPPA];
      Xprmt[8]  = parms[P_EPSILON];
      Xprmt[9]  = parms[P_C];
      Xprmt[10] = parms[P_ALPHA];

      **/
      
      break;
    case M_KING:
      // Xprmt[7] = parms[P_KAPPA];

      break;    
    case M_TRUNC_KING:
      // Xprmt[7] = parms[P_C];
      // Xprmt[8] = parms[P_KAPPA2];

      break;
    case M_HUBBLE:
      // Xprmt[7] = parms[P_KAPPA];

      break;
    case M_DE_VAUCOULEUR:
      // Xprmt[7] = parms[P_KAPPA];

      break;
    case M_SPIRAL:
      // Xprmt[7] = parms[P_KAPPA];
      // Xprmt[8] = parms[P_ALPHA2];
      
      break;      
    case M_MULTIPOLE:
      /*
        
      Xprmt[7]  = parms[P_KAPPA0];
      Xprmt[8]  = parms[P_DX_QP];
      Xprmt[9]  = parms[P_DY_QP];
      Xprmt[10] = parms[P_QXX];
      Xprmt[11] = parms[P_QXY];
      Xprmt[12] = parms[P_QYY];

      **/
      
      break;      
    case M_ROTATION_LENS:
      // Xprmt[7] = parms[P_SX];
      // Xprmt[8] = parms[P_SY];

      break;      
    case M_DOUBLE_LENS:
      /*
        
      Xprmt[7]  = parms[P_X_1];
      Xprmt[8]  = parms[P_Y_1];
      Xprmt[9]  = parms[P_X_2];
      Xprmt[10] = parms[P_Y_2];
      Xprmt[11] = parms[P_M_1];
      Xprmt[12] = parms[P_M_2];
      Xprmt[13] = parms[P_BETA];
      Xprmt[14] = parms[P_GAMMA2];
      Xprmt[15] = parms[P_SIGMA2];
      Xprmt[16] = parms[P_PHI2];

      **/
      
      break;      
    case M_UNIFORM_RING:
      /*
        
      Xprmt[7] = parms[P_KAPPA];
      Xprmt[8] = parms[P_Ri];
      Xprmt[9] = parms[P_Ro];

      **/
      
      break;
    default:
      break; 
    }           
  } else if(sl_position == TRUE && sl_re == TRUE &&
            sl_macro == FALSE && sl_model == TRUE) {
    /*
    
    Xprmt[4]  = parms[P_GAMMA];
    Xprmt[5]  = parms[P_SIGMA];
    Xprmt[6]  = parms[P_PHI];

    **/
    
    switch(current_model) {
    case M_CHANG_REFSDAL:
      // cprax.n = 4;
      
      Y[0] = cprax.x[0];
      Y[1] = cprax.x[1];

      parms[P_E]     = cprax.x[2]; 
      parms[P_THETA] = cprax.x[3];     

      break;   
    case M_SING_ISOT_SPHERE:
      // cprax.n = 5;

      Y[0] = cprax.x[0];
      Y[1] = cprax.x[1];

      parms[P_E]     = cprax.x[2]; 
      parms[P_THETA] = cprax.x[3];     
      parms[P_EXP]   = cprax.x[4];

      break;   
    case M_NSING_ISOT_SPHERE:
      // cprax.n = 6;

      Y[0] = cprax.x[0];
      Y[1] = cprax.x[1];

      parms[P_E]     = cprax.x[2]; 
      parms[P_THETA] = cprax.x[3];     
      parms[P_KAPPA] = cprax.x[4];
      parms[P_C]     = cprax.x[5];

      break;   
    case M_TRANSP_SPHERE:
      // cprax.n = 5;

      cprax.x[0] = xl;
      cprax.x[1] = yl;
      cprax.x[2] = parms[P_E];
      cprax.x[3] = parms[P_THETA];
      cprax.x[4] = parms[P_C];
      
      break;   
    case M_ELLIPTICAL:         
      // cprax.n = 8;

      Y[0] = cprax.x[0];
      Y[1] = cprax.x[1];

      parms[P_E]       = cprax.x[2]; 
      parms[P_THETA]   = cprax.x[3];     
      parms[P_KAPPA]   = cprax.x[4];
      parms[P_EPSILON] = cprax.x[5];
      parms[P_C]       = cprax.x[6];
      parms[P_ALPHA]   = cprax.x[7];

      break;
    case M_KING:
      // cprax.n = 5;

      Y[0] = cprax.x[0];
      Y[1] = cprax.x[1];

      parms[P_E]     = cprax.x[2]; 
      parms[P_THETA] = cprax.x[3];     
      parms[P_KAPPA] = cprax.x[4];

      break;
    case M_TRUNC_KING:
      // cprax.n = 6;

      Y[0] = cprax.x[0];
      Y[1] = cprax.x[1];

      parms[P_E]      = cprax.x[2]; 
      parms[P_THETA]  = cprax.x[3];     
      parms[P_C]      = cprax.x[4];
      parms[P_KAPPA2] = cprax.x[5];

      break;
    case M_HUBBLE:
      // cprax.n = 5;

      Y[0] = cprax.x[0];
      Y[1] = cprax.x[1];

      parms[P_E]     = cprax.x[2]; 
      parms[P_THETA] = cprax.x[3];     
      parms[P_KAPPA] = cprax.x[4];

      break;
    case M_DE_VAUCOULEUR:
      // cprax.n = 5;

      Y[0] = cprax.x[0];
      Y[1] = cprax.x[1];

      parms[P_E]     = cprax.x[2]; 
      parms[P_THETA] = cprax.x[3];     
      parms[P_KAPPA] = cprax.x[4];

      break;
    case M_SPIRAL:
      // cprax.n = 6;

      Y[0] = cprax.x[0];
      Y[1] = cprax.x[1];

      parms[P_E]      = cprax.x[2]; 
      parms[P_THETA]  = cprax.x[3];     
      parms[P_KAPPA]  = cprax.x[4];
      parms[P_ALPHA2] = cprax.x[5];

      break;
    case M_MULTIPOLE:
      // cprax.n = 10;

      Y[0] = cprax.x[0];
      Y[1] = cprax.x[1];

      parms[P_E]      = cprax.x[2]; 
      parms[P_THETA]  = cprax.x[3];     
      parms[P_KAPPA0] = cprax.x[4];
      parms[P_DX_QP]  = cprax.x[5];
      parms[P_DY_QP]  = cprax.x[6];
      parms[P_QXX]    =  cprax.x[7];
      parms[P_QXY]    = cprax.x[8];
      parms[P_QYY]    = cprax.x[9];

      break;
    case M_ROTATION_LENS:
      // cprax.n = 6;

      Y[0] = cprax.x[0];
      Y[1] = cprax.x[1];

      parms[P_E]     = cprax.x[2]; 
      parms[P_THETA] = cprax.x[3];     
      parms[P_SX]    = cprax.x[4];
      parms[P_SY]    = cprax.x[5];

      break;
    case M_DOUBLE_LENS:
      // cprax.n = 11;

      Y[0] = cprax.x[0];
      Y[1] = cprax.x[1];

      parms[P_E]     = cprax.x[2]; 
      parms[P_THETA] = cprax.x[3];     
      parms[P_X_1]   = cprax.x[4];
      parms[P_Y_1]   = cprax.x[5];
      parms[P_X_2]   = cprax.x[4];
      parms[P_Y_2]   = cprax.x[5];
      parms[P_M_1]   = cprax.x[4];
      parms[P_M_2]   = cprax.x[5];
      parms[P_BETA]  = cprax.x[10];

      /*
        
      Xprmt[14] = parms[P_GAMMA2];
      Xprmt[15] = parms[P_SIGMA2];
      Xprmt[16] = parms[P_PHI2];

      */
      
      break;
    case M_UNIFORM_RING:
      // cprax.n = 7;

      Y[0] = cprax.x[0];
      Y[1] = cprax.x[1];

      parms[P_E]     = cprax.x[2]; 
      parms[P_THETA] = cprax.x[3];     
      parms[P_KAPPA] = cprax.x[4];
      parms[P_Ri]    = cprax.x[5];
      parms[P_Ro]    = cprax.x[6];

      break;
    default:
      break; 
    }
  } else if(sl_position == TRUE && sl_re == TRUE &&
            sl_macro == FALSE && sl_model == FALSE) {
    // cprax.n = 3;

    Y[0] = cprax.x[0];
    Y[1] = cprax.x[1];
      
    parms[P_E] = cprax.x[2]; 

    switch(current_model) {
    case M_CHANG_REFSDAL:
      /*
        
      Xprmt[3] = parms[P_THETA];
      Xprmt[4] = parms[P_GAMMA];
      Xprmt[5] = parms[P_SIGMA];
      Xprmt[6] = parms[P_PHI];

      **/
      
      break;   
    case M_SING_ISOT_SPHERE:
      /*
        
      Xprmt[3] = parms[P_THETA];
      Xprmt[4] = parms[P_GAMMA];
      Xprmt[5] = parms[P_SIGMA];
      Xprmt[6] = parms[P_PHI];
      Xprmt[7] = parms[P_EXP];

      **/
      
      break;   
    case M_NSING_ISOT_SPHERE:
      /*
        
      Xprmt[3] = parms[P_THETA];
      Xprmt[4] = parms[P_GAMMA];
      Xprmt[5] = parms[P_SIGMA];
      Xprmt[6] = parms[P_PHI];
      Xprmt[7] = parms[P_KAPPA];
      Xprmt[8] = parms[P_C];

      **/

      break;   
    case M_TRANSP_SPHERE:
      /*

      Xprmt[3] = parms[P_THETA];
      Xprmt[4] = parms[P_GAMMA];
      Xprmt[5] = parms[P_SIGMA];
      Xprmt[6] = parms[P_PHI];
      Xprmt[7] = parms[P_C];

      **/
      
      break;
    case M_ELLIPTICAL:
      /*
        
      Xprmt[3]  = parms[P_THETA];
      Xprmt[4]  = parms[P_GAMMA];
      Xprmt[5]  = parms[P_SIGMA];
      Xprmt[6]  = parms[P_PHI];
      Xprmt[7]  = parms[P_KAPPA];
      Xprmt[8]  = parms[P_EPSILON];
      Xprmt[9]  = parms[P_C];
      Xprmt[10] = parms[P_ALPHA];

      **/
      
      break;
    case M_KING:
      /*
        
      Xprmt[3] = parms[P_THETA];
      Xprmt[4] = parms[P_GAMMA];
      Xprmt[5] = parms[P_SIGMA];
      Xprmt[6] = parms[P_PHI];
      Xprmt[7] = parms[P_KAPPA];

      **/
      

      break;
    case M_TRUNC_KING:
      /*
        
      Xprmt[3] = parms[P_THETA];
      Xprmt[4] = parms[P_GAMMA];
      Xprmt[5] = parms[P_SIGMA];
      Xprmt[6] = parms[P_PHI];
      Xprmt[7] = parms[P_C];
      Xprmt[8] = parms[P_KAPPA2];

      **/

      break;
    case M_HUBBLE:
      /*
        
      Xprmt[3] = parms[P_THETA];
      Xprmt[4] = parms[P_GAMMA];
      Xprmt[5] = parms[P_SIGMA];
      Xprmt[6] = parms[P_PHI];
      Xprmt[7] = parms[P_KAPPA];

      **/
      
      break;
    case M_DE_VAUCOULEUR:
      /*
        
      Xprmt[3] = parms[P_THETA];
      Xprmt[4] = parms[P_GAMMA];
      Xprmt[5] = parms[P_SIGMA];
      Xprmt[6] = parms[P_PHI];
      Xprmt[7] = parms[P_KAPPA];

      **/
      
      break;
    case M_SPIRAL:
      /*
        
      Xprmt[3] = parms[P_THETA];
      Xprmt[4] = parms[P_GAMMA];
      Xprmt[5] = parms[P_SIGMA];
      Xprmt[6] = parms[P_PHI];
      Xprmt[7] = parms[P_KAPPA];
      Xprmt[8] = parms[P_ALPHA2];

      **/
      
      break;
    case M_MULTIPOLE:
      /*
        
      Xprmt[3]  = parms[P_THETA];
      Xprmt[4]  = parms[P_GAMMA];
      Xprmt[5]  = parms[P_SIGMA];
      Xprmt[6]  = parms[P_PHI];
      Xprmt[7]  = parms[P_KAPPA0];
      Xprmt[8]  = parms[P_DX_QP];
      Xprmt[9]  = parms[P_DY_QP];
      Xprmt[10] = parms[P_QXX];
      Xprmt[11] = parms[P_QXY];
      Xprmt[12] = parms[P_QYY];

      **/
      
      break;
    case M_ROTATION_LENS:
      /*
        
      Xprmt[3] = parms[P_THETA];
      Xprmt[4] = parms[P_GAMMA];
      Xprmt[5] = parms[P_SIGMA];
      Xprmt[6] = parms[P_PHI];
      Xprmt[7] = parms[P_SX];
      Xprmt[8] = parms[P_SY];

      **/
      
      break;
    case M_DOUBLE_LENS:
      /*
        
      Xprmt[3]  = parms[P_THETA];
      Xprmt[4]  = parms[P_GAMMA];
      Xprmt[5]  = parms[P_SIGMA];
      Xprmt[6]  = parms[P_PHI];
      Xprmt[7]  = parms[P_X_1];
      Xprmt[8]  = parms[P_Y_1];
      Xprmt[9]  = parms[P_X_2];
      Xprmt[10] = parms[P_Y_2];
      Xprmt[11] = parms[P_M_1];
      Xprmt[12] = parms[P_M_2];
      Xprmt[13] = parms[P_BETA];
      Xprmt[14] = parms[P_GAMMA2];
      Xprmt[15] = parms[P_SIGMA2];
      Xprmt[16] = parms[P_PHI2];

      **/
      
      break;
    case M_UNIFORM_RING:
      /*
        
      Xprmt[3] = parms[P_THETA];
      Xprmt[4] = parms[P_GAMMA];
      Xprmt[5] = parms[P_SIGMA];
      Xprmt[6] = parms[P_PHI];
      Xprmt[7] = parms[P_KAPPA];
      Xprmt[8] = parms[P_Ri];
      Xprmt[9] = parms[P_Ro];

      **/
      
      break;
    default:
      break; 
    }
  } else if(sl_position == TRUE && sl_re == FALSE &&
            sl_macro == TRUE && sl_model == TRUE) {
    // Xprmt[2] = parms[P_E];

    switch(current_model) {
    case M_CHANG_REFSDAL:
      // cprax.n = 6;

      Y[0] = cprax.x[0];
      Y[1] = cprax.x[1];

      parms[P_THETA] = cprax.x[2];
      parms[P_GAMMA] = cprax.x[3];
      parms[P_SIGMA] = cprax.x[4]; 
      parms[P_PHI]   = cprax.x[5];

      break;   
    case M_SING_ISOT_SPHERE:
      // cprax.n = 7;

      Y[0] = cprax.x[0];
      Y[1] = cprax.x[1];

      parms[P_THETA] = cprax.x[2];
      parms[P_GAMMA] = cprax.x[3];
      parms[P_SIGMA] = cprax.x[4]; 
      parms[P_PHI]   = cprax.x[5];
      parms[P_EXP]   = cprax.x[6];

      break;   
    case M_NSING_ISOT_SPHERE:
      // cprax.n = 8;

      Y[0] = cprax.x[0];
      Y[1] = cprax.x[1];

      parms[P_THETA] = cprax.x[2];
      parms[P_GAMMA] = cprax.x[3];
      parms[P_SIGMA] = cprax.x[4]; 
      parms[P_PHI]   = cprax.x[5];
      parms[P_KAPPA] = cprax.x[6];
      parms[P_C]     = cprax.x[7];

      break;   
    case M_TRANSP_SPHERE:
      // cprax.n = 7;

      Y[0] = cprax.x[0];
      Y[1] = cprax.x[1];

      parms[P_THETA] = cprax.x[2];
      parms[P_GAMMA] = cprax.x[3];
      parms[P_SIGMA] = cprax.x[4]; 
      parms[P_PHI]   = cprax.x[5];
      parms[P_C]     = cprax.x[6];
      
      break;   
    case M_ELLIPTICAL:         
      // cprax.n = 10;

      Y[0] = cprax.x[0];
      Y[1] = cprax.x[1];

      parms[P_THETA]   = cprax.x[2];
      parms[P_GAMMA]   = cprax.x[3];
      parms[P_SIGMA]   = cprax.x[4]; 
      parms[P_PHI]     = cprax.x[5];
      parms[P_KAPPA]   = cprax.x[6];
      parms[P_EPSILON] = cprax.x[7];
      parms[P_C]       = cprax.x[8];
      parms[P_ALPHA]   = cprax.x[9];

      break;
    case M_KING:
      // cprax.n = 7;

      Y[0] = cprax.x[0];
      Y[1] = cprax.x[1];

      parms[P_THETA] = cprax.x[2];
      parms[P_GAMMA] = cprax.x[3];
      parms[P_SIGMA] = cprax.x[4]; 
      parms[P_PHI]   = cprax.x[5];
      parms[P_KAPPA] = cprax.x[6];

      break;
    case M_TRUNC_KING:
      // cprax.n = 8;

      Y[0] = cprax.x[0];
      Y[1] = cprax.x[1];

      parms[P_THETA]  = cprax.x[2];
      parms[P_GAMMA]  = cprax.x[3];
      parms[P_SIGMA]  = cprax.x[4]; 
      parms[P_PHI]    = cprax.x[5];
      parms[P_C]      = cprax.x[6];
      parms[P_KAPPA2] = cprax.x[7];

      break;
    case M_HUBBLE:
      // cprax.n = 7;

      Y[0] = cprax.x[0];
      Y[1] = cprax.x[1];

      parms[P_THETA] = cprax.x[2];
      parms[P_GAMMA] = cprax.x[3];
      parms[P_SIGMA] = cprax.x[4]; 
      parms[P_PHI]   = cprax.x[5];
      parms[P_KAPPA] = cprax.x[6];
      
      break;
    case M_DE_VAUCOULEUR:
      // cprax.n = 7;

      Y[0] = cprax.x[0];
      Y[1] = cprax.x[1];

      parms[P_THETA] = cprax.x[2];
      parms[P_GAMMA] = cprax.x[3];
      parms[P_SIGMA] = cprax.x[4]; 
      parms[P_PHI]   = cprax.x[5];
      parms[P_KAPPA] = cprax.x[6];

      break;
    case M_SPIRAL:
      // cprax.n = 8;

      Y[0] = cprax.x[0];
      Y[1] = cprax.x[1];

      parms[P_THETA]  = cprax.x[2];
      parms[P_GAMMA]  = cprax.x[3];
      parms[P_SIGMA]  = cprax.x[4]; 
      parms[P_PHI]    = cprax.x[5];
      parms[P_KAPPA]  = cprax.x[6];
      parms[P_ALPHA2] = cprax.x[7];

      break;
    case M_MULTIPOLE:
      // cprax.n = 12;

      Y[0] = cprax.x[0];
      Y[1] = cprax.x[1];

      parms[P_THETA]  = cprax.x[2];
      parms[P_GAMMA]  = cprax.x[3];
      parms[P_SIGMA]  = cprax.x[4]; 
      parms[P_PHI]    = cprax.x[5];
      parms[P_KAPPA0] = cprax.x[6];
      parms[P_DX_QP]  = cprax.x[7];
      parms[P_DY_QP]  = cprax.x[8];
      parms[P_QXX]    = cprax.x[9]; 
      parms[P_QXY]    = cprax.x[10]; 
      parms[P_QYY]    = cprax.x[11]; 

      break;
    case M_ROTATION_LENS:
      // cprax.n = 8;

      Y[0] = cprax.x[0];
      Y[1] = cprax.x[1];

      parms[P_THETA] = cprax.x[2];
      parms[P_GAMMA] = cprax.x[3];
      parms[P_SIGMA] = cprax.x[4]; 
      parms[P_PHI]   = cprax.x[5];
      parms[P_SX]    = cprax.x[6];
      parms[P_SY]    = cprax.x[7];

      break;
    case M_DOUBLE_LENS:
      // cprax.n = 16;

      Y[0] = cprax.x[0];
      Y[1] = cprax.x[1];

      parms[P_THETA]  = cprax.x[2];
      parms[P_GAMMA]  = cprax.x[3];
      parms[P_SIGMA]  = cprax.x[4]; 
      parms[P_PHI]    = cprax.x[5];
      parms[P_X_1]    = cprax.x[6];
      parms[P_Y_1]    = cprax.x[7];
      parms[P_X_2]    = cprax.x[8];
      parms[P_Y_2]    = cprax.x[9];
      parms[P_M_1]    = cprax.x[10];
      parms[P_M_2]    = cprax.x[11];
      parms[P_BETA]   = cprax.x[12];
      parms[P_GAMMA2] = cprax.x[13];
      parms[P_SIGMA2] = cprax.x[14];
      parms[P_PHI2]   = cprax.x[15];

      break;
    case M_UNIFORM_RING:
      // cprax.n = 9;

      Y[0] = cprax.x[0];
      Y[1] = cprax.x[1];

      parms[P_THETA] = cprax.x[2];
      parms[P_GAMMA] = cprax.x[3];
      parms[P_SIGMA] = cprax.x[4]; 
      parms[P_PHI]   = cprax.x[5];
      parms[P_KAPPA] = cprax.x[6];
      parms[P_Ri]    = cprax.x[7];
      parms[P_Ro]    = cprax.x[8];

      break;
    default:
      break; 
    }           
  } else if(sl_position == TRUE && sl_re == FALSE &&
            sl_macro == TRUE && sl_model == FALSE) {
    // cprax.n = 5;

    Y[0] = cprax.x[0];
    Y[1] = cprax.x[1];
    
    parms[P_GAMMA] = cprax.x[2];
    parms[P_SIGMA] = cprax.x[3]; 
    parms[P_PHI]   = cprax.x[4];

    // Xprmt[2] = parms[P_E];
    // Xprmt[3] = parms[P_THETA];

    switch(current_model) {
    case M_CHANG_REFSDAL:

      break;   
    case M_SING_ISOT_SPHERE:
      // Xprmt[7] = parms[P_EXP];

      break;   
    case M_NSING_ISOT_SPHERE:
      // Xprmt[7] = parms[P_KAPPA];
      // Xprmt[8] = parms[P_C];

      break;   
    case M_TRANSP_SPHERE:
      // Xprmt[7] = parms[P_C];
            
      break;   
    case M_ELLIPTICAL:         
      /*
        
      Xprmt[7]  = parms[P_KAPPA];
      Xprmt[8]  = parms[P_EPSILON];
      Xprmt[9]  = parms[P_C];
      Xprmt[10] = parms[P_ALPHA];

      **/
      
      break;
    case M_KING:
      // Xprmt[7] = parms[P_KAPPA];

      break;
    case M_TRUNC_KING:
      // Xprmt[7] = parms[P_C];
      // Xprmt[8] = parms[P_KAPPA2];

      break;
    case M_HUBBLE:
      // Xprmt[7] = parms[P_KAPPA];
      
      break;
    case M_DE_VAUCOULEUR:
      // Xprmt[7] = parms[P_KAPPA];

      break;
    case M_SPIRAL:
      // Xprmt[7] = parms[P_KAPPA];
      // Xprmt[8] = parms[P_ALPHA2];

      break;
    case M_MULTIPOLE:
      /*
        
      Xprmt[7]  = parms[P_KAPPA0];
      Xprmt[8]  = parms[P_DX_QP];
      Xprmt[9]  = parms[P_DY_QP];
      Xprmt[10] = parms[P_QXX];
      Xprmt[11] = parms[P_QXY];
      Xprmt[12] = parms[P_QYY];

      **/
      
      break;
    case M_ROTATION_LENS:
      // Xprmt[7] = parms[P_SX];
      // Xprmt[8] = parms[P_SY];

      break;
    case M_DOUBLE_LENS:
      /*
        
      Xprmt[7]  = parms[P_X_1];
      Xprmt[8]  = parms[P_Y_1];
      Xprmt[9]  = parms[P_X_2];
      Xprmt[10] = parms[P_Y_2];
      Xprmt[11] = parms[P_M_1];
      Xprmt[12] = parms[P_M_2];
      Xprmt[13] = parms[P_BETA];
      Xprmt[4]  = parms[P_GAMMA2];
      Xprmt[5]  = parms[P_SIGMA2];
      Xprmt[6]  = parms[P_PHI2];

      **/
      
      break;
    case M_UNIFORM_RING:
      /*
        
      Xprmt[7] = parms[P_KAPPA];
      Xprmt[8] = parms[P_Ri];
      Xprmt[9] = parms[P_Ro];

      **/
      
      break;
    default:
      break; 
    }
  } else if(sl_position == TRUE && sl_re == FALSE &&
            sl_macro == FALSE && sl_model == TRUE) {
    /*
      
    Xprmt[2] = parms[P_E];
    Xprmt[4] = parms[P_GAMMA];
    Xprmt[5] = parms[P_SIGMA];
    Xprmt[6] = parms[P_PHI];

    **/
    
    switch(current_model) {
    case M_CHANG_REFSDAL:
      // cprax.n = 3;

      Y[0] = cprax.x[0];
      Y[1] = cprax.x[1];
    
      parms[P_THETA] = cprax.x[2];

      break;   
    case M_SING_ISOT_SPHERE:
      // cprax.n = 4;

      Y[0] = cprax.x[0];
      Y[1] = cprax.x[1];
    
      parms[P_THETA] = cprax.x[2];
      parms[P_EXP]   = cprax.x[3];

      break;   
    case M_NSING_ISOT_SPHERE:
      // cprax.n = 5;

      Y[0] = cprax.x[0];
      Y[1] = cprax.x[1];
    
      parms[P_THETA] = cprax.x[2];
      parms[P_KAPPA] = cprax.x[3];
      parms[P_C]     = cprax.x[4];

      break;   
    case M_TRANSP_SPHERE:
      // cprax.n = 4;

      Y[0] = cprax.x[0];
      Y[1] = cprax.x[1];
    
      parms[P_THETA] = cprax.x[2];
      parms[P_C]     = cprax.x[3];
      
      break;   
    case M_ELLIPTICAL:         
      // cprax.n = 7;

      Y[0] = cprax.x[0];
      Y[1] = cprax.x[1];
    
      parms[P_THETA]   = cprax.x[2];
      parms[P_KAPPA]   = cprax.x[3];
      parms[P_EPSILON] = cprax.x[4];
      parms[P_C]       = cprax.x[5];
      parms[P_ALPHA]   = cprax.x[6];

      break;
    case M_KING:
      // cprax.n = 4;

      Y[0] = cprax.x[0];
      Y[1] = cprax.x[1];
    
      parms[P_THETA] = cprax.x[2];
      parms[P_KAPPA] = cprax.x[3];

      break;
    case M_TRUNC_KING:
      // cprax.n = 5;

      Y[0] = cprax.x[0];
      Y[1] = cprax.x[1];
    
      parms[P_THETA]  = cprax.x[2];
      parms[P_C]      = cprax.x[3];
      parms[P_KAPPA2] = cprax.x[4];

      break;
    case M_HUBBLE:
      // cprax.n = 4;

      Y[0] = cprax.x[0];
      Y[1] = cprax.x[1];
    
      parms[P_THETA] = cprax.x[2];
      parms[P_KAPPA] = cprax.x[3];
      
      break;
    case M_DE_VAUCOULEUR:
      // cprax.n = 4;

      Y[0] = cprax.x[0];
      Y[1] = cprax.x[1];
    
      parms[P_THETA] = cprax.x[2];
      parms[P_KAPPA] = cprax.x[3];

      break;
    case M_SPIRAL:
      // cprax.n = 5;

      Y[0] = cprax.x[0];
      Y[1] = cprax.x[1];
    
      parms[P_THETA]  = cprax.x[2];
      parms[P_KAPPA]  = cprax.x[3];
      parms[P_ALPHA2] = cprax.x[4];
   
      break;
    case M_MULTIPOLE:
      // cprax.n = 9;

      Y[0] = cprax.x[0];
      Y[1] = cprax.x[1];
    
      parms[P_THETA]  = cprax.x[2];
      parms[P_KAPPA0] = cprax.x[3];
      parms[P_DX_QP]  = cprax.x[4];
      parms[P_DY_QP]  = cprax.x[5];
      parms[P_QXX]    = cprax.x[6];
      parms[P_QXY]    = cprax.x[7];
      parms[P_QYY]    = cprax.x[8];

      break;
    case M_ROTATION_LENS:
      // cprax.n = 5;

      Y[0] = cprax.x[0];
      Y[1] = cprax.x[1];
    
      parms[P_THETA] = cprax.x[2];
      parms[P_SX]    = cprax.x[3];
      parms[P_SY]    = cprax.x[4];

      break;
    case M_DOUBLE_LENS:
      // cprax.n = 13;

      Y[0] = cprax.x[0];
      Y[1] = cprax.x[1];
    
      parms[P_THETA]  = cprax.x[2];
      parms[P_X_1]    = cprax.x[3];
      parms[P_Y_1]    = cprax.x[4];
      parms[P_X_2]    = cprax.x[5];
      parms[P_Y_2]    = cprax.x[6];
      parms[P_M_1]    = cprax.x[7];
      parms[P_M_2]    = cprax.x[8];
      parms[P_BETA]   = cprax.x[9];
      parms[P_GAMMA2] = cprax.x[10];
      parms[P_SIGMA2] = cprax.x[11];
      parms[P_PHI2]   = cprax.x[12];

      break;
    case M_UNIFORM_RING:
      // cprax.n = 6;

      Y[0] = cprax.x[0];
      Y[1] = cprax.x[1];
    
      parms[P_THETA] = cprax.x[2];
      parms[P_KAPPA] = cprax.x[3];
      parms[P_Ri]    = cprax.x[4];
      parms[P_Ro]    = cprax.x[5];

      break;
    default:
      break; 
    }
  } else if(sl_position == TRUE && sl_re == FALSE &&
            sl_macro == FALSE && sl_model == FALSE) {      
    // cprax.n = 2;

    Y[0] = cprax.x[0];
    Y[1] = cprax.x[1];

    /*
      
    Xprmt[2] = parms[P_E];
    Xprmt[3] = parms[P_THETA];
    Xprmt[4] = parms[P_GAMMA];
    Xprmt[5] = parms[P_SIGMA];
    Xprmt[6] = parms[P_PHI];

    **/
    
    switch(current_model) {
    case M_CHANG_REFSDAL:

      break;   
    case M_SING_ISOT_SPHERE:
      // Xprmt[7] = parms[P_EXP];

      break;   
    case M_NSING_ISOT_SPHERE:
      // Xprmt[7] = parms[P_KAPPA];
      // Xprmt[8] = parms[P_C];

      break;   
    case M_TRANSP_SPHERE:
      // Xprmt[7] = parms[P_C];
      
      break;   
    case M_ELLIPTICAL:         
      /*
        
      Xprmt[7]  = parms[P_KAPPA];
      Xprmt[8]  = parms[P_EPSILON];
      Xprmt[9]  = parms[P_C];
      Xprmt[10] = parms[P_ALPHA];

      **/
      
      break;    
    case M_KING:
      // Xprmt[7] = parms[P_KAPPA];

      break;
    case M_TRUNC_KING:
      // Xprmt[7] = parms[P_C];
      // Xprmt[8] = parms[P_KAPPA2];

      break;
    case M_HUBBLE:
      // Xprmt[7] = parms[P_KAPPA];
      
      break;
    case M_DE_VAUCOULEUR:
      // Xprmt[7] = parms[P_KAPPA];

      break;
    case M_SPIRAL:
      // Xprmt[7] = parms[P_KAPPA];
      // Xprmt[8] = parms[P_ALPHA2];

      break;
    case M_MULTIPOLE:
      /*
        
      Xprmt[7]  = parms[P_KAPPA0];
      Xprmt[8]  = parms[P_DX_QP];
      Xprmt[9]  = parms[P_DY_QP];
      Xprmt[10] = parms[P_QXX];
      Xprmt[11] = parms[P_QXY];
      Xprmt[12] = parms[P_QYY];

      **/
      
      break;
    case M_ROTATION_LENS:
      /*
        
      Xprmt[7] = parms[P_SX];
      Xprmt[8] = parms[P_SY];

      **/
      
      break;
    case M_DOUBLE_LENS:
      /*
        
      Xprmt[13] = parms[P_BETA];
      Xprmt[14] = parms[P_GAMMA2];
      Xprmt[15] = parms[P_SIGMA2];
      Xprmt[16] = parms[P_PHI2];

      **/
      
      break;
    case M_UNIFORM_RING:
      /*
        
      Xprmt[7] = parms[P_KAPPA];
      Xprmt[8] = parms[P_Ri];
      Xprmt[9] = parms[P_Ro];

      **/
      
      break;
    default:
      break; 
    }
  } else if(sl_position == FALSE && sl_re == TRUE &&
            sl_macro == TRUE && sl_model == TRUE) {
    // Xprmt[0] = xl;
    // Xprmt[1] = yl;
    
    switch(current_model) {
    case M_CHANG_REFSDAL:
      // cprax.n = 5;
      
      parms[P_E]     = cprax.x[0];
      parms[P_THETA] = cprax.x[1];
      parms[P_GAMMA] = cprax.x[2];    
      parms[P_SIGMA] = cprax.x[3];
      parms[P_PHI]   = cprax.x[4];
      
      break;   
    case M_SING_ISOT_SPHERE:
      // cprax.n = 6;

      parms[P_E]     = cprax.x[0];
      parms[P_THETA] = cprax.x[1];
      parms[P_GAMMA] = cprax.x[2];    
      parms[P_SIGMA] = cprax.x[3];
      parms[P_PHI]   = cprax.x[4];
      parms[P_EXP]   = cprax.x[5];

      break;   
    case M_NSING_ISOT_SPHERE:
      // cprax.n = 7;

      parms[P_E]     = cprax.x[0];
      parms[P_THETA] = cprax.x[1];
      parms[P_GAMMA] = cprax.x[2];    
      parms[P_SIGMA] = cprax.x[3];
      parms[P_PHI]   = cprax.x[4];
      parms[P_KAPPA] = cprax.x[5];
      parms[P_C]     = cprax.x[6];

      break;   
    case M_TRANSP_SPHERE:
      // cprax.n = 6;

      parms[P_E]     = cprax.x[0];
      parms[P_THETA] = cprax.x[1];
      parms[P_GAMMA] = cprax.x[2];    
      parms[P_SIGMA] = cprax.x[3];
      parms[P_PHI]   = cprax.x[4];
      parms[P_C]     = cprax.x[5];

      break;   
    case M_ELLIPTICAL:         
      // cprax.n = 9;

      parms[P_E]       = cprax.x[0];
      parms[P_THETA]   = cprax.x[1];
      parms[P_GAMMA]   = cprax.x[2];    
      parms[P_SIGMA]   = cprax.x[3];
      parms[P_PHI]     = cprax.x[4];
      parms[P_KAPPA]   = cprax.x[5];
      parms[P_EPSILON] = cprax.x[6];
      parms[P_C]       = cprax.x[7];
      parms[P_ALPHA]   = cprax.x[8];

      break;
    case M_KING:
      // cprax.n = 6;

      parms[P_E]     = cprax.x[0];
      parms[P_THETA] = cprax.x[1];
      parms[P_GAMMA] = cprax.x[2];    
      parms[P_SIGMA] = cprax.x[3];
      parms[P_PHI]   = cprax.x[4];
      parms[P_KAPPA] = cprax.x[5];

      break;
    case M_TRUNC_KING:
      // cprax.n = 7;

      parms[P_E]      = cprax.x[0];
      parms[P_THETA]  = cprax.x[1];
      parms[P_GAMMA]  = cprax.x[2];    
      parms[P_SIGMA]  = cprax.x[3];
      parms[P_PHI]    = cprax.x[4];
      parms[P_C]      = cprax.x[5];
      parms[P_KAPPA2] = cprax.x[6];

      break;
    case M_HUBBLE:
      // cprax.n = 6;

      parms[P_E]     = cprax.x[0];
      parms[P_THETA] = cprax.x[1];
      parms[P_GAMMA] = cprax.x[2];    
      parms[P_SIGMA] = cprax.x[3];
      parms[P_PHI]   = cprax.x[4];
      parms[P_KAPPA] = cprax.x[5];

      break;
    case M_DE_VAUCOULEUR:
      // cprax.n = 6;

      parms[P_E]     = cprax.x[0];
      parms[P_THETA] = cprax.x[1];
      parms[P_GAMMA] = cprax.x[2];    
      parms[P_SIGMA] = cprax.x[3];
      parms[P_PHI]   = cprax.x[4];
      parms[P_KAPPA] = cprax.x[5];

      break;
    case M_SPIRAL:
      // cprax.n = 7;

      parms[P_E]      = cprax.x[0];
      parms[P_THETA]  = cprax.x[1];
      parms[P_GAMMA]  = cprax.x[2];    
      parms[P_SIGMA]  = cprax.x[3];
      parms[P_PHI]    = cprax.x[4];
      parms[P_KAPPA]  = cprax.x[5];
      parms[P_ALPHA2] = cprax.x[6];

      break;
    case M_MULTIPOLE:
      // cprax.n = 11;

      parms[P_E]      = cprax.x[0];
      parms[P_THETA]  = cprax.x[1];
      parms[P_GAMMA]  = cprax.x[2];    
      parms[P_SIGMA]  = cprax.x[3];
      parms[P_PHI]    = cprax.x[4];
      parms[P_KAPPA0] = cprax.x[5];
      parms[P_DX_QP]  = cprax.x[6];
      parms[P_DY_QP]  = cprax.x[7];
      parms[P_QXX]    = cprax.x[8];
      parms[P_QXY]    = cprax.x[9];
      parms[P_QYY]    = cprax.x[10];

      break;
    case M_ROTATION_LENS:
      // cprax.n = 7;

      parms[P_E]     = cprax.x[0];
      parms[P_THETA] = cprax.x[1];
      parms[P_GAMMA] = cprax.x[2];    
      parms[P_SIGMA] = cprax.x[3];
      parms[P_PHI]   = cprax.x[4];
      parms[P_SX]    = cprax.x[5];
      parms[P_SY]    = cprax.x[6];

      break;
    case M_DOUBLE_LENS:
      // cprax.n = 15;

      parms[P_E]      = cprax.x[0];
      parms[P_THETA]  = cprax.x[1];
      parms[P_GAMMA]  = cprax.x[2];    
      parms[P_SIGMA]  = cprax.x[3];
      parms[P_PHI]    = cprax.x[4];
      parms[P_X_1]    = cprax.x[5];
      parms[P_Y_1]    = cprax.x[6];
      parms[P_X_2]    = cprax.x[7];
      parms[P_Y_2]    = cprax.x[8];
      parms[P_M_1]    = cprax.x[9];
      parms[P_M_2]    = cprax.x[10];
      parms[P_BETA]   = cprax.x[11];
      parms[P_GAMMA2] = cprax.x[11];
      parms[P_SIGMA2] = cprax.x[11];
      parms[P_PHI2]   = cprax.x[11];

      break;
    case M_UNIFORM_RING:
      // cprax.n = 8;

      parms[P_E]     = cprax.x[0];
      parms[P_THETA] = cprax.x[1];
      parms[P_GAMMA] = cprax.x[2];    
      parms[P_SIGMA] = cprax.x[3];
      parms[P_PHI]   = cprax.x[4];
      parms[P_KAPPA] = cprax.x[5];
      parms[P_Ri]    = cprax.x[6];
      parms[P_Ro]    = cprax.x[7];

      break;
    default:
      break; 
    }
  } else if(sl_position == FALSE && sl_re == TRUE &&
            sl_macro == TRUE && sl_model == FALSE) {
    // cprax.n = 4;

    parms[P_E]     = cprax.x[0];
    parms[P_GAMMA] = cprax.x[1];    
    parms[P_SIGMA] = cprax.x[2];
    parms[P_PHI]   = cprax.x[3];
    
    /*
      
    Xprmt[0] = xl;
    Xprmt[1] = yl;
    Xprmt[3] = parms[P_THETA];

    **/
    
    switch(current_model) {   
    case M_CHANG_REFSDAL:

      break;   
    case M_SING_ISOT_SPHERE:
      // Xprmt[8] = parms[P_EXP];

      break;   
    case M_NSING_ISOT_SPHERE:
      // Xprmt[7] = parms[P_KAPPA];
      // Xprmt[9] = parms[P_C];

      break;   
    case M_TRANSP_SPHERE:
      // Xprmt[7] = parms[P_C];
      
      break;   
    case M_ELLIPTICAL:         
      /*
        
      Xprmt[7]  = parms[P_KAPPA];
      Xprmt[8]  = parms[P_EPSILON];
      Xprmt[9]  = parms[P_C];
      Xprmt[10] = parms[P_ALPHA];    

      **/
      
      break;
    case M_KING:
      // Xprmt[7] = parms[P_KAPPA];
 
      break;
    case M_TRUNC_KING:
      // prmt[7] = parms[P_C];
      // Xprmt[8] = parms[P_KAPPA2];

      break;
    case M_HUBBLE:
      // Xprmt[7] = parms[P_KAPPA];
      
      break;
    case M_DE_VAUCOULEUR:
      // Xprmt[7] = parms[P_KAPPA];

      break;
    case M_SPIRAL:
      // Xprmt[7] = parms[P_KAPPA];
      // Xprmt[8] = parms[P_ALPHA2];    

      break;
    case M_MULTIPOLE:
      /*
        
      Xprmt[7]  = parms[P_KAPPA0];
      Xprmt[8]  = parms[P_DX_QP];
      Xprmt[9]  = parms[P_DY_QP];
      Xprmt[10] = parms[P_QXX];
      Xprmt[11] = parms[P_QXY];
      Xprmt[12] = parms[P_QYY];

      **/
      
      break;
    case M_ROTATION_LENS:
      // Xprmt[7] = parms[P_SX];
      // Xprmt[8] = parms[P_SY];

      break;
    case M_DOUBLE_LENS:
      /*
        
      Xprmt[7]  = parms[P_X_1];
      Xprmt[8]  = parms[P_Y_1];
      Xprmt[9]  = parms[P_X_2];
      Xprmt[10] = parms[P_Y_2];
      Xprmt[11] = parms[P_M_1];
      Xprmt[12] = parms[P_M_2];
      Xprmt[13] = parms[P_BETA];
      Xprmt[14] = parms[P_GAMMA2];
      Xprmt[15] = parms[P_SIGMA2];
      Xprmt[16] = parms[P_PHI2];

      **/
      
      break;
    case M_UNIFORM_RING:
      /*
        
      Xprmt[7] = parms[P_KAPPA];
      Xprmt[8] = parms[P_Ri];
      Xprmt[9] = parms[P_Ro];

      **/
      
      break;
    default:
      break;     
    }
  } else if(sl_position == FALSE && sl_re == TRUE &&
            sl_macro == FALSE && sl_model == TRUE) { 
    /*
      
    Xprmt[0] = xl;
    Xprmt[1] = yl;
    Xprmt[4] = parms[P_GAMMA];
    Xprmt[5] = parms[P_SIGMA];
    Xprmt[6] = parms[P_PHI];

    **/
    
    switch(current_model) {
    case M_CHANG_REFSDAL:
      // cprax.n = 2;

      parms[P_E]     = cprax.x[0];
      parms[P_THETA] = cprax.x[1];

      break;   
    case M_SING_ISOT_SPHERE:
      // cprax.n = 3;

      parms[P_E]     = cprax.x[0];
      parms[P_THETA] = cprax.x[1];
      parms[P_EXP]   = cprax.x[2];

      break;   
    case M_NSING_ISOT_SPHERE:
      // cprax.n = 4;

      parms[P_E]     = cprax.x[0];
      parms[P_THETA] = cprax.x[1];
      parms[P_KAPPA] = cprax.x[2];
      parms[P_C]     = cprax.x[3];

      break;   
    case M_TRANSP_SPHERE:
      // cprax.n = 3;

      parms[P_E]     = cprax.x[0];
      parms[P_THETA] = cprax.x[1];
      parms[P_C]     = cprax.x[2];

      cprax.x[0] = parms[P_E];
      cprax.x[1] = parms[P_THETA];
      cprax.x[2] = parms[P_C];

      break;   
    case M_ELLIPTICAL:         
      // cprax.n = 6;

      parms[P_E]       = cprax.x[0];
      parms[P_THETA]   = cprax.x[1];
      parms[P_KAPPA]   = cprax.x[2];
      parms[P_EPSILON] = cprax.x[3];
      parms[P_C]       = cprax.x[4];
      parms[P_ALPHA]   = cprax.x[5];

      break;
    case M_KING:
      // cprax.n = 3;

      parms[P_E]     = cprax.x[0];
      parms[P_THETA] = cprax.x[1];
      parms[P_KAPPA] = cprax.x[2];

      break;
    case M_TRUNC_KING:
      // cprax.n = 4;

      parms[P_E]      = cprax.x[0];
      parms[P_THETA]  = cprax.x[1];
      parms[P_C]      = cprax.x[2];
      parms[P_KAPPA2] = cprax.x[3];

      break;
    case M_HUBBLE:
      // cprax.n = 3;

      parms[P_E]     = cprax.x[0];
      parms[P_THETA] = cprax.x[1];
      parms[P_KAPPA] = cprax.x[2];

      break;
    case M_DE_VAUCOULEUR:
      // cprax.n = 3;

      parms[P_E]     = cprax.x[0];
      parms[P_THETA] = cprax.x[1];
      parms[P_KAPPA] = cprax.x[2];

      break;
    case M_SPIRAL:
      // cprax.n = 4;

      parms[P_E]      = cprax.x[0];
      parms[P_THETA]  = cprax.x[1];
      parms[P_KAPPA]  = cprax.x[2];
      parms[P_ALPHA2] = cprax.x[3];

      break;
    case M_MULTIPOLE:
      // cprax.n = 8;

      parms[P_E]     = cprax.x[0];
      parms[P_THETA] = cprax.x[1];
      parms[P_KAPPA] = cprax.x[2];
      parms[P_DX_QP] = cprax.x[3];
      parms[P_DY_QP] = cprax.x[4];
      parms[P_QXX]   = cprax.x[5];
      parms[P_QXY]   = cprax.x[6];
      parms[P_QYY]   = cprax.x[7];

      break;
    case M_ROTATION_LENS:
      // cprax.n = 4;

      parms[P_E]     = cprax.x[0];
      parms[P_THETA] = cprax.x[1];
      parms[P_SX]    = cprax.x[2];
      parms[P_SY]    = cprax.x[3];

      break;
    case M_DOUBLE_LENS:
      // cprax.n = 12;

      parms[P_E]      = cprax.x[0];
      parms[P_THETA]  = cprax.x[1];
      parms[P_KAPPA]  = cprax.x[2];
      parms[P_X_1]    = cprax.x[3];
      parms[P_Y_1]    = cprax.x[4];
      parms[P_X_2]    = cprax.x[5];
      parms[P_Y_2]    = cprax.x[6];
      parms[P_M_1]    = cprax.x[7];
      parms[P_M_2]    = cprax.x[8];
      parms[P_GAMMA2] = cprax.x[9];
      parms[P_SIGMA2] = cprax.x[10];
      parms[P_PHI2]   = cprax.x[11];
      
      break;
    case M_UNIFORM_RING:
      // cprax.n = 5;

      parms[P_E]     = cprax.x[0];
      parms[P_THETA] = cprax.x[1];
      parms[P_KAPPA] = cprax.x[2];
      parms[P_Ri]    = cprax.x[3];
      parms[P_Ri]    = cprax.x[4];

      break;
    default:
      break; 
    }
  } else if(sl_position == FALSE && sl_re == TRUE &&
            sl_macro == FALSE && sl_model == FALSE) {
    /* We have to avoid this case because cprax.n >= 2 */

    // cprax.n = 1;

    parms[P_E] = cprax.x[0];

    /*
      
    Xprmt[0] = xl;
    Xprmt[1] = yl;
    Xprmt[3] = parms[P_THETA];
    Xprmt[4] = parms[P_GAMMA];
    Xprmt[5] = parms[P_SIGMA];
    Xprmt[6] = parms[P_PHI];

    **/
    
    switch(current_model) {
    case M_CHANG_REFSDAL:
      
      break;   
    case M_SING_ISOT_SPHERE:
      // Xprmt[7] = parms[P_EXP];

      break;   
    case M_NSING_ISOT_SPHERE:
      // Xprmt[7] = parms[P_KAPPA];
      // Xprmt[8] = parms[P_C];

      break;   
    case M_TRANSP_SPHERE:
      // Xprmt[7] = parms[P_C];
      
      break;   
    case M_ELLIPTICAL:         
      /*
        
      Xprmt[7]  = parms[P_KAPPA];
      Xprmt[8]  = parms[P_EPSILON];
      Xprmt[9]  = parms[P_C];
      Xprmt[10] = parms[P_ALPHA];    

      **/
      
      break;
    case M_KING:
      // Xprmt[7] = parms[P_KAPPA];

      break;
    case M_TRUNC_KING:
      /*
        
      Xprmt[7] = parms[P_C];
      Xprmt[8] = parms[P_KAPPA2];

      **/
      
      break;
    case M_HUBBLE:
      // Xprmt[7] = parms[P_KAPPA];
      
      break;
    case M_DE_VAUCOULEUR:
      // Xprmt[7] = parms[P_KAPPA];

      break;
    case M_SPIRAL:
      // Xprmt[7] = parms[P_KAPPA];
      // Xprmt[8] = parms[P_ALPHA2];

      break;
    case M_MULTIPOLE:
      /*
        
      Xprmt[7]  = parms[P_KAPPA0];
      Xprmt[8]  = parms[P_DX_QP];
      Xprmt[9]  = parms[P_DY_QP];
      Xprmt[10] = parms[P_QXX];
      Xprmt[11] = parms[P_QXY];
      Xprmt[12] = parms[P_QYY];

      **/
      
      break;
    case M_ROTATION_LENS:
      // Xprmt[7] = parms[P_SX];
      // Xprmt[8] = parms[P_SY];

      break;
    case M_DOUBLE_LENS:
      /*
        
      Xprmt[7]  = parms[P_X_1];
      Xprmt[8]  = parms[P_Y_1];
      Xprmt[9]  = parms[P_X_2];
      Xprmt[10] = parms[P_Y_2];
      Xprmt[11] = parms[P_M_1];
      Xprmt[12] = parms[P_M_2];
      Xprmt[13] = parms[P_BETA];
      Xprmt[14] = parms[P_GAMMA2];
      Xprmt[15] = parms[P_SIGMA2];
      Xprmt[16] = parms[P_PHI2];

      **/
      
      break;
    case M_UNIFORM_RING:
      /*
        
      Xprmt[7] = parms[P_KAPPA];
      Xprmt[8] = parms[P_Ri];
      Xprmt[9] = parms[P_Ro];

      **/
      
      break;
    default:
      break;
    }
  } else if(sl_position == FALSE && sl_re == FALSE &&
            sl_macro == TRUE && sl_model == TRUE) {
    /*
      
    Xprmt[0] = xl;
    Xprmt[1] = yl;
    Xprmt[2] = parms[P_E];

    **/
    
    switch(current_model) {
    case M_CHANG_REFSDAL:
      // cprax.n = 4;

      parms[P_THETA] = cprax.x[0];
      parms[P_GAMMA] = cprax.x[1];
      parms[P_SIGMA] = cprax.x[2];
      parms[P_PHI]   = cprax.x[3];

      break;   
    case M_SING_ISOT_SPHERE:
      // cprax.n = 5;

      parms[P_THETA] = cprax.x[0];
      parms[P_GAMMA] = cprax.x[1];
      parms[P_SIGMA] = cprax.x[2];
      parms[P_PHI]   = cprax.x[3];
      parms[P_EXP]   = cprax.x[4];

      break;   
    case M_NSING_ISOT_SPHERE:
      // cprax.n = 6;

      parms[P_THETA] = cprax.x[0];
      parms[P_GAMMA] = cprax.x[1];
      parms[P_SIGMA] = cprax.x[2];
      parms[P_PHI]   = cprax.x[3];
      parms[P_KAPPA] = cprax.x[4];
      parms[P_C]     = cprax.x[5];

      break;   
    case M_TRANSP_SPHERE:
      // cprax.n = 5;

      parms[P_THETA] = cprax.x[0];
      parms[P_GAMMA] = cprax.x[1];
      parms[P_SIGMA] = cprax.x[2];
      parms[P_PHI]   = cprax.x[3];
      parms[P_C]     = cprax.x[4];
      
      break;   
    case M_ELLIPTICAL:         
      // cprax.n = 8;

      parms[P_THETA]   = cprax.x[0];
      parms[P_GAMMA]   = cprax.x[1];
      parms[P_SIGMA]   = cprax.x[2];
      parms[P_PHI]     = cprax.x[3];
      parms[P_KAPPA]   = cprax.x[4];
      parms[P_EPSILON] = cprax.x[5];
      parms[P_C]       = cprax.x[6];
      parms[P_ALPHA]   = cprax.x[7];

      break;
    case M_KING:
      // cprax.n = 5;

      parms[P_THETA] = cprax.x[0];
      parms[P_GAMMA] = cprax.x[1];
      parms[P_SIGMA] = cprax.x[2];
      parms[P_PHI]   = cprax.x[3];
      parms[P_KAPPA] = cprax.x[4];

      break;
    case M_TRUNC_KING:
      // cprax.n = 6;

      parms[P_THETA]  = cprax.x[0];
      parms[P_GAMMA]  = cprax.x[1];
      parms[P_SIGMA]  = cprax.x[2];
      parms[P_PHI]    = cprax.x[3];
      parms[P_C]      = cprax.x[4];
      parms[P_KAPPA2] = cprax.x[5];

      break;
    case M_HUBBLE:
      // cprax.n = 5;

      parms[P_THETA] = cprax.x[0];
      parms[P_GAMMA] = cprax.x[1];
      parms[P_SIGMA] = cprax.x[2];
      parms[P_PHI]   = cprax.x[3];
      parms[P_KAPPA] = cprax.x[4];
      
      break;
    case M_DE_VAUCOULEUR:
      // cprax.n = 5;

      parms[P_THETA] = cprax.x[0];
      parms[P_GAMMA] = cprax.x[1];
      parms[P_SIGMA] = cprax.x[2];
      parms[P_PHI]   = cprax.x[3];
      parms[P_KAPPA] = cprax.x[4];

      break;
    case M_SPIRAL:
      // cprax.n = 6;

      parms[P_THETA]  = cprax.x[0];
      parms[P_GAMMA]  = cprax.x[1];
      parms[P_SIGMA]  = cprax.x[2];
      parms[P_PHI]    = cprax.x[3];
      parms[P_KAPPA]  = cprax.x[4];
      parms[P_ALPHA2] = cprax.x[5];

      break;
    case M_MULTIPOLE:
      // cprax.n = 10;

      parms[P_THETA]  = cprax.x[0];
      parms[P_GAMMA]  = cprax.x[1];
      parms[P_SIGMA]  = cprax.x[2];
      parms[P_PHI]    = cprax.x[3];
      parms[P_KAPPA0] = cprax.x[4];
      parms[P_DX_QP]  = cprax.x[5];
      parms[P_DY_QP]  = cprax.x[6];
      parms[P_QXX]    = cprax.x[7];
      parms[P_QXY]    = cprax.x[8];
      parms[P_QYY]    = cprax.x[9];

      break;
    case M_ROTATION_LENS:
      // cprax.n = 6;

      parms[P_THETA] = cprax.x[0];
      parms[P_GAMMA] = cprax.x[1];
      parms[P_SIGMA] = cprax.x[2];
      parms[P_PHI]   = cprax.x[3];
      parms[P_SX]    = cprax.x[4];
      parms[P_SY]    = cprax.x[5];

      break;
    case M_DOUBLE_LENS:
      // cprax.n = 14;

      parms[P_THETA]  = cprax.x[0];
      parms[P_GAMMA]  = cprax.x[1];
      parms[P_SIGMA]  = cprax.x[2];
      parms[P_PHI]    = cprax.x[3];
      parms[P_X_1]    = cprax.x[4];
      parms[P_Y_1]    = cprax.x[5];
      parms[P_X_2]    = cprax.x[6];
      parms[P_Y_2]    = cprax.x[7];
      parms[P_M_1]    = cprax.x[8];
      parms[P_M_2]    = cprax.x[9];
      parms[P_BETA]   = cprax.x[10];
      parms[P_GAMMA2] = cprax.x[11];
      parms[P_SIGMA2] = cprax.x[12];
      parms[P_PHI2]   = cprax.x[13];

      break;
    case M_UNIFORM_RING:
      // cprax.n = 7;

      parms[P_THETA] = cprax.x[0];
      parms[P_GAMMA] = cprax.x[1];
      parms[P_SIGMA] = cprax.x[2];
      parms[P_PHI]   = cprax.x[3];
      parms[P_KAPPA] = cprax.x[4];
      parms[P_Ri]    = cprax.x[5];
      parms[P_Ro]    = cprax.x[6];

      break;
    default:
      break; 
    }
  } else if(sl_position == FALSE && sl_re == FALSE &&
            sl_macro == TRUE && sl_model == FALSE) {
    // cprax.n = 3;

    parms[P_GAMMA] = cprax.x[0];
    parms[P_SIGMA] = cprax.x[1];
    parms[P_PHI]   = cprax.x[2];

    switch(current_model) {
    case M_CHANG_REFSDAL:
      /*
        
      Xprmt[0] = xl;
      Xprmt[1] = yl;
      Xprmt[2] = parms[P_E];
      Xprmt[3] = parms[P_THETA]; 

      **/
      
      break;   
    case M_SING_ISOT_SPHERE:
      /*
        
      Xprmt[0] = xl;
      Xprmt[1] = yl;
      Xprmt[2] = parms[P_E];
      Xprmt[3] = parms[P_THETA]; 
      Xprmt[7] = parms[P_EXP];

      **/
      
      break;   
    case M_NSING_ISOT_SPHERE:
      /*
        
      Xprmt[0] = xl;
      Xprmt[1] = yl;
      Xprmt[2] = parms[P_E];
      Xprmt[3] = parms[P_THETA]; 
      Xprmt[7] = parms[P_KAPPA];
      Xprmt[8] = parms[P_C];

      **/
      
      break;   
    case M_TRANSP_SPHERE:
      /*
        
      Xprmt[0] = xl;
      Xprmt[1] = yl;
      Xprmt[2] = parms[P_E];
      Xprmt[3] = parms[P_THETA]; 
      Xprmt[7] = parms[P_C];

      **/
      
      break;   
    case M_ELLIPTICAL:         
      /*
        
      Xprmt[0]  = xl;
      Xprmt[1]  = yl;
      Xprmt[2]  = parms[P_E];
      Xprmt[3]  = parms[P_THETA]; 
      Xprmt[7]  = parms[P_KAPPA];
      Xprmt[8]  = parms[P_EPSILON];
      Xprmt[9]  = parms[P_C];
      Xprmt[10] = parms[P_ALPHA];        

      **/
      
      break;
    case M_KING:
      /*
        
      Xprmt[0] = xl;
      Xprmt[1] = yl;
      Xprmt[2] = parms[P_E];
      Xprmt[3] = parms[P_THETA]; 
      Xprmt[7] = parms[P_KAPPA];

      **/

      break;
    case M_TRUNC_KING:
      /*
        
      Xprmt[0] = xl;
      Xprmt[1] = yl;
      Xprmt[2] = parms[P_E];
      Xprmt[3] = parms[P_THETA]; 
      Xprmt[7] = parms[P_C];
      Xprmt[8] = parms[P_KAPPA2];

      **/
      
      break;
    case M_HUBBLE:
      /*
        
      Xprmt[0] = xl;
      Xprmt[1] = yl;
      Xprmt[2] = parms[P_E];
      Xprmt[3] = parms[P_THETA]; 
      Xprmt[7] = parms[P_KAPPA];

      **/
      
      break;
    case M_DE_VAUCOULEUR:
      /*
        
      Xprmt[0] = xl;
      Xprmt[1] = yl;
      Xprmt[2] = parms[P_E];
      Xprmt[3] = parms[P_THETA]; 
      Xprmt[7] = parms[P_KAPPA];

      **/
      
      break;
    case M_SPIRAL:
      /*
        
      Xprmt[0] = xl;
      Xprmt[1] = yl;
      Xprmt[2] = parms[P_E];
      Xprmt[3] = parms[P_THETA]; 
      Xprmt[7] = parms[P_KAPPA];
      Xprmt[8] = parms[P_ALPHA2];

      **/
      
      break;
    case M_MULTIPOLE:
      /*
        
      Xprmt[0]  = xl;
      Xprmt[1]  = yl;
      Xprmt[2]  = parms[P_E];
      Xprmt[3]  = parms[P_THETA];
      Xprmt[7]  = parms[P_KAPPA0];
      Xprmt[8]  = parms[P_DX_QP];
      Xprmt[9]  = parms[P_DY_QP];
      Xprmt[10] = parms[P_QXX];
      Xprmt[11] = parms[P_QXY];
      Xprmt[12] = parms[P_QYY];

      **/
      
      break;      
    case M_ROTATION_LENS:
      /*
        
      Xprmt[0] = xl;
      Xprmt[1] = yl;
      Xprmt[2] = parms[P_E];
      Xprmt[3] = parms[P_THETA];
      Xprmt[7] = parms[P_SX];
      Xprmt[8] = parms[P_SY];

      **/
      
      break;
    case M_DOUBLE_LENS:
      // cprax.n = 6;

      parms[P_GAMMA2] = cprax.x[3];
      parms[P_SIGMA2] = cprax.x[4];
      parms[P_PHI2]   = cprax.x[5];

      /*
        
      Xprmt[0]  = xl;
      Xprmt[1]  = yl;
      Xprmt[2]  = parms[P_E];
      Xprmt[3]  = parms[P_THETA];
      Xprmt[7]  = parms[P_X_1];
      Xprmt[8]  = parms[P_Y_1];
      Xprmt[9]  = parms[P_X_2];
      Xprmt[10] = parms[P_Y_2];
      Xprmt[11] = parms[P_M_1];
      Xprmt[12] = parms[P_M_2];
      Xprmt[13] = parms[P_BETA];

      **/
      
      break;
    case M_UNIFORM_RING:
      /*
        
      Xprmt[0] = xl;
      Xprmt[1] = yl;
      Xprmt[2] = parms[P_E];
      Xprmt[3] = parms[P_THETA];
      Xprmt[7] = parms[P_KAPPA];
      Xprmt[8] = parms[P_Ri];
      Xprmt[9] = parms[P_Ro];

      **/
      
      break;
    default:
      break;
    }
  } else if(sl_position == FALSE && sl_re == FALSE &&
            sl_macro == FALSE && sl_model == TRUE) {
    /*
      
    Xprmt[0] = xl;
    Xprmt[1] = yl;
    Xprmt[2] = parms[P_E];
    Xprmt[4] = parms[P_GAMMA];
    Xprmt[5] = parms[P_SIGMA];
    Xprmt[6] = parms[P_PHI];

    **/
    
    switch(current_model) {
    case M_CHANG_REFSDAL:
      /* We have to avoid this case because cprax.n >= 2 */
      
      // cprax.n = 1;

      parms[P_THETA] = cprax.x[0]; 

      break;   
    case M_SING_ISOT_SPHERE:
      // cprax.n = 2;

      parms[P_THETA] = cprax.x[0]; 
      parms[P_EXP]   = cprax.x[1]; 

      break;   
    case M_NSING_ISOT_SPHERE:
      // cprax.n = 3;

      parms[P_THETA] = cprax.x[0]; 
      parms[P_KAPPA] = cprax.x[1]; 
      parms[P_C]     = cprax.x[2]; 

      break;   
    case M_TRANSP_SPHERE:
      // cprax.n = 2;

      parms[P_THETA] = cprax.x[0]; 
      parms[P_C]     = cprax.x[1]; 

      break;   
    case M_ELLIPTICAL:         
      // cprax.n = 5;

      parms[P_THETA]   = cprax.x[0]; 
      parms[P_KAPPA]   = cprax.x[1]; 
      parms[P_EPSILON] = cprax.x[2]; 
      parms[P_C]       = cprax.x[3]; 
      parms[P_ALPHA]   = cprax.x[4]; 

      break;
    case M_KING:
      // cprax.n = 2;

      parms[P_THETA] = cprax.x[0]; 
      parms[P_KAPPA] = cprax.x[1]; 

      break;
    case M_TRUNC_KING:
      // cprax.n = 3;

      parms[P_THETA]  = cprax.x[0]; 
      parms[P_C]      = cprax.x[1]; 
      parms[P_KAPPA2] = cprax.x[2]; 
      
      break;
    case M_HUBBLE:
      // cprax.n = 2;

      parms[P_THETA] = cprax.x[0]; 
      parms[P_KAPPA] = cprax.x[1]; 

      break;
    case M_DE_VAUCOULEUR:
      // cprax.n = 2;

      parms[P_THETA] = cprax.x[0]; 
      parms[P_KAPPA] = cprax.x[1]; 

      break;
    case M_SPIRAL:
      // cprax.n = 3;

      parms[P_THETA]  = cprax.x[0]; 
      parms[P_KAPPA]  = cprax.x[1]; 
      parms[P_ALPHA2] = cprax.x[2]; 

      break;
    case M_MULTIPOLE:
      // cprax.n = 7;

      parms[P_THETA]  = cprax.x[0]; 
      parms[P_KAPPA0] = cprax.x[1]; 
      parms[P_DX_QP]  = cprax.x[2]; 
      parms[P_DY_QP]  = cprax.x[3]; 
      parms[P_QXX]    = cprax.x[4]; 
      parms[P_QXY]    = cprax.x[5]; 
      parms[P_QYY]    = cprax.x[6]; 

      break;
    case M_ROTATION_LENS:
      // cprax.n = 3;

      parms[P_THETA] = cprax.x[0]; 
      parms[P_SX]    = cprax.x[1]; 
      parms[P_SY]    = cprax.x[2]; 

      break;
    case M_DOUBLE_LENS:
      // cprax.n = 11;

      parms[P_THETA]  = cprax.x[0]; 
      parms[P_X_1]    = cprax.x[1]; 
      parms[P_Y_1]    = cprax.x[2]; 
      parms[P_X_2]    = cprax.x[3]; 
      parms[P_Y_2]    = cprax.x[4]; 
      parms[P_M_1]    = cprax.x[5]; 
      parms[P_M_2]    = cprax.x[6]; 
      parms[P_BETA]   = cprax.x[7];
      parms[P_GAMMA2] = cprax.x[8];
      parms[P_SIGMA2] = cprax.x[9];
      parms[P_PHI2]   = cprax.x[10];

      break;
    case M_UNIFORM_RING:
      // cprax.n = 4;

      parms[P_THETA]  = cprax.x[0]; 
      parms[P_KAPPA0] = cprax.x[1]; 
      parms[P_Ri]     = cprax.x[2]; 
      parms[P_Ro]     = cprax.x[3]; 

      break;
    default:
      break; 
    }
  } else if(sl_position == FALSE && sl_re == FALSE &&
            sl_macro == FALSE && sl_model == FALSE) {
    /* This case is impossible */
    
    // cprax.n = 0;

    switch(current_model) {
    case M_CHANG_REFSDAL:
      Xprmt[0] = xl;
      Xprmt[1] = yl;
      Xprmt[2] = parms[P_E];
      Xprmt[3] = parms[P_THETA];
      Xprmt[4] = parms[P_GAMMA];
      Xprmt[5] = parms[P_SIGMA];
      Xprmt[6] = parms[P_PHI];

      break;   
    case M_SING_ISOT_SPHERE:
      Xprmt[0] = xl;
      Xprmt[1] = yl;
      Xprmt[2] = parms[P_E];
      Xprmt[3] = parms[P_THETA];
      Xprmt[4] = parms[P_GAMMA];
      Xprmt[5] = parms[P_SIGMA];
      Xprmt[6] = parms[P_PHI];
      Xprmt[7] = parms[P_EXP];

      break;   
    case M_NSING_ISOT_SPHERE:
      Xprmt[0] = xl;
      Xprmt[1] = yl;
      Xprmt[2] = parms[P_E];
      Xprmt[3] = parms[P_THETA];
      Xprmt[4] = parms[P_GAMMA];
      Xprmt[5] = parms[P_SIGMA];
      Xprmt[6] = parms[P_PHI];
      Xprmt[7] = parms[P_KAPPA];
      Xprmt[8] = parms[P_C];

      break;   
    case M_TRANSP_SPHERE:
      Xprmt[0] = xl;
      Xprmt[1] = yl;
      Xprmt[2] = parms[P_E];
      Xprmt[3] = parms[P_THETA];
      Xprmt[4] = parms[P_GAMMA];
      Xprmt[5] = parms[P_SIGMA];
      Xprmt[6] = parms[P_PHI];
      Xprmt[7] = parms[P_C];
      
      break;   
    case M_ELLIPTICAL:         
      Xprmt[0]  = xl;
      Xprmt[1]  = yl;
      Xprmt[2]  = parms[P_E];
      Xprmt[3]  = parms[P_THETA];
      Xprmt[4]  = parms[P_GAMMA];
      Xprmt[5]  = parms[P_SIGMA];
      Xprmt[6]  = parms[P_PHI];
      Xprmt[7]  = parms[P_KAPPA];
      Xprmt[8]  = parms[P_EPSILON];
      Xprmt[9]  = parms[P_C];
      Xprmt[10] = parms[P_ALPHA];

      break;
    case M_KING:
      Xprmt[0] = xl;
      Xprmt[1] = yl;
      Xprmt[2] = parms[P_E];
      Xprmt[3] = parms[P_THETA];
      Xprmt[4] = parms[P_GAMMA];
      Xprmt[5] = parms[P_SIGMA];
      Xprmt[6] = parms[P_PHI];
      Xprmt[7] = parms[P_KAPPA];

      break;
    case M_TRUNC_KING:
      Xprmt[0] = xl;
      Xprmt[1] = yl;
      Xprmt[2] = parms[P_E];
      Xprmt[3] = parms[P_THETA];
      Xprmt[4] = parms[P_GAMMA];
      Xprmt[5] = parms[P_SIGMA];
      Xprmt[6] = parms[P_PHI];
      Xprmt[7] = parms[P_C];
      Xprmt[8] = parms[P_KAPPA2];

      break;
    case M_HUBBLE:
      Xprmt[0] = xl;
      Xprmt[1] = yl;
      Xprmt[2] = parms[P_E];
      Xprmt[3] = parms[P_THETA];
      Xprmt[4] = parms[P_GAMMA];
      Xprmt[5] = parms[P_SIGMA];
      Xprmt[6] = parms[P_PHI];
      Xprmt[7] = parms[P_KAPPA];
      
      break;
    case M_DE_VAUCOULEUR:
      Xprmt[0] = xl;
      Xprmt[1] = yl;
      Xprmt[2] = parms[P_E];
      Xprmt[3] = parms[P_THETA];
      Xprmt[4] = parms[P_GAMMA];
      Xprmt[5] = parms[P_SIGMA];
      Xprmt[6] = parms[P_PHI];
      Xprmt[7] = parms[P_KAPPA];

      break;
    case M_SPIRAL:
      Xprmt[0] = xl;
      Xprmt[1] = yl;
      Xprmt[2] = parms[P_E];
      Xprmt[3] = parms[P_THETA];
      Xprmt[4] = parms[P_GAMMA];
      Xprmt[5] = parms[P_SIGMA];
      Xprmt[6] = parms[P_PHI];
      Xprmt[7] = parms[P_KAPPA];
      Xprmt[8] = parms[P_ALPHA2];

      break;
    case M_MULTIPOLE:
      Xprmt[0]  = xl;
      Xprmt[1]  = yl;
      Xprmt[2]  = parms[P_E];
      Xprmt[3]  = parms[P_THETA];
      Xprmt[4]  = parms[P_GAMMA];
      Xprmt[5]  = parms[P_SIGMA];
      Xprmt[6]  = parms[P_PHI];
      Xprmt[7]  = parms[P_KAPPA0];
      Xprmt[8]  = parms[P_DX_QP];
      Xprmt[9]  = parms[P_DY_QP];
      Xprmt[10] = parms[P_QXX];
      Xprmt[11] = parms[P_QXY];
      Xprmt[12] = parms[P_QYY];

      break;
    case M_ROTATION_LENS:
      Xprmt[0]  = xl;
      Xprmt[1]  = yl;
      Xprmt[2]  = parms[P_E];
      Xprmt[3]  = parms[P_THETA];
      Xprmt[4]  = parms[P_GAMMA];
      Xprmt[5]  = parms[P_SIGMA];
      Xprmt[6]  = parms[P_PHI];
      Xprmt[7]  = parms[P_SX];
      Xprmt[8]  = parms[P_SY];

      break;
    case M_DOUBLE_LENS:
      cprax.n = 6;
      
      Xprmt[0]  = xl;
      Xprmt[1]  = yl;
      Xprmt[2]  = parms[P_E];
      Xprmt[3]  = parms[P_THETA];
      Xprmt[4]  = parms[P_GAMMA];
      Xprmt[5]  = parms[P_SIGMA];
      Xprmt[6]  = parms[P_PHI];
      Xprmt[7]  = parms[P_X_1];
      Xprmt[8]  = parms[P_Y_1];
      Xprmt[9]  = parms[P_X_2];
      Xprmt[10] = parms[P_Y_2];
      Xprmt[11] = parms[P_M_1];
      Xprmt[12] = parms[P_M_2];
      Xprmt[13] = parms[P_BETA];
      Xprmt[4]  = parms[P_GAMMA2];
      Xprmt[5]  = parms[P_SIGMA2];
      Xprmt[6]  = parms[P_PHI2];

      break;
    case M_UNIFORM_RING:
      Xprmt[0] = xl;
      Xprmt[1] = yl;
      Xprmt[2] = parms[P_E];
      Xprmt[3] = parms[P_THETA];
      Xprmt[4] = parms[P_GAMMA];
      Xprmt[5] = parms[P_SIGMA];
      Xprmt[6] = parms[P_PHI];
      Xprmt[7] = parms[P_KAPPA];
      Xprmt[8] = parms[P_Ri];
      Xprmt[9] = parms[P_Ro];

      break;
    default:
      break; 
    }
  }
}
